<?php
require_once ("functions/init.php");
require_once ("rechteverwaltung.php");
require_once ("functions/ext/Payment_Sepa/sepaexport.php");

$filter = $_SESSION ["dtausexport_filter"];
unset ( $_SESSION ["dtausexport_filter"] );
$sortierung = $_SESSION ["dtausexport_sortierung"];
unset ( $_SESSION ["dtausexport_sortierung"] );

$listenname = "rechnungen";
$bk = $_POST ["bk"];
$iban = $_POST ["iban"];
$bic = $_POST ["bic"];

if ($bk != "") {
	// Bankkonto bestimmen
	$query = $sql_query ["bankkontenliste"] . " AND id = " . $bk;
	$bankkonto_row = get_table_row ( $query );
}

if ($_POST ["dtaus"])
	$sDownloadTyp = "dtaus";
else
	$sDownloadTyp = "sepa";
	
	// **********************************************************************************************************
$query = $sql_query ["rechnungliste"];
$anzahl_gesamt = get_table_count ( $query );

// Rechnungstatusfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["rechnungstatus"], "$tblrechnungen.fiStatus" );

// Lieferantenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["lieferant"], "$tblrechnungen.fiLieferant" );

// Faelligkeitfilter
if ($filter [$listenname] ["faelligkeitfilter"] == 1) {
	$query .= " and to_days($tblrechnungen.dtDatumFaelligkeit)-7 <= to_days('" . concat_date ( $akttag, $aktmonat, $aktjahr ) . "')";
}
if ($filter [$listenname] ["faelligkeitfilter"] == 2) {
	$query .= " and to_days($tblrechnungen.dtDatumFaelligkeit) <= to_days('" . concat_date ( $akttag, $aktmonat, $aktjahr ) . "')";
}

// Zahlartfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["zahlart"], "$tblrechnungen.fiZahlart" );

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and to_days(dtRechnungDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "')";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and to_days(dtRechnungDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "')";
	}
}

// Volltextsuche
$query .= create_fulltext_index_search ( array (
		$tblrechnungen,
		$tblkontakte 
), $filter [$listenname] ["textfilter"] );

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sei dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

if ($sDownloadTyp == "dtaus") {
	// Payment_DTA
	$dta_file = new DTA ( DTA_CREDIT );
	
	// Inhaberkonto
	$dta_file->setAccountFileSender ( array (
			"name" => $bankkonto_row ['dtInhaberName'],
			"bank_code" => $bankkonto_row ['dtBankLeitZahl'],
			"account_number" => $bankkonto_row ['dtKontoNummer'] 
	) );
} else {
	// Payment_DTA
	$dta_file = new DTA ( DTA_CREDIT );
	
	$creator = new SepaXmlCreator ();
	$creator->setAccountValues ( $bankkonto_row ['dtInhaberName'], $iban, $bic );
	
	// Einfhren wenn bentigt, gibt an wann eine berweisung bertragen werden soll
	// $creator->setAusfuehrungOffset(1);
}

if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		if ($_POST ["exportieren_" . $listenzeile ["Rechnung_id"]] == "1" || ! isset ( $listeHaken )) {
			$bilanz_query = "select * from tblBilanzRechnungen where fiRechnung = " . $listenzeile ["Rechnung_id"];
			$bilanz_row = get_table_row ( $bilanz_query );
			
			$aRechnungUpdate ["dtDatumDTA"] = $aktdatum;
			update_into_table ( $tblrechnungen, $listenzeile ["Rechnung_id"], $aRechnungUpdate );
			
			// Leerzeichen filtern
			$listenzeile ['dtBankLeitZahl'] = str_replace ( " ", "", $listenzeile ['dtBankLeitZahl'] );
			$listenzeile ['dtBankKontoNummer'] = str_replace ( " ", "", $listenzeile ['dtBankKontoNummer'] );
			
			if (strlen ( $listenzeile ['dtLieferant_Anzeige'] ) > 0 && strlen ( $listenzeile ['dtBankLeitZahl'] ) > 0 && strlen ( $listenzeile ['dtBankLeitZahl'] ) <= 8 && ctype_digit ( $listenzeile ['dtBankLeitZahl'] ) && strlen ( $listenzeile ['dtLieferant_Anzeige'] ) > 0 && strlen ( $listenzeile ['dtBankKontoNummer'] ) <= 10 && ctype_digit ( $listenzeile ['dtBankKontoNummer'] )) {
			}
			
			if ($listenzeile ["dtSkonto"] > 0) {
				$fSummeBrutto = $bilanz_row ["dtSummeBrutto"] - (($bilanz_row ["dtSummeBrutto"] / 100) * $listenzeile ["dtSkonto"]);
			} else {
				$fSummeBrutto = $bilanz_row ["dtSummeBrutto"];
			}
			
			if ($sDownloadTyp == "dtaus") {
				$listenzeile ['dtBankBIC'] = str_replace ( " ", "", $listenzeile ['dtBankBIC'] );
				$listenzeile ['dtBankIBAN'] = str_replace ( " ", "", $listenzeile ['dtBankIBAN'] );
				
				unset ( $verwendungszweck_suche_array );
				$verwendungszweck_suche_array = array (
						0 => "%%%rechnungsnummer%%%",
						1 => "%%%rechnungsdatum%%%",
						2 => "%%%betrag%%%" 
				);
				
				unset ( $verwendungszweck_ersetz_array );
				$verwendungszweck_ersetz_array = array (
						0 => $listenzeile ["dtRechnungNrExtern"],
						1 => date_from_sql ( $listenzeile ["dtRechnungDatum"] ),
						2 => number_format ( $fSummeBrutto, 2, ".", "" ) . "EUR" 
				);
				
				$zweck_zeile1 = str_replace ( $verwendungszweck_suche_array, $verwendungszweck_ersetz_array, $verwendungszweck_dtaus_zeile1 );
				$zweck_zeile2 = str_replace ( $verwendungszweck_suche_array, $verwendungszweck_ersetz_array, $verwendungszweck_dtaus_zeile2 );
				
				if ($listenzeile ["dtLieferantEigeneKdNr"] != "") {
					$zweck_zeile2 .= " KdNr.: " . $listenzeile ["dtLieferantEigeneKdNr"];
				}
				
				$dta_file->addExchange ( array (
						"name" => check_input_string ( $listenzeile ['dtLieferant_Anzeige'] ), // Name of account owner.
						"bank_code" => $listenzeile ['dtBankLeitZahl'], // Bank code.
						"account_number" => $listenzeile ['dtBankKontoNummer'] 
				), // Account number.
number_format ( $fSummeBrutto, 2, ".", "" ), // Amount of money.
array ( // Description of the transaction ("Verwendungszweck").
						$zweck_zeile1,
						$zweck_zeile2 
				) );
			} else {
				unset ( $verwendungszweck_suche_array );
				$verwendungszweck_suche_array = array (
						0 => "%%%rechnungsnummer%%%",
						1 => "%%%rechnungsdatum%%%",
						2 => "%%%betrag%%%" 
				);
				
				unset ( $verwendungszweck_ersetz_array );
				$verwendungszweck_ersetz_array = array (
						0 => $listenzeile ["dtRechnungNrExtern"],
						1 => date_from_sql ( $listenzeile ["dtRechnungDatum"] ),
						2 => number_format ( $fSummeBrutto, 2, ".", "" ) . "EUR" 
				);
				
				$zweck_zeile1 = str_replace ( $verwendungszweck_suche_array, $verwendungszweck_ersetz_array, $verwendungszweck_sepa_rechnungen_zeile1 );
				$zweck_zeile2 = str_replace ( $verwendungszweck_suche_array, $verwendungszweck_ersetz_array, $verwendungszweck_sepa_rechnungen_zeile2 );
				
				if ($listenzeile ["dtLieferantEigeneKdNr"] != "") {
					$zweck_zeile2 .= " KdNr.: " . $listenzeile ["dtLieferantEigeneKdNr"];
				}
				
				// Erzeugung einer neuen berweisung
				$buchung = new SepaBuchung ();
				// gewnschter berweisungsbetrag
				$buchung->setBetrag ( number_format ( $fSummeBrutto, 2, ".", "" ) );
				// gewnschte End2End Referenz (OPTIONAL)
				$buchung->setEnd2End ( 'TRA-ID0-' . date ( 'YmdHis', $creationTime ) . rand ( 0, 1000 ) );
				// BIC des Empfngerinstituts
				$buchung->setBic ( $listenzeile ["dtBankBIC"] );
				// Name des Zahlungsempfngers
				$buchung->setName ( replace_special_character ( $dta_file->makeValidString ( check_input_string ( $listenzeile ['dtLieferant_Anzeige'] ) ) ) );
				// IBAN des Zahlungsmpfngers
				$buchung->setIban ( $listenzeile ["dtBankIBAN"] );
				// gewnschter Verwendungszweck (OPTIONAL)
				$buchung->setVerwendungszweck ( replace_special_character ( $dta_file->makeValidString ( ($zweck_zeile1 . " " . $zweck_zeile2) ) ) );
				// Buchung zur Liste hinzufgen
				$creator->addBuchung ( $buchung );
			}
		}
	}
}

if ($sDownloadTyp == "dtaus") {
	if (file_exists ( $tmpoutputordner . "/" . SID . "_DTAUS0.txt" ))
		unlink ( $tmpoutputordner . "/" . SID . "_DTAUS0.txt" );
	$dta_file->saveFile ( $tmpoutputordner . "/" . SID . "_DTAUS0.txt" );
	
	// +++++ Header Informationen +++++ //
	$sDateiDTAUS = $tmpoutputordner . "/" . SID . "_DTAUS0.txt";
	$sNameDTAUS = SID . "_DTAUS0.txt";
	
	header ( "Content-Disposition: attachment; filename=$sNameDTAUS" );
	header ( 'Content-type: application/force-download' );
	header ( 'Content-type: application/octetstream' );
	readfile ( $sDateiDTAUS );
} else {
	$sDateiSEPA = $tmpoutputordner . "/" . SID . "_SEPA0.xml";
	$sNameSEPA = "Rechnung_" . $aktdatum . ".xml";
	$iSessionID = SID;
	
	// $creator->validateUeberweisungXml($sNameSEPA);
	// $creator->printXmlErrors();
	
	header ( 'Content-type: text/xml' );
	header ( 'Content-Disposition: attachment; filename=' . $sNameSEPA . '' );
	
	print $creator->generateSammelueberweisungXml ();
}
?>