<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenkopfzeile
listenkopf ( $listenname, $show_fields, $field_headlines, $field_width, $field_sort_options, $sortierung [$listenname], $target, $typ );

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["kontaktaspliste"];

if ($target == "kunden") {
	$query .= " and dtIstKunde = 1 ";
}
;
if ($target == "lieferanten") {
	$query .= " and dtIstLieferant = 1 ";
}
;
if ($target == "mitarbeiter") {
	$query .= " and dtIstMitarbeiter = 1 ";
}
;

// Rechte
$rechte_sql = "";
if ($benutzerrechte [$target] ["zugriffsart"] == 1) {
	$rechte_sql = " and $tblkontakte.id = " . $_SESSION ['benutzerkontaktid'];
}

// Volltextsuche
$query .= create_fulltext_index_search ( $tblkontaktasp, $filter ["kontakte"] ["textfilter"] );

$anzahl_gesamt = get_table_count ( $query . $rechte_sql );

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sei dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$liste = get_table_array ( $query . $rechte_sql . $sortierung_sql . $limit_sql );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ entferne alle nicht-Ziffern aus Telefonnummer f. Suche
		$listenzeile ["dtTelefonSuche"] = format_string_allowed_chars ( $listenzeile ["dtTelefon"], array (
				"0",
				"1",
				"2",
				"3",
				"4",
				"5",
				"6",
				"7",
				"8",
				"9" 
		) );
		$listenzeile ["dtMobilSuche"] = format_string_allowed_chars ( $listenzeile ["dtMobil"], array (
				"0",
				"1",
				"2",
				"3",
				"4",
				"5",
				"6",
				"7",
				"8",
				"9" 
		) );
		
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = liste_output_textfilter_markieren ( $listenzeile, $field_textfilter_active, $filter ["kontakte"] ["textfilter"] );
		
		// +++++++++++ Buttons hinzufgen
		$liste_output [$listenzeile_id] ["ButtonAnzeigen"] = detailbutton ( $liste [$listenzeile_id] ["fiKontaktID"], $target, $benutzerrechte, "&subtarget=ansprechpartner&subtyp=show" );
		$liste_output [$listenzeile_id] ["ButtonKopieren"] = kopierensubbutton ( $target, $typ, $liste [$listenzeile_id] ["fiKontaktID"], "ansprechpartner", $liste [$listenzeile_id] ["KontaktASP_id"], $benutzerrechte );
		$liste_output [$listenzeile_id] ["ButtonLoeschen"] = loeschensubbutton ( $target, $typ, $liste [$listenzeile_id] ["fiKontaktID"], "ansprechpartner", $liste [$listenzeile_id] ["KontaktASP_id"], $benutzerrechte );
	}
}

// ++++++++++++++++++++++++++++++++
// +++++++++++ Liste ausgeben
$anzahl = liste_output ( $liste_output, $show_fields, $field_width, $field_colors, $listenhoehe, $target, $typ );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenfusszeile
listenfuss ( $listenname, $field_width, $sortierung [$listenname], $anzahl, $anzahl_ausgabe, $anzahl_gesamt, $target, $typ );

?>