<?php
// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenkopfzeile
listenkopf ( $listenname, $show_fields, $field_headlines, $field_width, $field_sort_options, $sortierung [$listenname], $target, $typ, $id, $subtarget, $subtyp );

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["bestellungdrucklogliste"] . " and $tblbestellungdrucklog.fiBeleg = " . $id;
$anzahl_gesamt = get_table_count ( $query );

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sie dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "" and $filter [$listenname] ["textfilter"] == "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren

unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = liste_output_textfilter ( $listenzeile, $field_textfilter_active, $filter [$listenname] ["textfilter"] );
		
		// +++++++++++ Felder formatieren
		switch ($liste_output [$listenzeile_id] ["dtAusgabeTyp"]) {
			case 0 :
				$liste_output [$listenzeile_id] ["dtAusgabeTyp"] = "anzeigen";
				break;
			
			case 1 :
				$liste_output [$listenzeile_id] ["dtAusgabeTyp"] = "drucken";
				break;
			
			case 2 :
				$liste_output [$listenzeile_id] ["dtAusgabeTyp"] = "<span title=\"eMail an " . $liste_output [$listenzeile_id] ["dtEmpfaenger"] . "\">eMail an " . $liste_output [$listenzeile_id] ["dtEmpfaenger"] . "</span>";
				break;
		}
		
		$liste_output [$listenzeile_id] ["dtDatumZeit"] = datetime_from_sql ( $liste_output [$listenzeile_id] ["dtDatumZeit"] );
		
		switch ($liste_output [$listenzeile_id] ["dtBelegTyp"]) {
			case 0 :
				$liste_output [$listenzeile_id] ["dtBelegTyp"] = "Bestellung";
				break;
		}
		
		if ($liste_output [$listenzeile_id] ["fiBenutzer"] == "0") {
			$liste_output [$listenzeile_id] ["dtAnzeigeName"] = "Admin";
		} else {
			$liste_output [$listenzeile_id] ["dtAnzeigeName"] = $liste_output [$listenzeile_id] ["dtVorname"] . " " . $liste_output [$listenzeile_id] ["dtNachname"];
		}
		
		// ++++ Prfsummencheck
		$psum = create_pruefsumme ( $bestellungarchivordner, $id, $liste_output [$listenzeile_id] ["BestellungDruckLog_id"] . "_" . strtolower ( $liste_output [$listenzeile_id] ["dtBelegTyp"] ) . ".pdf" );
		
		if (! $psum) {
			$liste_output [$listenzeile_id] ["dtIntegritaet"] = "<span style=\"color: #ff5555;\">Datei fehlt</span>";
		} else if ($psum != $liste_output [$listenzeile_id] ["dtPruefsumme"]) {
			$liste_output [$listenzeile_id] ["dtIntegritaet"] = "<span style=\"color: #ff5555;\">Datei wurde verndert</span>";
		} else {
			$liste_output [$listenzeile_id] ["dtIntegritaet"] = "<span style=\"color: #55ff55;\">OK</span>";
		}
		
		// +++++++++++ Buttons hinzufgen
		if ($psum) {
			$liste_output [$listenzeile_id] ["ButtonAnzeigen"] = druckenbutton ( $subtarget, "drucken", $id, $benutzerrechte, "&layout=" . strtolower ( $liste_output [$listenzeile_id] ["dtBelegTyp"] ) . "&ziel=archiv&archivid=" . $liste_output [$listenzeile_id] ["BestellungDruckLog_id"], "&nbsp;&nbsp;&nbsp;aus Archiv anzeigen&nbsp;&nbsp;&nbsp;", "Archivierte Version dieses Beleges anzeigen" );
		}
		
		$sSqlQuery = $sql_query ["dokumentlayoutliste"] . " AND $tbldokumentlayout.id = " . $listenzeile ["fiDokumentLayout"];
		$aDokumentlayoutResult = get_table_array ( $sSqlQuery );
		
		$liste_output [$listenzeile_id] ["fiDokumentLayout"] = $aDokumentlayoutResult [0] ["dtDokumentName"];
	}
}

// ++++++++++++++++++++++++++++++++
// +++++++++++ Liste ausgeben
$anzahl = liste_output ( $liste_output, $show_fields, $field_width, $field_colors, $listenhoehe, $target, $typ );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenfusszeile
listenfuss ( $listenname, $field_width, $sortierung [$listenname], $anzahl, $anzahl_ausgabe, $anzahl_gesamt, $target, $typ );

?>

