<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["artikellisteexport"];
$anzahl_gesamt = get_table_count_complete ( $tblartikel );

// Warengruppenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["warengruppe"], "$tblartikel.fiWarengruppe" );

// Lieferantenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["lieferant"], "$tblartikellieferanten.fiLieferant" );

// Volltextsuche
$query .= create_fulltext_index_search ( array (
		$tblartikel,
		$tblwarengruppen 
), $filter [$listenname] ["textfilter"] );

$groupierung_sql = " group by Artikel_id ";

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sie dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

// erweiterung des SQL-Strings wenn nach Lieferanten gesucht wird
if ($filter [$listenname] ["lieferant"] != "") {
	$query = str_replace ( "from " . $tblartikel, "from " . $tblartikel . " left join " . $tblartikellieferanten . " on " . $tblartikellieferanten . ".fiArtikel = " . $tblartikel . ".id", $query );
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $groupierung_sql . $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

/*
 * Zur Darstellung der VK Preise
 */

$query = $sql_query ["preisgruppenliste"];

$field_preisgruppen_array = get_table_array ( $query );
foreach ( ( array ) $field_preisgruppen_array as $key => $value ) {
	$preisgruppen_array [$value ["PreisGruppen_id"]] = $value;
}

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		$sArtikelIDs .= $listenzeile ["Artikel_id"] . ",";
		// +++++++++++ Cache
		$cache = CacheListe_getFromCache ( $target, $typ, $liste [$listenzeile_id] ["Artikel_id"], $tblartikel, $liste [$listenzeile_id] );
		
		$liste_output [$listenzeile_id] ["dtEigeneArtikelNr"] = $listenzeile ["dtEigeneArtikelNr"];
		$liste_output [$listenzeile_id] ["dtArtikel"] = $listenzeile ["dtArtikel"];
		$liste_output [$listenzeile_id] ["dtFabrikat"] = $listenzeile ["dtFabrikat"];
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = liste_output_textfilter_markieren ( $listenzeile, $field_textfilter_active, $filter [$target] ["textfilter"] );
		
		// +++++++++++ Cache
		CacheListe_writeIntoCache ( $target, $typ, $liste [$listenzeile_id] ["Artikel_id"], $tblartikel, $listenzeile, $liste_output [$listenzeile_id] );
	}
}
$sArtikelIDs .= "1=1";

// Zeilen zum Listenobjekt hinzufgen
$oListe->addZeilen ( $liste_output );

?>