<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["bilanztaetigkeitenliste"];
$anzahl_gesamt = get_table_count ( $query );

// Mitarbeiterfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["mitarbeiter"], "$tblprojektzeiten.fiMitarbeiter" );

// Projektstatusfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["projektstatus"], "$tblprojekte.fiStatus" );

// Projekttypfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["projekttyp"], "$tblprojekte.fiProjektTyp" );

// Projektfilter
if ($filter [$listenname] ["projekt"] != "") {
	if (in_array ( "-1", $filter [$listenname] ["projekt"] )) {
		$query .= " and $tblprojektzeiten.fiProjekt = 0 ";
	}
	if (in_array ( "-2", $filter [$listenname] ["projekt"] )) {
		$query .= " and $tblprojektzeiten.fiProjekt != 0 ";
	}
	
	$query .= filter_multiselect_return_query ( $filter [$listenname] ["projekt"], "$tblprojektzeiten.fiProjekt", false, false, false, array (
			"-1",
			"-2" 
	) );
}

// Kundenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["kunde"], "$tblprojekte.fiKunde", false, false, "$tblprojektzeiten.fiProjektzeitenKunde" );

// Datumsbereich (oberer Filter)
if ($filter ["bilanz"] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter ["bilanz"] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and to_days(dtDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "')";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and to_days(dtDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "')";
	}
}

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sei dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );

$query .= " and $tblprojektzeiten.fiTaetigkeit > 0";
$query .= " GROUP BY $tblprojektzeiten.fiTaetigkeit";

$query .= $sortierung_sql . $limit_sql;

$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = liste_output_textfilter_markieren ( $listenzeile, $field_textfilter_active, $filter [$listenname] ["textfilter"] );
		
		// +++++++++++ Felder formatieren
		$liste_output [$listenzeile_id] ["Zeiten"] = double_from_sql ( $liste_output [$listenzeile_id] ["Zeiten"], 2 );
		$liste_output [$listenzeile_id] ["Kosten"] = "<div style=\"text-align: right;\">" . preis_from_sql ( $liste_output [$listenzeile_id] ["Kosten"], null, 2 ) . "</div>";
		
		// +++++++++++ Buttons hinzufgen
		
		$gesamtZeiten += $listenzeile ["Zeiten"];
		$gesamtKosten += $listenzeile ["Kosten"];
	}
}

/*
 * Summe
 */
$summeId = count ( $liste_output );
$liste_output [$summeId] ["dtTaetigkeitCode"] = "<b>---</b>";
$liste_output [$summeId] ["dtTaetigkeit"] = "<b>---</b>";
$liste_output [$summeId] ["dtTaetigkeitBeschreibung"] = "<b>Gesamt:</b>";
$liste_output [$summeId] ["Zeiten"] = "<b>" . double_from_sql ( $gesamtZeiten, 2 ) . "</b>";
$liste_output [$summeId] ["Kosten"] = "<b>" . preis_from_sql ( $gesamtKosten, null, 2 ) . "</b>";

// Zeilen zum Listenobjekt hinzufgen
$oListe->addZeilen ( $liste_output );

?>