<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["bestellungliste"];

// nur die Projekte dieses Contents anzeigen
if ($field ["fiBestellung"] != ";") {
	$contentprojekte_array = explode ( ";", $field ["fiBestellung"] );
	$query .= " and ( 0=1 ";
	foreach ( ( array ) $contentprojekte_array as $key => $projektid ) {
		if ($projektid != "") {
			$query .= " or $tblbestellungen.id = " . $projektid . " ";
		}
	}
	$query .= " ) ";
} else {
	$query .= " and 2=4 ";
}
$anzahl_gesamt = get_table_count ( $query );

// Bestellungstatusfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["bestellungstatus"], "$tblbestellungen.fiStatus" );

// Lieferantenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["lieferant"], "$tblbestellungen.fiLieferant" );

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and to_days(dtRechnungDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "')";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and to_days(dtRechnungDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "')";
	}
}

// Volltextsuche
$query .= create_fulltext_index_search ( array (
		$tblrechnungen,
		$tblkontakte 
), $filter [$listenname] ["textfilter"] );

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sei dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ hole Bilanzdaten
		$bilanz_row ["dtSummeNetto"] = bestellungendbetrag_netto ( $liste [$listenzeile_id] ["Bestellung_id"] );
		$bilanz_row ["dtSummeBrutto"] = bestellungendbetrag_brutto ( $liste [$listenzeile_id] ["Bestellung_id"] );
		
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = liste_output_textfilter_markieren ( $listenzeile, $field_textfilter_active, $filter [$listenname] ["textfilter"] );
		
		// +++++++++++ Felder formatieren
		$liste_output [$listenzeile_id] ["dtLieferant_Anzeige"] = shortcutlink ( format_name_html ( $liste_output [$listenzeile_id] ["dtLieferant_Anzeige"] ), "kontakte", "show", $liste_output [$listenzeile_id] ["fiLieferant"], $benutzerrechte );
		$liste_output [$listenzeile_id] ["dtBestellungDatum"] = date_from_sql ( $liste_output [$listenzeile_id] ["dtBestellungDatum"] );
		$liste_output [$listenzeile_id] ["dtLieferungDatum"] = date_from_sql ( $liste_output [$listenzeile_id] ["dtLieferungDatum"] );
		
		$liste_output [$listenzeile_id] ["dtBestellungSummeNetto"] = preis_from_sql ( $bilanz_row ["dtSummeNetto"], null, 2 );
		$liste_output [$listenzeile_id] ["dtBestellungSummeBrutto"] = preis_from_sql ( $bilanz_row ["dtSummeBrutto"], null, 2 );
		
		$summe_netto = $summe_netto + $bilanz_row ["dtSummeNetto"];
		$summe_brutto = $summe_brutto + $bilanz_row ["dtSummeBrutto"];
		
		// +++++++++++ Buttons hinzufgen
		$liste_output [$listenzeile_id] ["ButtonAnzeigen"] = detailbutton ( $liste [$listenzeile_id] ["Bestellung_id"], "bestellungen", $benutzerrechte );
		if ($readonly == "") {
			$liste_output [$listenzeile_id] ["ButtonLoeschen"] = loeschensubbutton ( $target, $typ, $id, $subtarget, $liste [$listenzeile_id] ["Bestellung_id"], $benutzerrechte, "", "lschen", "Diese Zuordnung entfernen" );
		}
	}
}

// Zeilen zum Listenobjekt hinzufgen
$oListe->addZeilen ( $liste_output );

?>