<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenkopfzeile
listenkopf ( $listenname, $sort_fields, $field_headlines, $field_width, $field_sort_options, $sortierung [$listenname], $target, $typ );

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["fahrstreckenliste"];

$anzahl_gesamt = get_table_count ( $query );

// Kontaktfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["kontakt"], "$tblfahrstrecken.fiVonKontakt", false, false, "$tblfahrstrecken.fiNachKontakt" );

// Mitarbeiterfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["mitarbeiter"], "$tblfahrstrecken.fiVonKontakt", false, false, "$tblfahrstrecken.fiNachKontakt" );

// Kundenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["kunde"], "$tblfahrstrecken.fiVonKontakt", false, false, "$tblfahrstrecken.fiNachKontakt" );

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sei dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		// +++++++++++ Cache
		$cache = CacheListe_getFromCache ( $target, $typ, $liste [$listenzeile_id] ["Fahrstrecken_id"], $tblfahrstrecken, $listenzeile );
		if ($cache !== false) {
			$liste_output [$listenzeile_id] = $cache;
			continue;
		}
		
		// +++++++++++ Eingabefelder erzeugen
		$liste_output [$listenzeile_id] ["id"] = "<!--" . $liste [$listenzeile_id] ["Fahrstrecken_id"] . "//-->";
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "target", $target );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "typ", "send" );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "id", $liste [$listenzeile_id] ["Fahrstrecken_id"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "ajaxid", $liste [$listenzeile_id] ["Fahrstrecken_id"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subtarget", $subtarget );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subtyp", $subtyp );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subid", $subid );
		
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "fiVonKontakt", $liste [$listenzeile_id] ["fiVonKontakt"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "fiNachKontakt", $liste [$listenzeile_id] ["fiNachKontakt"] );
		
		// +++++++++++ Felder formatieren
		$query = $sql_query ["kontaktliste"] . " and $tblkontakte.id = " . $liste [$listenzeile_id] ["fiVonKontakt"];
		$von_kontakt_field = get_table_row ( $query );
		$liste_output [$listenzeile_id] ["dtVonKontakt"] = input_text ( "Von-Kontakt", "dtVonKontakt", $von_kontakt_field ["dtKontaktDDText2"], "input_text_250", "readonly" );
		$liste_output [$listenzeile_id] ["dtVonKontakt"] .= shortcutbutton ( "kontakte", "show", $liste [$listenzeile_id] ["fiVonKontakt"], $benutzerrechte );
		
		$query = $sql_query ["kontaktliste"] . " and $tblkontakte.id = " . $liste [$listenzeile_id] ["fiNachKontakt"];
		$nach_kontakt_field = get_table_row ( $query );
		$liste_output [$listenzeile_id] ["dtNachKontakt"] = input_text ( "Nach-Kontakt", "dtNachKontakt", $nach_kontakt_field ["dtKontaktDDText2"], "input_text_250", "readonly" );
		$liste_output [$listenzeile_id] ["dtNachKontakt"] .= shortcutbutton ( "kontakte", "show", $liste [$listenzeile_id] ["fiNachKontakt"], $benutzerrechte );
		
		$liste_output [$listenzeile_id] ["dtEntfernung"] = input_text ( "Entfernung (km)", "dtEntfernung", double_from_sql ( $liste [$listenzeile_id] ["dtEntfernung"], 1 ), "input_text_50", "", "text-align: right;" );
		
		// +++++++++++ Buttons hinzufgen
		$liste_output [$listenzeile_id] ["ButtonAendern"] = uebernehmenbutton_kurz ( $liste [$listenzeile_id] ["Fahrstrecken_id"], $target, $benutzerrechte, "", "nderungen speichern", "onClick='formular_senden(this.form); return false;'" );
		$liste_output [$listenzeile_id] ["ButtonZuruecksetzen"] = zuruecksetzenbutton_kurz ( $liste [$listenzeile_id] ["Fahrstrecken_id"], $target, $benutzerrechte );
		$liste_output [$listenzeile_id] ["ButtonLoeschen"] = klickbutton ( "loeschen_kurz", "onClick='formular_loeschen(this.form)'", "width: 15px;", "Diesen Eintrag lschen" );
		$liste_output [$listenzeile_id] ["Aenderungsanzeiger"] = aenderungsanzeiger ();
		
		// +++++++++++ Cache
		CacheListe_writeIntoCache ( $target, $typ, $liste [$listenzeile_id] ["Fahrstrecken_id"], $tblfahrstrecken, $listenzeile, $liste_output [$listenzeile_id] );
	}
}

// ++++++++++++++++++++++++++++++++
// +++++++++++ Liste ausgeben
$anzahl = liste_output ( $liste_output, $show_fields, $field_width, $field_colors, $listenhoehe, $target, $typ );

// +++++++++++ Eingabefelder fr Neu-Zeile erzeugen
unset ( $liste_output );

$liste_output [0] ["dtVonKontakt"] = "neu:";

$liste_output [1] ["id"] = input_hidden ( "target", $target );
$liste_output [1] ["id"] .= input_hidden ( "typ", "send" );
$liste_output [1] ["id"] .= input_hidden ( "id", "" );
$liste_output [1] ["id"] .= input_hidden ( "subtarget", $subtarget );
$liste_output [1] ["id"] .= input_hidden ( "subtyp", $subtyp );
$liste_output [1] ["id"] .= input_hidden ( "subid", $subid );

// +++++++++++ Felder formatieren
$query = $sql_query ["kontaktliste"] . " order by dtKontaktSortierung";
$liste_output [1] ["dtVonKontakt"] = input_dropdownbox ( "Von-Kontakt", $query, "Kontakte_id", "fiVonKontakt", $filter [$listenname] ["mitarbeiter"], "dtKontaktDDText2", "input_select_250" );

$liste_output [1] ["dtNachKontakt"] = input_dropdownbox ( "Nach-Kontakt", $query, "Kontakte_id", "fiNachKontakt", $filter [$listenname] ["kunde"], "dtKontaktDDText2", "input_select_250" );

$liste_output [1] ["dtEntfernung"] = input_text ( "Entfernung (km)", "dtEntfernung", "", "input_text_50", "", "text-align: right;" );

// +++++++++++ Buttons hinzufgen
$liste_output [1] ["ButtonAendern"] = uebernehmenbutton_kurz ( "neuer Eintrag", $target, $benutzerrechte );
$liste_output [1] ["ButtonZuruecksetzen"] = zuruecksetzenbutton_kurz ( "neuer Eintrag", $target, $benutzerrechte );
$liste_output [1] ["Aenderungsanzeiger"] = aenderungsanzeiger ();

// ++++++++++++++++++++++++++++++++
// +++++++++++ Neu-Zeile ausgeben
liste_output ( $liste_output, $show_fields, $field_width, $field_colors, 60, $target, $typ );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenfusszeile
listenfuss ( $listenname, $field_width, $sortierung [$listenname], $anzahl, $anzahl_ausgabe, $anzahl_gesamt, $target, $typ );

?>