<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["projektzeitenliste"];
$anzahl_gesamt = get_table_count_complete ( $tblprojektzeiten );

// Mitarbeiter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["mitarbeiter"], "$tblprojektzeiten.fiMitarbeiter" );

// Projektverantwortlicherfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["projektverantwortlicher"], "$tblprojekte.fiProjektVerantwortlicher" );

// Projektfilter
if ($filter [$listenname] ["projekt"] != "") {
	if (in_array ( "-1", ( array ) $filter [$listenname] ["projekt"] )) {
		$query .= " and $tblprojektzeiten.fiProjekt = 0 ";
	}
	if (in_array ( "-2", ( array ) $filter [$listenname] ["projekt"] )) {
		$query .= " and $tblprojektzeiten.fiProjekt != 0 ";
	}
	
	$query .= filter_multiselect_return_query ( $filter [$listenname] ["projekt"], "$tblprojektzeiten.fiProjekt", false, false, false, array (
			"-1",
			"-2" 
	) );
}

// Projektstatusfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["projektstatus"], "$tblprojekte.fiStatus" );

// Ttigkeitenfilter
$query .= " AND $tblprojektzeiten.fiTaetigkeit = " . $standard_taetigkeit_fahrt . " ";

// Kundenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["kunde"], "$tblprojekte.fiKunde", false, false, "$tblprojektzeiten.fiProjektzeitenKunde" );

// projektzeitenstatusgeprueftfilter
if ($filter [$listenname] ["projektzeitengeprueftstatus"] != "") {
	$query .= " and $tblprojektzeiten.dtStundennachweisGeprueft = '" . ($filter [$listenname] ["projektzeitengeprueftstatus"] - 1) . "' ";
}

// projektzeitenabgerechnetstatusfilter
if ($filter [$listenname] ["projektzeitenabgerechnetstatus"] != "") {
	$query .= " and $tblprojektzeiten.dtAbgerechnet = '" . ($filter [$listenname] ["projektzeitenabgerechnetstatus"] - 1) . "' ";
}

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and to_days(dtDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "')";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and to_days(dtDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "')";
	}
}

// Uhrzeitbereich
if ($filter [$listenname] ["uhrzeitbereich"] != "") {
	
	$uhrzeit_explode = explode ( "-", $filter [$listenname] ["uhrzeitbereich"] );
	$uhrzeit_stunde_von = $uhrzeit_explode [0];
	$uhrzeit_minute_von = $uhrzeit_explode [1];
	$uhrzeit_stunde_bis = $uhrzeit_explode [2];
	$uhrzeit_minute_bis = $uhrzeit_explode [3];
	
	if (! ($uhrzeit_stunde_von == 24 and $uhrzeit_minute_von == 60) and ! ($uhrzeit_stunde_von == "" and $uhrzeit_minute_von == "")) {
		$query .= " and (time_to_sec(dtBeginnZeit) >= time_to_sec('" . concat_time ( $uhrzeit_stunde_von, $uhrzeit_minute_von, 0 ) . "')";
		$query .= " or time_to_sec(dtEndeZeit) >= time_to_sec('" . concat_time ( $uhrzeit_stunde_von, $uhrzeit_minute_von, 0 ) . "'))";
	}
	
	if (! ($uhrzeit_stunde_bis == 24 and $uhrzeit_minute_bis == 60) and ! ($uhrzeit_stunde_bis == "" and $uhrzeit_minute_bis == "")) {
		$query .= " and time_to_sec(dtBeginnZeit) <= time_to_sec('" . concat_time ( $uhrzeit_stunde_bis, $uhrzeit_minute_bis, 0 ) . "')";
	}
}

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sei dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "" and $filter [$listenname] ["textfilter"] == "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ Summenfelder berechnen
		$projektzeiten_summe = round ( $projektzeiten_summe + round ( $liste [$listenzeile_id] ["dtKilometer"], 2 ), 2 );
		
		// +++++++++++ Eingabefelder erzeugen
		$liste_output [$listenzeile_id] ["id"] = "<!--" . $liste [$listenzeile_id] ["Projektzeiten_id"] . "//-->";
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "target", $target );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "typ", "send" );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "id", $liste [$listenzeile_id] ["Projektzeiten_id"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "ajaxid", $liste [$listenzeile_id] ["Projektzeiten_id"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subtarget", $subtarget );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subtyp", $subtyp );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subid", $subid );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "referer", $typ );
		
		$query = $sql_query ["personaldatenliste"] . " and $tblpersonaldaten.fiKontaktNr = '" . $liste [$listenzeile_id] ["fiMitarbeiter"] . "' ";
		$personaldaten_field = get_table_row ( $query );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "teilzeit", $personaldaten_field ["dtTeilzeit"] );
		
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "dtFahrzeit", $liste [$listenzeile_id] ["dtFahrzeit"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "dtEntfernungKilometer", $liste [$listenzeile_id] ["dtEntfernungKilometer"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "standardstdsatz", stundensatz_zu_projektzeit ( $liste [$listenzeile_id] ["fiMitarbeiter"], $liste [$listenzeile_id] ["fiProjekt"] ) );
		
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "fiProjekt", $liste [$listenzeile_id] ["fiProjekt"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "fiTaetigkeit", $liste [$listenzeile_id] ["fiTaetigkeit"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "fiMitarbeiter", $liste [$listenzeile_id] ["fiMitarbeiter"] );
		
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "mitarbeitervorauswahl", "" );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "projektvorauswahl", "" );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "taetigkeitvorauswahl", "" );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "stdsatzvorauswahl", "" );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "stdsatzautomanuellvorauswahl", "" );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "bemerkungvorauswahl", "" );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "bemerkungvorauswahlfreitext", "" );
		
		$query = $sql_query ["kontaktliste"] . " and $tblkontakte.id = '" . $liste [$listenzeile_id] ["fiMitarbeiter"] . "' ";
		$mitarbeiter_field = get_table_row ( $query );
		$mitarbeiter_title = "Mitarbeiter: " . $mitarbeiter_field ["dtKontaktDDText2"];
		$liste_output [$listenzeile_id] ["dtKontaktDDText2"] = input_text ( $mitarbeiter_title, "dtKontaktDDText", $mitarbeiter_field ["dtKontaktDDText2"], "input_text_70", "onDblClick='mitarbeitervorauswahl_einfuegen(this.form)';", "background-color: $bgcolor_datum;" );
		
		if ($liste [$listenzeile_id] ["fiMitarbeiter"] != "") {
			$liste_output [$listenzeile_id] ["dtKontaktDDText2"] .= shortcutbutton ( "kontakte", "show", $liste [$listenzeile_id] ["fiMitarbeiter"], $benutzerrechte );
		}
		
		$query = $sql_query ["kontaktliste"] . " and $tblkontakte.id = '" . $liste [$listenzeile_id] ["fiProjektzeitenKunde"] . "' ";
		$mitarbeiter_field = get_table_row ( $query );
		
		$liste_output [$listenzeile_id] ["dtKundeDDText"] .= input_text ( $mitarbeiter_title, "dtKontaktDDText", $mitarbeiter_field ["dtKontaktDDText2"], "input_text_70", "onDblClick='mitarbeitervorauswahl_einfuegen(this.form)';", "background-color: $bgcolor_datum;" );
		
		if ($liste [$listenzeile_id] ["fiProjektzeitenKunde"] != "") {
			$liste_output [$listenzeile_id] ["dtKundeDDText"] .= shortcutbutton ( "kontakte", "show", $liste [$listenzeile_id] ["fiProjektzeitenKunde"], $benutzerrechte );
		}
		
		// +++++++++++ Felder formatieren
		if ($liste_output [$listenzeile_id] ["dtDatum"] != "2030-01-01") {
			$datum = split_date ( $liste [$listenzeile_id] ["dtDatum"] );
		}
		
		$liste_output [$listenzeile_id] ["dtDatum"] = input_text ( "Tag", "datum_tagname", weekday_from_date ( $liste [$listenzeile_id] ["dtDatum"] ), "input_date_small", "readonly disabled", "background-color: $bgcolor_datum;" );
		$liste_output [$listenzeile_id] ["dtDatum"] .= input_text ( "Tag", "datum_tag", $datum ["tag"], "input_date_small", "", "background-color: $bgcolor_datum;" );
		$liste_output [$listenzeile_id] ["dtDatum"] .= input_text ( "Monat", "datum_monat", $datum ["monat"], "input_date_small", "", "background-color: $bgcolor_datum;" );
		$liste_output [$listenzeile_id] ["dtDatum"] .= input_text ( "Jahr", "datum_jahr", $datum ["jahr"], "input_date", "", "background-color: $bgcolor_datum;" );
		$liste_output [$listenzeile_id] ["dtDatum"] .= input_text ( "KW", "datum_kw", week_from_date ( $liste [$listenzeile_id] ["dtDatum"] ), "input_date_small", "readonly disabled", "background-color: $bgcolor_datum;" );
		
		$query = $sql_query ["projektliste"] . " and $tblprojekte.id = " . $liste [$listenzeile_id] ["fiProjekt"];
		$projekt_field = get_table_row ( $query );
		
		if ($liste [$listenzeile_id] ["dtProjektzeitAutoManuell"] != 0) {
			if ($liste [$listenzeile_id] ["dtProjektzeitDezimal"] != 0) {
				$bgcolor_projektzeit = "#ffddcc";
			} else {
				$bgcolor_projektzeit = "#ff6666";
			}
			;
		} else {
			if ($liste [$listenzeile_id] ["dtProjektzeitDezimal"] != 0) {
				$bgcolor_projektzeit = "#ffff44";
			} else {
				$bgcolor_projektzeit = "#ff6666";
			}
			;
		}
		
		if ($liste [$listenzeile_id] ["fiProjekt"] != 0) {
			$query = $sql_query ["projektliste"] . " and $tblprojekte.id = '" . $liste [$listenzeile_id] ["fiProjekt"] . "' ";
			$projekt_field = get_table_row ( $query );
			$projekt_title = "Projekt: " . $projekt_field ["dtProjektDDText"];
		} else {
			$projekt_field = "";
			$projekt_title = "Projekt";
		}
		$liste_output [$listenzeile_id] ["dtProjektDDText"] = input_text ( $projekt_title, "dtProjektDDText", $projekt_field ["dtProjektDDText"], "input_text_70", "onDblClick='projektvorauswahl_einfuegen(this.form)';" );
		
		if ($liste [$listenzeile_id] ["fiProjekt"] != "") {
			$liste_output [$listenzeile_id] ["dtProjektDDText"] .= shortcutbutton ( "projekte", "show", $liste [$listenzeile_id] ["fiProjekt"], $benutzerrechte );
		}
		
		if ($liste [$listenzeile_id] ["fiTaetigkeit"] != 0) {
			$query = $sql_query ["taetigkeitenliste"] . " and $tbltaetigkeiten.id = '" . $liste [$listenzeile_id] ["fiTaetigkeit"] . "' ";
			$taetigkeit_field = get_table_row ( $query );
			$taetigkeit_title = "Ttigkeit: " . $taetigkeit_field ["dtTaetigkeitDDText"];
		} else {
			$taetigkeit_field = "";
			$taetigkeit_title = "Ttigkeit";
		}
		$liste_output [$listenzeile_id] ["dtTaetigkeitDDText"] = input_text ( $taetigkeit_title, "dtTaetigkeitDDText", $taetigkeit_field ["dtTaetigkeitDDText"], "input_text_70", "onDblClick='taetigkeitvorauswahl_einfuegen(this.form)';" );
		
		$liste_output [$listenzeile_id] ["dtErlaeuterungStundennachweis"] = input_text ( $bemerkung_title, "dtErlaeuterungStundennachweis", $liste [$listenzeile_id] ["dtErlaeuterungStundennachweis"], "input_text_70", "onDblClick='bemerkungvorauswahl_einfuegen(this.form)';" );
		
		$liste_output [$listenzeile_id] ["dtKilometer"] = input_text ( "Kilometer", "dtKilometer", $liste [$listenzeile_id] ["dtKilometer"], "input_text_50" );
		
		// +++++++++++ Buttons hinzufgen
		
		$liste_output [$listenzeile_id] ["ButtonAendern"] = uebernehmenbutton_kurz ( $liste [$listenzeile_id] ["Projektzeiten_id"], $target, $benutzerrechte, "", "nderungen speichern", "onClick='vorauswahl_speichern(this.form); formular_senden(this.form); return false;'" );
		$liste_output [$listenzeile_id] ["ButtonLoeschen"] = klickbutton ( "loeschen_kurz", "onClick='formular_loeschen(this.form)'", "width: 15px;", "Diesen Eintrag lschen" );
		$liste_output [$listenzeile_id] ["Aenderungsanzeiger"] = aenderungsanzeiger ();
		
		$filterarray = str_replace ( "\"", "&quot;", serialize ( array (
				"mitarbeiter" => $liste [$listenzeile_id] ["fiMitarbeiter"],
				"geraet" => "",
				"stempelcode" => "",
				"stempelzeitenstatus" => "",
				"uhrzeitbereich" => "24-60-24-60",
				"datum" => $datum ["tag"] . "-" . $datum ["monat"] . "-" . $datum ["jahr"] . "-" . $datum ["tag"] . "-" . $datum ["monat"] . "-" . $datum ["jahr"] 
		) ) );
		$liste_output [$listenzeile_id] ["ButtonSZ"] = "<nobr>" . button ( "SZ", "stempelzeiten", "list", "", $benutzerrechte, "&listenname=stempelzeiten&filterwert_neu=" . $filterarray, "Stempelzeiten zu diesem Eintrag anzeigen" );
		$liste_output [$listenzeile_id] ["ButtonSZ"] .= button ( "SN", "stundennachweis", "list", "", $benutzerrechte, "&listenname=stundennachweis&filterwert_neu=" . $filterarray, $liste [$listenzeile_id] ["dtBemerkungKontrolle"] );
		$liste_output [$listenzeile_id] ["ButtonSZ"] .= "</nobr>";
		
		// +++++++++++ Cache
		CacheListe_writeIntoCache ( $target, $typ, $liste [$listenzeile_id] ["Projektzeiten_id"], $tblprojektzeiten, $listenzeile, $liste_output [$listenzeile_id] );
	}
}

// Zeilen zum Listenobjekt hinzufgen
$oListe->addZeilen ( $liste_output );

?>