<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenkopfzeile
listenkopf ( $listenname, $show_fields, $field_headlines, $field_width, $field_sort_options, $sortierung [$listenname], $target, $typ, $id, $subtarget, $subtyp );

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["contentliste"];

// nur Content dieses Kontaktes anzeigen
$query .= " and fiKontakt like '%;" . $id . ";%' ";
$query .= " and $tblcontent.fiContentTyp < 900 ";

$anzahl_gesamt = get_table_count ( $query );

// Contenttypfilter
if ($filter [$listenname] ["contenttyp"] != "") {
	$query .= " and $tblcontent.fiContentTyp = " . $filter [$listenname] ["contenttyp"] . " ";
}

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and to_days(dtDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "')";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and to_days(dtDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "')";
	}
}

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sei dem SQL-String hinzu
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = liste_output_textfilter ( $listenzeile, $field_textfilter_active, $filter [$listenname] ["textfilter"] );
		
		// +++++++++++ Zeige nur die Eintrge, die der aktuelle Benutzer sehen darf
		if ($_SESSION ['benutzername'] != "admin" and $bContentBerechtigungenAktiv and $liste_output [$listenzeile_id] ["fiAutor"] != $_SESSION ['benutzerkontaktid'] and ! (in_array ( $_SESSION ['benutzergruppe'], explode ( ";", $liste_output [$listenzeile_id] ["dtBerechtigung"] ) ))) {
			$liste_output [$listenzeile_id] ["Textfilter"] = "nomatch";
		} else {
			
			// +++++++++++ Felder formatieren
			$liste_output [$listenzeile_id] ["dtDatum"] = date_from_sql ( $liste_output [$listenzeile_id] ["dtDatum"] );
			
			// +++++++++++ hole Namen des Autors
			$autor_query = $sql_query ["kontaktliste"] . " and $tblkontakte.id = " . $liste_output [$listenzeile_id] ["fiAutor"];
			$autor_field = get_table_row ( $autor_query );
			
			$liste_output [$listenzeile_id] ["dtAutor"] = $autor_field ["dtKontaktDDText"];
			
			// +++++++++++ Buttons hinzufgen
			$liste_output [$listenzeile_id] ["ButtonAnzeigen"] = detailbutton ( $liste [$listenzeile_id] ["Content_id"], "content", $benutzerrechte );
			$liste_output [$listenzeile_id] ["ButtonLoeschen"] = loeschensubbutton ( $target, $typ, $id, $subtarget, $liste [$listenzeile_id] ["Content_id"], $benutzerrechte, "", "lschen", "Diese Zuordnung entfernen" );
			
			if ($liste [$listenzeile_id] ["dtSchreibschutz"] != 1) {
				$liste_output [$listenzeile_id] ["ButtonOrdnerOeffnen"] = contentopenbutton ( $subtarget, $subtyp, $liste [$listenzeile_id] ["Content_id"], $benutzerrechte );
			}
		}
	}
}

// ++++++++++++++++++++++++++++++++
// +++++++++++ Liste ausgeben
$anzahl = liste_output ( $liste_output, $show_fields, $field_width, $field_colors, $listenhoehe, $target, $typ );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenfusszeile
listenfuss ( $listenname, $field_width, $sortierung [$listenname], $anzahl, $anzahl_ausgabe, $anzahl_gesamt, $target, $typ, $id, $subtarget, $subtyp );

?>