<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = "SELECT $tblbelege.id AS Beleg_id, $tblartikel.id AS Artikel_id, $tblbelegstatus.dtBelegStatus, $tblbelege.dtBelegNr, $tblbelege.dtRechnungDatum, $tblartikel.dtEigeneArtikelNr, $tblartikel.dtArtikel, $tblbelegmaterialposten.dtMenge, $tblartikeleinheiten.dtEinheit, (
$tblbelegmaterialposten.dtMenge * $tblbelegmaterialposten.dtPreisNetto) AS dtPreisNettoSumme FROM $tblbelegmaterialposten

LEFT JOIN $tblbelege ON $tblbelege.id = $tblbelegmaterialposten.fiBeleg
LEFT JOIN $tblartikel ON $tblartikel.id = $tblbelegmaterialposten.fiArtikel
LEFT JOIN $tblartikeleinheiten ON $tblartikeleinheiten.id = $tblbelegmaterialposten.fiEinheit
LEFT JOIN $tblbelegstatus ON $tblbelegstatus.id = $tblbelege.fiStatus

WHERE $tblbelege.fiKunde = $id ";

$anzahl_gesamt = get_table_count ( $query );

// Belegstatusfilter
if (is_array ( $filter [$listenname] ["belegstatus"] )) {
	$query .= filter_multiselect_return_query ( $filter [$listenname] ["belegstatus"], "$tblbelege.fiStatus" );
} else {
	$query .= " and $tblbelege.fiStatus < 900 ";
}

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and to_days(dtRechnungDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "')";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and to_days(dtRechnungDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "')";
	}
}

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sei dem SQL-String hinzu
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) > 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = liste_output_textfilter ( $listenzeile, $field_textfilter_active, $filter [$listenname] ["textfilter"] );
		
		// +++++++++++ Felder formatieren
		$liste_output [$listenzeile_id] ["dtEigeneArtikelNr"] = shortcutlink ( $liste_output [$listenzeile_id] ["dtEigeneArtikelNr"], "lagerartikel", "show", $liste_output [$listenzeile_id] ["Artikel_id"], $benutzerrechte );
		$liste_output [$listenzeile_id] ["dtArtikel"] = shortcutlink ( $liste_output [$listenzeile_id] ["dtArtikel"], "lagerartikel", "show", $liste_output [$listenzeile_id] ["Artikel_id"], $benutzerrechte );
		$liste_output [$listenzeile_id] ["dtBelegNr"] = shortcutlink ( $liste_output [$listenzeile_id] ["dtBelegNr"], "belege", "show", $liste_output [$listenzeile_id] ["Beleg_id"], $benutzerrechte );
		
		$liste_output [$listenzeile_id] ["dtRechnungDatum"] = date_from_sql ( $liste_output [$listenzeile_id] ["dtRechnungDatum"] );
		$liste_output [$listenzeile_id] ["dtMenge"] = mengenfeld ( $liste_output [$listenzeile_id] ["dtMenge"] ) . " " . $liste_output [$listenzeile_id] ["dtEinheit"];
		$liste_output [$listenzeile_id] ["dtPreisNettoSumme"] = preis_from_sql ( $liste_output [$listenzeile_id] ["dtPreisNettoSumme"] );
		
		// +++++++++++ Buttons hinzufgen
		$liste_output [$listenzeile_id] ["ButtonAnzeigen"] = detailbutton ( $liste_output [$listenzeile_id] ["Beleg_id"], "belege", $benutzerrechte );
	}
}

// Zeilen zum Listenobjekt hinzufgen
$oListe->addZeilen ( $liste_output );

?>