<?php
// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["lagerartikellisteanzeige"];

$anzahl_gesamt = listeanzahl_ermitteln ( $tblartikel );

$iQueryLaenge = strlen ( $query );

// Warengruppenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["warengruppe"], "$tblartikel.fiWarengruppe" );

// Lieferantenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["lieferant"], "$tblartikellieferanten.fiLieferant" );

// Lagerartikelaktivfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["lagerartikelaktiv"] == 2 ? "0" : $filter [$listenname] ["lagerartikelaktiv"], "$tblartikel.dtArtikelAktiv" );

// Volltextsuche
$query .= create_fulltext_index_search ( array (
		$tblartikel,
		$tblwarengruppen,
		$tblartikelhersteller,
		$tblartikellieferanten 
), $filter [$listenname] ["textfilter"] );

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sie dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

// erweiterung des SQL-Strings wenn nach Lieferanten gesucht wird
// if ($filter [$listenname] ["lieferant"] != "") {
// 	$query = str_replace ( "from " . $tblartikel, "from " . $tblartikel . " left join " . $tblartikellieferanten . " on " . $tblartikellieferanten . ".fiArtikel = " . $tblartikel . ".id", $query );
// }

$anzahl_ausgabe = get_table_count ( $query );

$query .= " group by tblArtikel.id " . $sortierung_sql . $limit_sql;

$liste = get_table_array ( $query );

/*
 * Zur Darstellung der VK Preise
 */

$query = $sql_query ["preisgruppenliste"];

$field_preisgruppen_array = get_table_array ( $query );
foreach ( ( array ) $field_preisgruppen_array as $key => $value ) {
	$preisgruppen_array [$value ["PreisGruppen_id"]] = $value;
}

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		if ($bZeigeLagerbestandInArtikelliste and $liste [$listenzeile_id] ["dtArtikelEinheitenArt"] != 2) {
			
 				$aVariantenListe = getArtikelVariantenKombinationenListe ( $liste [$listenzeile_id] ["Artikel_id"] );
 				if($aVariantenListe)
 				{
 					$iAnzahlVerfuegbar = 0;
 					$iAnzahlReserviert = 0;
 					$iAnzahlBestellt = 0;
 					for($i = 0; $i < count ( $aVariantenListe ); $i ++) {
 						$iAnzahlVerfuegbar += getArtikelAnzahlVerfuegbar ( $liste [$listenzeile_id] ["Artikel_id"], 0, $aVariantenListe[$i] );
 						$iAnzahlReserviert += getArtikelAnzahlVerfuegbar ( $liste [$listenzeile_id] ["Artikel_id"], 0, $aVariantenListe[$i], 0, 1 );
 						$iAnzahlBestellt += getArtikelAnzahlVerfuegbar ( $liste [$listenzeile_id] ["Artikel_id"], 0, $aVariantenListe[$i], 0, 2 );
 					}		
 				}else 
 				{
 					$iAnzahlVerfuegbar = getArtikelAnzahlVerfuegbar ( $liste [$listenzeile_id] ["Artikel_id"], 0, "stammdaten" );
 					$iAnzahlReserviert = getArtikelAnzahlVerfuegbar ( $liste [$listenzeile_id] ["Artikel_id"], 0, "stammdaten", 0, 1 );
 					$iAnzahlBestellt = getArtikelAnzahlVerfuegbar ( $liste [$listenzeile_id] ["Artikel_id"], 0, "stammdaten", 0, 2 );
 					
 				}
					


		}
		
		// +++++++++++ Cache
		
		$cache = CacheListe_getFromCache ( $target, $typ, $liste [$listenzeile_id] ["Artikel_id"], $tblartikel, $liste [$listenzeile_id] );
		
		if ($cache !== false) {
			$liste_output [$listenzeile_id] = $cache;
			
			if ($me == "lws" || $me == "develop") {
				$qArtikellieferant = "SELECT dtArtikelNrFremd, fiLieferant, dtStueckPreisEK FROM $tblartikellieferanten WHERE  	dtLieferantIstHauptlieferant = 1 AND fiArtikel = " . $listenzeile ["Artikel_id"];
				$rArtikellieferant = get_table_row ( $qArtikellieferant );
				
				$rLieferant = get_table_row ( "SELECT dtFirmenname FROM $tblkontakte WHERE id = " . $rArtikellieferant ['fiLieferant'] . "" );
				
				$liste_output [$listenzeile_id] ["dtLieferant"] = $rLieferant ["dtFirmenname"];
				$liste_output [$listenzeile_id] ["dtFremdartikelNr"] = $rArtikellieferant ["dtArtikelNrFremd"];
				$liste_output [$listenzeile_id] ["dtLieferantEk"] = preis_from_sql ( $rArtikellieferant ["dtStueckPreisEK"] );
			}
			
			if ($bZeigeLagerbestandInArtikelliste) {
				if ($liste [$listenzeile_id] ["dtArtikelEinheitenArt"] == 2) // Virtuell
{
					$liste_output [$listenzeile_id] ["dtAnz"] = "(virtuell)";
				} elseif ($liste [$listenzeile_id] ["dtArtikelEinheitenArt"] == 1) // Massengut
{
					$aRow = get_table_row ( "SELECT SUM(dtStueckMenge) as summe FROM $tblartikelstueck WHERE fiArtikel = " . $liste [$listenzeile_id] ["Artikel_id"] );
					
					$liste_output [$listenzeile_id] ["dtAnz"] = "<span title=\"Auf Lager / Eingekauft\">" . double_from_sql ( $iAnzahlVerfuegbar, 2 ) . " / " . double_from_sql ( $aRow ["summe"], 2 ) . "</span>";
				} else // Stckgut
{
					$liste_output [$listenzeile_id] ["dtAnz"] = "<span title=\"Auf Lager / Eingekauft\">" . $iAnzahlVerfuegbar . " / " . $row_eingekauft ["Anzahl"] . "</span>";
				}
			}
			
			continue;
		}
		
		if ($me == "lws" || $me == "develop") {
			$qArtikellieferant = "SELECT dtArtikelNrFremd, fiLieferant, dtStueckPreisEK FROM $tblartikellieferanten WHERE  	dtLieferantIstHauptlieferant = 1 AND fiArtikel = " . $listenzeile ["Artikel_id"];
			$rArtikellieferant = get_table_row ( $qArtikellieferant );
			
			$rLieferant = get_table_row ( "SELECT dtFirmenname FROM $tblkontakte WHERE id = " . $rArtikellieferant ['fiLieferant'] . "" );
			
			$liste_output [$listenzeile_id] ["dtLieferant"] = $rLieferant ["dtFirmenname"];
			$liste_output [$listenzeile_id] ["dtFremdartikelNr"] = $rArtikellieferant ["dtArtikelNrFremd"];
			$liste_output [$listenzeile_id] ["dtFremdartikelNr"] = $rArtikellieferant ["dtArtikelNrFremd"];
			$liste_output [$listenzeile_id] ["dtLieferantEk"] = preis_from_sql ( $rArtikellieferant ["dtStueckPreisEK"] );
		}
		
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = liste_output_textfilter_markieren ( $listenzeile, $field_textfilter_active, $filter [$target] ["textfilter"] );
		
		if ($bZeigeLagerbestandInArtikelliste) {
			if ($liste [$listenzeile_id] ["dtArtikelEinheitenArt"] == 2) // Virtuell
{
				$liste_output [$listenzeile_id] ["dtAnz"] = "(virtuell)";
			} elseif ($liste [$listenzeile_id] ["dtArtikelEinheitenArt"] == 1) // Massengut
{
				$aRow = get_table_row ( "SELECT SUM(dtStueckMenge) as summe FROM $tblartikelstueck WHERE fiArtikel = " . $liste [$listenzeile_id] ["Artikel_id"] );
				
				$liste_output [$listenzeile_id] ["dtAnz"] = "<span title=\"Bestand aktuell/reserviert/bestellt\">";
				$liste_output [$listenzeile_id] ["dtAnz"] .= mengenfeld ( $iAnzahlVerfuegbar ) . " / " . mengenfeld ( $iAnzahlReserviert ) . " / " . mengenfeld ( $iAnzahlBestellt ) . "</span>";
			} else // Stckgut
{
				$liste_output [$listenzeile_id] ["dtAnz"] = "<span title=\"Bestand aktuell/reserviert/bestellt\">";
				$liste_output [$listenzeile_id] ["dtAnz"] .= ( int ) $iAnzahlVerfuegbar . " / " . ( int ) $iAnzahlReserviert . " / " . ( int ) $iAnzahlBestellt . "</span>";
			}
		}
		
		$liste_output [$listenzeile_id] ["dtVK"] = "</div><div style='text-align: right;'>" . preis_from_sql ( $liste_output [$listenzeile_id] ["dtPreisVK1"] ) . "&nbsp;";
		
		/*
		 * Info Box VK Preise Anfang
		 */
		$liste_output [$listenzeile_id] ["dtVK"] .= aufzuklappbutton ( $liste [$listenzeile_id] ["Artikel_id"], "" );
		$liste_output [$listenzeile_id] ["dtVK"] .= "<div style=\"position: absolute;\">";
		$liste_output [$listenzeile_id] ["dtVK"] .= "<div style=\"position: relative; left: -100px; display:none; z-index:350;\" id='" . $liste [$listenzeile_id] ["Artikel_id"] . "' class=\"" . $historyboxclass . "\" onClick=\"this.style.display = 'none';\" >";
		$liste_output [$listenzeile_id] ["dtVK"] .= "<table border=0 cellspacing=5 cellpadding=0 class=\"text\" style=\"background-color: " . $bgcolor_formular . ";\">";
		
		for($i = 1; $i <= 5; $i ++) {
			if ($preisgruppen_array [$i] ["dtBezeichnung"] != "") {
				$vkpreis_text [$i] = "VK Preis $i (" . $preisgruppen_array [$i] ["dtBezeichnung"] . ")";
			} else {
				$vkpreis_text [$i] = "VK Preis $i";
			}
		}
		
		for($i = 1; $i <= 5; $i ++) {
			$liste_output [$listenzeile_id] ["dtVK"] .= formular_text ( $vkpreis_text [$i], "dtPreisVK" . $i, preis_from_sql ( $liste_output [$listenzeile_id] ["dtPreisVK" . $i] ), "input_text_100", "readonly", "text-align: right;" );
			$liste_output [$listenzeile_id] ["dtVK"] .= "</tr><tr>";
		}
		
		$liste_output [$listenzeile_id] ["dtVK"] .= formular_text ( "Mwst Satz VK", "dtMwstSatzVK", double_from_sql ( $liste_output [$listenzeile_id] ["dtMwstSatzVK"], 0 ), "input_text_100", "readonly", "text-align: right;" );
		
		$liste_output [$listenzeile_id] ["dtVK"] .= "</table></div></div></div>";
		/*
		 * Info Box VK Preise Ende
		 */
		
		/*
		 * Letzter EK
		 */
		if ($bZeigeLagerbestandInArtikelliste) {
			$dLetzterEK = getArtikelEK ( $liste [$listenzeile_id] ["Artikel_id"] );
			$liste_output [$listenzeile_id] ["dtEkLetzter"] = preis_from_sql ( $dLetzterEK );
		}
		
		/*
		 * berschsse
		 */
		unset ( $sUeberschussVK );
		if ($bZeigeLagerbestandInArtikelliste and $bZeigeUeberschussInArtikelliste and $dLetzterEK != 0) {
			
			for($i = 1; $i <= 5; $i ++) {
				if ($dLetzterEK != 0) {
					$dUeberschussVK [$i] = ($liste_output [$listenzeile_id] ["dtPreisVK" . $i] / $dLetzterEK * 100) - 100;
				}
				$sUeberschussVK [$i] = double_from_sql ( $dUeberschussVK [$i], 2 ) . " %";
			}
			
			$liste_output [$listenzeile_id] ["dtUeberschuss"] = double_from_sql ( $dUeberschussVK [1], 2 ) . " %";
			
			if ($dUeberschussVK [1] <= 0) {
				$liste_output [$listenzeile_id] ["dtUeberschuss"] = "<span style=\"background-color: " . $bgcolor_formular_rot . ";\">" . $liste_output [$listenzeile_id] ["dtUeberschuss"] . "</span>";
			} else if ($dUeberschussVK [1] <= $dArtikelueberschussAnzeigeschwelleGelb) {
				$liste_output [$listenzeile_id] ["dtUeberschuss"] = "<span style=\"background-color: " . $bgcolor_formular_gelb . ";\">" . $liste_output [$listenzeile_id] ["dtUeberschuss"] . "</span>";
			}
			
			/*
			 * Info Box VK berschsse Anfang
			 */
			$liste_output [$listenzeile_id] ["dtUeberschussInfobox"] = aufzuklappbutton ( $liste [$listenzeile_id] ["Artikel_id"] . "_Ueberschuss", "" );
			$liste_output [$listenzeile_id] ["dtUeberschussInfobox"] .= "<div style=\"position: absolute;\">";
			$liste_output [$listenzeile_id] ["dtUeberschussInfobox"] .= "<div style=\"position: relative; left: 100px; display:none; z-index:350;\" id='" . $liste [$listenzeile_id] ["Artikel_id"] . "_Ueberschuss' class=\"" . $historyboxclass . "\" onClick=\"this.style.display = 'none';\" >";
			$liste_output [$listenzeile_id] ["dtUeberschussInfobox"] .= "<table border=0 cellspacing=5 cellpadding=0 class=\"text\" style=\"background-color: " . $bgcolor_formular . ";\">";
			
			for($i = 1; $i <= 5; $i ++) {
				if ($preisgruppen_array [$i] ["dtBezeichnung"] != "") {
					$vkpreis_text [$i] = "berschuss VK Preis $i (" . $preisgruppen_array [$i] ["dtBezeichnung"] . ")";
				} else {
					$vkpreis_text [$i] = "berschuss VK Preis $i";
				}
			}
			
			for($i = 1; $i <= 5; $i ++) {
				
				$sUeberschussStyle = "";
				if ($dUeberschussVK [$i] <= 0)
					$sUeberschussStyle = "background-color: " . $bgcolor_formular_rot;
				else if ($dUeberschussVK [$i] <= $dArtikelueberschussAnzeigeschwelleGelb)
					$sUeberschussStyle = "background-color: " . $bgcolor_formular_gelb;
				
				$liste_output [$listenzeile_id] ["dtUeberschussInfobox"] .= formular_text ( $vkpreis_text [$i], "dtUeberschussVK" . $i, $sUeberschussVK [$i], "input_text_100", "readonly", "text-align: right;" . $sUeberschussStyle );
				$liste_output [$listenzeile_id] ["dtUeberschussInfobox"] .= "</tr><tr>";
			}
			
			$liste_output [$listenzeile_id] ["dtUeberschussInfobox"] .= "</table></div></div></div>";
			/*
			 * Info Box VK Preise Ende
			 */
			
			$liste_output [$listenzeile_id] ["dtUeberschuss"] = "</div><div style='text-align: right;'>" . $liste_output [$listenzeile_id] ["dtUeberschuss"] . "&nbsp;" . $liste_output [$listenzeile_id] ["dtUeberschussInfobox"];
		}
		
		/*
		 * Wenn Liste != HTML dann VK Felder fr Ausgabe formatieren
		 */
		if (get_class ( $oListe ) != "ListeHTML") {
			$liste_output [$listenzeile_id] ["dtPreisVK1"] = preis_from_sql ( $liste_output [$listenzeile_id] ["dtPreisVK1"], "PDF" );
			$liste_output [$listenzeile_id] ["dtPreisVK2"] = preis_from_sql ( $liste_output [$listenzeile_id] ["dtPreisVK2"], "PDF" );
			$liste_output [$listenzeile_id] ["dtPreisVK3"] = preis_from_sql ( $liste_output [$listenzeile_id] ["dtPreisVK3"], "PDF" );
			$liste_output [$listenzeile_id] ["dtPreisVK4"] = preis_from_sql ( $liste_output [$listenzeile_id] ["dtPreisVK4"], "PDF" );
			$liste_output [$listenzeile_id] ["dtPreisVK5"] = preis_from_sql ( $liste_output [$listenzeile_id] ["dtPreisVK5"], "PDF" );
			
			$liste_output [$listenzeile_id] ["dtUeberschuss1"] = $sUeberschuss [1];
			$liste_output [$listenzeile_id] ["dtUeberschuss2"] = $sUeberschuss [2];
			$liste_output [$listenzeile_id] ["dtUeberschuss3"] = $sUeberschuss [3];
			$liste_output [$listenzeile_id] ["dtUeberschuss4"] = $sUeberschuss [4];
			$liste_output [$listenzeile_id] ["dtUeberschuss5"] = $sUeberschuss [5];
		}
		
		// +++++++++++ Buttons hinzufgen
		$liste_output [$listenzeile_id] ["ButtonAnzeigen"] = detailbutton ( $liste [$listenzeile_id] ["Artikel_id"], $target, $benutzerrechte );
		$liste_output [$listenzeile_id] ["ButtonKopieren"] = kopierenbutton ( $liste [$listenzeile_id] ["Artikel_id"], $target, $benutzerrechte );
		$liste_output [$listenzeile_id] ["ButtonLoeschen"] = loeschenbutton ( $liste [$listenzeile_id] ["Artikel_id"], $target, $benutzerrechte );
		
		// +++++++++++ Cache
		CacheListe_writeIntoCache ( $target, $typ, $liste [$listenzeile_id] ["Artikel_id"], $tblartikel, $listenzeile, $liste_output [$listenzeile_id] );
	}
}

unset ( $aArtikelVorhanden );

// Zeilen zum Listenobjekt hinzufgen
$oListe->addZeilen ( $liste_output );

?>