<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenkopfzeile
listenkopf ( $listenname, $sort_fields, $field_headlines, $field_width, $field_sort_options, $sortierung [$listenname], $target, $typ, $id, $subtarget, $subtyp );

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["artikelstueckliste"];
$query .= " and $tblartikelstueck.fiArtikel = " . $id . " and ($tblartikelstueck.fiBeleg != 0 or $tblartikelstueck.fiBelegVerbrauch != 0) ";

$anzahl_gesamt = get_table_count ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["belegmaterialpostenliste"];
$query .= " and $tblbelegmaterialposten.fiArtikel = " . $id;

$anzahl_gesamt = get_table_count ( $query );

// Projekt-Filter
if ($filter [$listenname] ["projekt"] != "") {
	$query .= " and $tblartikelstueck.fiProjekt = " . $filter [$listenname] ["projekt"] . " ";
}

// Rechnung-Filter
if ($filter [$listenname] ["rechnung"] != "") {
	$query .= " and $tblartikelstueck.fiRechnung = " . $filter [$listenname] ["rechnung"] . " ";
}

// Beleg-Filter
if ($filter [$listenname] ["beleg"] != "") {
	$query .= " and ($tblbelegmaterialposten.fiBeleg = " . $filter [$listenname] ["beleg"] . ") ";
}

// Volltextsuche
$query .= create_fulltext_index_search ( array (
		$tblartikel,
		$tblbelege,
		$tblbelegmaterialposten,
		$tblartikeleinheiten,
		$tblartikelkonten 
), $filter [$listenname] ["textfilter"] );

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sie dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = liste_output_textfilter_markieren ( $listenzeile, $field_textfilter_active, $filter [$subtarget] ["textfilter"] );
		
		// +++++++++++ Eingabefelder erzeugen
		$liste_output [$listenzeile_id] ["id"] = input_hidden ( "target", $target );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "typ", $typ );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "id", $liste [$listenzeile_id] ["Artikel_id"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subtarget", $subtarget );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subtyp", "send" );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subid", $liste [$listenzeile_id] ["ArtikelStueck_id"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "referer", $typ );
		
		$liste_output [$listenzeile_id] ["dtSeriennummer"] = input_text ( "Seriennummer", "dtSeriennummer", $liste [$listenzeile_id] ["dtSeriennummer"], "input_text_150" );
		$liste_output [$listenzeile_id] ["dtProjektNr"] = shortcutlink ( format_name_html ( $liste_output [$listenzeile_id] ["dtProjektNr"] ), "projekte", "show", $liste_output [$listenzeile_id] ["Projekt_id"], $benutzerrechte, "projektartikel", "list" );
		$liste_output [$listenzeile_id] ["dtKontaktDDText"] = shortcutlink ( format_name_html ( $liste_output [$listenzeile_id] ["dtKontaktDDText"] ), "lieferanten", "show", $liste_output [$listenzeile_id] ["Kontakte_id"], $benutzerrechte );
		$liste_output [$listenzeile_id] ["dtRechnungNrIntern"] = shortcutlink ( format_name_html ( $liste_output [$listenzeile_id] ["dtRechnungNrIntern"] ), "rechnungen", "show", $liste_output [$listenzeile_id] ["Rechnung_id"], $benutzerrechte );
		
		if ($liste_output [$listenzeile_id] ["fiBeleg"] != 0) {
			$liste_output [$listenzeile_id] ["dtBelegNr"] = shortcutlink ( format_name_html ( $liste_output [$listenzeile_id] ["dtBelegNr"] . " / P" ), "belege", "show", $liste_output [$listenzeile_id] ["Beleg_id"], $benutzerrechte, "belegmaterialposten", "show" );
		} elseif ($liste_output [$listenzeile_id] ["fiBelegVerbrauch"] != 0) {
			$belegquery = $sql_query ["belegliste"] . " and $tblbelege.id = " . $liste_output [$listenzeile_id] ["fiBelegVerbrauch"];
			$belegrow = get_table_row ( $belegquery );
			$liste_output [$listenzeile_id] ["dtBelegNr"] = shortcutlink ( format_name_html ( $belegrow ["dtBelegNr"] . " / V" ), "belege", "show", $belegrow ["Beleg_id"], $benutzerrechte, "belegmaterialverbrauch", "show" );
		}
		
		$liste_output [$listenzeile_id] ["dtLagerName"] = shortcutlink ( format_name_html ( $liste_output [$listenzeile_id] ["dtLagerName"] . " | " . $liste_output [$listenzeile_id] ["dtLagerPosition"] ), "lagerorte", "show", "1", $benutzerrechte );
		
		$liste_output [$listenzeile_id] ["dtPreisNettoEK"] = preis_from_sql ( $liste_output [$listenzeile_id] ["dtPreisNettoEK"] );
		$liste_output [$listenzeile_id] ["dtMwstNettoEK"] = double_from_sql ( $liste_output [$listenzeile_id] ["dtMwstNettoEK"], 0 ) . " %";
	}
}

// ++++++++++++++++++++++++++++++++
// +++++++++++ Liste ausgeben
$anzahl = liste_output ( $liste_output, $show_fields, $field_width, $field_colors, $listenhoehe, $target, $typ, "", "", "", "", $field_parameter );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenfusszeile
listenfuss ( $listenname, $field_width, $sortierung [$listenname], $anzahl, $anzahl_ausgabe, $anzahl_gesamt, $target, $typ, $id, $subtarget, $subtyp );

?>