<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["mitarbeiterliste"] . " and $tblkontakte.dtIstMitarbeiter = 1";

// Mitarbeiteraktiv-Filter
if ($filter [$listenname] ["mitarbeiteraktiv"] == 1) {
	$query .= " and $tblkontakte.dtAktiv = 1 ";
}
if ($filter [$listenname] ["mitarbeiteraktiv"] == 2) {
	$query .= " and $tblkontakte.dtAktiv = 0 ";
}

// Rechte
$rechte_sql = "";
if ($benutzerrechte [$target] ["zugriffsart"] != 0) {
	$rechte_sql = " and $tblkontakte.id = " . $_SESSION ['benutzerkontaktid'];
}

// Benutzergruppenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["benutzergruppe"], "$tblkontakte.fiBenutzergruppe" );

// Lnderfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["laender"], "$tblkontakte.fiLand" );

// Volltextsuche
$query .= create_fulltext_index_search ( array (
		$tblkontakte,
		$tbllaender 
), $filter [$listenname] ["textfilter"] );

$anzahl_gesamt = get_table_count ( $query . $rechte_sql );

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sei dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "" and $filter [$listenname] ["textfilter"] == "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$liste = get_table_array ( $query . $rechte_sql . $sortierung_sql . $limit_sql );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ entferne Leerzeilen aus Namensfeld
		$listenzeile ["dtName_Anzeige"] = format_name_html ( $listenzeile ["dtName_Anzeige"] );
		
		// +++++++++++ entferne alle nicht-Ziffern aus Telefonnummer f. Suche
		$listenzeile ["dtTelefonSuche"] = format_string_allowed_chars ( $listenzeile ["dtTelefon"], array (
				"0",
				"1",
				"2",
				"3",
				"4",
				"5",
				"6",
				"7",
				"8",
				"9" 
		) );
		$listenzeile ["dtMobilSuche"] = format_string_allowed_chars ( $listenzeile ["dtMobil"], array (
				"0",
				"1",
				"2",
				"3",
				"4",
				"5",
				"6",
				"7",
				"8",
				"9" 
		) );
		
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = liste_output_textfilter_markieren ( $listenzeile, $field_textfilter_active, $filter [$listenname] ["textfilter"] );
		
		// +++++++++++ Zeile durch Abteilungfilter laufen lassen
		if ($filter [$listenname] ["abteilung"] != "") {
			$personaldaten_query = $sql_query ["personaldatenliste"] . " and $tblpersonaldaten.fiKontaktNr = " . $liste [$listenzeile_id] ["Kontakte_id"];
			$personaldaten_query .= " and $tblpersonaldaten.fiAbteilung = " . $filter [$listenname] ["abteilung"];
			if (get_table_count ( $personaldaten_query ) != 0) {
				$liste_output [$listenzeile_id] ["Textfilter"] = "";
			} else {
				$liste_output [$listenzeile_id] ["Textfilter"] = "nomatch";
			}
		}
		
		$liste_output [$listenzeile_id] ["dtGeburtsdatum"] = date_from_sql ( $liste [$listenzeile_id] ["dtGeburtsdatum"] );
		$liste_output [$listenzeile_id] ["dtGleitzeitkontoMinuten"] = min_to_stdmin ( $liste [$listenzeile_id] ["dtGleitzeitkontoMinuten"] );
		
		if ($liste [$listenzeile_id] ["dtAktiv"] == 0) {
			$liste_output [$listenzeile_id] ["dtGleitzeitkontoMinuten"] = "";
			$liste_output [$listenzeile_id] ["dtResturlaub"] = "";
		}
		
		// +++++++++++ Buttons hinzufgen
		$liste_output [$listenzeile_id] ["ButtonAnzeigen"] = detailbutton ( $liste [$listenzeile_id] ["Kontakte_id"], $target, $benutzerrechte );
		$liste_output [$listenzeile_id] ["ButtonKopieren"] = kopierenbutton ( $liste [$listenzeile_id] ["Kontakte_id"], $target, $benutzerrechte );
		$liste_output [$listenzeile_id] ["ButtonLoeschen"] = loeschenbutton ( $liste [$listenzeile_id] ["Kontakte_id"], $target, $benutzerrechte );
	}
}

// Zeilen zum Listenobjekt hinzufgen
$oListe->addZeilen ( $liste_output );

?>