<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["artikelstuecklistegrouped-negativ"];
$query .= " and $tblartikelstuecknegativ.fiProjekt =  " . $id;
$anzahl_gesamt = get_table_count ( $query );

// Lieferantenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["lieferant"], "$tblartikelstuecknegativ.fiLieferant" );

// Lagerort-Filter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["lagerort"], "$tblartikelstuecknegativ.fiLagerOrt" );

// Projekt-Filter
if ($filter [$listenname] ["projekt"] != "") {
	$query .= " and $tblartikelstuecknegativ.fiProjekt = " . $filter [$listenname] ["projekt"] . " ";
}

// Rechnung-Filter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["rechnung"], "$tblartikelstuecknegativ.fiRechnung" );

// Beleg-Filter
if ($filter [$listenname] ["beleg"] != "") {
	if (in_array ( "-1", $filter [$listenname] ["beleg"] )) {
		$query .= " and ($tblartikelstuecknegativ.fiBeleg = 0 and $tblartikelstuecknegativ.fiBelegVerbrauch = 0) ";
	}
	if (in_array ( "-2", $filter [$listenname] ["beleg"] )) {
		$query .= " and ($tblartikelstuecknegativ.fiBeleg != 0 or $tblartikelstuecknegativ.fiBelegVerbrauch != 0) ";
	}
	$query .= filter_multiselect_return_query ( $filter [$listenname] ["beleg"], "$tblartikelstuecknegativ.fiBeleg", false, false, "$tblartikelstueck.fiBelegVerbrauch", array (
			"-1",
			"-2" 
	) );
}

// Volltextsuche
$query .= create_fulltext_index_search ( array (
		$tblartikel,
		$tblartikelstuecknegativ,
		$tblwarengruppen,
		$tblprojekte,
		$tblkontakte,
		$tblbelege,
		$tblrechnungen 
), $filter [$listenname] ["textfilter"] );

// Gruppierung
$query .= " GROUP BY $tblartikelstuecknegativ.fiArtikel, $tblartikelstuecknegativ.dtVariante, $tblartikelstuecknegativ.fiBeleg";

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sie dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = liste_output_textfilter_markieren ( $listenzeile, $field_textfilter_active, $filter [$subtarget] ["textfilter"] );
		
		// +++++++++++ Cache
		$cache = CacheListe_getFromCache ( $subtarget, $subtyp, $liste [$listenzeile_id] ["Artikel_id"], $tblartikelstuecknegativ, $listenzeile );
		if ($cache !== false) {
			$liste_output [$listenzeile_id] = $cache;
			continue;
		}
		
		/*
		 * Variantenbox aufbauen
		 */
		if (! empty ( $liste_output [$listenzeile_id] ["dtVariante"] )) {
			unset ( $artikelvarianten_array );
			$varianten_output = "";
			
			$query = $sql_query ["artikelvariantenliste"] . " and $tblartikelvarianten.fiArtikel = " . $listenzeile ["Artikel_id"];
			if (get_table_count ( $query ) > 0) {
				
				// aktuelle Varianteninfo
				$akt_varianten = unserialize ( $listenzeile ["dtVariante"] );
				
				// hole Artikelvariantendaten
				$artikelvarianten_liste = get_table_array ( $query );
				
				// baue Variantenarray auf
				foreach ( ( array ) $artikelvarianten_liste as $key => $value ) {
					$artikelvarianten_array [$value ["fiArtikelVariantenGruppe"]] [$value ["Variante_id"]] = $value;
				}
				
				$boxname = "variante_" . $listenzeile_id;
				
				$varianten_output .= "<div style=\"position: absolute; z-index:5000;\">";
				$varianten_output .= "<div style=\"position: relative;  top: 0px; left: 0px; display:none; \" id='" . $boxname . "' class=\"" . $historyboxclass . "\">";
				$varianten_output .= "<table border=0 cellspacing=5 cellpadding=0 class=\"text\" style=\"background-color: " . $bgcolor_formular . ";\">";
				$varianten_output .= "<tr>";
				
				foreach ( ( array ) $artikelvarianten_array as $vgruppe => $artikelvarianten_gruppe ) {
					
					unset ( $array );
					foreach ( ( array ) $artikelvarianten_gruppe as $variantenid => $vrow ) {
						
						if ($vrow ["dtGruppenMehrfachauswahl"] != 1 && $vrow ["dtGruppenZwangsauswahl"] != 1) {
							$array [- 1] = "-------------------";
						}
						
						if ($vrow ["dtArtikelVariantenPreisEinheit"] == 0) {
							$preisdiff1 = double_from_sql ( $vrow ["dtArtikelVariantenPreisdiffVK1"], 2 ) . " %";
							$preisdiff2 = double_from_sql ( $vrow ["dtArtikelVariantenPreisdiffVK2"], 2 ) . " %";
							$preisdiff3 = double_from_sql ( $vrow ["dtArtikelVariantenPreisdiffVK3"], 2 ) . " %";
							$preisdiff4 = double_from_sql ( $vrow ["dtArtikelVariantenPreisdiffVK4"], 2 ) . " %";
							$preisdiff5 = double_from_sql ( $vrow ["dtArtikelVariantenPreisdiffVK5"], 2 ) . " %";
						} else if ($vrow ["dtArtikelVariantenPreisEinheit"] == 1) {
							$preisdiff1 = preis_from_sql ( $vrow ["dtArtikelVariantenPreisdiffVK1"] );
							$preisdiff2 = preis_from_sql ( $vrow ["dtArtikelVariantenPreisdiffVK2"] );
							$preisdiff3 = preis_from_sql ( $vrow ["dtArtikelVariantenPreisdiffVK3"] );
							$preisdiff4 = preis_from_sql ( $vrow ["dtArtikelVariantenPreisdiffVK4"] );
							$preisdiff5 = preis_from_sql ( $vrow ["dtArtikelVariantenPreisdiffVK5"] );
						}
						
						if (substr ( $preisdiff1, 0, 1 ) != "-")
							$preisdiff1 = "+" . $preisdiff1;
						if (substr ( $preisdiff2, 0, 1 ) != "-")
							$preisdiff2 = "+" . $preisdiff2;
						if (substr ( $preisdiff3, 0, 1 ) != "-")
							$preisdiff3 = "+" . $preisdiff3;
						if (substr ( $preisdiff4, 0, 1 ) != "-")
							$preisdiff4 = "+" . $preisdiff4;
						if (substr ( $preisdiff5, 0, 1 ) != "-")
							$preisdiff5 = "+" . $preisdiff5;
						
						$array [$variantenid] = $vrow ["dtArtikelVariantenNr"] . " | " . $vrow ["dtArtikelVariantenName"];
						$array [$variantenid] .= " | VK1: " . $preisdiff1;
						$array [$variantenid] .= " | VK2: " . $preisdiff2;
						$array [$variantenid] .= " | VK3: " . $preisdiff3;
						$array [$variantenid] .= " | VK4: " . $preisdiff4;
						$array [$variantenid] .= " | VK5: " . $preisdiff5;
					}
					
					$aVariantenOptionen = array ();
					if ($vrow ["dtGruppenMehrfachauswahl"] == 1) {
						$aVariantenOptionen [] = "Mehrfachauswahl";
					}
					
					if ($vrow ["dtGruppenZwangsauswahl"] == 1) {
						$aVariantenOptionen [] = "Zwangsauswahl";
					}
					
					if (count ( $aVariantenOptionen ) > 0) {
						$sVName = $vrow ["dtGruppenName"] . "<br>(" . join ( " |<br>", $aVariantenOptionen ) . ")";
					} else {
						$sVName = $vrow ["dtGruppenName"];
					}
					
					if ($vrow ["dtGruppenMehrfachauswahl"] != 1) {
						$varianten_output .= formular_dropdownbox_array ( $sVName, $array, "variante_" . $vrow ["fiArtikelVariantenGruppe"], $akt_varianten ["variante_" . $vrow ["fiArtikelVariantenGruppe"]], "input_select_250", "readonly" );
					} else {
						$akt_varianten_array = explode ( ";", $akt_varianten ["variante_" . $vrow ["fiArtikelVariantenGruppe"]] );
						$varianten_output .= formular_dropdownbox_array ( $sVName, $array, "variante_" . $vrow ["fiArtikelVariantenGruppe"] . "[]", $akt_varianten_array, "input_select_250", "multiple size=5 readonly" );
					}
					$varianten_output .= "</tr><tr>";
				}
				
				$varianten_output .= "<td colspan=10><hr></td></tr><tr>";
				
				$variante_artikelnummer = $liste_output [$listenzeile_id] ["dtEigeneArtikelNr"] . $liste_output [$listenzeile_id] ["dtVarianteArtNr"];
				$varianten_output .= formular_text ( "Artikelnummer", "VariantenArtikelnummer", $variante_artikelnummer, "input_text_250", "readonly" );
				$varianten_output .= "</tr><tr>";
				$varianten_output .= formular_textarea ( "Beschreibung", "VariantenBeschreibung", $liste_output [$listenzeile_id] ["dtVarianteArtName"], "input_textarea_250x50", "wrap=virtual readonly" );
				$varianten_output .= "</tr></table></div></div>";
				
				$varianten_output .= input_hidden ( "dtVariante", $liste_output [$listenzeile_id] ["dtVariante"] );
			}
		}
		
		$iAnzahlVerfuegbar = getArtikelAnzahlVerfuegbar ( $liste [$listenzeile_id] ["fiArtikel"], 0, $liste_output [$listenzeile_id] ["dtVariante"] );
		$iAnzahlReserviert = getArtikelAnzahlVerfuegbar ( $liste [$listenzeile_id] ["fiArtikel"], 0, $liste_output [$listenzeile_id] ["dtVariante"], 0, 1 );
		$iAnzahlBestellt = getArtikelAnzahlVerfuegbar ( $liste [$listenzeile_id] ["fiArtikel"], 0, $liste_output [$listenzeile_id] ["dtVariante"], 0, 2 );
		
		$iArtikelTyp = getArtikelTyp ( $liste [$listenzeile_id] ["Artikel_id"] );
		
		if ($iArtikelTyp == 2)
			$liste_output [$listenzeile_id] ["dtBestand"] = "(virtuell)";
		else
			$liste_output [$listenzeile_id] ["dtBestand"] = mengenfeld ( $iAnzahlVerfuegbar ) . " / " . mengenfeld ( $iAnzahlReserviert ) . " / " . mengenfeld ( $iAnzahlBestellt );
			
			// +++++++++++ entferne Leerzeilen aus Namensfeld
		$listenzeile ["dtLieferant_Anzeige"] = format_name_html ( $listenzeile ["dtLieferant_Anzeige"] );
		
		if ($listenzeile ["dtArtikelEinheitenArt"] == 1) 		// Massengut
		{
			$liste_output [$listenzeile_id] ["dtMenge"] = double_from_sql ( $listenzeile ["dtMassenMenge"], 2 );
		}
		
		// +++++++++++ Eingabefelder erzeugen
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "target", $target );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "typ", $typ );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "id", $id );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subtarget", $subtarget );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subtyp", "send" );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subid", $liste [$listenzeile_id] ["ArtikelStueck_id"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "fiArtikel", $liste [$listenzeile_id] ["fiArtikel"] );
		
		$liste_output [$listenzeile_id] ["dtWarengruppe"] = shortcutlink ( format_name_html ( $liste_output [$listenzeile_id] ["dtWarengruppe"] ), "warengruppen", "show", "1", $benutzerrechte );
		$liste_output [$listenzeile_id] ["dtEigeneArtikelNr"] = shortcutlink ( format_name_html ( $liste_output [$listenzeile_id] ["dtEigeneArtikelNr"] ), "lagerartikel", "show", $liste_output [$listenzeile_id] ["fiArtikel"], $benutzerrechte, "", "", "", $liste_output [$listenzeile_id] ["dtArtikel"] . " " . $liste_output [$listenzeile_id] ["dtFabrikat"] );
		$liste_output [$listenzeile_id] ["dtArtikel"] = shortcutlink ( format_name_html ( $liste_output [$listenzeile_id] ["dtArtikel"] ), "lagerartikel", "show", $liste_output [$listenzeile_id] ["fiArtikel"], $benutzerrechte, "", "", "", $liste_output [$listenzeile_id] ["dtArtikel"] . " " . $liste_output [$listenzeile_id] ["dtFabrikat"] );
		
		if (! empty ( $liste_output [$listenzeile_id] ["dtVariante"] ) && unserialize ( $liste_output [$listenzeile_id] ["dtVariante"] )) {
			$liste_output [$listenzeile_id] ["dtVariante"] = klickbutton ( "anzeigen", "title='" . str_replace ( "\n", ", ", $liste_output [$listenzeile_id] ["dtVarianteArtName"] ) . "' onclick='$(\"#" . $boxname . "\").toggle();'" );
			$liste_output [$listenzeile_id] ["dtVariante"] .= $varianten_output;
		} else {
			$liste_output [$listenzeile_id] ["dtVariante"] = "";
		}
		
		if ($liste_output [$listenzeile_id] ["fiBeleg"] != 0) {
			$liste_output [$listenzeile_id] ["dtBelegNr"] = shortcutlink ( format_name_html ( $liste_output [$listenzeile_id] ["dtBelegNr"] . " / P" ), "belege", "show", $liste_output [$listenzeile_id] ["Beleg_id"], $benutzerrechte, "belegmaterialposten", "show" );
		} elseif ($liste_output [$listenzeile_id] ["fiBelegVerbrauch"] != 0) {
			$belegquery = $sql_query ["belegliste"] . " and $tblbelege.id = " . $liste_output [$listenzeile_id] ["fiBelegVerbrauch"];
			$belegrow = get_table_row ( $belegquery );
			$liste_output [$listenzeile_id] ["dtBelegNr"] = shortcutlink ( format_name_html ( $belegrow ["dtBelegNr"] . " / V" ), "belege", "show", $belegrow ["Beleg_id"], $benutzerrechte, "belegmaterialverbrauch", "show" );
		}
		$boxname .= "_" . $liste [$listenzeile_id] ["fiArtikel"];
		$liste_output [$listenzeile_id] ["dtDetails"] = returnDetailsDivBox ( $boxname . "_Details", $liste_output, $listenzeile_id );
		
		$aArtikel ["fiArtikel"] = $liste [$listenzeile_id] ["fiArtikel"];
		$aArtikel ["dtVariante"] = $listenzeile ["dtVariante"];
		$aArtikel ["dtMwstSatz"] = $field_new ["dtMwstSatz"];
		
		// +++++ Der EK Preis des Artikels wird berechnet +++++ //
		
		$aBerechnungEK = getBerechnungFuerEK ( $aArtikel );
		$iEkPreis = $aBerechnungEK ["dtPreisNettoEK"];
		
		$liste_output [$listenzeile_id] ["dtPreisEK"] = preis_from_sql ( $iEkPreis );
		
		// +++++++++++ Buttons hinzufgen
		$liste_output [$listenzeile_id] ["ButtonAendern"] = uebernehmenbutton_kurz ( $liste [$listenzeile_id] ["Artikel_id"], $target, $benutzerrechte );
		$liste_output [$listenzeile_id] ["ButtonZuruecksetzen"] = zuruecksetzenbutton_kurz ( $liste [$listenzeile_id] ["Artikel_id"], $target, $benutzerrechte );
		$liste_output [$listenzeile_id] ["ButtonAnzeigen"] = detailbutton ( $liste [$listenzeile_id] ["Artikel_id"], "lagerartikel", $benutzerrechte );
		$liste_output [$listenzeile_id] ["ButtonLoeschen"] = loeschensubbutton_kurz ( $target, $typ, $id, $subtarget, $liste [$listenzeile_id] ["ArtikelStueck_id"], $benutzerrechte );
		$liste_output [$listenzeile_id] ["Aenderungsanzeiger"] = aenderungsanzeiger ();
		
		// +++++++++++ Cache
		CacheListe_writeIntoCache ( $subtarget, $subtyp, $liste [$listenzeile_id] ["Artikel_id"], $tblartikelstuecknegativ, $listenzeile, $liste_output [$listenzeile_id] );
	}
}

// Zeilen zum Listenobjekt hinzufgen
$oListe->addZeilen ( $liste_output );

?>