<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["projektliste"];
$anzahl_gesamt = get_table_count_complete ( $tblprojekte );

$iQueryLaenge = strlen ( $query );

// Projektstatusfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["projektstatus"], "$tblprojekte.fiStatus" );

// Projekttypfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["projekttyp"], "$tblprojekte.fiProjektTyp" );

// Projektverantwortlicherfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["projektverantwortlicher"], "$tblprojekte.fiProjektVerantwortlicher" );

// Kundenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["kunde"], "$tblprojekte.fiKunde", false, false, "$tblprojekte.fiEndkunde" );

// KundenASPfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["kontaktasp"], "$tblprojekte.fiKundeAnsprechpartner", false, false, "$tblprojekte.fiEndkundeAnsprechpartner" );

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and to_days(dtEingangsdatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "')";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and to_days(dtEingangsdatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "')";
	}
}

// Volltextsuche
$query .= create_fulltext_index_search ( array (
		$tblprojekte,
		$tblkontakte 
), $filter [$listenname] ["textfilter"] );

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

/*
 * // wenn es eine Limitierung der Liste gibt, dann fge sie dem SQL-String hinzu if (!(array_key_exists("anzahl", (array)$sortierung[$listenname]))) { $sortierung[$listenname]["anzahl"] = 50; $sortierung[$listenname]["position"] = 1; }; //if ($sortierung[$listenname]["anzahl"] != "" and $filter[$listenname]["textfilter"] == "") { $limit_sql = " limit ".($sortierung[$listenname]["position"] - 1).",".$sortierung[$listenname]["anzahl"]; //} else { // $limit_sql = ""; // $sortierung[$listenname]["anzahl"] = ""; //}
 */

// wenn es eine Limitierung der Liste gibt, dann fge sie dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

$adressausgabe = "ProjektNr\tProjektname\tEingangsdatum\tKunde\tKundeAnsprechpartner\tEndkunde\tEndkundeAnsprechpartner\t";
$adressausgabe .= "Bestellnr\tProjekttyp\tStatus\tVerantwortlicher\tBeschreibung\t";

$query = $sql_query ["taetigkeitenliste"] . " and $tbltaetigkeiten.dtProjektkalkulationRelevant = 1";
$query .= " order by $tbltaetigkeiten.dtTaetigkeitCode";
$taetigkeiten_liste = get_table_array ( $query );

if (count ( $taetigkeiten_liste ) != 0) {
	foreach ( $taetigkeiten_liste as $taetigkeiten_liste_id => $taetigkeiten_listenzeile ) {
		$adressausgabe .= "\"" . $taetigkeiten_listenzeile ["dtTaetigkeitCode"] . " " . $taetigkeiten_listenzeile ["dtTaetigkeit"] . " " . $taetigkeiten_listenzeile ["dtTaetigkeitBeschreibung"] . ": Kalkulation\"\t";
		$adressausgabe .= "\"" . $taetigkeiten_listenzeile ["dtTaetigkeitCode"] . " " . $taetigkeiten_listenzeile ["dtTaetigkeit"] . " " . $taetigkeiten_listenzeile ["dtTaetigkeitBeschreibung"] . ": bisherige Kosten\"\t";
		$adressausgabe .= "\"" . $taetigkeiten_listenzeile ["dtTaetigkeitCode"] . " " . $taetigkeiten_listenzeile ["dtTaetigkeit"] . " " . $taetigkeiten_listenzeile ["dtTaetigkeitBeschreibung"] . ": Bemerkung\"\t";
	}
}

$adressausgabe .= "\n";

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ notwendige Informationen holen
		
		unset ( $kunde_field );
		unset ( $endkunde_field );
		unset ( $kundeasp_field );
		unset ( $endkundeasp_field );
		unset ( $projektverantwortlicher_field );
		
		$query = $sql_query ["kontaktliste"] . " and $tblkontakte.id = '" . $liste [$listenzeile_id] ["fiKunde"] . "'";
		$kunde_field = get_table_row ( $query );
		
		if ($liste [$listenzeile_id] ["fiEndkunde"] != "") {
			$query = $sql_query ["kontaktliste"] . " and $tblkontakte.id = '" . $liste [$listenzeile_id] ["fiEndkunde"] . "'";
			$endkunde_field = get_table_row ( $query );
		}
		
		if ($liste [$listenzeile_id] ["fiKundeAnsprechpartner"] != "") {
			$query = $sql_query ["kontaktaspliste"] . " and $tblkontaktasp.id = '" . $liste [$listenzeile_id] ["fiKundeAnsprechpartner"] . "'";
			$kundeasp_field = get_table_row ( $query );
		}
		
		if ($liste [$listenzeile_id] ["fiEndkundeAnsprechpartner"] != "") {
			$query = $sql_query ["kontaktaspliste"] . " and $tblkontaktasp.id = '" . $liste [$listenzeile_id] ["fiEndkundeAnsprechpartner"] . "'";
			$endkundeasp_field = get_table_row ( $query );
		}
		
		$query = $sql_query ["kontaktliste"] . " and $tblkontakte.id = '" . $liste [$listenzeile_id] ["fiProjektVerantwortlicher"] . "'";
		$projektverantwortlicher_field = get_table_row ( $query );
		
		$kalkulationsdaten_array = explode ( "%%%", $liste [$listenzeile_id] ["dtKalkulation"] );
		$kalkulation_array = unserialize ( $kalkulationsdaten_array [0] );
		$kalkulation_bemerkungen_array = unserialize ( $kalkulationsdaten_array [1] );
		
		// +++++++++++ Felder formatieren
		if ($liste_output [$listenzeile_id] ["dtEingangsdatum"] != "2030-01-01") {
			$datum = split_date ( $liste [$listenzeile_id] ["dtEingangsdatum"] );
		}
		
		/*
		 * $adressausgabe .= "\"".str_replace(array("\"", "\t"), " ", $liste[$listenzeile_id]["dtProjektNr"]) . "\"\t"; $adressausgabe .= "\"".str_replace(array("\"", "\t"), " ", $liste[$listenzeile_id]["dtProjektname"]) . "\"\t"; $adressausgabe .= "\"".$datum["tag"].".".$datum["monat"].".".$datum["jahr"] . "\"\t"; $adressausgabe .= "\"".ltrim($kunde_field["dtKontaktDDText2"]) . "\"\t"; $adressausgabe .= "\"".ltrim($kundeasp_field["dtKontaktDDText2"]) . "\"\t"; $adressausgabe .= "\"".ltrim($endkunde_field["dtKontaktDDText2"]) . "\"\t"; $adressausgabe .= "\"".ltrim($endkundeasp_field["dtKontaktDDText2"]) . "\"\t"; $adressausgabe .= "\"".str_replace(array("\"", "\t"), " ", $liste[$listenzeile_id]["dtBestellnummer"]) . "\"\t"; $adressausgabe .= "\"".str_replace(array("\"", "\t"), " ", $liste[$listenzeile_id]["dtProjektTyp"]) . "\"\t"; $adressausgabe .= "\"".str_replace(array("\"", "\t"), " ", $liste[$listenzeile_id]["dtProjektStatus"]) . "\"\t"; $adressausgabe .= "\"".ltrim($projektverantwortlicher_field["dtKontaktDDText2"]) . "\"\t"; $adressausgabe .= "\"".str_replace(array("\"", "\t"), " ", $liste[$listenzeile_id]["dtProjektBeschreibung"]) . "\"\t";
		 */
		$removeChars = array (
				"\"",
				"\t",
				"\r",
				"\n" 
		);
		
		$adressausgabe .= str_replace ( $removeChars, " ", $liste [$listenzeile_id] ["dtProjektNr"] ) . "\t";
		$adressausgabe .= str_replace ( $removeChars, " ", $liste [$listenzeile_id] ["dtProjektname"] ) . "\t";
		$adressausgabe .= $datum ["tag"] . "." . $datum ["monat"] . "." . $datum ["jahr"] . "\t";
		$adressausgabe .= ltrim ( $kunde_field ["dtKontaktDDText2"] ) . "\t";
		$adressausgabe .= ltrim ( $kundeasp_field ["dtKontaktDDText2"] ) . "\t";
		$adressausgabe .= ltrim ( $endkunde_field ["dtKontaktDDText2"] ) . "\t";
		$adressausgabe .= ltrim ( $endkundeasp_field ["dtKontaktDDText2"] ) . "\t";
		$adressausgabe .= str_replace ( $removeChars, " ", $liste [$listenzeile_id] ["dtBestellnummer"] ) . "\t";
		$adressausgabe .= str_replace ( $removeChars, " ", $liste [$listenzeile_id] ["dtProjektTyp"] ) . "\t";
		$adressausgabe .= str_replace ( $removeChars, " ", $liste [$listenzeile_id] ["dtProjektStatus"] ) . "\t";
		$adressausgabe .= ltrim ( $projektverantwortlicher_field ["dtKontaktDDText2"] ) . "\t";
		$adressausgabe .= str_replace ( $removeChars, " ", $liste [$listenzeile_id] ["dtProjektBeschreibung"] ) . "\t";
		
		if (count ( $taetigkeiten_liste ) != 0) {
			foreach ( $taetigkeiten_liste as $taetigkeiten_liste_id => $taetigkeiten_listenzeile ) {
				
				$bisherige_kosten = 0;
				$kalkulation_wert = 0;
				
				// Wenn es ein Mat-Code ist, dann summiere alle Artikel zu diesem Projekt und Mat-Code
				if ($taetigkeiten_field ["dtIstMaterial"] != 0) {
					
					$query = $sql_query ["artikelstueckliste"] . " and $tblartikelstueck.fiProjekt = " . $liste [$listenzeile_id] ["Projekt_id"] . " and $tblartikelstueck.fiProjektTaetigkeit = " . $taetigkeiten_listenzeile ["Taetigkeiten_id"];
					$projektartikel_liste = get_table_array ( $query );
					
					if (is_array ( $projektartikel_liste )) {
						foreach ( $projektartikel_liste as $key => $projektartikel_field ) {
							$bisherige_kosten = $bisherige_kosten + $projektartikel_field ["dtPreisEK"];
						}
					}
				}
				
				// Wenn es ein Ttigkeiten-Code ist, dann summiere alle Arbeitszeiten zu diesem Projekt und Code
				if ($taetigkeiten_field ["dtIstMaterial"] == 0) {
					
					$query = $sql_query ["projektzeitenliste"] . " and $tblprojektzeiten.fiProjekt = " . $liste [$listenzeile_id] ["Projekt_id"] . " and $tblprojektzeiten.fiTaetigkeit = " . $taetigkeiten_listenzeile ["Taetigkeiten_id"];
					$projektzeit_liste = get_table_array ( $query );
					
					if (is_array ( $projektzeit_liste )) {
						foreach ( $projektzeit_liste as $key => $projektzeit_field ) {
							$bisherige_kosten = $bisherige_kosten + ($projektzeit_field ["dtProjektzeitDezimal"] * $projektzeit_field ["dtStdSatz"]);
						}
					}
				}
				/*
				 * $adressausgabe .= "\"".preis_from_sql($kalkulation_array[$taetigkeiten_field["dtTaetigkeitCode"]]) . "\"\t"; $adressausgabe .= "\"".preis_from_sql($bisherige_kosten) . "\t"; $adressausgabe .= "\"".$kalkulation_bemerkungen_array[$taetigkeiten_field["dtTaetigkeitCode"]] . "\"\t";
				 */
				$adressausgabe .= preis_from_sql ( $kalkulation_array [$taetigkeiten_field ["dtTaetigkeitCode"]] ) . "\t";
				$adressausgabe .= preis_from_sql ( $bisherige_kosten ) . "\t";
				$adressausgabe .= $kalkulation_bemerkungen_array [$taetigkeiten_field ["dtTaetigkeitCode"]] . "\t";
			}
		}
		
		$adressausgabe .= "\r\n";
	}
}

// **********************************************************************************************************
// **********************************************************************************************************

echo "<textarea style=\"width: 620px; height: 250px; font-size: 14px;\" wrap=\"off\">" . $adressausgabe . "</textarea>";

echo "<br><center>";
echo klickbutton ( " schliessen ", "onClick='self.close();'", "", "Dieses Fenster schliessen" );
echo "</center>";

?>