<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["projektzeitenliste"];
$anzahl_gesamt = get_table_count ( $query );

// Mitarbeiter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["mitarbeiter"], "$tblprojektzeiten.fiMitarbeiter" );

// Projektverantwortlicherfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["projektverantwortlicher"], "$tblprojekte.fiProjektVerantwortlicher" );

// Projektfilter
if ($filter [$listenname] ["projekt"] != "") {
	if (in_array ( "-1", $filter [$listenname] ["projekt"] )) {
		$query .= " and $tblprojektzeiten.fiProjekt = 0 ";
	}
	if (in_array ( "-2", $filter [$listenname] ["projekt"] )) {
		$query .= " and $tblprojektzeiten.fiProjekt != 0 ";
	}
	
	$query .= filter_multiselect_return_query ( $filter [$listenname] ["projekt"], "$tblprojektzeiten.fiProjekt", false, false, false, array (
			"-1",
			"-2" 
	) );
}

// Projektstatusfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["projektstatus"], "$tblprojekte.fiStatus" );

// Ttigkeitenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["taetigkeit"], "$tblprojektzeiten.fiTaetigkeit" );

// Kundenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["kunde"], "$tblprojekte.fiKunde", false, false, "$tblprojektzeiten.fiProjektzeitenKunde" );

// projektzeitenstatusgeprueftfilter
if ($filter [$listenname] ["projektzeitengeprueftstatus"] != "") {
	$query .= " and $tblprojektzeiten.dtStundennachweisGeprueft = '" . ($filter [$listenname] ["projektzeitengeprueftstatus"] - 1) . "' ";
}

// projektzeitenabgerechnetstatusfilter
if ($filter [$listenname] ["projektzeitenabgerechnetstatus"] != "") {
	$query .= " and $tblprojektzeiten.dtAbgerechnet = '" . ($filter [$listenname] ["projektzeitenabgerechnetstatus"] - 1) . "' ";
}

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and to_days(dtDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "')";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and to_days(dtDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "')";
	}
}

// Uhrzeitbereich
if ($filter [$listenname] ["uhrzeitbereich"] != "") {
	
	$uhrzeit_explode = explode ( "-", $filter [$listenname] ["uhrzeitbereich"] );
	$uhrzeit_stunde_von = $uhrzeit_explode [0];
	$uhrzeit_minute_von = $uhrzeit_explode [1];
	$uhrzeit_stunde_bis = $uhrzeit_explode [2];
	$uhrzeit_minute_bis = $uhrzeit_explode [3];
	
	if (! ($uhrzeit_stunde_von == 24 and $uhrzeit_minute_von == 60) and ! ($uhrzeit_stunde_von == "" and $uhrzeit_minute_von == "")) {
		$query .= " and (time_to_sec(dtBeginnZeit) >= time_to_sec('" . concat_time ( $uhrzeit_stunde_von, $uhrzeit_minute_von, 0 ) . "')";
		$query .= " or time_to_sec(dtEndeZeit) >= time_to_sec('" . concat_time ( $uhrzeit_stunde_von, $uhrzeit_minute_von, 0 ) . "'))";
	}
	
	if (! ($uhrzeit_stunde_bis == 24 and $uhrzeit_minute_bis == 60) and ! ($uhrzeit_stunde_bis == "" and $uhrzeit_minute_bis == "")) {
		$query .= " and time_to_sec(dtBeginnZeit) <= time_to_sec('" . concat_time ( $uhrzeit_stunde_bis, $uhrzeit_minute_bis, 0 ) . "')";
	}
}

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sei dem SQL-String hinzu
// if (!(array_key_exists("anzahl", (array)$sortierung[$listenname]))) { $sortierung[$listenname]["anzahl"] = 50; $sortierung[$listenname]["position"] = 1; };
// if ($sortierung[$listenname]["anzahl"] != "") {
// $limit_sql = " limit ".($sortierung[$listenname]["position"] - 1).",".$sortierung[$listenname]["anzahl"];
// } else {
$limit_sql = "";
$sortierung [$listenname] ["anzahl"] = "";
// }

$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

$adressausgabe = "Mitarbeiter\tDatum\tBeginnzeit\tEndezeit\tAnwesendzeit\tPausezeit\tArbeitszeit\tZusatzzeit\tVergtezeit\tProjektzeit\tProjektzeit automatisch berechnet\t";
$adressausgabe .= "Projekt\tProjekt Nr\tProjekt Datum\tProjekt Status\tProjektTyp\tProjektVerantwortlicher\t";
$adressausgabe .= "Ttigkeit\tEuro/h\tEuro/h gesamt\tStundensatzberechnung automatisch\tBemerkung Projektzeit\tBemerkung Arbeitszeit\tErluterung Stundennachweis\tBemerkung Stundenkontrolle\tStundennachweis vorhanden\tEintrag abgerechnet\n";

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		$query = $sql_query ["personaldatenliste"] . " and $tblpersonaldaten.fiKontaktNr = '" . $liste [$listenzeile_id] ["fiMitarbeiter"] . "' ";
		$personaldaten_field = get_table_row ( $query );
		
		// +++++++++++ Felder formatieren
		if ($liste_output [$listenzeile_id] ["dtDatum"] != "2030-01-01") {
			$datum = split_date ( $liste [$listenzeile_id] ["dtDatum"] );
		}
		
		$query = $sql_query ["kontaktliste"] . " and $tblkontakte.id = '" . $liste [$listenzeile_id] ["fiMitarbeiter"] . "' ";
		$mitarbeiter_field = get_table_row ( $query );
		$mitarbeiter_title = "Mitarbeiter: " . $mitarbeiter_field ["dtKontaktDDText2"];
		
		$adressausgabe .= ltrim ( $mitarbeiter_field ["dtKontaktDDText2"] ) . "\t";
		$adressausgabe .= $datum ["tag"] . "." . $datum ["monat"] . "." . $datum ["jahr"] . "\t";
		$adressausgabe .= time_from_sql ( $liste [$listenzeile_id] ["dtBeginnZeit"] ) . "\t";
		$adressausgabe .= time_from_sql ( $liste [$listenzeile_id] ["dtEndeZeit"] ) . "\t";
		$adressausgabe .= time_from_sql ( $liste [$listenzeile_id] ["dtAnwesendZeit"] ) . "\t";
		$adressausgabe .= time_from_sql ( $liste [$listenzeile_id] ["dtPauseZeit"] ) . "\t";
		$adressausgabe .= time_from_sql ( $liste [$listenzeile_id] ["dtArbeitsZeit"] ) . "\t";
		$adressausgabe .= time_from_sql ( $liste [$listenzeile_id] ["dtZusatzZeit"] ) . "\t";
		$adressausgabe .= time_from_sql ( $liste [$listenzeile_id] ["dtVergueteZeit"] ) . "\t";
		$adressausgabe .= double_from_sql ( $liste [$listenzeile_id] ["dtProjektzeitDezimal"], 2 ) . "\t";
		$adressausgabe .= ( int ) $liste [$listenzeile_id] ["dtProjektzeitAutoManuell"] . "\t";
		
		if ($liste [$listenzeile_id] ["fiProjekt"] != 0) {
			$query = $sql_query ["projektliste"] . " and $tblprojekte.id = '" . $liste [$listenzeile_id] ["fiProjekt"] . "' ";
			$projekt_field = get_table_row ( $query );
			
			$datum = split_date ( $projekt_field ["dtEingangsdatum"] );
			
			$adressausgabe .= $projekt_field ["dtProjektDDText"] . "\t";
			$adressausgabe .= $projekt_field ["dtProjektNr"] . "\t";
			$adressausgabe .= $datum ["tag"] . "." . $datum ["monat"] . "." . $datum ["jahr"] . "\t";
			$adressausgabe .= $projekt_field ["dtProjektStatus"] . "\t";
			$adressausgabe .= $projekt_field ["dtProjektTyp"] . "\t";
			
			if ($projekt_field ["fiProjektVerantwortlicher"] != 0) {
				$query = $sql_query ["kontaktliste"] . " and $tblkontakte.id = '" . $projekt_field ["fiProjektVerantwortlicher"] . "' ";
				$projekt_va_field = get_table_row ( $query );
				
				$adressausgabe .= ltrim ( $projekt_va_field ["dtKontaktDDText2"] ) . "\t";
			} else {
				$adressausgabe .= "\t";
			}
		} else {
			$adressausgabe .= "\t\t\t\t\t\t";
		}
		
		if ($liste [$listenzeile_id] ["fiTaetigkeit"] != 0) {
			$query = $sql_query ["taetigkeitenliste"] . " and $tbltaetigkeiten.id = '" . $liste [$listenzeile_id] ["fiTaetigkeit"] . "' ";
			$taetigkeit_field = get_table_row ( $query );
			$adressausgabe .= $taetigkeit_field ["dtTaetigkeitDDText"] . "\t";
		} else {
			$adressausgabe .= "\t";
		}
		
		$adressausgabe .= preis_from_sql ( $liste [$listenzeile_id] ["dtStdSatz"] ) . "\t";
		$adressausgabe .= preis_from_sql ( $liste [$listenzeile_id] ["dtStdSatz"] * $liste [$listenzeile_id] ["dtProjektzeitDezimal"] ) . "\t";
		$adressausgabe .= ( int ) $liste [$listenzeile_id] ["dtStdSatzAutoManuell"] . "\t";
		$adressausgabe .= str_replace ( "\t", " ", $liste [$listenzeile_id] ["dtBemerkungProjektzeit"] ) . "\t";
		$adressausgabe .= str_replace ( "\t", " ", $liste [$listenzeile_id] ["dtBemerkungArbeitszeit"] ) . "\t";
		$adressausgabe .= str_replace ( "\t", " ", $liste [$listenzeile_id] ["dtErlaeuterungStundennachweis"] ) . "\t";
		$adressausgabe .= str_replace ( "\t", " ", $liste [$listenzeile_id] ["dtBemerkungKontrolle"] ) . "\t";
		$adressausgabe .= ( int ) $liste [$listenzeile_id] ["dtStundennachweisGeprueft"] . "\t";
		$adressausgabe .= ( int ) $liste [$listenzeile_id] ["dtAbgerechnet"] . "\t";
		
		$adressausgabe .= "\n";
	}
}

// **********************************************************************************************************
// **********************************************************************************************************

echo "<textarea style=\"width: 620px; height: 250px; font-size: 14px;\" wrap=\"off\">" . $adressausgabe . "</textarea>";

echo "<br><center>";
echo klickbutton ( " schliessen ", "onClick='self.close();'", "width: 85px;", "Dieses Fenster schliessen" );
echo "</center>";

?>