<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["provisionenliste"];
$anzahl_gesamt = get_table_count ( $query );

// Belegstatusfilter
if (is_array ( $filter [$listenname] ["belegstatus"] )) {
	$query .= filter_multiselect_return_query ( $filter [$listenname] ["belegstatus"], "$tblbelege.fiStatus" );
} else {
	$query .= " and $tblbelege.fiStatus < 900 ";
}

// Kundefilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["kunde"], "$tblbelege.fiKunde" );

// Provisionsempfaenger
$query .= filter_multiselect_return_query ( $filter [$listenname] ["provisionsempfaenger"], "$tblbelege.fiBelegProvisionsempfaenger" );

// Provision abgerechnet oder nicht
if ($filter [$listenname] ["provisionabgerechnet"] == 2) {
	$query .= " and $tblbelege.dtProvisionAbgerechnet = '0'";
} else {
	$query .= filter_multiselect_return_query ( $filter [$listenname] ["provisionabgerechnet"], "$tblbelege.dtProvisionAbgerechnet" );
}

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and (dtRechnungDatum <> '2030-01-01' and to_days(dtRechnungDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "'))";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and (dtRechnungDatum <> '2030-01-01' and to_days(dtRechnungDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "'))";
	}
}

// Volltextsuche
$query .= create_fulltext_index_search ( array (
		$tblbelege,
		$tblkontakte,
		$tblartikel 
), $filter [$listenname] ["textfilter"] );

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sei dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
$fProvisionSumme = 0;

if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ hole Provisionsempfaenger
		$provisionsempfaenger_query = $sql_query ["mitarbeiterliste"] . " and $tblkontakte.id = " . $listenzeile ["fiBelegProvisionsempfaenger"];
		$provisionsempfaenger_row = get_table_row ( $provisionsempfaenger_query );
		
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = liste_output_textfilter_markieren ( $listenzeile, $field_textfilter_active, $filter [$listenname] ["textfilter"] );
		
		/*
		 * Rabatt
		 */
		if ($listenzeile ["BelegMaterialPosten_Rabattfaehig"] == "1") {
			$posten_netto = $listenzeile ["dtPreisNetto"] - $listenzeile ["dtPreisNetto"] / 100 * $listenzeile ["dtMaterialpostenRabatt"];
		} else {
			$posten_netto = $listenzeile ["dtPreisNetto"];
		}
		
		$liste_output [$listenzeile_id] ["id"] = "<!--" . $liste [$listenzeile_id] ["fiBeleg"] . "//-->";
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "target", $target );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "typ", "send" );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "id", $liste [$listenzeile_id] ["fiBeleg"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "ajaxid", $liste [$listenzeile_id] ["fiBeleg"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subtarget", $subtarget );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subtyp", $subtyp );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subid", $subid );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "referer", $typ );
		
		// +++++++++++ Felder formatieren
		$liste_output [$listenzeile_id] ["dtRechnungDatum"] = date_from_sql ( $liste_output [$listenzeile_id] ["dtRechnungDatum"] );
		$liste_output [$listenzeile_id] ["dtMenge"] = double_from_sql ( $liste_output [$listenzeile_id] ["dtMenge"], 0 );
		$liste_output [$listenzeile_id] ["dtPreisNetto"] = preis_from_sql ( $posten_netto, null, 2 );
		$liste_output [$listenzeile_id] ["dtProvisionsempfaengerAnzeige"] = shortcutlink ( format_name_html ( $provisionsempfaenger_row ["dtKontaktDDText"] ), "mitarbeiter", "show", $liste_output [$listenzeile_id] ["fiBelegProvisionsempfaenger"], $benutzerrechte, "mitarbeiterprovision", "show" );
		$liste_output [$listenzeile_id] ["dtBelegNr"] = shortcutlink ( $liste_output [$listenzeile_id] ["dtBelegNr"], "belege", "show", $liste_output [$listenzeile_id] ["fiBeleg"], $benutzerrechte );
		$liste_output [$listenzeile_id] ["dtBezeichnung"] = shortcutlink ( $liste_output [$listenzeile_id] ["dtBezeichnung"], "belege", "show", $liste_output [$listenzeile_id] ["fiBeleg"], $benutzerrechte );
		$liste_output [$listenzeile_id] ["dtEigeneArtikelNr"] = shortcutlink ( $liste_output [$listenzeile_id] ["dtEigeneArtikelNr"], "lagerartikel", "show", $liste_output [$listenzeile_id] ["fiArtikel"], $benutzerrechte, "lagerartikelprovision", "show" );
		$liste_output [$listenzeile_id] ["dtArtikel"] = shortcutlink ( $liste_output [$listenzeile_id] ["dtArtikel"], "lagerartikel", "show", $liste_output [$listenzeile_id] ["fiArtikel"], $benutzerrechte, "lagerartikelprovision", "show" );
		
		$fProvisionAktuell = berechneProvisionshoeheInProzent ( $listenzeile ["fiBelegProvisionsempfaenger"], $listenzeile ["Kontakte_id"], $listenzeile ["Artikel_id"] );
		
		$liste_output [$listenzeile_id] ["dtProvisionshoeheInProzent"] = double_from_sql ( $fProvisionAktuell, 1 ) . "%";
		
		$fProvisionBetrag = $posten_netto * ($fProvisionAktuell / 100) * $listenzeile ["dtMenge"];
		$fProvisionSumme += $fProvisionBetrag;
		$liste_output [$listenzeile_id] ["dtProvision"] = preis_from_sql ( $fProvisionBetrag, null, 2 );
		
		/* Der ProvisionAbgerechnet Wert wird ausgelesen */
		$sQuerySQL = "SELECT * FROM $tblbelege WHERE id = " . $listenzeile ["fiBeleg"];
		$rBelegResult = get_table_row ( $sQuerySQL );
		
		if ($rBelegResult) {
			if ($rBelegResult ["dtProvisionAbgerechnet"] > 0) {
				$title = "Provision abgerechnet";
			} else {
				$title = "Provision nicht abgerechnet";
			}
			;
			
			$liste_output [$listenzeile_id] ["dtProvisionAbgerechnet"] = input_checkbox ( $title, "dtProvisionAbgerechnet", $rBelegResult ["dtProvisionAbgerechnet"] );
			$liste_output [$listenzeile_id] ["ButtonAendern"] = uebernehmenbutton_kurz ( $listenzeile ["fiBeleg"], $target, $benutzerrechte, "", "nderungen speichern", "onClick='vorauswahl_speichern(this.form); formular_senden(this.form); return false;'" );
		} else {
			$liste_output [$listenzeile_id] ["dtProvisionAbgerechnet"] = input_checkbox ( $title, "dtProvisionAbgerechnet", 0 );
			$liste_output [$listenzeile_id] ["ButtonAendern"] = uebernehmenbutton_kurz ( $listenzeile ["fiBeleg"], $target, $benutzerrechte, "", "nderungen speichern", "onClick='vorauswahl_speichern(this.form); formular_senden(this.form); return false;'" );
		}
	}
}
// Zeilen zum Listenobjekt hinzufgen
$oListe->addZeilen ( $liste_output );

?>