<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["stempelzeitenliste"] . " and fiStatus < 3 ";
$anzahl_gesamt = get_table_count_complete ( $tblstempelzeiten );

// Mitarbeiter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["mitarbeiter"], "$tblstempelzeiten.fiMitarbeiter" );

// Gertefilter
if ($filter [$listenname] ["geraet"] != "") {
	$query .= " and $tblstempelzeiten.dtGeraet = '" . $filter [$listenname] ["geraet"] . "' ";
}

// Stempel-Code-Filter
if ($filter [$listenname] ["stempelcode"] != "") {
	$query .= " and $tblstempelzeiten.dtStempelCode = '" . $filter [$listenname] ["stempelcode"] . "' ";
}

// Stempelzeiten-Status-Filter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["stempelzeitenstatus"], "$tblstempelzeiten.fiStatus" );

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and to_days(dtDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "')";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and to_days(dtDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "')";
	}
}

// Uhrzeitbereich
if ($filter [$listenname] ["uhrzeitbereich"] != "") {
	
	$uhrzeit_explode = explode ( "-", $filter [$listenname] ["uhrzeitbereich"] );
	$uhrzeit_stunde_von = $uhrzeit_explode [0];
	$uhrzeit_minute_von = $uhrzeit_explode [1];
	$uhrzeit_stunde_bis = $uhrzeit_explode [2];
	$uhrzeit_minute_bis = $uhrzeit_explode [3];
	
	if (! ($uhrzeit_stunde_von == 24 and $uhrzeit_minute_von == 60) and ! ($uhrzeit_stunde_von == "" and $uhrzeit_minute_von == "")) {
		$query .= " and time_to_sec(dtUhrzeit) >= time_to_sec('" . concat_time ( $uhrzeit_stunde_von, $uhrzeit_minute_von, 0 ) . "')";
	}
	
	if (! ($uhrzeit_stunde_bis == 24 and $uhrzeit_minute_bis == 60) and ! ($uhrzeit_stunde_bis == "" and $uhrzeit_minute_bis == "")) {
		$query .= " and time_to_sec(dtUhrzeit) <= time_to_sec('" . concat_time ( $uhrzeit_stunde_bis, $uhrzeit_minute_bis, 0 ) . "')";
	}
}

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sei dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ Cache
		$cache = CacheListe_getFromCache ( $target, $typ, $liste [$listenzeile_id] ["StempelZeiten_id"], $tblstempelzeiten, $listenzeile );
		if ($cache !== false) {
			$liste_output [$listenzeile_id] = $cache;
			continue;
		}
		
		// +++++++++++ Eingabefelder erzeugen
		$liste_output [$listenzeile_id] ["id"] = "<!--" . $liste [$listenzeile_id] ["StempelZeiten_id"] . "//-->";
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "target", $target );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "typ", "send" );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "id", $liste [$listenzeile_id] ["StempelZeiten_id"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "ajaxid", $liste [$listenzeile_id] ["StempelZeiten_id"] );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subtarget", $subtarget );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subtyp", $subtyp );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "subid", $subid );
		$liste_output [$listenzeile_id] ["id"] .= input_hidden ( "referer", $typ );
		
		// +++++++++++ Felder formatieren
		if ($liste_output [$listenzeile_id] ["dtDatum"] != "2030-01-01") {
			$datum = split_date ( $liste [$listenzeile_id] ["dtDatum"] );
		}
		
		// if (date("Y-m-d", mktime(0,0,0,$aktmonat,$akttag,$aktjahr)) == date("Y-m-d", mktime(0,0,0,$datum["monat"],$datum["tag"],$datum["jahr"]))) {
		// $bgcolor_datum = "#44ff44";
		// } elseif (date("Y-m-d", mktime(0,0,0,$aktmonat,$akttag-1,$aktjahr)) == date("Y-m-d", mktime(0,0,0,$datum["monat"],$datum["tag"],$datum["jahr"]))) {
		// $bgcolor_datum = "#bbffbb";
		// } elseif (date("Y-m-d", mktime(0,0,0,$aktmonat,$akttag-2,$aktjahr)) == date("Y-m-d", mktime(0,0,0,$datum["monat"],$datum["tag"],$datum["jahr"]))) {
		// $bgcolor_datum = "#ffffdd";
		// } else {
		// $bgcolor_datum = "#eeeeee";
		// }
		
		$query = "%%%kontaktliste%%% and dtIstMitarbeiter=1 and dtAktiv=1 order by dtKontaktSortierung";
		$liste_output [$listenzeile_id] ["dtKontaktDDText"] = input_dropdownbox_ajax ( "Mitarbeiter", $query, "Kontakte_id", "fiMitarbeiter__" . $listenzeile_id . "__", $liste [$listenzeile_id] ["fiMitarbeiter"], "dtKontaktDDText", "input_select_150", "", "background-color: $bgcolor_datum;" );
		
		if ($liste [$listenzeile_id] ["fiMitarbeiter"] != "") {
			$liste_output [$listenzeile_id] ["dtKontaktDDText"] .= shortcutbutton ( "kontakte", "show", $liste [$listenzeile_id] ["fiMitarbeiter"], $benutzerrechte );
		}
		
		if ($liste_output [$listenzeile_id] ["dtDatum"] != "2030-01-01") {
			$datum = split_date ( $liste [$listenzeile_id] ["dtDatum"] );
		}
		$liste_output [$listenzeile_id] ["dtDatum"] = input_text ( "Tag", "datum_tag", $datum ["tag"], "input_date", "", "background-color: $bgcolor_datum;" );
		$liste_output [$listenzeile_id] ["dtDatum"] .= input_text ( "Monat", "datum_monat", $datum ["monat"], "input_date", "", "background-color: $bgcolor_datum;" );
		$liste_output [$listenzeile_id] ["dtDatum"] .= input_text ( "Jahr", "datum_jahr", $datum ["jahr"], "input_date", "", "background-color: $bgcolor_datum;" );
		
		if ($liste_output [$listenzeile_id] ["dtUhrzeit"] != "24-60") {
			$uhrzeit = split_time ( $liste [$listenzeile_id] ["dtUhrzeit"] );
		}
		$liste_output [$listenzeile_id] ["dtUhrzeit"] = input_text ( "Uhrzeit", "uhrzeit", $uhrzeit ["stunde"] . ":" . $uhrzeit ["minute"], "input_time", "onChange='this.form.uhrzeit.value=check_zeit(this.form.uhrzeit.value)'", "background-color: $bgcolor_datum;" );
		
		$query = "select * from $tblstempelzeiten group by dtGeraet order by dtGeraet";
		$liste_output [$listenzeile_id] ["dtGeraet"] = input_dropdownbox ( "Gert", $query, "dtGeraet", "dtGeraet", $liste [$listenzeile_id] ["dtGeraet"], "dtGeraet", "input_select_100" );
		
		$query = "select * from $tblstempelzeiten group by dtStempelCode order by dtStempelCode";
		$liste_output [$listenzeile_id] ["dtStempelCode"] = input_dropdownbox ( "Stempel-Code", $query, "dtStempelCode", "dtStempelCode", $liste [$listenzeile_id] ["dtStempelCode"], "dtStempelCode", "input_select_150" );
		
		$query = $sql_query ["stempelzeitenstatusliste"] . " order by dtSortierung";
		$liste_output [$listenzeile_id] ["dtStempelzeitStatus"] = input_dropdownbox ( "Stempelzeiten-Status", $query, "StempelZeitenStatus_id", "fiStatus", $liste [$listenzeile_id] ["fiStatus"], "dtStempelzeitStatus", "input_select_150" );
		
		// +++++++++++ Buttons hinzufgen
		$liste_output [$listenzeile_id] ["ButtonAendern"] = uebernehmenbutton_kurz ( $liste [$listenzeile_id] ["StempelZeiten_id"], $target, $benutzerrechte, "", "nderungen speichern", "onClick='formular_senden(this.form); return false;'" );
		$liste_output [$listenzeile_id] ["ButtonZuruecksetzen"] = zuruecksetzenbutton_kurz ( $liste [$listenzeile_id] ["StempelZeiten_id"], $target, $benutzerrechte );
		$liste_output [$listenzeile_id] ["ButtonLoeschen"] = klickbutton ( "loeschen_kurz", "onClick='formular_loeschen(this.form)'", "width: 15px;", "Diesen Eintrag lschen" );
		$liste_output [$listenzeile_id] ["Aenderungsanzeiger"] = aenderungsanzeiger ();
		
		// +++++++++++ Cache
		CacheListe_writeIntoCache ( $target, $typ, $liste [$listenzeile_id] ["StempelZeiten_id"], $tblstempelzeiten, $listenzeile, $liste_output [$listenzeile_id] );
	}
}

// Zeilen zum Listenobjekt hinzufgen
$oListe->addZeilen ( $liste_output );

// +++++++++++ Eingabefelder fr Neu-Zeile erzeugen
unset ( $liste_output );

$liste_output [0] ["dtKontaktDDText"] = "neuer Eintrag:";

$liste_output [1] ["id"] = input_hidden ( "target", $target );
$liste_output [1] ["id"] .= input_hidden ( "typ", "send" );
$liste_output [1] ["id"] .= input_hidden ( "id", "" );
$liste_output [1] ["id"] .= input_hidden ( "subtarget", $subtarget );
$liste_output [1] ["id"] .= input_hidden ( "subtyp", $subtyp );
$liste_output [1] ["id"] .= input_hidden ( "subid", $subid );
$liste_output [1] ["id"] .= input_hidden ( "referer", $typ );

// +++++++++++ Felder formatieren
$query = $sql_query ["kontaktliste"] . " and dtIstMitarbeiter=1 and dtAktiv=1 order by dtKontaktSortierung";
$liste_output [1] ["dtKontaktDDText"] = input_dropdownbox ( "Mitarbeiter", $query, "Kontakte_id", "fiMitarbeiter", $filter [$listenname] ["mitarbeiter"], "dtKontaktDDText", "input_select_150" );

$liste_output [1] ["dtDatum"] = input_text ( "Tag", "datum_tag", $akttag, "input_date" );
$liste_output [1] ["dtDatum"] .= input_text ( "Monat", "datum_monat", $aktmonat, "input_date" );
$liste_output [1] ["dtDatum"] .= input_text ( "Jahr", "datum_jahr", $aktjahr, "input_date" );

$liste_output [1] ["dtUhrzeit"] = input_text ( "Uhrzeit", "uhrzeit", "00:00", "input_time", "onChange='this.form.uhrzeit.value=check_zeit(this.form.uhrzeit.value)''" );

$query = "select * from $tblstempelzeiten group by dtGeraet order by dtGeraet";
$liste_output [1] ["dtGeraet"] = input_dropdownbox ( "Gert", $query, "dtGeraet", "dtGeraet", "", "dtGeraet", "input_select_100" );

$query = "select * from $tblstempelzeiten group by dtStempelCode order by dtStempelCode";
$liste_output [1] ["dtStempelCode"] = input_dropdownbox ( "Stempel-Code", $query, "dtStempelCode", "dtStempelCode", "", "dtStempelCode", "input_select_150" );

$query = $sql_query ["stempelzeitenstatusliste"] . " order by dtSortierung";
$liste_output [1] ["dtStempelzeitStatus"] = input_dropdownbox ( "Stempelzeiten-Status", $query, "StempelZeitenStatus_id", "fiStatus", 0, "dtStempelzeitStatus", "input_select_150" );

// +++++++++++ Buttons hinzufgen
$liste_output [1] ["ButtonAendern"] = uebernehmenbutton_kurz ( "neuer Eintrag", $target, $benutzerrechte );
$liste_output [1] ["ButtonZuruecksetzen"] = zuruecksetzenbutton_kurz ( "neuer Eintrag", $target, $benutzerrechte );
$liste_output [1] ["Aenderungsanzeiger"] = aenderungsanzeiger ();

// Zeilen zum Listenobjekt hinzufgen
$oListe->addZeilen ( $liste_output );
$oListe->setAnzahlZeilenBlind ( 2 );

?>