<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["stempelzeitenliste"];

$anzahl_gesamt = get_table_count ( $query );

// Mitarbeiter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["mitarbeiter"], "$tblstempelzeiten.fiMitarbeiter" );

// Gertefilter
if ($filter [$listenname] ["geraet"] != "") {
	$query .= " and $tblstempelzeiten.dtGeraet = '" . $filter [$listenname] ["geraet"] . "' ";
}

// Stempel-Code-Filter
if ($filter [$listenname] ["stempelcode"] != "") {
	$query .= " and $tblstempelzeiten.dtStempelCode = '" . $filter [$listenname] ["stempelcode"] . "' ";
}

// Stempelzeiten-Status-Filter
// if ($filter[$listenname]["stempelzeitenstatus"] != "") {
// $query .= " and $tblstempelzeiten.fiStatus = " . $filter[$listenname]["stempelzeitenstatus"] . " " ;
// }
$query .= filter_multiselect_return_query ( $filter [$listenname] ["stempelzeitenstatus"], "$tblstempelzeiten.fiStatus" );

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and to_days(dtDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "')";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and to_days(dtDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "')";
	}
}

// Uhrzeitbereich
if ($filter [$listenname] ["uhrzeitbereich"] != "") {
	
	$uhrzeit_explode = explode ( "-", $filter [$listenname] ["uhrzeitbereich"] );
	$uhrzeit_stunde_von = $uhrzeit_explode [0];
	$uhrzeit_minute_von = $uhrzeit_explode [1];
	$uhrzeit_stunde_bis = $uhrzeit_explode [2];
	$uhrzeit_minute_bis = $uhrzeit_explode [3];
	
	if (! ($uhrzeit_stunde_von == 24 and $uhrzeit_minute_von == 60) and ! ($uhrzeit_stunde_von == "" and $uhrzeit_minute_von == "")) {
		$query .= " and time_to_sec(dtUhrzeit) >= time_to_sec('" . concat_time ( $uhrzeit_stunde_von, $uhrzeit_minute_von, 0 ) . "')";
	}
	
	if (! ($uhrzeit_stunde_bis == 24 and $uhrzeit_minute_bis == 60) and ! ($uhrzeit_stunde_bis == "" and $uhrzeit_minute_bis == "")) {
		$query .= " and time_to_sec(dtUhrzeit) <= time_to_sec('" . concat_time ( $uhrzeit_stunde_bis, $uhrzeit_minute_bis, 0 ) . "')";
	}
}

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

$query .= $sortierung_sql;
$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ Zeile durch Textfilter laufen lassen
		// $liste_output[$listenzeile_id] = liste_output_textfilter($listenzeile, $field_textfilter_active, $filter[$listenname]["textfilter"]);
		
		// +++++++++++ Felder formatieren
		$query = $sql_query ["kontaktliste"] . " and $tblkontakte.id = " . $liste [$listenzeile_id] ["fiMitarbeiter"];
		$mitarbeiter_row = get_table_row ( $query );
		$liste_output [$listenzeile_id] ["dtKontaktDDText"] = $mitarbeiter_row ["dtKontaktDDText"];
		
		if ($liste_output [$listenzeile_id] ["dtDatum"] != "2030-01-01") {
			$datum = split_date ( $liste [$listenzeile_id] ["dtDatum"] );
		}
		$liste_output [$listenzeile_id] ["dtDatum"] = $datum ["tag"] . "." . $datum ["monat"] . "." . $datum ["jahr"];
		
		if ($liste_output [$listenzeile_id] ["dtUhrzeit"] != "24-60") {
			$uhrzeit = split_time ( $liste [$listenzeile_id] ["dtUhrzeit"] );
		}
		$liste_output [$listenzeile_id] ["dtUhrzeit"] = $uhrzeit ["stunde"] . ":" . $uhrzeit ["minute"];
		
		$liste_output [$listenzeile_id] ["dtGeraet"] = $liste [$listenzeile_id] ["dtGeraet"];
		$liste_output [$listenzeile_id] ["dtStempelCode"] = $liste [$listenzeile_id] ["dtStempelCode"];
		
		$query = $sql_query ["stempelzeitenstatusliste"] . " and $tblstempelzeitenstatus.id = " . $liste [$listenzeile_id] ["fiStatus"];
		$stempelzeitstatus_row = get_table_row ( $query );
		$liste_output [$listenzeile_id] ["dtStempelzeitStatus"] = $stempelzeitstatus_row ["dtStempelzeitStatus"];
	}
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ hole Layout Infos
$query = $sql_query ["dokumentlayoutliste"] . " and $tbldokumentlayout.id = '" . $standard_layout_liste_hochformat . "'";
$field = get_table_row ( $query );

$layout_vorlagen_ersteseite = unserialize ( $field ["dtVorlagenErsteSeite"] );
$layout_vorlagen_folgeseiten = unserialize ( $field ["dtVorlagenFolgeSeiten"] );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ Definiere Seitenrnder
$typ = "seitenraender";
include ("$functionsordner/function_pdf.php");

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge neues PDF Dokument (nur fr Berechnung von Feldbreiten, je nach Schriftart)
$pdf = new PDF ();
$pdf->new_document ( $field ["dtDokumentName"], $ausrichtung );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge Listenkopf
$printzeile = 0;

foreach ( $show_fields as $key => $show_field ) {
	$feldinhalte [$show_field] = $field_headlines [$key];
}

$liste_print [$printzeile] ["zeilentyp"] = "kopfzeile";
$liste_print [$printzeile] ["zeilennr"] = 1;
$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
$liste_print [$printzeile] ["feldinhalte"] = $feldinhalte;
$liste_print [$printzeile] ["feldbreiten"] = $field_width;
$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = $schriftausrichtung_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];

$printzeile ++;

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ bearbeite Liste zeilenweise, wenn es der Textfilter erlaubt
$zeilenzahl = 1;
if (is_array ( $liste_output )) {
	foreach ( $liste_output as $zeile => $listenzeile ) {
		if ($liste_output [$zeile] ["Textfilter"] != "nomatch") {
			
			// ++++ formatiere Listenfelder (HTML zu PDF) (Schriftart muss gesetzt sein fr Zeilenberechnung)
			foreach ( $show_fields as $key => $show_field ) {
				
				$pdf->SetFont ( "$field[dtStandardSchriftArt]", "", $field ["dtStandardSchriftGroesse"] );
				$tabellenzeile [$show_field] = $pdf->format_tabellenfeld ( $listenzeile [$show_field], $field_width [$key] );
			}
			
			// ++++ berechne grte Zeilenanzahl der Listenfelder
			$maxzeilen = $pdf->get_maxzeilen ( $tabellenzeile );
			
			// ++++ erzeuge neues Array mit jeweils einer Textzeile
			for($n = 0; $n < $maxzeilen; $n ++) {
				
				foreach ( $show_fields as $key => $show_field ) {
					$feldinhalte [$show_field] = $pdf->extract_print_zeile ( $tabellenzeile [$show_field], $n );
				}
				
				$liste_print [$printzeile] ["zeilentyp"] = "zeile";
				$liste_print [$printzeile] ["zeilennr"] = $n + 1;
				$liste_print [$printzeile] ["zeilenmaxnr"] = $maxzeilen;
				$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
				$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
				$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
				$liste_print [$printzeile] ["feldinhalte"] = $feldinhalte;
				$liste_print [$printzeile] ["feldbreiten"] = $field_width;
				if ($zeilenzahl % 2 == 0) {
					$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_gerade;
				} else {
					$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_ungerade;
				}
				$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_textzeile;
				$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_textzeile;
				$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_textzeile;
				$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = $schriftausrichtung_textzeile;
				$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
				$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];
				
				$printzeile ++;
			}
			$zeilenzahl ++;
		}
	}
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge Listenfu

$liste_print [$printzeile] = $liste_print [0];
$liste_print [$printzeile] ["zeilentyp"] = "fusszeile";
$liste_print [$printzeile] ["feldinhalte"] = array (
		"Anzahl: " . ($zeilenzahl - 1) . " von " . $anzahl_gesamt 
);
$liste_print [$printzeile] ["feldbreiten"] = array (
		array_sum ( $field_width ) 
);

$printzeile ++;

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ schliesse temporres PDF Dokument
$pdf->Close ();

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ fge Seitenumbrche ein
$liste_print = $pdf->tabellenseitenumbrueche ( $liste_print, round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ), $druckhoehe_p1, $druckhoehe );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ drucke alle Seiten
$pdf->tabelle_output ( $liste_print, $rand_links_p1, $rand_oben_p1, $rand_links, $rand_oben, $druckbreite_p1, $druckbreite, $dateiname, $field ["dtDokumentName"], $ausrichtung );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge ggf. Seite mit Infofeld auf erster Seite
if ($field ["dtInfofeldVorhanden"] == 1) {
	$infofeld_array = create_infofeld_liste_array ( "Stempelzeitenliste", $field ["dtInfofeldSchriftArt"], $field ["dtInfofeldSchriftGroesse"], $filter [$listenname], $sortierung [$listenname], $field_headlines, $show_fields );
	create_infofeldseite ( $infofeld_array, $ausrichtung, $field ["dtInfofeldLinks"], $field ["dtInfofeldOben"], $seitenbreite - $field ["dtInfofeldLinks"] - $field ["dtInfofeldRechts"], $seitenhoehe - $field ["dtInfofeldOben"] - $field ["dtInfofeldUnten"] );
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge ggf. Seite mit Datumsfeld auf erster Seite
if ($field ["dtDatumsfeldVorhanden"] == 1) {
	create_datumsfeldseite ( $field ["dtDatumsfeldText"], $ausrichtung, $field ["dtDatumsfeldLinks"], $field ["dtDatumsfeldOben"], $seitenbreite - $field ["dtDatumsfeldLinks"] - $field ["dtDatumsfeldRechts"], $field ["dtDatumsfeldSchriftArt"], $field ["dtDatumsfeldSchriftGroesse"] );
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge ggf. Seiten mit Seitenzahl-Feld fr alle Seiten
if ($field ["dtSeitenzahlfeldVorhanden"] == 1) {
	create_seitenzahlseiten ( $field ["dtSeitenzahlfeldText"], $ausrichtung, $field ["dtSeitenzahlfeldLinks"], $field ["dtSeitenzahlfeldOben"], $seitenbreite - $field ["dtSeitenzahlfeldLinks"] - $field ["dtSeitenzahlfeldRechts"], $field ["dtSeitenzahlfeldSchriftArt"], $field ["dtSeitenzahlfeldSchriftGroesse"] );
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ hinzufgen des Layouts und zusammenfhren aller Seiten
$output_filename = create_document ( $layout_vorlagen_ersteseite, $layout_vorlagen_folgeseiten );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ Ausgabe des PDF im Browser durch Reload der Seite
output_reload ( $output_filename );

?>