<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["projektzeitenliste"];
$anzahl_gesamt = get_table_count_complete ( $tblprojektzeiten );

if($me == "boeker" )
{
	$sProjektListenname = "boekerprojekt";
	$sMitarbeiterListenname = "boekermitarbeiter";
}
else
{
	$sProjektListenname = "projekt";
	$sMitarbeiterListenname = "mitarbeiter";
}

// Mitarbeiter
$query .= filter_multiselect_return_query ( $filter [$listenname] [$sMitarbeiterListenname], "$tblprojektzeiten.fiMitarbeiter" );

// Projektverantwortlicherfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["projektverantwortlicher"], "$tblprojekte.fiProjektVerantwortlicher" );

// Projektfilter
if ($filter [$listenname] [$sProjektListenname] != "") {
	if (in_array ( "-1", ( array ) $filter [$listenname] [$sProjektListenname] )) {
		$query .= " and $tblprojektzeiten.fiProjekt = 0 ";
	}
	if (in_array ( "-2", ( array ) $filter [$listenname] [$sProjektListenname] )) {
		$query .= " and $tblprojektzeiten.fiProjekt != 0 ";
	}
	
	$query .= filter_multiselect_return_query ( $filter [$listenname] [$sProjektListenname], "$tblprojektzeiten.fiProjekt", false, false, false, array (
			"-1",
			"-2" 
	) );
}

// Teil-Projektfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["teilprojekt"], "$tblprojektzeiten.fiTeilprojekt" );
$teilprojekte_vorhanden = false;

// Ttigkeitenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["taetigkeit"], "$tblprojektzeiten.fiTaetigkeit" );

// Kundenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["kunde"], "$tblprojekte.fiKunde" );

// projektzeitenstatusgeprueftfilter
if ($filter [$listenname] ["projektzeitengeprueftstatus"] != "") {
	$query .= " and $tblprojektzeiten.dtStundennachweisGeprueft = '" . ($filter [$listenname] ["projektzeitengeprueftstatus"] - 1) . "' ";
}

// projektzeitenabgerechnetstatusfilter
if ($filter [$listenname] ["projektzeitenabgerechnetstatus"] != "") {
	$query .= " and $tblprojektzeiten.dtAbgerechnet = '" . ($filter [$listenname] ["projektzeitenabgerechnetstatus"] - 1) . "' ";
}

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and to_days(dtDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "')";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and to_days(dtDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "')";
	}
}

// Uhrzeitbereich
if ($filter [$listenname] ["uhrzeitbereich"] != "") {
	
	$uhrzeit_explode = explode ( "-", $filter [$listenname] ["uhrzeitbereich"] );
	$uhrzeit_stunde_von = $uhrzeit_explode [0];
	$uhrzeit_minute_von = $uhrzeit_explode [1];
	$uhrzeit_stunde_bis = $uhrzeit_explode [2];
	$uhrzeit_minute_bis = $uhrzeit_explode [3];
	
	if (! ($uhrzeit_stunde_von == 24 and $uhrzeit_minute_von == 60) and ! ($uhrzeit_stunde_von == "" and $uhrzeit_minute_von == "")) {
		$query .= " and (time_to_sec(dtBeginnZeit) >= time_to_sec('" . concat_time ( $uhrzeit_stunde_von, $uhrzeit_minute_von, 0 ) . "')";
		$query .= " or time_to_sec(dtEndeZeit) >= time_to_sec('" . concat_time ( $uhrzeit_stunde_von, $uhrzeit_minute_von, 0 ) . "'))";
	}
	
	if (! ($uhrzeit_stunde_bis == 24 and $uhrzeit_minute_bis == 60) and ! ($uhrzeit_stunde_bis == "" and $uhrzeit_minute_bis == "")) {
		$query .= " and time_to_sec(dtBeginnZeit) <= time_to_sec('" . concat_time ( $uhrzeit_stunde_bis, $uhrzeit_minute_bis, 0 ) . "')";
	}
}

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sie dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ Felder formatieren
		if ($liste_output [$listenzeile_id] ["dtDatum"] != "2030-01-01") {
			$datum = split_date ( $liste [$listenzeile_id] ["dtDatum"] );
		}
		
		$liste_output [$listenzeile_id] ["dtDatum"] = date_from_sql ( $liste [$listenzeile_id] ["dtDatum"] );
		
		$query = $sql_query ["kontaktliste"] . " and $tblkontakte.id = '" . $liste [$listenzeile_id] ["fiMitarbeiter"] . "' ";
		$mitarbeiter_field = get_table_row ( $query );
		$liste_output [$listenzeile_id] ["dtKontaktDDText2"] = shortcutlink ( format_name_html ( $mitarbeiter_field ["dtKontaktDDText2"] ), "kontakte", "show", $liste [$listenzeile_id] ["fiMitarbeiter"], $benutzerrechte );
		
		if ($liste [$listenzeile_id] ["fiTaetigkeit"] != 0) {
			$query = $sql_query ["taetigkeitenliste"] . " and $tbltaetigkeiten.id = '" . $liste [$listenzeile_id] ["fiTaetigkeit"] . "' ";
			$taetigkeit_field = get_table_row ( $query );
			$taetigkeit_array = explode ( " | ", $taetigkeit_field ["dtTaetigkeitDDText"] );
			$taetigkeit_text = $taetigkeit_array [0] . " | " . $taetigkeit_array [1];
		} else {
			$taetigkeit_text = "";
		}
		$liste_output [$listenzeile_id] ["dtTaetigkeitDDText"] = $taetigkeit_text;
		
		if ($liste [$listenzeile_id] ["fiProjekt"] != 0) {
			$query = $sql_query ["projektliste"] . " and $tblprojekte.id = '" . $liste [$listenzeile_id] ["fiProjekt"] . "' ";
			$projekt_field = get_table_row ( $query );
			$projekt_text = shortcutlink ( format_name_html ( $projekt_field ["dtProjektDDText"] ), "projekte", "show", $liste [$listenzeile_id] ["fiProjekt"], $benutzerrechte );
		} else {
			$projekt_text = "";
		}
		$liste_output [$listenzeile_id] ["dtProjektDDText"] = $projekt_text;
		$liste_output [$listenzeile_id] ["dtTeilprojektName"] = $liste [$listenzeile_id] ["dtTeilprojektName"];
		
		$liste_output [$listenzeile_id] ["dtProjektzeitDezimal"] = double_from_sql ( $liste [$listenzeile_id] ["dtProjektzeitDezimal"], 2 );
		
		$liste_output [$listenzeile_id] ["dtStdSatz"] = preis_from_sql ( $liste [$listenzeile_id] ["dtStdSatz"] );
		$liste_output [$listenzeile_id] ["dtStdSatzGesamt"] = preis_from_sql ( $liste [$listenzeile_id] ["dtStdSatz"] * $liste [$listenzeile_id] ["dtProjektzeitDezimal"] );
		
		$liste_output [$listenzeile_id] ["dtErlaeuterungStundennachweis"] = $liste [$listenzeile_id] ["dtErlaeuterungStundennachweis"];
		$liste_output [$listenzeile_id] ["dtBemerkungKontrolle"] = $liste [$listenzeile_id] ["dtBemerkungKontrolle"];
		
		// +++++++++++ Buttons hinzufgen
		$filterarray = str_replace ( "\"", "&quot;", serialize ( array (
				"mitarbeiter" => $liste [$listenzeile_id] ["fiMitarbeiter"],
				"geraet" => "",
				"stempelcode" => "",
				"stempelzeitenstatus" => "",
				"uhrzeitbereich" => "24-6024-60",
				"datum" => $datum ["tag"] . "-" . $datum ["monat"] . "-" . $datum ["jahr"] . "-" . $datum ["tag"] . "-" . $datum ["monat"] . "-" . $datum ["jahr"] 
		) ) );
		$liste_output [$listenzeile_id] ["Buttons"] = "<nobr>";
		$liste_output [$listenzeile_id] ["Buttons"] = button ( "SN", "stundennachweis", "list", "", $benutzerrechte, "&listenname=stundennachweis&filterwert_neu=" . $filterarray, $liste [$listenzeile_id] ["dtBemerkungKontrolle"] );
		$liste_output [$listenzeile_id] ["Buttons"] .= button ( "SN", "coestundennachweis", "list", "", $benutzerrechte, "&listenname=stundennachweis&filterwert_neu=" . $filterarray, $liste [$listenzeile_id] ["dtBemerkungKontrolle"] );
		$liste_output [$listenzeile_id] ["Buttons"] .= button ( "SN", "eshaesstundennachweis", "list", "", $benutzerrechte, "&listenname=stundennachweis&filterwert_neu=" . $filterarray, $liste [$listenzeile_id] ["dtBemerkungKontrolle"] );
		$liste_output [$listenzeile_id] ["Buttons"] .= "</nobr>";
		
		// +++++++++++ Summen berechnen
		$text_taetigkeit [$liste [$listenzeile_id] ["fiTaetigkeit"]] = $taetigkeit_text;
		$summe_projektzeit [$liste [$listenzeile_id] ["fiTaetigkeit"]] = $summe_projektzeit [$liste [$listenzeile_id] ["fiTaetigkeit"]] + $liste [$listenzeile_id] ["dtProjektzeitDezimal"];
		$summe_taetigkeit [$liste [$listenzeile_id] ["fiTaetigkeit"]] = $summe_taetigkeit [$liste [$listenzeile_id] ["fiTaetigkeit"]] + ($liste [$listenzeile_id] ["dtStdSatz"] * $liste [$listenzeile_id] ["dtProjektzeitDezimal"]);
		
		if ($liste [$listenzeile_id] ["fiTeilprojekt"] == 0) {
			$summenid = $liste [$listenzeile_id] ["fiProjekt"] . "%%%OT";
			if ($text_projekt [$summenid] == "") {
				$text_projekt [$summenid] = $projekt_text;
			}
		} else {
			$teilprojekte_vorhanden = true;
			$summenid = $liste [$listenzeile_id] ["fiProjekt"] . "%%%" . $liste [$listenzeile_id] ["fiTeilprojekt"];
			$text_projekt [$summenid] = $projekt_text . " -- " . $liste [$listenzeile_id] ["dtTeilprojektName"];
			
			$text_projekt [$liste [$listenzeile_id] ["fiProjekt"] . "%%%OT"] = $projekt_text . " (ohne Teilprojekt)";
		}
		$summe_teilprojektzeit_projekt [$summenid] = $summe_teilprojektzeit_projekt [$summenid] + $liste [$listenzeile_id] ["dtProjektzeitDezimal"];
		$summe_teilprojekt [$summenid] = $summe_teilprojekt [$summenid] + ($liste [$listenzeile_id] ["dtStdSatz"] * $liste [$listenzeile_id] ["dtProjektzeitDezimal"]);
		
		$summe_projektzeit_gesamt = $summe_projektzeit_gesamt + $liste [$listenzeile_id] ["dtProjektzeitDezimal"];
		$summe_taetigkeit_gesamt = $summe_taetigkeit_gesamt + ($liste [$listenzeile_id] ["dtStdSatz"] * $liste [$listenzeile_id] ["dtProjektzeitDezimal"]);
		
		$text_projekt [$liste [$listenzeile_id] ["fiProjekt"]] = $projekt_text;
		$summe_projektzeit_projekt [$liste [$listenzeile_id] ["fiProjekt"]] = $summe_projektzeit_projekt [$liste [$listenzeile_id] ["fiProjekt"]] + $liste [$listenzeile_id] ["dtProjektzeitDezimal"];
		$summe_projekt [$liste [$listenzeile_id] ["fiProjekt"]] = $summe_projekt [$liste [$listenzeile_id] ["fiProjekt"]] + ($liste [$listenzeile_id] ["dtStdSatz"] * $liste [$listenzeile_id] ["dtProjektzeitDezimal"]);
		
		$summe_projektzeit_gesamt_projekt = $summe_projektzeit_gesamt_projekt + $liste [$listenzeile_id] ["dtProjektzeitDezimal"];
		$summe_projekt_gesamt = $summe_projekt_gesamt + ($liste [$listenzeile_id] ["dtStdSatz"] * $liste [$listenzeile_id] ["dtProjektzeitDezimal"]);
		
		$text_mitarbeiter [$liste [$listenzeile_id] ["fiMitarbeiter"]] = $liste_output [$listenzeile_id] ["dtKontaktDDText2"];
		$summe_projektzeit_mitarbeiter [$liste [$listenzeile_id] ["fiMitarbeiter"]] = $summe_projektzeit_mitarbeiter [$liste [$listenzeile_id] ["fiMitarbeiter"]] + $liste [$listenzeile_id] ["dtProjektzeitDezimal"];
		$summe_mitarbeiter [$liste [$listenzeile_id] ["fiMitarbeiter"]] = $summe_mitarbeiter [$liste [$listenzeile_id] ["fiMitarbeiter"]] + ($liste [$listenzeile_id] ["dtStdSatz"] * $liste [$listenzeile_id] ["dtProjektzeitDezimal"]);
		
		$summe_projektzeit_gesamt_mitarbeiter = $summe_projektzeit_gesamt_mitarbeiter + $liste [$listenzeile_id] ["dtProjektzeitDezimal"];
		$summe_mitarbeiter_gesamt = $summe_mitarbeiter_gesamt + ($liste [$listenzeile_id] ["dtStdSatz"] * $liste [$listenzeile_id] ["dtProjektzeitDezimal"]);
	}
}

// Zeilen zum Listenobjekt hinzufgen
$oListe->addZeilen ( $liste_output );

?>