<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["projektzeitenliste"];
$anzahl_gesamt = get_table_count_complete ( $tblprojektzeiten );

if($me == "boeker")
{
	$sProjektListenname = "boekerprojekt";
	$sMitarbeiterListenname = "boekermitarbeiter";
}
else
{
	$sProjektListenname = "projekt";
	$sMitarbeiterListenname = "mitarbeiter";
}

// Mitarbeiter
$query .= filter_multiselect_return_query ( $filter [$listenname] [$sMitarbeiterListenname], "$tblprojektzeiten.fiMitarbeiter" );

// Projektverantwortlicherfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["projektverantwortlicher"], "$tblprojekte.fiProjektVerantwortlicher" );

// Projektfilter
if ($filter [$listenname] [$sProjektListenname] != "") {
	if (in_array ( "-1", ( array ) $filter [$listenname] [$sProjektListenname] )) {
		$query .= " and $tblprojektzeiten.fiProjekt = 0 ";
	}
	if (in_array ( "-2", ( array ) $filter [$listenname] [$sProjektListenname] )) {
		$query .= " and $tblprojektzeiten.fiProjekt != 0 ";
	}
	
	$query .= filter_multiselect_return_query ( $filter [$listenname] [$sProjektListenname], "$tblprojektzeiten.fiProjekt", false, false, false, array (
			"-1",
			"-2" 
	) );
}

// Teil-Projektfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["teilprojekt"], "$tblprojektzeiten.fiTeilprojekt" );
$teilprojekte_vorhanden = false;

// Ttigkeitenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["taetigkeit"], "$tblprojektzeiten.fiTaetigkeit" );

// Kundenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["kunde"], "$tblprojekte.fiKunde" );

// projektzeitenstatusgeprueftfilter
if ($filter [$listenname] ["projektzeitengeprueftstatus"] != "") {
	$query .= " and $tblprojektzeiten.dtStundennachweisGeprueft = '" . ($filter [$listenname] ["projektzeitengeprueftstatus"] - 1) . "' ";
}

// projektzeitenabgerechnetstatusfilter
if ($filter [$listenname] ["projektzeitenabgerechnetstatus"] != "") {
	$query .= " and $tblprojektzeiten.dtAbgerechnet = '" . ($filter [$listenname] ["projektzeitenabgerechnetstatus"] - 1) . "' ";
}

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and to_days(dtDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "')";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and to_days(dtDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "')";
	}
}

// Uhrzeitbereich
if ($filter [$listenname] ["uhrzeitbereich"] != "") {
	
	$uhrzeit_explode = explode ( "-", $filter [$listenname] ["uhrzeitbereich"] );
	$uhrzeit_stunde_von = $uhrzeit_explode [0];
	$uhrzeit_minute_von = $uhrzeit_explode [1];
	$uhrzeit_stunde_bis = $uhrzeit_explode [2];
	$uhrzeit_minute_bis = $uhrzeit_explode [3];
	
	if (! ($uhrzeit_stunde_von == 24 and $uhrzeit_minute_von == 60) and ! ($uhrzeit_stunde_von == "" and $uhrzeit_minute_von == "")) {
		$query .= " and (time_to_sec(dtBeginnZeit) >= time_to_sec('" . concat_time ( $uhrzeit_stunde_von, $uhrzeit_minute_von, 0 ) . "')";
		$query .= " or time_to_sec(dtEndeZeit) >= time_to_sec('" . concat_time ( $uhrzeit_stunde_von, $uhrzeit_minute_von, 0 ) . "'))";
	}
	
	if (! ($uhrzeit_stunde_bis == 24 and $uhrzeit_minute_bis == 60) and ! ($uhrzeit_stunde_bis == "" and $uhrzeit_minute_bis == "")) {
		$query .= " and time_to_sec(dtBeginnZeit) <= time_to_sec('" . concat_time ( $uhrzeit_stunde_bis, $uhrzeit_minute_bis, 0 ) . "')";
	}
}

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . " limit 0,5000";

$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ Zeile durch Textfilter laufen lassen
		// $liste_output[$listenzeile_id] = liste_output_textfilter($listenzeile, $field_textfilter_active, $filter[$listenname]["textfilter"]);
		
		// +++++++++++ Felder formatieren
		$liste_output [$listenzeile_id] ["dtDatum"] = date_from_sql ( $liste [$listenzeile_id] ["dtDatum"] );
		
		$query = $sql_query ["kontaktliste"] . " and $tblkontakte.id = '" . $liste [$listenzeile_id] ["fiMitarbeiter"] . "' ";
		$mitarbeiter_field = get_table_row ( $query );
		$liste_output [$listenzeile_id] ["dtKontaktDDText2"] = shortcutlink ( format_name_html ( $mitarbeiter_field ["dtKontaktDDText2"] ), "kontakte", "show", $liste [$listenzeile_id] ["fiMitarbeiter"], $benutzerrechte );
		
		$liste_output [$listenzeile_id] ["dtProjektzeitDezimal"] = double_from_sql ( $liste [$listenzeile_id] ["dtProjektzeitDezimal"], 2 ) . " h";
		
		if ($liste [$listenzeile_id] ["fiTaetigkeit"] != 0) {
			$query = $sql_query ["taetigkeitenliste"] . " and $tbltaetigkeiten.id = '" . $liste [$listenzeile_id] ["fiTaetigkeit"] . "' ";
			$taetigkeit_field = get_table_row ( $query );
			$taetigkeit_text_array = explode ( "|", $taetigkeit_field ["dtTaetigkeitDDText"] );
			$taetigkeit_text_kurz = $taetigkeit_text_array [0] . " | " . $taetigkeit_text_array [1];
			$taetigkeit_text = $taetigkeit_field ["dtTaetigkeitDDText"];
		} else {
			$taetigkeit_text_kurz = "";
			$taetigkeit_text = "";
		}
		$liste_output [$listenzeile_id] ["dtTaetigkeitDDText"] = $taetigkeit_text_kurz;
		
		$liste_output [$listenzeile_id] ["dtStdSatz"] = preis_from_sql ( $liste [$listenzeile_id] ["dtStdSatz"], "PDF" );
		$liste_output [$listenzeile_id] ["dtStdSatzGesamt"] = preis_from_sql ( $liste [$listenzeile_id] ["dtStdSatz"] * $liste [$listenzeile_id] ["dtProjektzeitDezimal"], "PDF" );
		
		$liste_output [$listenzeile_id] ["dtErlaeuterungStundennachweis"] = $liste [$listenzeile_id] ["dtErlaeuterungStundennachweis"];
		$liste_output [$listenzeile_id] ["dtBemerkungKontrolle"] = $liste [$listenzeile_id] ["dtBemerkungKontrolle"];
		
		// +++++++++++ Buttons hinzufgen
		
		// +++++++++++ Summen berechnen
		$text_taetigkeit [$liste [$listenzeile_id] ["fiTaetigkeit"]] = $taetigkeit_text;
		$summe_projektzeit [$liste [$listenzeile_id] ["fiTaetigkeit"]] = $summe_projektzeit [$liste [$listenzeile_id] ["fiTaetigkeit"]] + $liste [$listenzeile_id] ["dtProjektzeitDezimal"];
		$summe_taetigkeit [$liste [$listenzeile_id] ["fiTaetigkeit"]] = $summe_taetigkeit [$liste [$listenzeile_id] ["fiTaetigkeit"]] + ($liste [$listenzeile_id] ["dtStdSatz"] * $liste [$listenzeile_id] ["dtProjektzeitDezimal"]);
		
		$summe_projektzeit_gesamt = $summe_projektzeit_gesamt + $liste [$listenzeile_id] ["dtProjektzeitDezimal"];
		$summe_taetigkeit_gesamt = $summe_taetigkeit_gesamt + ($liste [$listenzeile_id] ["dtStdSatz"] * $liste [$listenzeile_id] ["dtProjektzeitDezimal"]);
	}
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ hole Layout Infos
$query = $sql_query ["dokumentlayoutliste"] . " and $tbldokumentlayout.id = '" . $standard_layout_liste_querformat . "'";
$field = get_table_row ( $query );

$layout_vorlagen_ersteseite = unserialize ( $field ["dtVorlagenErsteSeite"] );
$layout_vorlagen_folgeseiten = unserialize ( $field ["dtVorlagenFolgeSeiten"] );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ Definiere Seitenrnder
$typ = "seitenraender";
include ("$functionsordner/function_pdf.php");

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge neues PDF Dokument (nur fr Berechnung von Feldbreiten, je nach Schriftart)
$pdf = new PDF ();
$pdf->new_document ( $field ["dtDokumentName"], $ausrichtung );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge Listenkopf
$printzeile = 0;

foreach ( $show_fields as $key => $show_field ) {
	$feldinhalte [$show_field] = $field_headlines [$key];
}

$liste_print [$printzeile] ["zeilentyp"] = "kopfzeile";
$liste_print [$printzeile] ["zeilennr"] = 1;
$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
$liste_print [$printzeile] ["feldinhalte"] = $feldinhalte;
$liste_print [$printzeile] ["feldbreiten"] = $field_width;
$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = $schriftausrichtung_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];

$printzeile ++;

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ bearbeite Liste zeilenweise, wenn es der Textfilter erlaubt
$zeilenzahl = 1;
if (is_array ( $liste_output )) {
	foreach ( $liste_output as $zeile => $listenzeile ) {
		if ($liste_output [$zeile] ["Textfilter"] != "nomatch") {
			
			// ++++ formatiere Listenfelder (HTML zu PDF) (Schriftart muss gesetzt sein fr Zeilenberechnung)
			foreach ( $show_fields as $key => $show_field ) {
				
				$pdf->SetFont ( "$field[dtStandardSchriftArt]", "", $field ["dtStandardSchriftGroesse"] );
				$tabellenzeile [$show_field] = $pdf->format_tabellenfeld ( $listenzeile [$show_field], $field_width [$key] );
			}
			
			// ++++ berechne grte Zeilenanzahl der Listenfelder
			$maxzeilen = $pdf->get_maxzeilen ( $tabellenzeile );
			
			// ++++ erzeuge neues Array mit jeweils einer Textzeile
			for($n = 0; $n < $maxzeilen; $n ++) {
				
				foreach ( $show_fields as $key => $show_field ) {
					$feldinhalte [$show_field] = $pdf->extract_print_zeile ( $tabellenzeile [$show_field], $n );
				}
				
				$liste_print [$printzeile] ["zeilentyp"] = "zeile";
				$liste_print [$printzeile] ["zeilennr"] = $n + 1;
				$liste_print [$printzeile] ["zeilenmaxnr"] = $maxzeilen;
				$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
				$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
				$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
				$liste_print [$printzeile] ["feldinhalte"] = $feldinhalte;
				$liste_print [$printzeile] ["feldbreiten"] = $field_width;
				if ($zeilenzahl % 2 == 0) {
					$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_gerade;
				} else {
					$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_ungerade;
				}
				$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_textzeile;
				$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_textzeile;
				$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_textzeile;
				$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = $schriftausrichtung_textzeile;
				$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
				$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];
				
				$printzeile ++;
			}
			$zeilenzahl ++;
		}
	}
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge Listenfu

$liste_print [$printzeile] = $liste_print [0];
$liste_print [$printzeile] ["zeilentyp"] = "fusszeile";
$liste_print [$printzeile] ["feldinhalte"] = array (
		"Anzahl: " . ($zeilenzahl - 1) 
);
$liste_print [$printzeile] ["feldbreiten"] = array (
		array_sum ( $field_width ) 
);

$printzeile ++;
$liste_print [$printzeile] ["zeilentyp"] = "zeile";
$liste_print [$printzeile] ["zeilennr"] = 1;
$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
$liste_print [$printzeile] ["zeilenhoehe"] = 10;
$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
$liste_print [$printzeile] ["feldinhalte"] = array (
		"." 
);
$liste_print [$printzeile] ["feldbreiten"] = $field_width;
$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_ungerade;
$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = $schriftausrichtung_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];

$printzeile ++;

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge Listenkopf fr Summentabelle

foreach ( $show_fields2 as $key => $show_field ) {
	$feldinhalte [$show_field] = $field_headlines2 [$key];
}

$liste_print [$printzeile] ["zeilentyp"] = "kopfzeile";
$liste_print [$printzeile] ["zeilennr"] = 1;
$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
$liste_print [$printzeile] ["feldinhalte"] = $feldinhalte;
$liste_print [$printzeile] ["feldbreiten"] = $field_width2;
$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = $schriftausrichtung_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];

$printzeile ++;

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge Summen-Liste zeilenweise
foreach ( ( array ) $summe_taetigkeit as $key => $value ) {
	
	$feldinhalte ["dtDatum"] = "";
	$feldinhalte ["dtTaetigkeitDDText"] = $text_taetigkeit [$key];
	$feldinhalte ["dtProjektzeitDezimal"] = double_from_sql ( $summe_projektzeit [$key], 2 ) . " h";
	$feldinhalte ["dtStdSatzGesamt"] = preis_from_sql ( $summe_taetigkeit [$key], "PDF" );
	
	$liste_print [$printzeile] ["zeilentyp"] = "zeile";
	$liste_print [$printzeile] ["zeilennr"] = 1;
	$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
	$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
	$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
	$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
	$liste_print [$printzeile] ["feldinhalte"] = $feldinhalte;
	$liste_print [$printzeile] ["feldbreiten"] = $field_width2;
	if ($zeilenzahl % 2 == 0) {
		$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_gerade;
	} else {
		$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_ungerade;
	}
	$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_textzeile;
	$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_textzeile;
	$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_textzeile;
	$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = $schriftausrichtung_textzeile;
	$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
	$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];
	
	$printzeile ++;
	$zeilenzahl ++;
}

$feldinhalte ["dtDatum"] = "";
$feldinhalte ["dtTaetigkeitDDText"] = "";
$feldinhalte ["dtProjektzeitDezimal"] = double_from_sql ( $summe_projektzeit_gesamt, 2 ) . " h";
$feldinhalte ["dtStdSatzGesamt"] = preis_from_sql ( $summe_taetigkeit_gesamt, "PDF" );

$liste_print [$printzeile] ["zeilentyp"] = "fusszeile";
$liste_print [$printzeile] ["zeilennr"] = 1;
$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
$liste_print [$printzeile] ["feldinhalte"] = $feldinhalte;
$liste_print [$printzeile] ["feldbreiten"] = $field_width2;
$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = $schriftausrichtung_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];

$printzeile ++;

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ schliesse temporres PDF Dokument
$pdf->Close ();

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ fge Seitenumbrche ein
$liste_print = $pdf->tabellenseitenumbrueche ( $liste_print, round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ), $druckhoehe_p1, $druckhoehe );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ drucke alle Seiten
$pdf->tabelle_output ( $liste_print, $rand_links_p1, $rand_oben_p1, $rand_links, $rand_oben, $druckbreite_p1, $druckbreite, $dateiname, $field ["dtDokumentName"], $ausrichtung );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge ggf. Seite mit Infofeld auf erster Seite
if ($field ["dtInfofeldVorhanden"] == 1) {
	// $infofeld_array = create_infofeld_liste_array ("Leistungsbeschreibung", $field["dtInfofeldSchriftArt"], $field["dtInfofeldSchriftGroesse"], $filter[$listenname], $sortierung[$listenname], $field_headlines, $show_fields);
	$infofeld_array = create_infofeld_liste_array ( "Leistungsbeschreibung", $field ["dtInfofeldSchriftArt"], $field ["dtInfofeldSchriftGroesse"], $filter [$listenname], array (), $field_headlines, $show_fields );
	create_infofeldseite ( $infofeld_array, $ausrichtung, $field ["dtInfofeldLinks"], $field ["dtInfofeldOben"], $seitenbreite - $field ["dtInfofeldLinks"] - $field ["dtInfofeldRechts"], $seitenhoehe - $field ["dtInfofeldOben"] - $field ["dtInfofeldUnten"] );
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge ggf. Seite mit Datumsfeld auf erster Seite
if ($field ["dtDatumsfeldVorhanden"] == 1) {
	create_datumsfeldseite ( $field ["dtDatumsfeldText"], $ausrichtung, $field ["dtDatumsfeldLinks"], $field ["dtDatumsfeldOben"], $seitenbreite - $field ["dtDatumsfeldLinks"] - $field ["dtDatumsfeldRechts"], $field ["dtDatumsfeldSchriftArt"], $field ["dtDatumsfeldSchriftGroesse"] );
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge ggf. Seiten mit Seitenzahl-Feld fr alle Seiten
if ($field ["dtSeitenzahlfeldVorhanden"] == 1) {
	create_seitenzahlseiten ( $field ["dtSeitenzahlfeldText"], $ausrichtung, $field ["dtSeitenzahlfeldLinks"], $field ["dtSeitenzahlfeldOben"], $seitenbreite - $field ["dtSeitenzahlfeldLinks"] - $field ["dtSeitenzahlfeldRechts"], $field ["dtSeitenzahlfeldSchriftArt"], $field ["dtSeitenzahlfeldSchriftGroesse"] );
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ hinzufgen des Layouts und zusammenfhren aller Seiten
$output_filename = create_document ( $layout_vorlagen_ersteseite, $layout_vorlagen_folgeseiten );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ Ausgabe des PDF im Browser durch Reload der Seite
output_reload ( $output_filename );

?>