<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["taskplanerliste"];
$anzahl_gesamt = get_table_count_complete ( $tbltaskplaner );

// Volltextsuche
$query .= create_fulltext_index_search ( array (
		$tbltaskplaner 
), $filter [$listenname] ["textfilter"] );

// wenn es eine Sortierung gibt, dann füge sie dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann füge sei dem SQL-String hinzu
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = liste_output_textfilter_markieren ( $listenzeile, $field_textfilter_active, $filter [$listenname] ["textfilter"] );
		
		// +++++++++++ Felder formatieren
		$liste_output [$listenzeile_id] ["dtReturncode"] = taskplanerReturncodeReadable ( $liste_output [$listenzeile_id] ["dtReturncode"] );
		$liste_output [$listenzeile_id] ["dtAnzeigeName"] = "<span title=\"" . $liste_output [$listenzeile_id] ["dtAnzeigeName"] . "\">" . $liste_output [$listenzeile_id] ["dtAnzeigeName"] . "</span>";
		$liste_output [$listenzeile_id] ["dtBeschreibung"] = "<span title=\"" . $liste_output [$listenzeile_id] ["dtBeschreibung"] . "\">" . $liste_output [$listenzeile_id] ["dtBeschreibung"] . "</span>";
		$liste_output [$listenzeile_id] ["dtLetzteAusfuehrung"] = datetime_from_sql ( $liste_output [$listenzeile_id] ["dtLetzteAusfuehrung"] );
		
		if (trim ( $liste_output [$listenzeile_id] ["dtLetzteAusfuehrung"] ) == "00:00") {
			$liste_output [$listenzeile_id] ["dtLetzteAusfuehrung"] = "nie";
			$liste_output [$listenzeile_id] ["dtReturncode"] = "";
		}
		
		if ($liste_output [$listenzeile_id] ["dtAktiv"] == 1) {
			$liste_output [$listenzeile_id] ["dtAktiv"] = "X";
		} else {
			$liste_output [$listenzeile_id] ["dtAktiv"] = "";
		}
		
		// +++++++++++ Buttons hinzufügen
		$liste_output [$listenzeile_id] ["ButtonAnzeigen"] = detailbutton ( $liste [$listenzeile_id] ["Taskplaner_id"], $target, $benutzerrechte );
	}
}

// Zeilen zum Listenobjekt hinzufügen
$oListe->addZeilen ( $liste_output );

?>