<?php

// ++++++++++++++++++++++++++++++++
// +++++++++++ SQL Abfrage
$query = $sql_query ["umsatzliste"];
$anzahl_gesamt = get_table_count ( $query );

// Bankkontofilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["bankkonto"], "$tblbankumsatz.fiBankKonto" );

// Buchungskontofilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["buchungskonto"], "$tblbankumsatz.fiBuchungsKonto" );

// Lieferantenfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["lieferant"], "$tblrechnungen.fiLieferant" );

// Kundefilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["kunde"], "$tblbelege.fiKunde" );

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$bDatumfilterAktiv = true;
		$query .= " and to_days(dtValutaDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "')";
	} else {
		$bDatumfilterAktiv = false;
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and to_days(dtValutaDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "')";
	}
}

// Volltextsuche
$query .= create_fulltext_index_search ( array (
		$tblbankumsatz,
		$tblbankkonten,
		$tblrechnungen,
		$tblbelege 
), $filter [$listenname] ["textfilter"] );

// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

$query .= $sortierung_sql;

// Bestand am Anfang
$dBestandAnfang = 0.00;
foreach ( ( array ) $filter [$listenname] ["bankkonto"] as $iBankkonto ) {
	$dBestandAnfang += kontostand ( $iBankkonto, $datum_jahr_von . "-" . $datum_monat_von . "-" . $datum_tag_von, false );
}

$aListeAnfangsbestand = array (
		array (
				"dtKontoName" => "Kontostand am " . $datum_tag_von . "." . $datum_monat_von . "." . $datum_jahr_von,
				"dtValutaBetrag" => $dBestandAnfang 
		) 
);

$liste = get_table_array ( $query );

if (! empty ( $filter [$listenname] ["bankkonto"] ) && $bDatumfilterAktiv) // Kontostand nur zeigen wenn Filterung auf Bankkonto und Datum
{
	$liste = array_merge ( $aListeAnfangsbestand, $liste );
}

$dBestand = 0.00;
$iOffset = 0;
$dSummeEinnahmen = 0.00;
$dSummeAusgaben = 0.00;

// ++++++++++++++++++++++++++++++++
// +++++++++++ Listenwerte formatieren
unset ( $liste_output );
if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		if ($listenzeile ["dtUmsatzDifferenz"] == 1)
			continue;
		
		$listenzeile_id += $iOffset;
		
		// +++++++++++ Zeile durch Textfilter laufen lassen
		$liste_output [$listenzeile_id] = $listenzeile;
		
		// +++++++++++ Summe aller angeziegten Umstze berechnen
		if ($liste_output [$listenzeile_id] ["Textfilter"] != "nomatch") {
			$umsatzsumme = $umsatzsumme + $liste_output [$listenzeile_id] ["dtValutaBetrag"];
		}
		
		$dBestand += $liste_output [$listenzeile_id] ["dtValutaBetrag"];
		
		if ($liste_output [$listenzeile_id] ["dtValutaBetrag"] < 0) {
			$dSummeAusgaben -= $liste_output [$listenzeile_id] ["dtValutaBetrag"];
		} else {
			$dSummeEinnahmen += $liste_output [$listenzeile_id] ["dtValutaBetrag"];
		}
		
		// +++++++++++ Felder formatieren
		$liste_output [$listenzeile_id] ["dtKontoBezeichnung"] = $liste_output [$listenzeile_id] ["dtKontoID"] . " | " . $liste_output [$listenzeile_id] ["dtKontoBezeichnung"];
		
		$liste_output [$listenzeile_id] ["dtValutaDatum"] = date_from_sql ( $liste_output [$listenzeile_id] ["dtValutaDatum"] );
		$liste_output [$listenzeile_id] ["dtValutaBetrag"] = preis_from_sql ( $liste_output [$listenzeile_id] ["dtValutaBetrag"], "PDF" );
		if ($liste_output [$listenzeile_id] ["dtUmsatzGebucht"] == 0) {
			$liste_output [$listenzeile_id] ["dtUmsatzGebucht"] = "";
		} else {
			$liste_output [$listenzeile_id] ["dtUmsatzGebucht"] = "X";
		}
		
		$liste_output [$listenzeile_id] ["dtBestand"] = preis_from_sql ( $dBestand, "PDF" );
		
		if ($listenzeile ["fiBeleg"] > 0 || $listenzeile ["fiRechnung"] > 0) {
			$liste_output [$listenzeile_id] ["dtKontoBezeichnung"] = "";
			$liste_output [$listenzeile_id] ["dtBuchhaltungKonto"] = "";
		}
		
		if ($listenzeile ["fiBeleg"] > 0) {
			$aKunde = get_table_row ( $sql_query ["kontaktliste"] . " and $tblkontakte.id = " . $listenzeile ["fiKunde"] );
			$dFaktor = double_to_sql ( $liste_output [$listenzeile_id] ["dtValutaBetrag"] ) / belegendbetrag_brutto ( $listenzeile ["fiBeleg"] );
			
			$sSqlPosten = "SELECT SUM(summe) AS summe, mwst, bk FROM (
			(
			SELECT ((dtPreisNetto + dtPreisNetto / 100 * dtMwstSatz) * dtMenge) AS summe, dtMwstSatz AS mwst, fiBuchungsKonto AS bk FROM $tblbelegmaterialposten WHERE fiBeleg = " . $listenzeile ["fiBeleg"] . "

			UNION
			(
			SELECT ((dtPreisNetto + dtPreisNetto / 100 * dtMwstSatz) * dtMenge) AS summe, dtMwstSatz AS mwst, fiBuchungsKonto AS bk FROM $tblbelegposten WHERE fiBeleg = " . $listenzeile ["fiBeleg"] . "
			)
			UNION
			(
			SELECT ((dtPreisNetto + dtPreisNetto / 100 * dtMwstSatz) * dtMenge) AS summe, dtMwstSatz AS mwst, fiBuchungsKonto AS bk FROM $tblbelegzeitposten WHERE fiBeleg = " . $listenzeile ["fiBeleg"] . "
			)

			)) AS sq GROUP BY bk, mwst";
			
			$aListePosten = get_table_array ( $sSqlPosten );
			
			if (count ( $aListePosten ) > 0) {
				foreach ( $aListePosten as $aPosten ) {
					$aBK = get_table_row ( $sql_query ["buchungskontenliste"] . " and $tblbuchungskonten.id = " . $aPosten ["bk"] );
					
					if ($aBK ["dtBuchhaltungKonto"] != "auto") {
						$sBKExtern = $aBK ["dtBuchhaltungKonto"];
					} else {
						if ($aKunde ["dtIstHeimLand"] == "1") {
							$aAutoBKs = unserialize ( $aBK ["dtBuchungsKontoMwstAutoArray"] );
						} elseif ($aKunde ["dtIstEULand"] == "1") {
							$aAutoBKs = unserialize ( $aBK ["dtBuchungsKontoMwstAutoEUArray"] );
						} else {
							$aAutoBKs = unserialize ( $aBK ["dtBuchungsKontoMwstAutoNonEUArray"] );
						}
						
						$sBKExtern = $aAutoBKs [( int ) $aPosten ["mwst"]];
					}
					
					$liste_output [] = array (
							"dtTeilbetrag" => preis_from_sql ( $aPosten ["summe"] * $dFaktor, "PDF" ),
							"dtBuchhaltungKonto" => $sBKExtern,
							"dtKontoBezeichnung" => $aBK ["dtBuchungsKontoDDText"] 
					);
					
					$iOffset ++;
				}
			}
		} elseif ($listenzeile ["fiRechnung"] > 0) {
			$aLieferant = get_table_row ( $sql_query ["kontaktliste"] . " and $tblkontakte.id = " . $listenzeile ["fiLieferant"] );
			$dFaktor = double_to_sql ( $liste_output [$listenzeile_id] ["dtValutaBetrag"] ) / rechnungsendbetrag_brutto ( $listenzeile ["fiRechnung"] );
			$sSqlPosten = "SELECT SUM((dtPreisNetto + dtPreisNetto / 100 * dtMwstSatz) * dtMenge) AS summe, dtMwstSatz AS mwst, fiBuchungsKonto AS bk FROM $tblrechnungposten WHERE fiRechnung = " . $listenzeile ["fiRechnung"] . " GROUP BY bk, mwst";
			
			$aListePosten = get_table_array ( $sSqlPosten );
			
			if (count ( $aListePosten ) > 0) {
				foreach ( $aListePosten as $aPosten ) {
					$aBK = get_table_row ( $sql_query ["buchungskontenliste"] . " and $tblbuchungskonten.id = " . $aPosten ["bk"] );
					
					if ($aBK ["dtBuchhaltungKonto"] != "auto") {
						$sBKExtern = $aBK ["dtBuchhaltungKonto"];
					} else {
						if ($aKunde ["dtIstHeimLand"] == "1") {
							$aAutoBKs = unserialize ( $aBK ["dtBuchungsKontoMwstAutoArray"] );
						} elseif ($aKunde ["dtIstEULand"] == "1") {
							$aAutoBKs = unserialize ( $aBK ["dtBuchungsKontoMwstAutoEUArray"] );
						} else {
							$aAutoBKs = unserialize ( $aBK ["dtBuchungsKontoMwstAutoNonEUArray"] );
						}
						
						$sBKExtern = $aAutoBKs [( int ) $aPosten ["mwst"]];
					}
					
					$liste_output [] = array (
							"dtValutaBetrag" => preis_from_sql ( $aPosten ["summe"] * $dFaktor, "PDF" ),
							"dtBuchhaltungKonto" => $sBKExtern,
							"dtKontoBezeichnung" => $aBK ["dtBuchungsKontoDDText"] 
					);
					
					$iOffset ++;
				}
			}
		}
	}
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ hole Layout Infos
$query = $sql_query ["dokumentlayoutliste"] . " and $tbldokumentlayout.id = '" . $standard_layout_liste_querformat . "'";
$field = get_table_row ( $query );

$layout_vorlagen_ersteseite = unserialize ( $field ["dtVorlagenErsteSeite"] );
$layout_vorlagen_folgeseiten = unserialize ( $field ["dtVorlagenFolgeSeiten"] );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ Definiere Seitenrnder
$typ = "seitenraender";
include ("$functionsordner/function_pdf.php");

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge neues PDF Dokument (nur fr Berechnung von Feldbreiten, je nach Schriftart)
$pdf = new PDF ();
$pdf->new_document ( $field ["dtDokumentName"], $ausrichtung );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge Listenkopf
$printzeile = 0;

foreach ( $show_fields as $key => $show_field ) {
	$feldinhalte [$show_field] = $field_headlines [$key];
}

$liste_print [$printzeile] ["zeilentyp"] = "kopfzeile";
$liste_print [$printzeile] ["zeilennr"] = 1;
$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
$liste_print [$printzeile] ["feldinhalte"] = $feldinhalte;
$liste_print [$printzeile] ["feldbreiten"] = $field_width;
$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = $schriftausrichtung_kopfzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];

$printzeile ++;

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ bearbeite Liste zeilenweise, wenn es der Textfilter erlaubt
$zeilenzahl = 1;
if (is_array ( $liste_output )) {
	foreach ( $liste_output as $zeile => $listenzeile ) {
		if ($liste_output [$zeile] ["Textfilter"] != "nomatch") {
			
			// ++++ formatiere Listenfelder (HTML zu PDF) (Schriftart muss gesetzt sein fr Zeilenberechnung)
			foreach ( $show_fields as $key => $show_field ) {
				
				$pdf->SetFont ( "$field[dtStandardSchriftArt]", "", $field ["dtStandardSchriftGroesse"] );
				$tabellenzeile [$show_field] = $pdf->format_tabellenfeld ( $listenzeile [$show_field], $field_width [$key] );
			}
			
			// ++++ berechne grte Zeilenanzahl der Listenfelder
			$maxzeilen = $pdf->get_maxzeilen ( $tabellenzeile );
			
			// ++++ erzeuge neues Array mit jeweils einer Textzeile
			for($n = 0; $n < $maxzeilen; $n ++) {
				
				foreach ( $show_fields as $key => $show_field ) {
					$feldinhalte [$show_field] = $pdf->extract_print_zeile ( $tabellenzeile [$show_field], $n );
				}
				
				$liste_print [$printzeile] ["zeilentyp"] = "zeile";
				$liste_print [$printzeile] ["zeilennr"] = $n + 1;
				$liste_print [$printzeile] ["zeilenmaxnr"] = $maxzeilen;
				$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
				$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
				$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
				$liste_print [$printzeile] ["feldinhalte"] = $feldinhalte;
				$liste_print [$printzeile] ["feldbreiten"] = $field_width;
				if ($zeilenzahl % 2 == 0) {
					$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_gerade;
				} else {
					$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_ungerade;
				}
				$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_textzeile;
				$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_textzeile;
				$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_textzeile;
				$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = $schriftausrichtung_textzeile;
				$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
				$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];
				
				$printzeile ++;
			}
			
			// Farbwechsel nur bei Umstzen
			if ($liste_output [$zeile + 1] ["Umsatz_id"] != "") {
				$zeilenzahl ++;
			}
		}
	}
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ Summenzeilen

if (! empty ( $filter [$listenname] ["bankkonto"] ) && $bDatumfilterAktiv) // Anfangsbestand abziehen wenn Filterung auf Bankkonto und Datum
{
	$dSummeEinnahmen = $dSummeEinnahmen - $dBestandAnfang;
	$umsatzsumme = $umsatzsumme - $dBestandAnfang;
}

$liste_print [$printzeile] ["zeilentyp"] = "zeile";
$liste_print [$printzeile] ["zeilennr"] = 1;
$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
$liste_print [$printzeile] ["feldinhalte"] = array (
		"" 
);
$liste_print [$printzeile] ["feldbreiten"] = $field_width;
$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_ungerade;
$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = $schriftausrichtung_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];
$printzeile ++;

$liste_print [$printzeile] ["zeilentyp"] = "zeile";
$liste_print [$printzeile] ["zeilennr"] = 1;
$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
$liste_print [$printzeile] ["feldinhalte"] = array (
		"Summe Einnahmen",
		preis_from_sql ( $dSummeEinnahmen, "PDF" ) 
);
$liste_print [$printzeile] ["feldbreiten"] = array (
		80,
		30 
);
$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_ungerade;
$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = array (
		"L",
		"R" 
);
$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];
$printzeile ++;

$liste_print [$printzeile] ["zeilentyp"] = "zeile";
$liste_print [$printzeile] ["zeilennr"] = 1;
$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
$liste_print [$printzeile] ["feldinhalte"] = array (
		"Summe Ausgaben",
		preis_from_sql ( $dSummeAusgaben, "PDF" ) 
);
$liste_print [$printzeile] ["feldbreiten"] = array (
		80,
		30 
);
$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_ungerade;
$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = array (
		"L",
		"R" 
);
$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];
$printzeile ++;

$liste_print [$printzeile] ["zeilentyp"] = "zeile";
$liste_print [$printzeile] ["zeilennr"] = 1;
$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
$liste_print [$printzeile] ["feldinhalte"] = array (
		"Summe aller angezeigten Umstze",
		preis_from_sql ( $umsatzsumme, "PDF" ) 
);
$liste_print [$printzeile] ["feldbreiten"] = array (
		80,
		30 
);
$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_ungerade;
$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = array (
		"L",
		"R" 
);
$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];
$printzeile ++;

// Wenn Datumsfilter gesetzt sind, dann berechne Kontostnde vor und nach Datumsfilter
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$kontostand_vor = kontostand ( $filter [$listenname] ["bankkonto"], concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ), false );
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$kontostand_nach = kontostand ( $filter [$listenname] ["bankkonto"], concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) );
	}
}

if ($kontostand_vor != "" or $kontostand_nach != "") {
	
	$liste_print [$printzeile] ["zeilentyp"] = "zeile";
	$liste_print [$printzeile] ["zeilennr"] = 1;
	$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
	$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
	$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
	$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
	$liste_print [$printzeile] ["feldinhalte"] = array (
			"Kontostand vor angezeigtem Zeitraum",
			preis_from_sql ( $kontostand_vor, "PDF" ) 
	);
	$liste_print [$printzeile] ["feldbreiten"] = array (
			80,
			30 
	);
	$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_ungerade;
	$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_textzeile;
	$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_textzeile;
	$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_textzeile;
	$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = array (
			"L",
			"R" 
	);
	$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
	$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];
	$printzeile ++;
	
	$liste_print [$printzeile] ["zeilentyp"] = "zeile";
	$liste_print [$printzeile] ["zeilennr"] = 1;
	$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
	$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
	$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
	$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
	$liste_print [$printzeile] ["feldinhalte"] = array (
			"Kontostand zum Ende des angezeigten Zeitraumes",
			preis_from_sql ( $kontostand_nach, "PDF" ) 
	);
	$liste_print [$printzeile] ["feldbreiten"] = array (
			80,
			30 
	);
	$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_ungerade;
	$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_textzeile;
	$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_textzeile;
	$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_textzeile;
	$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = array (
			"L",
			"R" 
	);
	$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
	$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];
	$printzeile ++;
}

$liste_print [$printzeile] ["zeilentyp"] = "zeile";
$liste_print [$printzeile] ["zeilennr"] = 1;
$liste_print [$printzeile] ["zeilenmaxnr"] = 1;
$liste_print [$printzeile] ["zeilenhoehe"] = round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ) + $zeilen_spacing_innen;
$liste_print [$printzeile] ["zeilen_spacing"] = $zeilen_spacing;
$liste_print [$printzeile] ["zellen_spacing"] = $zellen_spacing;
$liste_print [$printzeile] ["feldinhalte"] = array (
		"aktueller Kontostand",
		preis_from_sql ( kontostand ( $filter [$listenname] ["bankkonto"] ), "PDF" ) 
);
$liste_print [$printzeile] ["feldbreiten"] = array (
		80,
		30 
);
$liste_print [$printzeile] ["formatierungen"] ["hintergrund"] = $hintergrund_textzeile_ungerade;
$liste_print [$printzeile] ["formatierungen"] ["schriftfarbe"] = $schriftfarbe_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["rahmenstil"] = $rahmenstil_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftstil"] = $schriftstil_textzeile;
$liste_print [$printzeile] ["formatierungen"] ["schriftausrichtung"] = array (
		"L",
		"R" 
);
$liste_print [$printzeile] ["formatierungen"] ["schriftart"] = $field ["dtStandardSchriftArt"];
$liste_print [$printzeile] ["formatierungen"] ["schriftgroesse"] = $field ["dtStandardSchriftGroesse"];
$printzeile ++;

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ schliesse temporres PDF Dokument
$pdf->Close ();

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ fge Seitenumbrche ein
$liste_print = $pdf->tabellenseitenumbrueche ( $liste_print, round ( $field ["dtStandardSchriftGroesse"] / 1.9, 0 ), $druckhoehe_p1, $druckhoehe );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ drucke alle Seiten
$pdf->tabelle_output ( $liste_print, $rand_links_p1, $rand_oben_p1, $rand_links, $rand_oben, $druckbreite_p1, $druckbreite, $dateiname, $field ["dtDokumentName"], $ausrichtung );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge ggf. Seite mit Infofeld auf erster Seite
if ($field ["dtInfofeldVorhanden"] == 1) {
	$infofeld_array = create_infofeld_liste_array ( "Umsatzliste", $field ["dtInfofeldSchriftArt"], $field ["dtInfofeldSchriftGroesse"], $filter [$listenname], $sortierung [$listenname], $field_headlines, $show_fields );
	create_infofeldseite ( $infofeld_array, $ausrichtung, $field ["dtInfofeldLinks"], $field ["dtInfofeldOben"], $seitenbreite - $field ["dtInfofeldLinks"] - $field ["dtInfofeldRechts"], $seitenhoehe - $field ["dtInfofeldOben"] - $field ["dtInfofeldUnten"] );
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge ggf. Seite mit Datumsfeld auf erster Seite
if ($field ["dtDatumsfeldVorhanden"] == 1) {
	create_datumsfeldseite ( $field ["dtDatumsfeldText"], $ausrichtung, $field ["dtDatumsfeldLinks"], $field ["dtDatumsfeldOben"], $seitenbreite - $field ["dtDatumsfeldLinks"] - $field ["dtDatumsfeldRechts"], $field ["dtDatumsfeldSchriftArt"], $field ["dtDatumsfeldSchriftGroesse"] );
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ erzeuge ggf. Seiten mit Seitenzahl-Feld fr alle Seiten
if ($field ["dtSeitenzahlfeldVorhanden"] == 1) {
	create_seitenzahlseiten ( $field ["dtSeitenzahlfeldText"], $ausrichtung, $field ["dtSeitenzahlfeldLinks"], $field ["dtSeitenzahlfeldOben"], $seitenbreite - $field ["dtSeitenzahlfeldLinks"] - $field ["dtSeitenzahlfeldRechts"], $field ["dtSeitenzahlfeldSchriftArt"], $field ["dtSeitenzahlfeldSchriftGroesse"] );
}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ hinzufgen des Layouts und zusammenfhren aller Seiten
$output_filename = create_document ( $layout_vorlagen_ersteseite, $layout_vorlagen_folgeseiten );

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++ Ausgabe des PDF im Browser durch Reload der Seite
output_reload ( $output_filename );

?>