<?php

/*
 * Sucht nach neuen Widgets fr das Dashboard und gleicht diese mit der Datenbank ab
 */
if (! function_exists ( "scanDashboardWidgets" )) {
	function scanDashboardWidgets() {
		global $tbldashboard, $sql_query;
		
		$aWidgetsSaved = get_table_array ( $sql_query ["dashboardliste"] );
		$aWidgetsInstalled = str_replace ( "dashboard/", "", glob ( "dashboard/*" ) );
		
		/*
		 * Nicht mehr vorhandene Widgets deinstallieren
		 */
		if (count ( $aWidgetsSaved ) > 0) {
			foreach ( $aWidgetsSaved as $aRow ) {
				$sWidgetName = $aRow ["dtWidgetName"];
				$iWidgetId = $aRow ["id"];
				
				if (! in_array ( $sWidgetName, $aWidgetsInstalled )) {
					delete_from_table ( $tbldashboard, $iWidgetId );
				}
			}
		}
		
		/*
		 * Neue Widgets installieren
		 */
		foreach ( $aWidgetsInstalled as $sWidgetName ) {
			$iAnzahl = get_table_count ( $sql_query ["dashboardliste"] . " and dtWidgetName LIKE '" . $sWidgetName . "'" );
			
			if ($iAnzahl < 1) {
				/*
				 * modul.info lesen
				 */
				$aModulInfo = parseModulInfo ( "dashboard/" . $sWidgetName . "/modul.info" );
				
				$aNewWidget = array ();
				$aNewWidget ["dtWidgetName"] = $sWidgetName;
				$aNewWidget ["dtAnzeigeName"] = $aModulInfo ["name"];
				$aNewWidget ["dtBeschreibung"] = $aModulInfo ["description"];
				$aNewWidget ["dtSortierung"] = get_max_from_table ( $tbldashboard, "dtSortierung" ) + 10;
				
				insert_into_table ( $tbldashboard, $aNewWidget );
			}
		}
	}
}

/*
 * Gibt eine Liste aller anzuzeigenden Widgets fr den angegebenen Benutzer und Gruppe zurck
 */
if (! function_exists ( "getListOfWidgets" )) {
	function getListOfWidgets($iBenutzerId, $iGruppenId) {
		global $tbldashboard, $sql_query;
		
		$sQuery = $sql_query ["dashboardliste"] . " and dtAktiv = 1";
		
		if (! empty ( $iBenutzerId )) {
			$sQuery .= " and (fiBenutzer LIKE '%;" . $iBenutzerId . ";%' OR fiGruppen LIKE '%;" . $iGruppenId . ";%')";
		}
		
		$sQuery .= " ORDER BY dtSortierung ASC";
		
		$aWidgetList = get_table_array ( $sQuery );
		$aWidgets = array ();
		
		if (count ( $aWidgetList ) > 0) {
			foreach ( $aWidgetList as $aRow ) {
				if ($aRow ["dtAnzeigen"] == 1) {
					$bShowWidget = true;
				} else {
					$bShowWidget = false;
				}
				
				$aWidgets [] = array (
						"sName" => $aRow ["dtWidgetName"],
						"sAnzeige" => $aRow ["dtAnzeigeName"],
						"bShowWidget" => $bShowWidget,
						"sBeschreibung" => $aRow ["dtBeschreibung"] 
				);
			}
		}
		
		return $aWidgets;
	}
}

/*
 * Wird genutzt um Widgets auf der Startseite auszugeben
 */
if (! function_exists ( "showWidget" )) {
	function showWidget($sWidgetTyp, $sQueryCount, $sUeberschrift) {
		global $typ, $bShowWidget, $sWidgetBeschreibung;
		
		$iWidgetCount = "";
		
		if (is_int ( $sQueryCount )) {
			$iWidgetCount = $sQueryCount;
		} else {
			if ($sQueryCount != "") {
				$iWidgetCount = get_table_count ( $sQueryCount );
			}
		}
		
		// ++++ berschrift
		if (! empty ( $sWidgetBeschreibung )) {
			$sTitle = "title='" . $sWidgetBeschreibung . "'";
		} else {
			$sTitle = "";
		}
		
		$html .= "<tr><td valign=\"top\" width=\"650\" $sTitle><b>$sUeberschrift: " . $iWidgetCount . "</b></td>";
		$html .= "<td valign=\"top\" width=\"50\">";
		
		// ++++ Detailbutton
		if ($iWidgetCount != 0 && ! $bShowWidget) {
			if ($typ == $sWidgetTyp || $bShowWidget) {
				$html .= minmax_button ( "min", "", "", $id );
			} else {
				$html .= minmax_button ( "max", "", $sWidgetTyp, $id );
			}
		}
		$html .= "</td></tr>";
		
		return $html;
	}
}

?>