<?php
if (! function_exists ( "DumpToFile" )) {
	function DumpToFile($filename, $string) {
		file_put_contents ( $filename, $string );
	}
}

if (! function_exists ( "DumpArrayToText2" )) {
	function DumpArrayToText2($array) {
		while ( list ( $key, $value ) = each ( $array ) ) {
			echo "<b>[$key]</b> => \"$value\"<br>";
		}
	}
}

if (! function_exists ( "DumpArrayToText" )) {
	function DumpArrayToText($myvar) {
		echo '<pre>' . str_replace ( array (
				"\n",
				" " 
		), array (
				'<br>',
				'&nbsp;' 
		), print_r ( $myvar, true ) ) . '</pre><br><br>';
	}
}

if (! function_exists ( "DumpArrayToTable" )) {
	function DumpArrayToTable($arDest) {
		// Random-Farbe fuer den Rand der Tabellen.
		$iBorderColor = str_pad ( mt_rand ( 0, 999999 ), 6, '0', STR_PAD_LEFT );
		
		print ('<table cellpadding="0" cellspacing="5" ') ;
		print ('style="border: 4px solid #' . $iBorderColor . '; ') ;
		print ('font-family: Courier New; font-size: .9em;">') ;
		
		// Wenn kein Array, dann Input in ein Array umwandeln.
		if (! is_array ( $arDest [0] )) {
			$arDest = array (
					$arDest 
			);
		}
		
		print ('<tr>') ;
		
		// Schluessel des Arrays als Tabellenspaltenueberschrift.
		foreach ( array_keys ( $arDest [0] ) as $strTmpT ) {
			$strType = 'Type: ' . gettype ( $strTmpT );
			
			print ('<td title="' . $strType . '" style="text-align: center;') ;
			print (' font-weight: bold; border: 2px solid #000; padding:') ;
			print (' 3px; background-color: #ccc;">' . $strTmpT . '</td>') ;
		}
		
		print ('</tr>') ;
		
		// Array durchlaufen.
		foreach ( $arDest as $arTmpElm ) {
			print ('<tr>') ;
			
			foreach ( $arTmpElm as $strTmpVal ) {
				$strType = 'Type: ' . gettype ( $strTmpVal );
				
				print ('<td title="' . $strType . '" style="text-align: ') ;
				print ('center; border: 2px solid #000; padding: 3px;">') ;
				
				if (is_array ( $strTmpVal ) && ! empty ( $strTmpVal )) {
					// Wenn ein Array in einem Array, dann
					// rekursiv DumpArrayToTable aufrufen.
					DumpArrayToTable ( $strTmpVal );
				} else {
					if (! empty ( $strTmpVal )) {
						print (substr ( $strTmpVal, 0, 1000 )) ;
					} else {
						// Wenn aktuelles Array-Element leer ist,
						// dann Tabellenzelle mit "empty" markieren.
						print ('empty') ;
					}
				}
				
				print ('</td>') ;
			}
			
			print ('</tr>') ;
		}
		
		print ('</table>') ;
	}
}

if (! function_exists ( "print_r_html" )) {
	function print_r_html($myvar) {
		echo '<pre>' . str_replace ( array (
				"\n",
				" " 
		), array (
				'<br>',
				'&nbsp;' 
		), print_r ( $myvar, true ) ) . '</pre><br><br>';
	}
}

if (! function_exists ( "loggeLadezeit" )) {
	function loggeLadezeit($fDauer) {
		global $target, $typ, $id, $subtarget, $subtyp, $subid;
		
		$aNeu = array (
				"dtTarget" => $target,
				"dtTyp" => $typ,
				"dtId" => $id,
				"dtSubtarget" => $subtarget,
				"dtSubtyp" => $subtyp,
				"dtSubid" => $subid,
				"dtLadezeit" => $fDauer,
				"dtPOST" => serialize ( $_POST ),
				"dtGET" => serialize ( $_GET ),
				"dtSESSION" => serialize ( $_SESSION ),
				"dtBenutzername" => $_SESSION ["benutzername"] 
		);
		
		insert_into_table ( "tblLadezeitenLog", $aNeu );
	}
}

?>