<?php

// Pfad zu include Dateien bestimmen
file_exists ( "config/" ) ? $include_prefix = "" : $include_prefix = "../";

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++ $filter_array mit passender Value zur�ckliefern
if (! function_exists ( "get_filter_array" )) {
	function get_filter_array($value) {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql.php");
		include ("$functionsordner/function_sql_query.php");
		
		$filter_array = array (
				"projektstatus" => array (
						"Projektstatusfilter",
						"select * from $tblprojektstatus where id = $value order by dtSortierung",
						"dtProjektStatus" 
				),
				"projekttyp" => array (
						"Projekttypfilter",
						"select * from $tblprojekttyp where id = $value order by dtSortierung",
						"dtProjektTyp" 
				),
				"belegstatus" => array (
						"Belegstatusfilter",
						"select * from $tblbelegstatus where id = $value order by dtSortierung",
						"dtBelegStatus" 
				),
				"rechnungstatus" => array (
						"Rechnungsstatusfilter",
						"select * from $tblrechnungstatus where id = $value order by dtSortierung",
						"dtRechnungStatus" 
				),
				"mailverteilergruppe" => array (
						"Verteilergruppenfilter",
						$sql_query ["mailverteilergruppenliste"] . " and id = $value order by dtGruppenname",
						"dtGruppenname" 
				),
				"kontakt" => array (
						"Kontaktfilter",
						$sql_query ["kontaktliste"] . " and $tblkontakte.id = $value order by dtKontaktSortierung",
						"dtKontaktDDText" 
				),
				"mitarbeiter" => array (
						"Mitarbeiterfilter",
						$sql_query ["kontaktliste"] . " and $tblkontakte.id = $value order by dtKontaktSortierung",
						"dtKontaktDDText" 
				),
				"boekermitarbeiter" => array (
						"Bearbeiter",
						$sql_query ["kontaktliste"] . " and $tblkontakte.id = $value order by dtKontaktSortierung",
						"dtKontaktDDText"
				),
				"projektverantwortlicher" => array (
						"Projektverantwortlicher-Filter",
						$sql_query ["kontaktliste"] . " and $tblkontakte.id = $value order by dtKontaktSortierung",
						"dtKontaktDDText" 
				),
				"lieferant" => array (
						"Lieferantenfilter",
						$sql_query ["kontaktliste"] . " and $tblkontakte.id = $value order by dtKontaktSortierung",
						"dtKontaktDDText" 
				),
				"kunde" => array (
						"Kundenfilter",
						$sql_query ["kontaktliste"] . " and $tblkontakte.id = $value order by dtKontaktSortierung",
						"dtKontaktDDText" 
				),
				"kontaktasp" => array (
						"Ansprechpartnerfilter",
						$sql_query ["kontaktaspliste"] . " and $tblkontaktasp.id = $value order by dtKontaktASPSortierung",
						"dtKontaktASPDDText" 
				),
				"warengruppe" => array (
						"Warengruppenfilter",
						$sql_query ["warengruppenliste"] . " and $tblwarengruppen.id = $value order by dtWarengruppenSortierung",
						"dtWarengruppe" 
				),
				"lagerort" => array (
						"Lager-Ort-Filter",
						$sql_query ["lagerorteliste"] . " and $tbllagerorte.id = $value order by dtLagerNr",
						"dtLagerOrtDDText" 
				),
				"projekt" => array (
						"Projektfilter",
						$sql_query ["projektliste"] . " and $tblprojekte.id = $value order by dtProjektNr desc",
						"dtProjektDDText" 
				),
				"boekerprojekt" => array (
						"Projekt",
						$sql_query ["projektliste"] . " and $tblprojekte.id = $value order by dtProjektNr desc",
						"dtProjektDDText"
				),
				"teilprojekt" => array (
						"Teilprojektfilter",
						$sql_query ["projektteilprojekteliste"] . " and $tblprojektteilprojekte.id = $value order by dtTeilprojektName",
						"dtTeilprojektDDText" 
				),
				"contenttyp" => array (
						"Contenttypfilter",
						$sql_query ["contenttypliste"] . " and $tblcontenttyp.id = $value order by dtSortierung",
						"dtContentTypName" 
				),
				"beleg" => array (
						"Belegfilter",
						$sql_query ["belegliste"] . " and $tblbelege.id = $value order by dtBelegNr desc",
						"dtBelegDDText" 
				),
				"rechnung" => array (
						"Rechnungsfilter",
						$sql_query ["rechnungliste"] . " and $tblrechnungen.id = $value order by dtRechnungNrIntern desc",
						"dtRechnungDDText" 
				),
				"buchungskonto" => array (
						"Buchungskontofilter",
						$sql_query ["buchungskontenliste"] . " and $tblbuchungskonten.id = $value order by dtKontoID",
						"dtBuchungsKontoDDText" 
				),
				"bankkonto" => array (
						"Bankkontofilter",
						$sql_query ["bankkontenliste"] . " and $tblbankkonten.id = $value order by dtKontoName",
						"dtKontoName" 
				),
				"geraete" => array (
						"Stempel-Gertefilter",
						$sql_query ["stempelzeitenliste"] . " and $tblstempelzeiten.dtGeraet = $value group by dtGeraet order by dtGeraet",
						"dtGeraet" 
				),
				"stempelcode" => array (
						"Stempel-Codefilter",
						$sql_query ["stempelzeitenliste"] . " and $tblstempelzeiten.dtStempelCode = $value group by dtStempelCode order by dtStempelCode",
						"dtStempelCode" 
				),
				"stempelzeitenstatus" => array (
						"Stempelzeiten-Statusfilter",
						$sql_query ["stempelzeitenstatusliste"] . " and $tblstempelzeitenstatus.id = $value order by dtSortierung",
						"dtStempelzeitStatus" 
				),
				"zahlart" => array (
						"Zahlart",
						$sql_query ["rechnungzahlartliste"] . " and tblRechnungZahlart.id = $value",
						"dtZahlart" 
				),
				"abteilung" => array (
						"Abteilungen-Filter",
						$sql_query ["abteilungenliste"] . " and $tblabteilungen.id = $value order by dtAbteilungNr",
						"dtAbteilungDDText" 
				),
				"provisionsempfaenger" => array (
						"Provisionsempfnger",
						$sql_query ["kontaktliste"] . " and $tblkontakte.id = $value order by dtKontaktSortierung",
						"dtKontaktDDText" 
				),
				"aufgabenprio" => array (
						"Priorittfilter",
						"select '" . $value . "' as id, '" . $aufgabenprio_array [$value] . "' as dtAusgabe",
						"dtAusgabe" 
				),
				"aufgabenstatus" => array (
						"Statusfilter",
						"select '" . $value . "' as id, '" . $aufgabenstatus_array [$value] . "' as dtAusgabe",
						"dtAusgabe" 
				) 
		);
		
		include ("$functionsordner_custom/function_custom_post.php");
		
		return $filter_array;
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++ zu jedem Filter werden hier die Klartextwerte und Namen geholt
if (! function_exists ( "get_filter_werte" )) {
	function get_filter_werte($filtername, $value = 0) {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$filter_array = get_filter_array ( $value );
		
		if (array_key_exists ( $filtername, $filter_array )) {
			if (is_array ( $value )) {
				// Multiselect Filter
				foreach ( ($oldvalue = $value) as $k => $value ) {
					$filter_array = get_filter_array ( $value ); // $filter_array mit passender Value erzeugen
					
					$filter_row = mysql_fetch_array ( mysql_query ( $filter_array [$filtername] [1] ), MYSQL_ASSOC );
					$filterwert_klartext_array [] = $filter_row [$filter_array [$filtername] [2]];
				}
				
				$filterwert_klartext = implode ( ", ", $filterwert_klartext_array );
				$value = $oldvalue;
			} else {
				$filter_row = mysql_fetch_array ( mysql_query ( $filter_array [$filtername] [1] ), MYSQL_ASSOC );
				$filterwert_klartext = $filter_row [$filter_array [$filtername] [2]];
			}
			
			$filtername_klartext = $filter_array [$filtername] [0];
		} else {
			
			if ($filtername == "textfilter") {
				$filtername_klartext = "Textfilter";
				$filterwert_klartext = $value;
			}
			
			if ($filtername == "datumsbereich") {
				
				$datum_explode = extract_datum_aus_datumsfilter ( $value );
				
				$datum_tag_von_anzeige = $datum_explode [6];
				$datum_monat_von_anzeige = $datum_explode [7];
				$datum_jahr_von_anzeige = $datum_explode [8];
				$datum_tag_bis_anzeige = $datum_explode [9];
				$datum_monat_bis_anzeige = $datum_explode [10];
				$datum_jahr_bis_anzeige = $datum_explode [11];
				
				if ($datum_tag_von_anzeige != "") {
					$filtername_klartext = "Datumsfilter";
					$filterwert_klartext = "vom " . $datum_tag_von_anzeige . "." . $datum_monat_von_anzeige . "." . $datum_jahr_von_anzeige . " ";
				}
				
				if ($datum_tag_bis_anzeige != "") {
					$filtername_klartext = "Datumsfilter";
					$filterwert_klartext .= "bis " . $datum_tag_bis_anzeige . "." . $datum_monat_bis_anzeige . "." . $datum_jahr_bis_anzeige;
				}
			}
			
			if ($filtername == "uhrzeitbereich") {
				
				$uhrzeit_explode = extract_uhrzeit_aus_uhrzeitfilter ( $value );
				
				if ($uhrzeit_stunde_von_anzeige != 24) {
					$filtername_klartext = "Uhrzeitfilter";
					$filterwert_klartext = "von " . $uhrzeit_explode [4] . " ";
				}
				
				if ($uhrzeit_stunde_bis_anzeige != 24) {
					$filtername_klartext = "Uhrzeitfilter";
					$filterwert_klartext .= "bis " . $uhrzeit_explode [5];
				}
			}
			
			if ($filtername == "mitarbeiteraktiv") {
				$filtername_klartext = "Mitarbeiterstatus-Filter";
				if ($value == 1) {
					$filterwert_klartext = "nur Aktive";
				} elseif ($value == 2) {
					$filterwert_klartext = "nur Passive";
				}
			}
			
			if ($filtername == "projektzeitengeprueftstatus") {
				$filtername_klartext = "Projektzeiten-Geprft-Filter";
				if ($value == 1) {
					$filterwert_klartext = "nur ungeprfte";
				} elseif ($value == 2) {
					$filterwert_klartext = "nur geprfte";
				}
			}
			if ($filtername == "projektzeitenabgerechnetstatus") {
				$filtername_klartext = "Projektzeiten-Abgerechnet-Filter";
				if ($value == 1) {
					$filterwert_klartext = "nur offene";
				} elseif ($value == 2) {
					$filterwert_klartext = "nur abgerechnete";
				}
			}
		}
		
		if ($filtername == "projekt") {
			if ($value == - 1) {
				$filterwert_klartext = "nur Eintrge ohne Projektzuordnung";
			} elseif ($value == - 2) {
				$filterwert_klartext = "nur Eintrge mit Projektzuordnung";
			}
		}
		
		return (array (
				$filtername_klartext,
				$filterwert_klartext 
		));
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "filter_anzeigefeld" )) {
	function filter_anzeigefeld($filtername, $listenname, $filter, $value, $input_class, $title, $acceskey, $dd_width = 450, $dd_height = 250, $dropdownboxclass = "dropdownbox", $query_bedingungen = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		// $html = "<form name=\"".$filtername."\" action=\"$PHP_SELF\" method=\"post\">";
		
		$html .= "<div style=\"position: relative; z-index:100; width: 1px; height: 1px; \">";
		$html .= "<div id=\"dd_" . $filtername . "\" name=\"dd_" . $filtername . "\" class=\"" . $dropdownboxclass . "\"  style=\"position: absolute; top: 18px; left: 0px; width: " . $dd_width . "px; height: " . $dd_height . "px; z-index:10; visibility: hidden; overflow: scroll;\"></div>";
		$html .= "</div>";
		
		$html .= "<input type=\"hidden\" id=\"" . $filtername . "_text_orig\" name=\"" . $filtername . "_text_orig\" value=\"" . $value . "\">";
		$html .= "<input type=\"hidden\" id=\"" . $filtername . "_queryzusatz\" name=\"" . $filtername . "_queryzusatz\" value=\"" . $query_bedingungen . "\">";
		$html .= "<input type=\"hidden\" id=\"" . $filtername . "_typ\" name=\"" . $filtername . "_typ\" value=\"filter\">";
		$html .= "<nobr><input class=\"" . $input_class . "\" id=\"" . $filtername . "_text\" name=\"" . $filtername . "_text\" title=\"" . $title . "\" autocomplete=\"off\" accesskey=\"" . $acceskey . "\" ";
		if ($filter != "") {
			$html .= "style=\"background-color: " . $filter_aktiv_color . "\" ";
		}
		$html .= "onClick=\"filter_focus('" . $filtername . "', '" . $listenname . "')\" ";
		$html .= "onKeyUp=\"dropdownbox_tastendruck('" . $filtername . "', '" . $listenname . "', event.keyCode?event.keyCode:event.which,  this.value)\" ";
		$html .= "value=\"" . $value . "\"></nobr>";
		
		// $html .= "</form>";
		
		return $html;
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "filter_dropdownbox" )) {
	function filter_dropdownbox($filtername, $listenname, $ziel, $filter, $standardvalue, $filter_values_array, $filter_key_target, $filter_key_feld, $filter_value_feld, $dropdownboxtextclass = "dropdownboxtext") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		global $ajax_dd_max_eintraege;
		
		// $typ muss immer list oder show sein, $subtyp muss immer leer, list oder show sein
		$ziel_array = explode ( "&", $ziel );
		foreach ( ( array ) $ziel_array as $key => $value ) {
			if (substr ( $value, 0, 4 ) == "typ=") {
				if ($value != "typ=list" and $value != "typ=show") {
					$ziel = str_replace ( $value, "typ=list", $ziel );
				}
			} else if (substr ( $value, 0, 7 ) == "subtyp=") {
				if ($value != "subtyp=" and $value != "subtyp=list" and $value != "subtyp=show") {
					$ziel = str_replace ( $value, "subtyp=list", $ziel );
				}
			}
		}
		
		$html = "<!--filtername" . $filtername . "-->";
		
		if (count ( $filter_values_array ) < $ajax_dd_max_eintraege) {
			
			$position = 1;
			$filterarray = str_replace ( "\"", "&quot;", serialize ( array (
					$filter_key_target => "" 
			) ) );
			$onclick_target = "main.php?" . SID . "&" . $ziel . "&listenname=" . $listenname . "&filterwert_neu=" . $filterarray;
			
			$html .= "<div position=\"" . $position ++ . "\" name=\"ddvalue_" . $filtername . "\" target=\"" . $onclick_target . "\" ";
			$html .= "class=\"" . $dropdownboxtextclass . "\" ";
			$html .= "onMouseOver=\"dropdownbox_mouseover('" . $filtername . "', this);\" ";
			$html .= "onClick=\"dropdownbox_enter('" . $filtername . "');\" ";
			$html .= ">" . $standardvalue . "</div>";
			
			foreach ( ( array ) $filter_values_array as $key => $sub_row ) {
				// Markierter Eintrag
				if ($sub_row [$filter_key_feld] == $filter) {
					
					$filterarray = str_replace ( "\"", "&quot;", serialize ( array (
							$filter_key_target => $sub_row [$filter_key_feld] 
					) ) );
					$onclick_target = "main.php?" . SID . "&" . $ziel . "&listenname=" . $listenname . "&filterwert_neu=" . $filterarray;
					
					$html .= "<div clicktarget=\"'" . $onclick_target . "'\" ";
					$html .= "class=\"" . $dropdownboxtextclass . "\" style=\"background-color: " . $filter_aktiv_color . ";\" ";
					$html .= ">" . $sub_row [$filter_value_feld] . "</div>";
					
					// Eintrag disabled
				} else if ($sub_row [$filter_key_feld] == "(disabled)") {
					
					// $filterarray = str_replace("\"", "&quot;", serialize(array($filter_key_target => $sub_row[$filter_key_feld])));
					// $onclick_target = "main.php?". SID ."&".$ziel."&listenname=".$listenname."&filterwert_neu=".$filterarray;
					
					$html .= "<div class=\"" . $dropdownboxtextclass . "\" ";
					$html .= ">" . $sub_row [$filter_value_feld] . "</div>";
					
					// normaler Eintrag
				} else {
					
					$filterarray = str_replace ( "\"", "&quot;", serialize ( array (
							$filter_key_target => $sub_row [$filter_key_feld] 
					) ) );
					$onclick_target = "main.php?" . SID . "&" . $ziel . "&listenname=" . $listenname . "&filterwert_neu=" . $filterarray;
					
					$html .= "<div position=\"" . $position ++ . "\" name=\"ddvalue_" . $filtername . "\" target=\"" . $onclick_target . "\" ";
					$html .= "content=\"" . strtolower ( $sub_row [$filter_value_feld] ) . "\"  ";
					$html .= "class=\"" . $dropdownboxtextclass . "\" ";
					$html .= "onMouseOver=\"dropdownbox_mouseover('" . $filtername . "', this);\" ";
					$html .= "onClick=\"dropdownbox_enter('" . $filtername . "');\" ";
					$html .= ">" . $sub_row [$filter_value_feld] . "</div>";
				}
			}
			$html .= "<div id=\"dd_overload_" . $filtername . "\" name=\"dd_overload_" . $filtername . "\" status=\"no\" class=\"" . $dropdownboxtextclass . "\"></div>";
		} else {
			
			$html .= "<div class=\"" . $dropdownboxtextclass . "\" ></div>";
			$html .= "<div class=\"" . $dropdownboxtextclass . "\" ></div>";
			$html .= "<div id=\"dd_overload_" . $filtername . "\" name=\"dd_overload_" . $filtername . "\" status=\"overload\" class=\"" . $dropdownboxtextclass . "\" style=\"height: 30px\" ";
			$html .= "><center>[ zu viele Eintrge gefunden (" . count ( $filter_values_array ) . ") ]<br>[ Bitte grenzen Sie die Auswahl durch Eingabe eines Suchtextes ein ]</center></div>";
		}
		
		return $html;
	}
}

if (! function_exists ( filter_multiselect )) {
	function filter_multiselect($einstellung, $listenname, $filtername, $query, $idfeld, $anzeigefeld, $tooltip, $standardtext, $array = false, $add_array = false) {
		$html = input_dropdownbox_ajax ( $listenname, $query, $idfeld, $filtername, $einstellung, $anzeigefeld, "input_select_200", "", "", $tooltip, false, "", 450, 250, 0, "dropdownboxtext", "dropdownbox", false, $array, true, $standardtext, $add_array );
		return $html;
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "projektzeitenstatusgeprueftfilter" )) {
	function projektzeitenstatusgeprueftfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		$projektzeitenstatus_geprueft_array = array (
				1 => "ungeprft",
				2 => "geprft",
				3 => "besttigt" 
		);
		
		$dd_array [0] = array (
				"id" => 0,
				"dtProjektzeitStatusGeprueft" => "--- alle PZ ---" 
		);
		$dd_array [1] = array (
				"id" => 1,
				"dtProjektzeitStatusGeprueft" => "ungeprft" 
		);
		$dd_array [2] = array (
				"id" => 2,
				"dtProjektzeitStatusGeprueft" => "geprft" 
		);
		$dd_array [3] = array (
				"id" => 3,
				"dtProjektzeitStatusGeprueft" => "besttigt" 
		);
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$filter = 0;
			}
			;
			
			$value = $dd_array [$filter] ["dtProjektzeitStatusGeprueft"];
			
			echo filter_anzeigefeld ( "projektzeitenstatusgeprueftfilter", $listenname, $filter, $value, "input_text_100", "Filterung nach Geprft-Status", "g", 150, 150 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			unset ( $dd_array [0] );
			echo filter_dropdownbox ( "projektzeitenstatusgeprueftfilter", $listenname, $ziel, $filter, "--- alle PZ ---", $dd_array, "projektzeitengeprueftstatus", "id", "dtProjektzeitStatusGeprueft" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "provisionabgerechnetfilter" )) {
	function provisionabgerechnetfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		$dd_array [0] = array (
				"id" => 0,
				"dtProvisionAbgerechnet" => "--- alle Provisionen ---" 
		);
		$dd_array [1] = array (
				"id" => 1,
				"dtProvisionAbgerechnet" => "abgerechnet" 
		);
		$dd_array [2] = array (
				"id" => 2,
				"dtProvisionAbgerechnet" => "nicht abgerechnet" 
		);
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$filter = 0;
			}
			;
			
			$value = $dd_array [$filter] ["dtProvisionAbgerechnet"];
			
			echo filter_anzeigefeld ( "provisionabgerechnetfilter", $listenname, $filter, $value, "input_text_100", "Filterung nach Geprft-Status", "m", 150, 150 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			unset ( $dd_array [0] );
			echo filter_dropdownbox ( "provisionabgerechnetfilter", $listenname, $ziel, $filter, "--- alle Provisionen ---", $dd_array, "provisionabgerechnet", "id", "dtProvisionAbgerechnet" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "datumanzeigefilter" )) {
	function datumanzeigefilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		$dd_array [0] = array (
				"id" => 0,
				"dtDatumanzeigeFilter" => "--- Datum ---" 
		);
		$dd_array ["dtAngebotDatum"] = array (
				"id" => "dtAngebotDatum",
				"dtDatumanzeigeFilter" => "Datum Angebot" 
		);
		$dd_array ["dtAuftragDatum"] = array (
				"id" => "dtAuftragDatum",
				"dtDatumanzeigeFilter" => "Datum Auftrag" 
		);
		$dd_array ["dtLieferungDatum"] = array (
				"id" => "dtLieferungDatum",
				"dtDatumanzeigeFilter" => "Datum Lieferung" 
		);
		$dd_array ["dtRechnungDatum"] = array (
				"id" => "dtRechnungDatum",
				"dtDatumanzeigeFilter" => "Datum Rechnung" 
		);
		$dd_array ["dtMahnungDatum"] = array (
				"id" => "dtMahnungDatum",
				"dtDatumanzeigeFilter" => "Datum Mahnung" 
		);
		$dd_array ["dtStornierungDatum"] = array (
				"id" => "dtStornierungDatum",
				"dtDatumanzeigeFilter" => "Datum Stornierung" 
		);
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$filter = 0;
			}
			;
			
			$value = $dd_array [$filter] ["dtDatumanzeigeFilter"];
			
			echo filter_anzeigefeld ( "datumanzeigefilter", $listenname, $filter, $value, "input_text_100", "Datum, welches in der Liste angezeigt wird", "m", 150, 150 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			unset ( $dd_array [0] );
			echo filter_dropdownbox ( "datumanzeigefilter", $listenname, $ziel, $filter, "--- Standard ---", $dd_array, "datumanzeigefilter", "id", "dtDatumanzeigeFilter" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "variantenfilter" )) {
	function variantenfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		$dd_array [0] = array (
				"id" => 0,
				"dtVariantenAuswahl" => "--- ohne Variantenartikel ---" 
		);
		$dd_array [1] = array (
				"id" => 1,
				"dtVariantenAuswahl" => "Nur Variantenartikel" 
		);
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$filter = 0;
			}
			;
			
			$value = $dd_array [$filter] ["dtVariantenAuswahl"];
			
			echo filter_anzeigefeld ( "variantenfilter", $listenname, $filter, $value, "input_text_100", "", "m", 150, 150 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			unset ( $dd_array [0] );
			echo filter_dropdownbox ( "variantenfilter", $listenname, $ziel, $filter, "--- ohne Variantenartikel ---", $dd_array, "variante", "id", "dtVariantenAuswahl" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "lagerartikelaktivfilter" )) {
	function lagerartikelaktivfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		$lagerartikelaktiv_array = array (
				1 => "aktiv",
				2 => "inaktiv" 
		);
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Artikel ---";
			} else {
				$value = $lagerartikelaktiv_array [$filter];
			}
			echo filter_anzeigefeld ( "lagerartikelaktivfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Artikel-Status", "m", 250 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			foreach ( $lagerartikelaktiv_array as $key => $value ) {
				$filter_values_array [] = array (
						"id" => $key,
						"dtArtikelAktiv" => $value 
				);
			}
			echo filter_dropdownbox ( "lagerartikelaktivfilter", $listenname, $ziel, $filter, "--- alle Artikel ---", $filter_values_array, "lagerartikelaktiv", "id", "dtArtikelAktiv" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "projektzeitenabgerechnetstatusfilter" )) {
	function projektzeitenabgerechnetstatusfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		$dd_array [0] = array (
				"id" => 0,
				"dtProjektzeitAbgerechnetStatus" => "--- alle PZ ---" 
		);
		$dd_array [1] = array (
				"id" => 1,
				"dtProjektzeitAbgerechnetStatus" => "offen" 
		);
		$dd_array [2] = array (
				"id" => 2,
				"dtProjektzeitAbgerechnetStatus" => "abgerechnet" 
		);
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$filter = 0;
			}
			;
			
			$value = $dd_array [$filter] ["dtProjektzeitAbgerechnetStatus"];
			
			echo filter_anzeigefeld ( "projektzeitenabgerechnetstatusfilter", $listenname, $filter, $value, "input_text_100", "Filterung nach Abgerechnet-Status", "m", 150, 150 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			unset ( $dd_array [0] );
			echo filter_dropdownbox ( "projektzeitenabgerechnetstatusfilter", $listenname, $ziel, $filter, "--- alle PZ ---", $dd_array, "projektzeitenabgerechnetstatus", "id", "dtProjektzeitAbgerechnetStatus" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "mitarbeiteraktivfilter" )) {
	function mitarbeiteraktivfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		$mitarbeiteraktiv_array = array (
				1 => "aktiv",
				2 => "inaktiv" 
		);
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Mitarbeiter ---";
			} else {
				$value = $mitarbeiteraktiv_array [$filter];
			}
			
			echo filter_anzeigefeld ( "mitarbeiteraktivfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Mitarbeiter-Status", "m", 250 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			foreach ( $mitarbeiteraktiv_array as $key => $value ) {
				$filter_values_array [] = array (
						"id" => $key,
						"dtMitarbeiterStatus" => $value 
				);
			}
			echo filter_dropdownbox ( "mitarbeiteraktivfilter", $listenname, $ziel, $filter, "--- alle Mitarbeiter ---", $filter_values_array, "mitarbeiteraktiv", "id", "dtMitarbeiterStatus" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "mitarbeiterproabteilungfilter" )) {
	function mitarbeiterproabteilungfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $posx = 0, $posy = 0, $width = 300, $height = 200, $abteilungfilter = "") {
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		$counter = 1;
		
		$anzahl_buttons_pro_zeile = 4;
		
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		/*
		 * Falls Wert von Multiselect Filter kommt
		 */
		if (is_array ( $filter )) {
			$filter = $filter [0];
		}
		
		if ($filter != "") {
			$filter_array = get_filter_werte ( "mitarbeiter", $filter );
		} else {
			$filter_array [1] = "Mitarbeiterfilter";
		}
		
		if ($abteilungfilter != "") {
			$query = $sql_query ["personaldatenliste"] . "and fiAbteilung = $abteilungfilter";
			$abteilung_mitarbeiter_array = get_table_array ( $query );
			foreach ( ( array ) $abteilung_mitarbeiter_array as $key => $value ) {
				$mitarbeiter_filter_array [] = $value ["fiKontaktNr"];
			}
		}
		
		// ++++ alle relevanten Mitarbeiter in ein Array laden und dabei auch den vorigen und den n�chten bestimmen
		$query = $sql_query ["kontaktliste"] . "and dtIstMitarbeiter = 1 and dtAktiv=1 order by dtKontaktSortierung";
		$result = mysql_query ( $query );
		
		while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
			if (is_array ( $mitarbeiter_filter_array ) or $abteilungfilter == "") {
				if (in_array ( $sub_row ["Kontakte_id"], ( array ) $mitarbeiter_filter_array ) or $abteilungfilter == "") {
					$mitarbeiter_array [] = $sub_row;
					if ($sub_row ["Kontakte_id"] == $filter) {
						$aktiver_mitarbeiter_id = count ( $mitarbeiter_array ) - 1;
					}
				}
			}
		}
		
		// ++++ ggf. Button "zum vorigen Mitarbeiter"
		echo "<table border=0 cellspacing=0 cellpadding=0 width=200><tr>";
		if ($filter != "" and $aktiver_mitarbeiter_id > 0) {
			
			$filterarray = str_replace ( "\"", "&quot;", serialize ( array (
					"mitarbeiter" => $mitarbeiter_array [($aktiver_mitarbeiter_id - 1)] ["Kontakte_id"] 
			) ) );
			$link = "main.php?" . SID . "&" . $ziel . "&listenname=" . $listenname . "&filterwert_neu=" . $filterarray;
			
			echo "<td width=25 align=\"left\" valign=\"top\">";
			echo erzeuge_button ( "&lt;", $link, "", "zum vorigen Mitarbeiter", "-" );
			echo "</td>";
		} else {
			echo "<td width=25 valign=\"top\"> </td>";
		}
		
		// ++++ Filterbutton zum �ffnen des Layers
		$link = "javascript:showLayer(0, 'Layer1')";
		
		echo "<td style=\"width: 150px;\" valign=\"top\">";
		echo erzeuge_button ( $filter_array [1], $link, "", "Mitarbeiter abhngig von der gewhlten Abteilung whlen", "", 135 );
		echo "</td>";
		
		// ++++ ggf. Button "zum n�chsten Mitarbeiter"
		if ($filter != "" and (count ( $mitarbeiter_array ) - 1) > $aktiver_mitarbeiter_id) {
			
			$filterarray = str_replace ( "\"", "&quot;", serialize ( array (
					"mitarbeiter" => $mitarbeiter_array [($aktiver_mitarbeiter_id + 1)] ["Kontakte_id"] 
			) ) );
			$link = "main.php?" . SID . "&" . $ziel . "&listenname=" . $listenname . "&filterwert_neu=" . $filterarray;
			
			echo "<td width=25 align=\"right\" valign=\"top\">";
			echo erzeuge_button ( "&gt;", $link, "", "zum nchsten Mitarbeiter", "+" );
			echo "</td>";
		} else {
			echo "<td width=25 valign=\"top\"> </td>";
		}
		
		echo "</tr></table>";
		
		echo "<div id=\"Layer1\" style=\"color: #000000; background-color: #ffffff; border-style: solid; border-color: $bgcolor_menu; border-width: 2px; ";
		echo "position:absolute; left:" . $posx . "px; top:" . $posy . "px; width:" . $width . "px; height:" . $height . "px; z-index:10; visibility: hidden; overflow: scroll;\">";
		
		echo "<table width=\"100%\" border=0 cellspacing=0 cellpadding=0><tr><td align=\"right\">";
		echo "<a href=\"javascript:hideLayer(0, 'Layer1')\" title=\"Fenster schliessen\">X</a>&nbsp;&nbsp;";
		echo "</td></tr></table>";
		
		echo "<table border=0 cellspacing=5 cellpadding=0><tr>";
		$filterarray = str_replace ( "\"", "&quot;", serialize ( array (
				"mitarbeiter" => "" 
		) ) );
		echo "<td width=" . round ( ($width / $anzahl_buttons_pro_zeile), 0 ) . " class=\"filterbutton\" align=\"center\"><a href=\"main.php?" . SID . "&" . $ziel . "&listenname=" . $listenname . "&filterwert_neu=" . $filterarray . "\">";
		echo "alle";
		echo "</a></td>";
		
		if (is_array ( $mitarbeiter_array )) {
			foreach ( $mitarbeiter_array as $key => $sub_row ) {
				
				if ($sub_row ["Kontakte_id"] == $filter) :
					$filterarray = str_replace ( "\"", "&quot;", serialize ( array (
							"mitarbeiter" => $sub_row ["Kontakte_id"] 
					) ) );
					echo "<td width=" . round ( ($width / $anzahl_buttons_pro_zeile), 0 ) . " class=\"filterbutton\" align=\"center\" style=\"background-color: $filter_aktiv_color;\"><a href=\"main.php?" . SID . "&" . $ziel . "&listenname=" . $listenname . "&filterwert_neu=" . $filterarray . "\">";
					echo $sub_row ["dtKontaktDDText"];
					echo "</a></td>";
				 else :
					$filterarray = str_replace ( "\"", "&quot;", serialize ( array (
							"mitarbeiter" => $sub_row ["Kontakte_id"] 
					) ) );
					echo "<td width=" . round ( ($width / $anzahl_buttons_pro_zeile), 0 ) . " class=\"filterbutton\" align=\"center\"><a href=\"main.php?" . SID . "&" . $ziel . "&listenname=" . $listenname . "&filterwert_neu=" . $filterarray . "\">";
					echo $sub_row ["dtKontaktDDText"];
					echo "</a></td>";
				endif;
				
				if ($counter ++ == ($anzahl_buttons_pro_zeile - 1)) {
					$counter = 0;
					echo "</tr><tr>";
				}
				;
			}
		}
		
		echo "</tr></table>";
		echo "</div>";
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "abteilungenfilter_rekursion" )) {
	function abteilungenfilter_rekursion($referer, $filter, $listenname, $ziel, $tiefe) {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		global $abteilungen_array;
		
		$result = mysql_query ( "select * from $tblabteilungen where fiReferer = $referer order by dtAbteilungNr" );
		
		while ( $sub_row = mysql_fetch_row ( $result ) ) {
			
			$abteilungen_array [] = array (
					"Abteilung_id" => $sub_row [0],
					"dtAbteilungDDText" => "|" . str_repeat ( "__", $tiefe ) . " " . $sub_row [2] . " | " . $sub_row [3],
					"tiefe" => $tiefe 
			);
			
			abteilungenfilter_rekursion ( $sub_row [0], $filter, $listenname, $ziel, $tiefe + 1 );
			
			if ($tiefe == 0) {
				$abteilungen_array [] = array (
						"Abteilung_id" => "(disabled)",
						"dtAbteilungDDText" => " ----------------------------- " 
				);
			}
		}
	}
}

if (! function_exists ( "abteilungenfilter" )) {
	function abteilungenfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		global $abteilungen_array;
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Abteilungen ---";
			} else {
				$query = "select * from $tblabteilungen where $tblabteilungen.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtAbteilungNr"] . " | " . $sub_row ["dtAbteilungName"];
			}
			
			echo filter_anzeigefeld ( "abteilungenfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Abteilung", "a" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			abteilungenfilter_rekursion ( 0, $filter, $listenname, $ziel, 0 );
			$filter_values_array = $abteilungen_array;
			
			echo filter_dropdownbox ( "abteilungenfilter", $listenname, $ziel, $filter, "--- alle Abteilungen ---", $filter_values_array, "abteilung", "Abteilung_id", "dtAbteilungDDText" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "stempelzeitenstatusfilter" )) {
	function stempelzeitenstatusfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Stempelzeiten ---";
			} else {
				$query = "select * from $tblstempelzeitenstatus where $tblstempelzeitenstatus.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtStempelzeitStatus"];
			}
			
			echo filter_anzeigefeld ( "stempelzeitenstatusfilter", $listenname, $filter, $value, "input_text_150", "Filterung nach Stempelzeitenstatus", "s", 200 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			$query = "select * from $tblstempelzeitenstatus order by dtSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			echo filter_dropdownbox ( "stempelzeitenstatusfilter", $listenname, $ziel, $filter, "--- alle Stempelzeiten ---", $filter_values_array, "stempelzeitenstatus", "id", "dtStempelzeitStatus" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( stempelcodefilter )) {
	function stempelcodefilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Stempel-Codes ---";
			} else {
				$value = $filter;
			}
			
			echo filter_anzeigefeld ( "stempelcodefilter", $listenname, $filter, $value, "input_text_150", "Filterung nach Stempel-Codes", "c", 200 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			$query = "select * from $tblstempelzeiten group by dtStempelCode order by dtStempelCode";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			echo filter_dropdownbox ( "stempelcodefilter", $listenname, $ziel, $filter, "--- alle Stempel-Codes ---", $filter_values_array, "stempelcode", "dtStempelCode", "dtStempelCode" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( geraetefilter )) {
	function geraetefilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Stempel-Gerte ---";
			} else {
				$value = $filter;
			}
			
			echo filter_anzeigefeld ( "geraetefilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Stempel-Gert", "t", 200 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			$query = "select * from $tblstempelzeiten group by dtGeraet order by dtGeraet";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			echo filter_dropdownbox ( "geraetefilter", $listenname, $ziel, $filter, "--- alle Stempel-Gerte ---", $filter_values_array, "geraet", "dtGeraet", "dtGeraet" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( contenttypfilter )) {
	function contenttypfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Content-Typen ---";
			} else {
				$query = "select * from $tblcontenttyp where $tblcontenttyp.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtContentTypName"];
			}
			
			echo filter_anzeigefeld ( "contenttypfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Content-Typ", "t", 250 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			$query = "select * from $tblcontenttyp order by dtSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			echo filter_dropdownbox ( "contenttypfilter", $listenname, $ziel, $filter, "--- alle Content-Typen ---", $filter_values_array, "contenttyp", "id", "dtContentTypName" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( projektstatusfilter )) {
	function projektstatusfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Projekte ---";
			} else {
				$query = "select * from $tblprojektstatus where $tblprojektstatus.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtProjektStatus"];
			}
			
			echo filter_anzeigefeld ( "projektstatusfilter", $listenname, $filter, $value, "input_text_150", "Filterung nach Projektstatus", "s", 250 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			$query = "select * from $tblprojektstatus order by dtSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			echo filter_dropdownbox ( "projektstatusfilter", $listenname, $ziel, $filter, "--- alle Projekte ---", $filter_values_array, "projektstatus", "id", "dtProjektStatus" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( projekttypfilter )) {
	function projekttypfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Projekt-Typen ---";
			} else {
				$query = "select * from $tblprojekttyp where $tblprojekttyp.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtProjektTyp"];
			}
			
			echo filter_anzeigefeld ( "projekttypfilter", $listenname, $filter, $value, "input_text_150", "Filterung nach Projekttyp", "t", 250 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			$query = "select * from $tblprojekttyp order by dtSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			echo filter_dropdownbox ( "projekttypfilter", $listenname, $ziel, $filter, "--- alle Projekt-Typen ---", $filter_values_array, "projekttyp", "id", "dtProjektTyp" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( projektstandfilter )) {
	function projektstandfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		$projektstand_array [0] = array (
				"id" => 0,
				"dtProjektStand" => "--- alle Projektstnde ---" 
		);
		$projektstand_array [1] = array (
				"id" => 1,
				"dtProjektStand" => "nur fr Kunden relevante Projektstnde" 
		);
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$filter = 0;
			}
			;
			
			$value = $projektstand_array [$filter] ["dtProjektStand"];
			
			echo filter_anzeigefeld ( "projektstandfilter", $listenname, $filter, $value, "input_text_150", "Filterung nach Art des Projektstandes", "p", 250 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			unset ( $projektstand_array [0] );
			echo filter_dropdownbox ( "projektstandfilter", $listenname, $ziel, $filter, "--- alle Projektstnde ---", $projektstand_array, "projektstand", "id", "dtProjektStand" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( belegstatusfilter )) {
	function belegstatusfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Belege ---";
			} else {
				$query = "select * from $tblbelegstatus where $tblbelegstatus.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtBelegStatus"];
			}
			
			echo filter_anzeigefeld ( "belegstatusfilter", $listenname, $filter, $value, "input_text_150", "Filterung nach Belegstatus", "s", 200 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			$query = "select * from $tblbelegstatus order by dtSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			echo filter_dropdownbox ( "belegstatusfilter", $listenname, $ziel, $filter, "--- alle Belege ---", $filter_values_array, "belegstatus", "id", "dtBelegStatus" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( bestellungstatusfilter )) {
	function bestellungstatusfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Bestellungen ---";
			} else {
				$query = "select * from $tblbestellungstatus where $tblbestellungstatus.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtBestellungStatus"];
			}
			
			echo filter_anzeigefeld ( "bestellungstatusfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Bestellungstatus", "s", 250 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			$query = "select * from $tblbestellungstatus order by dtSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			echo filter_dropdownbox ( "bestellungstatusfilter", $listenname, $ziel, $filter, "--- alle Bestellungen ---", $filter_values_array, "bestellungstatus", "id", "dtBestellungStatus" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( rechnungstatusfilter )) {
	function rechnungstatusfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Rechnungen ---";
			} else {
				$query = "select * from $tblrechnungstatus where $tblrechnungstatus.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtRechnungStatus"];
			}
			
			echo filter_anzeigefeld ( "rechnungstatusfilter", $listenname, $filter, $value, "input_text_150", "Filterung nach Rechnungsstatus", "s", 250 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			$query = "select * from $tblrechnungstatus order by dtSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			echo filter_dropdownbox ( "rechnungstatusfilter", $listenname, $ziel, $filter, "--- alle Rechnungen ---", $filter_values_array, "rechnungstatus", "id", "dtRechnungStatus" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
$faelligkeit_filter_array = array (
		1 => "f&auml;llige anzeigen",
		2 => "&uuml;berf&auml;llige anzeigen" 
);

if (! function_exists ( faelligkeitfilter )) {
	function faelligkeitfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		global $faelligkeit_filter_array;
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle F&auml;lligkeiten ---";
			} else {
				$value = $faelligkeit_filter_array [$filter];
			}
			
			echo filter_anzeigefeld ( "faelligkeitfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Flligkeit", "f", 250, 150 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			foreach ( $faelligkeit_filter_array as $key => $value ) {
				$filter_values_array [] = array (
						"id" => $key,
						"dtFaellig" => $value 
				);
			}
			echo filter_dropdownbox ( "faelligkeitfilter", $listenname, $ziel, $filter, "--- alle F&auml;lligkeiten ---", $filter_values_array, "faelligkeitfilter", "id", "dtFaellig" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( mailverteilergruppenfilter )) {
	function mailverteilergruppenfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Verteilergruppen ---";
			} else {
				$query = $sql_query ["mailverteilergruppenliste"] . " and $tblmailverteilergruppen.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtGruppenname"];
			}
			
			echo filter_anzeigefeld ( "mailverteilergruppenfilter", $listenname, $filter, $value, "input_text_150", "Filterung nach Verteilergruppen", "g" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblmailverteilergruppen.dtGruppenname like '%" . $textfilter . "%' )";
			}
			
			$query = $sql_query ["mailverteilergruppenliste"] . stripslashes ( $query_bedingungen ) . " order by dtGruppenname";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "mailverteilergruppenfilter", $listenname, $ziel, $filter, "--- alle Verteilergruppen ---", $filter_values_array, "mailverteilergruppe", "MailverteilerGruppe_id", "dtGruppenname" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( kontaktfilter )) {
	function kontaktfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Kontakte ---";
			} else {
				$query = $sql_query ["kontaktliste"] . "and dtAktiv=1 and $tblkontakte.id = $filter order by dtKontaktSortierung";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtKontaktDDText"];
			}
			
			echo filter_anzeigefeld ( "kontaktfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Kontakt", "k" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblkontakte.dtFirmenname like '%" . $textfilter . "%' or $tblkontakte.dtNachname like '%" . $textfilter . "%' or $tblkontakte.dtVorname like '%" . $textfilter . "%' or $tblkontakte.dtKontaktNr like '%" . $textfilter . "%')";
			}
			
			$query = $sql_query ["kontaktliste"] . stripslashes ( $query_bedingungen ) . "and dtAktiv=1 order by dtKontaktSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "kontaktfilter", $listenname, $ziel, $filter, "--- alle Kontakte ---", $filter_values_array, "kontakt", "Kontakte_id", "dtKontaktDDText" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( mitarbeiterfilter )) {
	function mitarbeiterfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Mitarbeiter ---";
			} else {
				$query = $sql_query ["kontaktliste"] . "and dtIstMitarbeiter = 1 and dtAktiv=1 and $tblkontakte.id = $filter order by dtKontaktSortierung";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtKontaktDDText"];
			}
			
			echo filter_anzeigefeld ( "mitarbeiterfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Mitarbeiter", "m" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblkontakte.dtFirmenname like '%" . $textfilter . "%' or $tblkontakte.dtNachname like '%" . $textfilter . "%' or $tblkontakte.dtVorname like '%" . $textfilter . "%' or $tblkontakte.dtKontaktNr like '%" . $textfilter . "%')";
			}
			
			$query = $sql_query ["kontaktliste"] . stripslashes ( $query_bedingungen ) . "and dtIstMitarbeiter = 1 and dtAktiv=1 order by dtKontaktSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "mitarbeiterfilter", $listenname, $ziel, $filter, "--- alle Mitarbeiter ---", $filter_values_array, "mitarbeiter", "Kontakte_id", "dtKontaktDDText" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( autorfilter )) {
	function autorfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Autoren ---";
			} else {
				$query = $sql_query ["kontaktliste"] . "and dtIstMitarbeiter = 1 and dtAktiv=1 and $tblkontakte.id = $filter order by dtKontaktSortierung";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtKontaktDDText"];
			}
			
			echo filter_anzeigefeld ( "autorfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Autor", "a" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblkontakte.dtFirmenname like '%" . $textfilter . "%' or $tblkontakte.dtNachname like '%" . $textfilter . "%' or $tblkontakte.dtVorname like '%" . $textfilter . "%' or $tblkontakte.dtKontaktNr like '%" . $textfilter . "%')";
			}
			
			$query = $sql_query ["kontaktliste"] . stripslashes ( $query_bedingungen ) . "and dtIstMitarbeiter = 1 and dtAktiv=1 order by dtKontaktSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "autorfilter", $listenname, $ziel, $filter, "--- alle Autoren ---", $filter_values_array, "autor", "Kontakte_id", "dtKontaktDDText" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( kundefilter )) {
	function kundefilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Kunden ---";
			} else {
				$query = $sql_query ["kontaktliste"] . "and dtIstKunde = 1 and dtAktiv=1 and $tblkontakte.id = $filter order by dtKontaktSortierung";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtKontaktDDText2"];
			}
			
			echo filter_anzeigefeld ( "kundefilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Kunde", "k" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblkontakte.dtFirmenname like '%" . $textfilter . "%' or $tblkontakte.dtNachname like '%" . $textfilter . "%' or $tblkontakte.dtVorname like '%" . $textfilter . "%' or $tblkontakte.dtKontaktNr like '%" . $textfilter . "%')";
			}
			
			$query = $sql_query ["kontaktliste"] . stripslashes ( $query_bedingungen ) . " and dtIstKunde = 1 and dtAktiv=1 order by dtKontaktSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "kundefilter", $listenname, $ziel, $filter, "--- alle Kunden ---", $filter_values_array, "kunde", "Kontakte_id", "dtKontaktDDText2" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( lieferantfilter )) {
	function lieferantfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Lieferanten ---";
			} else {
				$query = $sql_query ["kontaktliste"] . "and dtIstLieferant = 1 and dtAktiv=1 and $tblkontakte.id = $filter order by dtKontaktSortierung";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtKontaktDDText2"];
			}
			
			echo filter_anzeigefeld ( "lieferantfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Lieferant", "l" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblkontakte.dtFirmenname like '%" . $textfilter . "%' or $tblkontakte.dtNachname like '%" . $textfilter . "%' or $tblkontakte.dtVorname like '%" . $textfilter . "%' or $tblkontakte.dtKontaktNr like '%" . $textfilter . "%')";
			}
			
			$query = $sql_query ["kontaktliste"] . stripslashes ( $query_bedingungen ) . "and dtIstLieferant = 1 and dtAktiv=1 order by dtKontaktSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "lieferantfilter", $listenname, $ziel, $filter, "--- alle Lieferanten ---", $filter_values_array, "lieferant", "Kontakte_id", "dtKontaktDDText2" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( bestellerfilter )) {
	function bestellerfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Besteller ---";
			} else {
				$query = $sql_query ["kontaktliste"] . "and dtIstMitarbeiter = 1 and dtAktiv=1 and $tblkontakte.id = $filter order by dtKontaktSortierung";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtKontaktDDText"];
			}
			
			echo filter_anzeigefeld ( "bestellerfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Besteller", "b" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblkontakte.dtFirmenname like '%" . $textfilter . "%' or $tblkontakte.dtNachname like '%" . $textfilter . "%' or $tblkontakte.dtVorname like '%" . $textfilter . "%' or $tblkontakte.dtKontaktNr like '%" . $textfilter . "%')";
			}
			
			$query = $sql_query ["kontaktliste"] . stripslashes ( $query_bedingungen ) . "and dtIstMitarbeiter = 1 and dtAktiv=1 order by dtKontaktSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "bestellerfilter", $listenname, $ziel, $filter, "--- alle Besteller ---", $filter_values_array, "besteller", "Kontakte_id", "dtKontaktDDText" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( kontaktaspfilter )) {
	function kontaktaspfilter($filter, $listenname, $target, $typ, $kontaktid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, "", "", "", "" );
		
		if ($kontaktid != "") {
			$queryzusatz .= " and fiKontaktID = $kontaktid";
		}
		;
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Ansprechpartner ---";
			} else {
				$query = $sql_query ["kontaktaspliste"] . " and $tblkontakte.dtAktiv=1 and $tblkontaktasp.id = $filter $queryzusatz order by dtKontaktASPSortierung";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtKontaktASPDDText"];
			}
			
			echo filter_anzeigefeld ( "kontaktaspfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Ansprechpartner", "a" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblkontaktasp.dtVorname like '%" . $textfilter . "%' or $tblkontaktasp.dtNachname like '%" . $textfilter . "%' )";
			}
			
			$query = $sql_query ["kontaktaspliste"] . stripslashes ( $query_bedingungen ) . " and $tblkontakte.dtAktiv=1 $queryzusatz order by dtKontaktASPSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "kontaktaspfilter", $listenname, $ziel, $filter, "--- alle Ansprechpartner ---", $filter_values_array, "kontaktasp", "KontaktASP_id", "dtKontaktASPDDText" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

$warengruppen_array = array ();

if (! function_exists ( "warengruppenfilter" )) {
	function warengruppenfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		global $warengruppen_array;
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Warengruppen ---";
			} else {
				$query = "select * from $tblwarengruppen where $tblwarengruppen.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtWarengruppe"];
			}
			
			echo filter_anzeigefeld ( "warengruppenfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Warengruppe", "w" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			warengruppenfilter_rekursion ( 0, $filter, $listenname, $ziel, 0 );
			$filter_values_array = $warengruppen_array;
			
			echo filter_dropdownbox ( "warengruppenfilter", $listenname, $ziel, $filter, "--- alle Warengruppen ---", $filter_values_array, "warengruppe", "Warengruppe_id", "dtWarengruppe" );
		}
		
		return ($filter);
	}
}

if (! function_exists ( "warengruppenfilter_rekursion" )) {
	function warengruppenfilter_rekursion($referer, $filter, $listenname, $ziel, $tiefe) {
		global $warengruppen_array, $tblwarengruppen;
		
		$result = mysql_query ( "select * from $tblwarengruppen where fiWarengruppeUebergeordnet = $referer order by dtWarengruppenSortierung" );
		while ( $sub_row = mysql_fetch_row ( $result ) ) {
			$warengruppen_array [] = array (
					"Warengruppe_id" => $sub_row [0],
					"dtWarengruppe" => "|" . str_repeat ( "__", $tiefe ) . "| " . $sub_row [2],
					"tiefe" => $tiefe 
			);
			warengruppenfilter_rekursion ( $sub_row [0], $filter, $listenname, $ziel, $tiefe + 1 );
		}
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( taetigkeitenfilter )) {
	function taetigkeitenfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Ttigkeiten ---";
			} else {
				$query = $sql_query ["taetigkeitenliste"] . " and $tbltaetigkeiten.id = $filter order by dtTaetigkeitCode";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtTaetigkeitDDText"];
			}
			
			echo filter_anzeigefeld ( "taetigkeitenfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Ttigkeit", "t" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tbltaetigkeiten.dtTaetigkeitCode like '%" . $textfilter . "%' or $tbltaetigkeiten.dtTaetigkeit like '%" . $textfilter . "%' or $tbltaetigkeiten.dtTaetigkeitBeschreibung like '%" . $textfilter . "%' )";
			}
			
			$query = $sql_query ["taetigkeitenliste"] . stripslashes ( $query_bedingungen ) . " order by dtTaetigkeitCode";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "taetigkeitenfilter", $listenname, $ziel, $filter, "--- alle Ttigkeiten ---", $filter_values_array, "taetigkeit", "Taetigkeiten_id", "dtTaetigkeitDDText" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( lagerortfilter )) {
	function lagerortfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Lager-Orte ---";
			} else {
				$query = $sql_query ["lagerorteliste"] . " and $tbllagerorte.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtLagerOrtDDText"];
			}
			
			echo filter_anzeigefeld ( "lagerortfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Lager-Orten", "o" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tbllagerorte.dtLagerName like '%" . $textfilter . "%' or $tbllagerorte.dtLagerNr like '%" . $textfilter . "%' or $tbllagerorte.dtLagerPosition like '%" . $textfilter . "%')";
			}
			
			$query = $sql_query ["lagerorteliste"] . stripslashes ( $query_bedingungen ) . " order by dtLagerNr";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "lagerortfilter", $listenname, $ziel, $filter, "--- alle Lager-Orte ---", $filter_values_array, "lagerort", "LagerOrt_id", "dtLagerOrtDDText" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( projektfilter )) {
	function projektfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $query_bedingungen = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Projekte ---";
			} else {
				$query = $sql_query ["projektliste"] . " and $tblprojekte.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtProjektDDText"];
			}
			
			echo filter_anzeigefeld ( "projektfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Projekten", "p", 450, 250, "dropdownbox", $query_bedingungen );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblprojekte.dtProjektNr like '%" . $textfilter . "%' or $tblkontakte.dtFirmenname like '%" . $textfilter . "%' or $tblkontakte.dtVorname like '%" . $textfilter . "%' or $tblkontakte.dtNachname like '%" . $textfilter . "%' )";
			}
			
			$query = $sql_query ["projektliste"] . stripslashes ( $query_bedingungen ) . " order by dtProjektNr desc";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "projektfilter", $listenname, $ziel, $filter, "--- alle Projekte ---", $filter_values_array, "projekt", "Projekt_id", "dtProjektDDText" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( belegfilter )) {
	function belegfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Belege ---";
			} else {
				$query = $sql_query ["belegliste"] . " and $tblbelege.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtBelegDDText"];
			}
			
			echo filter_anzeigefeld ( "belegfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Beleg", "b" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblbelege.dtBelegNr like '%" . $textfilter . "%' or $tblbelege.dtBezeichnung like '%" . $textfilter . "%' )";
			}
			
			$query = $sql_query ["belegliste"] . stripslashes ( $query_bedingungen ) . " order by dtBelegDDText";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "belegfilter", $listenname, $ziel, $filter, "--- alle Belege ---", $filter_values_array, "beleg", "Beleg_id", "dtBelegDDText" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( rechnungfilter )) {
	function rechnungfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Rechnungen ---";
			} else {
				$query = $sql_query ["rechnungliste"] . " and $tblrechnungen.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtRechnungDDText"];
			}
			
			echo filter_anzeigefeld ( "rechnungfilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Rechnung", "r" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblrechnungen.dtRechnungNrIntern like '%" . $textfilter . "%' or $tblrechnungen.dtRechnungNrExtern like '%" . $textfilter . "%')";
			}
			
			$query = $sql_query ["rechnungliste"] . stripslashes ( $query_bedingungen ) . " order by dtRechnungNrIntern desc";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "rechnungfilter", $listenname, $ziel, $filter, "--- alle Rechnungen ---", $filter_values_array, "rechnung", "Rechnung_id", "dtRechnungDDText" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( buchungskontofilter )) {
	function buchungskontofilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Buchungskonten ---";
			} else {
				$query = $sql_query ["buchungskontenliste"] . " and $tblbuchungskonten.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtBuchungsKontoDDText"];
			}
			
			echo filter_anzeigefeld ( "buchungskontofilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Buchungskonto", "b" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblbuchungskonten.dtKontoID like '%" . $textfilter . "%' or $tblbuchungskonten.dtKontoBezeichnung like '%" . $textfilter . "%' )";
			}
			
			$query = $sql_query ["buchungskontenliste"] . stripslashes ( $query_bedingungen ) . " order by dtKontoID";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "buchungskontofilter", $listenname, $ziel, $filter, "--- alle Buchungskonten ---", $filter_values_array, "buchungskonto", "Buchungskonto_id", "dtBuchungsKontoDDText" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( bankkontofilter )) {
	function bankkontofilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Bankkonten ---";
			} else {
				$query = $sql_query ["bankkontenliste"] . " and $tblbankkonten.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtKontoName"];
			}
			
			echo filter_anzeigefeld ( "bankkontofilter", $listenname, $filter, $value, "input_text_200", "Filterung nach Bankkonto", "b" );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblbankkonten.dtKontoName like '%" . $textfilter . "%' or $tblbankkonten.dtKontoNummer like '%" . $textfilter . "%' or $tblbankkonten.dtBankLeitZahl like '%" . $textfilter . "%' or $tblbankkonten.dtBankName like '%" . $textfilter . "%' )";
			}
			
			$query = $sql_query ["bankkontenliste"] . stripslashes ( $query_bedingungen ) . " order by dtKontoName";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "bankkontofilter", $listenname, $ziel, $filter, "--- alle Bankkonten ---", $filter_values_array, "bankkonto", "Bankkonto_id", "dtKontoName" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( zahlartfilter )) {
	function zahlartfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$value = "--- alle Zahlarten ---";
			} else {
				$query = $sql_query ["rechnungzahlartliste"] . " and $tblrechnungzahlart.id = $filter";
				$result = mysql_query ( $query );
				$sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC );
				$value = $sub_row ["dtZahlart"];
			}
			
			echo filter_anzeigefeld ( "zahlartfilter", $listenname, $filter, $value, "input_text_150", "Filterung nach Zahlarten", "z", 250, 150 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			if ($textfilter != "") {
				$query_bedingungen .= " and ($tblrechnungzahlart.dtZahlart like '%" . $textfilter . "%' )";
			}
			
			$query = $sql_query ["rechnungzahlartliste"] . stripslashes ( $query_bedingungen ) . " order by dtSortierung";
			$result = mysql_query ( $query );
			
			while ( $sub_row = mysql_fetch_array ( $result, MYSQL_ASSOC ) ) {
				$filter_values_array [] = $sub_row;
			}
			
			echo filter_dropdownbox ( "zahlartfilter", $listenname, $ziel, $filter, "--- alle Zahlarten ---", $filter_values_array, "zahlartfilter", "RechnungZahlart_id", "dtZahlart" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++ Textfilter - suchen-Box
if (! function_exists ( textfilter )) {
	function textfilter($textfilter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $filtername = "", $iCheckLength = 1) {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		global $ft_min_word_len;
		
		if ($filtername != "")
			$filtername = "_" . $filtername;
		
		echo "<form name=\"textfilter" . $filtername . "\" action=\"$PHP_SELF\" method=\"post\">";
		echo "<input type=\"hidden\" name=\"" . session_name () . "\" value=\"" . session_id () . "\">";
		
		echo "<input type=\"hidden\" name=\"target\" value=\"" . $target . "\">";
		echo "<input type=\"hidden\" name=\"typ\" value=\"" . $typ . "\">";
		echo "<input type=\"hidden\" name=\"id\" value=\"" . $id . "\">";
		echo "<input type=\"hidden\" name=\"subtarget\" value=\"" . $subtarget . "\">";
		echo "<input type=\"hidden\" name=\"subtyp\" value=\"" . $subtyp . "\">";
		echo "<input type=\"hidden\" name=\"id\" value=\"" . $id . "\">";
		
		echo "<input type=\"hidden\" name=\"listenname\" value=\"" . $listenname . "\">";
		echo "<input type=\"hidden\" name=\"filtername\" value=\"textfilter" . $filtername . "\">";
		echo "<input type=\"hidden\" name=\"standardfilterladen\" value=\"0\">";
		echo "<input type=\"hidden\" name=\"standardfilterspeichern\" value=\"0\">";
		
		echo "<table border=0 cellspacing=0 cellpadding=0><tr><td valign=\"top\">";
		
		if ($textfilter != "") {
			$bgcolor = "background-color: " . $filter_aktiv_color;
		}
		
		echo "<input type=\"text\" class=\"input_text_200\" style=\"width: 220px; " . $bgcolor . "\" name=\"filterwert_neu\" title=\"Textfilter - geben Sie hier durch Leerzeichen getrennte Suchworte ein\" accesskey=\"#\" ";
		echo "value=\"" . useHtmlEntities ( $textfilter ) . "\">";
		echo "</td><td width=5></td><td>";
		
		if ($iCheckLength == 1)
			echo "<input id=\"absendenbutton\" type=\"image\" src=\"config/pics/button_suchen.png\" onClick=\"if(!textsucheCheckMinLength(this.form.filterwert_neu.value, " . $ft_min_word_len . ")) return false;\">";
		else
			echo "<input id=\"absendenbutton\" type=\"image\" src=\"config/pics/button_suchen.png\">";
		
		echo "</td></tr></table>";
		
		echo "</form>";
		
		return ($textfilter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++ Datumsbereich
if (! function_exists ( datumsbereich_datumspicker_popup )) {
	function datumsbereich_datumspicker_popup($x_offset, $bgcolor = "#ffffff;") {
		$html = "<table border=0 cellspacing=0 cellpadding=0 class=\"text\" style=\"background-color: " . $bgcolor . ";\" width=\"100%\">";
		$html .= "<tr><td>";
		
		$html .= "<table border=0 cellspacing=0 cellpadding=0 class=\"text\" style=\"background-color: " . $bgcolor . ";\">";
		$html .= "<tr><td style=\"width: " . ($x_offset + 153) . "px; height: 0px; \"></td>";
		$html .= "<td style=\"width: 111px;\" name=\"anchor_datum_tag_von_neu\" id=\"anchor_datum_tag_von_neu\" >";
		$html .= formular_datumspicker_obj ( "datum_tag_von_neu", "datum_monat_von_neu", "datum_jahr_von_neu", false );
		$html .= "</td>";
		$html .= "<td style=\"width: 100px;\" name=\"anchor_datum_tag_bis_neu\" id=\"anchor_datum_tag_bis_neu\" >";
		$html .= formular_datumspicker_obj ( "datum_tag_bis_neu", "datum_monat_bis_neu", "datum_jahr_bis_neu", false );
		$html .= "</td></tr>";
		$html .= "</table>";
		
		$html .= "</td></tr>";
		$html .= "</table>";
		
		return $html;
	}
}

if (! function_exists ( datumsbereich )) {
	function datumsbereich($datum, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $filtertyp = "sta") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// ++++ einzelne Datumsfelder aus Datumsstring extrahieren
		$datum_explode = extract_datum_aus_datumsfilter ( $datum );
		
		$datum_tag_von = $datum_explode [0];
		$datum_monat_von = $datum_explode [1];
		$datum_jahr_von = $datum_explode [2];
		$datum_tag_bis = $datum_explode [3];
		$datum_monat_bis = $datum_explode [4];
		$datum_jahr_bis = $datum_explode [5];
		
		$datum_tag_von_anzeige = $datum_explode [6];
		$datum_monat_von_anzeige = $datum_explode [7];
		$datum_jahr_von_anzeige = $datum_explode [8];
		$datum_tag_bis_anzeige = $datum_explode [9];
		$datum_monat_bis_anzeige = $datum_explode [10];
		$datum_jahr_bis_anzeige = $datum_explode [11];
		
		// ++++ Anzeige ausblenden, wenn Anzeigezeitraum unbegrenzt ist, sonst Anzeige des Zeitraumes mit aktivem Hintergrund
		if ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) {
			$backgroundstyle_von = "";
		} else {
			$backgroundstyle_von = "style=\"background-color: " . $filter_aktiv_color . "\" ";
		}
		
		// ++++ Anzeige ausblenden, wenn Anzeigezeitraum unbegrenzt ist, sonst Anzeige des Zeitraumes mit aktivem Hintergrund
		if ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) {
			$backgroundstyle_bis = "";
		} else {
			$backgroundstyle_bis = "style=\"background-color: " . $filter_aktiv_color . "\" ";
		}
		
		// ++++ Datumse f�r die Buttons abh�ngig vom aktuellen Datumsfilter berechnen
		// erkenne Zeitraum gesamtes Jahr
		if ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_tag_bis == 31 and $datum_monat_bis == 12 and $datum_jahr_von == $datum_jahr_bis) {
			
			$datum_frueher_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 1, 1, $datum_jahr_von - 1 ) ) );
			$datum_frueher_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 12, 31, $datum_jahr_von - 1 ) ) );
			
			$datum_spaeter_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 1, 1, $datum_jahr_bis + 1 ) ) );
			$datum_spaeter_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 12, 31, $datum_jahr_bis + 1 ) ) );
			
			// erkenne Zeitraum gesamter Monat
		} elseif ($datum_tag_von == 1 and date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_bis, $datum_tag_bis + 1, $datum_jahr_bis ) ) == date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_bis + 1, 1, $datum_jahr_bis ) ) and $datum_monat_von == $datum_monat_bis and $datum_jahr_von == $datum_jahr_bis) {
			
			$datum_frueher_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_von - 1, 1, $datum_jahr_von ) ) );
			$datum_frueher_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_von, 0, $datum_jahr_von ) ) );
			
			$datum_spaeter_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_bis + 1, 1, $datum_jahr_bis ) ) );
			$datum_spaeter_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_bis + 2, 0, $datum_jahr_bis ) ) );
			
			// erkenne Zeitraum gesamtes Quartal
		} elseif ($datum_tag_von == 1 and date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_bis, $datum_tag_bis + 1, $datum_jahr_bis ) ) == date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_bis + 1, 1, $datum_jahr_bis ) ) and (($datum_monat_von == 1 and $datum_monat_bis == 3) or ($datum_monat_von == 4 and $datum_monat_bis == 6) or ($datum_monat_von == 7 and $datum_monat_bis == 9) or ($datum_monat_von == 10 and $datum_monat_bis == 12)) and $datum_jahr_von == $datum_jahr_bis) {
			
			$datum_frueher_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_von - 3, 1, $datum_jahr_von ) ) );
			$datum_frueher_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_bis - 2, 0, $datum_jahr_von ) ) );
			
			$datum_spaeter_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_von + 3, 1, $datum_jahr_bis ) ) );
			$datum_spaeter_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_bis + 4, 0, $datum_jahr_bis ) ) );
			
			// sonst nehme den Anzeigezeitraum +/- (passt bei Tag und Woche immer!)
		} else {
			
			$zeitfenster = (date ( "U", mktime ( 0, 0, 0, $datum_monat_bis, $datum_tag_bis, $datum_jahr_bis ) ) - date ( "U", mktime ( 0, 0, 0, $datum_monat_von, $datum_tag_von, $datum_jahr_von ) )) / 86400;
			
			$datum_frueher_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_von, $datum_tag_von - 1 - $zeitfenster, $datum_jahr_von ) ) );
			$datum_frueher_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_von, $datum_tag_von - 1, $datum_jahr_von ) ) );
			
			$datum_spaeter_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_bis, $datum_tag_bis + 1, $datum_jahr_bis ) ) );
			$datum_spaeter_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $datum_monat_bis, $datum_tag_bis + 1 + $zeitfenster, $datum_jahr_bis ) ) );
		}
		
		// Wenn kein Filter gesetzt ist, dann haben auch die vor uns zur�ck-Buttons keine Funktion
		if ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) {
			$datum_frueher_von = split_date ( "1970-01-01" );
			$datum_frueher_bis = split_date ( "2030-01-01" );
		}
		if ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) {
			$datum_spaeter_von = split_date ( "1970-01-01" );
			$datum_spaeter_bis = split_date ( "2030-01-01" );
		}
		
		// ++++ Datumse f�r die Buttons mit aktueller Woche, Monat und Jahr berechnen
		$aktweek = split_date ( monday_of_week ( $aktdatum ) );
		
		$datum_aktwoche_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $aktweek ["monat"], $aktweek ["tag"], $aktweek ["jahr"] ) ) );
		$datum_aktwoche_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $aktweek ["monat"], $aktweek ["tag"] + 6, $aktweek ["jahr"] ) ) );
		
		$datum_aktmonat_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $aktmonat, 1, $aktjahr ) ) );
		$datum_aktmonat_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, $aktmonat + 1, 0, $aktjahr ) ) );
		
		if ($aktmonat == 1 or $aktmonat == 2 or $aktmonat == 3) {
			$datum_aktquartal_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 1, 1, $aktjahr ) ) );
			$datum_aktquartal_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 3, 31, $aktjahr ) ) );
		} else if ($aktmonat == 4 or $aktmonat == 5 or $aktmonat == 6) {
			$datum_aktquartal_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 4, 1, $aktjahr ) ) );
			$datum_aktquartal_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 6, 30, $aktjahr ) ) );
		} else if ($aktmonat == 7 or $aktmonat == 8 or $aktmonat == 9) {
			$datum_aktquartal_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 7, 1, $aktjahr ) ) );
			$datum_aktquartal_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 9, 30, $aktjahr ) ) );
		} else if ($aktmonat == 10 or $aktmonat == 11 or $aktmonat == 12) {
			$datum_aktquartal_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 10, 1, $aktjahr ) ) );
			$datum_aktquartal_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 12, 31, $aktjahr ) ) );
		}
		
		$datum_aktjahr_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 1, 1, $aktjahr ) ) );
		$datum_aktjahr_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 12, 31, $aktjahr ) ) );
		
		$datum_unbegrenzt_von = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 1, 1, 1970 ) ) );
		$datum_unbegrenzt_bis = split_date ( date ( "Y-m-d", mktime ( 0, 0, 0, 1, 1, 2030 ) ) );
		
		echo "<nobr class=\"text\">";
		echo "<table border=0 cellspacing=0 cellpadding=0><tr>";
		
		echo "<form name=\"datumsfilter\" action=\"$PHP_SELF\" method=\"post\">";
		echo "<td valign=\"top\" ><nobr>";
		
		echo "<input type=\"hidden\" name=\"" . session_name () . "\" value=\"" . session_id () . "\">";
		
		echo "<input type=\"hidden\" name=\"target\" value=\"" . $target . "\">";
		echo "<input type=\"hidden\" name=\"typ\" value=\"" . $typ . "\">";
		echo "<input type=\"hidden\" name=\"id\" value=\"" . $id . "\">";
		echo "<input type=\"hidden\" name=\"subtarget\" value=\"" . $subtarget . "\">";
		echo "<input type=\"hidden\" name=\"subtyp\" value=\"" . $subtyp . "\">";
		echo "<input type=\"hidden\" name=\"id\" value=\"" . $id . "\">";
		
		echo "<input type=\"hidden\" name=\"listenname\" value=\"" . $listenname . "\">";
		echo "<input type=\"hidden\" name=\"filtername\" value=\"datumsbereich\">";
		echo "<input type=\"hidden\" name=\"filterwert_neu\" value=\"xyz\">";
		echo "<input type=\"hidden\" name=\"standardfilterladen\" value=\"0\">";
		echo "<input type=\"hidden\" name=\"standardfilterspeichern\" value=\"0\">";
		
		echo "<input type=\"hidden\" name=\"" . session_name () . "\" value=\"" . session_id () . "\">";
		
		echo "<input type=\"text\" class=\"input_date\" $backgroundstyle_von name=\"datum_tag_von_neu\" value=\"$datum_tag_von_anzeige\" title=\"Datumsfilter Tag von\"  accesskey=\"d\">";
		echo "<input type=\"text\" class=\"input_date\" $backgroundstyle_von name=\"datum_monat_von_neu\" value=\"$datum_monat_von_anzeige\" title=\"Datumsfilter Monat von\">";
		echo "<input type=\"text\" class=\"input_date\" $backgroundstyle_von name=\"datum_jahr_von_neu\" value=\"$datum_jahr_von_anzeige\" title=\"Datumsfilter Jahr von\">";
		echo "</nobr></td><td valign=\"top\">";
		echo formular_datumspicker_button ( "datum_tag_von_neu", formular_datumspicker_datum ( $datum_jahr_von_anzeige . "-" . $datum_monat_von_anzeige . "-" . $datum_tag_von_anzeige ), "formular" );
		
		echo "</td><td style='width:5px;'></td><td valign=\"top\"><nobr>";
		echo "<input type=\"text\" class=\"input_date\" $backgroundstyle_bis name=\"datum_tag_bis_neu\" value=\"$datum_tag_bis_anzeige\" title=\"Datumsfilter Tag bis\">";
		echo "<input type=\"text\" class=\"input_date\" $backgroundstyle_bis name=\"datum_monat_bis_neu\" value=\"$datum_monat_bis_anzeige\" title=\"Datumsfilter Monat bis\">";
		echo "<input type=\"text\" class=\"input_date\" $backgroundstyle_bis name=\"datum_jahr_bis_neu\" value=\"$datum_jahr_bis_anzeige\" title=\"Datumsfilter Jahr bis\">";
		echo "</nobr></td><td valign=\"top\">";
		echo formular_datumspicker_button ( "datum_tag_bis_neu", formular_datumspicker_datum ( $datum_jahr_bis_anzeige . "-" . $datum_monat_bis_anzeige . "-" . $datum_tag_bis_anzeige ), "formular" );
		
		echo "</td><td style='width:5px;'></td><td>";
		echo "<input  id=\"absendenbutton\" type=\"image\" src=\"config/pics/button_filteranzeigen.png\" title=\"Datumsfilter anwenden\">&nbsp;";
		echo "</td>";
		
		echo "</form>";
		
		echo "<td valign=\"top\">";
		
		$link = "main.php?" . $ziel . "&filtername=datumsbereich&listenname=$listenname&filterwert_neu=xyz";
		$link .= "&datum_tag_von_neu=" . $datum_frueher_von ["tag"] . "&datum_monat_von_neu=" . $datum_frueher_von ["monat"] . "&datum_jahr_von_neu=" . $datum_frueher_von ["jahr"];
		$link .= "&datum_tag_bis_neu=" . $datum_frueher_bis ["tag"] . "&datum_monat_bis_neu=" . $datum_frueher_bis ["monat"] . "&datum_jahr_bis_neu=" . $datum_frueher_bis ["jahr"];
		echo erzeuge_button ( "&lt;", $link, "", "Anzeigezeitraum frher" );
		
		echo "</td><td valign=\"top\">";
		$link = "main.php?" . $ziel . "&filtername=datumsbereich&listenname=$listenname&filterwert_neu=xyz";
		$link .= "&datum_tag_von_neu=" . $datum_spaeter_von ["tag"] . "&datum_monat_von_neu=" . $datum_spaeter_von ["monat"] . "&datum_jahr_von_neu=" . $datum_spaeter_von ["jahr"];
		$link .= "&datum_tag_bis_neu=" . $datum_spaeter_bis ["tag"] . "&datum_monat_bis_neu=" . $datum_spaeter_bis ["monat"] . "&datum_jahr_bis_neu=" . $datum_spaeter_bis ["jahr"];
		echo erzeuge_button ( "&gt;", $link, "", "Anzeigezeitraum spter" );
		
		echo "</td><td valign=\"top\">";
		$link = "main.php?" . $ziel . "&filtername=datumsbereich&listenname=$listenname&filterwert_neu=xyz";
		$link .= "&datum_tag_von_neu=" . $akttag . "&datum_monat_von_neu=" . $aktmonat . "&datum_jahr_von_neu=" . $aktjahr;
		$link .= "&datum_tag_bis_neu=" . $akttag . "&datum_monat_bis_neu=" . $aktmonat . "&datum_jahr_bis_neu=" . $aktjahr;
		echo erzeuge_button ( "T", $link, "", "aktuellen Tag anzeigen" );
		
		echo "</td><td valign=\"top\">";
		$link = "main.php?" . $ziel . "&filtername=datumsbereich&listenname=$listenname&filterwert_neu=xyz";
		$link .= "&datum_tag_von_neu=" . $datum_aktwoche_von ["tag"] . "&datum_monat_von_neu=" . $datum_aktwoche_von ["monat"] . "&datum_jahr_von_neu=" . $datum_aktwoche_von ["jahr"];
		$link .= "&datum_tag_bis_neu=" . $datum_aktwoche_bis ["tag"] . "&datum_monat_bis_neu=" . $datum_aktwoche_bis ["monat"] . "&datum_jahr_bis_neu=" . $datum_aktwoche_bis ["jahr"];
		echo erzeuge_button ( "W", $link, "", "aktuelle Woche anzeigen" );
		
		echo "</td><td valign=\"top\">";
		$link = "main.php?" . $ziel . "&filtername=datumsbereich&listenname=$listenname&filterwert_neu=xyz";
		$link .= "&datum_tag_von_neu=" . $datum_aktmonat_von ["tag"] . "&datum_monat_von_neu=" . $datum_aktmonat_von ["monat"] . "&datum_jahr_von_neu=" . $datum_aktmonat_von ["jahr"];
		$link .= "&datum_tag_bis_neu=" . $datum_aktmonat_bis ["tag"] . "&datum_monat_bis_neu=" . $datum_aktmonat_bis ["monat"] . "&datum_jahr_bis_neu=" . $datum_aktmonat_bis ["jahr"];
		echo erzeuge_button ( "M", $link, "", "aktuellen Monat anzeigen" );
		
		echo "</td><td valign=\"top\">";
		$link = "main.php?" . $ziel . "&filtername=datumsbereich&listenname=$listenname&filterwert_neu=xyz";
		$link .= "&datum_tag_von_neu=" . $datum_aktquartal_von ["tag"] . "&datum_monat_von_neu=" . $datum_aktquartal_von ["monat"] . "&datum_jahr_von_neu=" . $datum_aktquartal_von ["jahr"];
		$link .= "&datum_tag_bis_neu=" . $datum_aktquartal_bis ["tag"] . "&datum_monat_bis_neu=" . $datum_aktquartal_bis ["monat"] . "&datum_jahr_bis_neu=" . $datum_aktquartal_bis ["jahr"];
		echo erzeuge_button ( "Q", $link, "", "aktuelles Quartal anzeigen" );
		
		echo "</td><td valign=\"top\">";
		$link = "main.php?" . $ziel . "&filtername=datumsbereich&listenname=$listenname&filterwert_neu=xyz";
		$link .= "&datum_tag_von_neu=" . $datum_aktjahr_von ["tag"] . "&datum_monat_von_neu=" . $datum_aktjahr_von ["monat"] . "&datum_jahr_von_neu=" . $datum_aktjahr_von ["jahr"];
		$link .= "&datum_tag_bis_neu=" . $datum_aktjahr_bis ["tag"] . "&datum_monat_bis_neu=" . $datum_aktjahr_bis ["monat"] . "&datum_jahr_bis_neu=" . $datum_aktjahr_bis ["jahr"];
		echo erzeuge_button ( "J", $link, "", "aktuelles Jahr anzeigen" );
		
		echo "</td><td valign=\"top\">";
		$link = "main.php?" . $ziel . "&filtername=datumsbereich&listenname=$listenname&filterwert_neu=xyz";
		$link .= "&datum_tag_von_neu=" . $datum_unbegrenzt_von ["tag"] . "&datum_monat_von_neu=" . $datum_unbegrenzt_von ["monat"] . "&datum_jahr_von_neu=" . $datum_unbegrenzt_von ["jahr"];
		$link .= "&datum_tag_bis_neu=" . $datum_unbegrenzt_bis ["tag"] . "&datum_monat_bis_neu=" . $datum_unbegrenzt_bis ["monat"] . "&datum_jahr_bis_neu=" . $datum_unbegrenzt_bis ["jahr"];
		echo erzeuge_button ( "...", $link, "", "Anzeigezeitraum unbegrenzt" );
		
		echo "</td><td valign=\"top\">";
		if ($filtertyp != "dyn") {
			$filterarray = str_replace ( "\"", "&quot;", serialize ( array (
					"datumsfiltertyp" => "dyn" 
			) ) );
			$link = "main.php?" . $ziel . "&listenname=$listenname&filterwert_neu=" . $filterarray;
			echo erzeuge_button ( "STA", $link, "", "Datumsfilter ist statisch. Schalte auf dynamischen Datumsfilter" );
		} else {
			$filterarray = str_replace ( "\"", "&quot;", serialize ( array (
					"datumsfiltertyp" => "sta" 
			) ) );
			$link = "main.php?" . $ziel . "&listenname=$listenname&filterwert_neu=" . $filterarray;
			echo erzeuge_button ( "DYN", $link, "", "Datumsfilter ist dynamisch. Schalte auf statischen Datumsfilter" );
		}
		
		echo "</td><td style='width:5px;'></td></tr></table>";
		
		return ($datum_tag_von . "-" . $datum_monat_von . "-" . $datum_jahr_von . "-" . $datum_tag_bis . "-" . $datum_monat_bis . "-" . $datum_jahr_bis);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "erledigtfilter" )) {
	function erledigtfilter($filter, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "", $ajax = "", $textfilter = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		$projektstand_array [0] = array (
				"id" => 0,
				"dtErledigt" => "--- alle Wiedervorlagen ---" 
		);
		$projektstand_array [1] = array (
				"id" => 1,
				"dtErledigt" => "nur offene Wiedervorlagen" 
		);
		$projektstand_array [2] = array (
				"id" => 2,
				"dtErledigt" => "nur erledigte Wiedervorlagen" 
		);
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Anzeigefeld
		if ($ajax == "") {
			
			if ($filter == "") {
				$filter = 0;
			}
			;
			
			$value = $projektstand_array [$filter] ["dtErledigt"];
			
			echo filter_anzeigefeld ( "erledigtfilter", $listenname, $filter, $value, "input_text_150", "Filterung nach Status", "p", 250 );
			
			// +++++++++++++++++++++++++++++++++++++++++++++++++
			// ++++ vollst�ndige Liste als Dropdown (Ajax post-load)
		} else {
			
			unset ( $projektstand_array [0] );
			echo filter_dropdownbox ( "erledigtfilter", $listenname, $ziel, $filter, "--- alle Wiedervorlagen ---", $projektstand_array, "erledigtfilter", "id", "dtErledigt" );
		}
		
		return ($filter);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++ Uhrzeitbereich
if (! function_exists ( uhrzeitbereich )) {
	function uhrzeitbereich($uhrzeit, $listenname, $target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$ziel = zielstring ( $target, $typ, $id, $subtarget, $subtyp, $subid );
		
		// ++++ einzelne Uhrzeit-Felder aus Uhrzeitstring extrahieren
		$uhrzeit_explode = extract_uhrzeit_aus_uhrzeitfilter ( $uhrzeit );
		
		$uhrzeit_stunde_von = $uhrzeit_explode [0];
		$uhrzeit_minute_von = $uhrzeit_explode [1];
		$uhrzeit_stunde_bis = $uhrzeit_explode [2];
		$uhrzeit_minute_bis = $uhrzeit_explode [3];
		
		$uhrzeit_von_anzeige = $uhrzeit_explode [4];
		$uhrzeit_bis_anzeige = $uhrzeit_explode [5];
		
		// ++++ Anzeige ausblenden, wenn Anzeigezeitraum unbegrenzt ist, sonst Anzeige des Zeitraumes mit aktivem Hintergrund
		if (($uhrzeit_stunde_von == 24 and $uhrzeit_minute_von == 60) or ($uhrzeit_stunde_von == "" and $uhrzeit_minute_von == "")) {
			$backgroundstyle_von = "";
		} else {
			$backgroundstyle_von = "style=\"background-color: " . $filter_aktiv_color . "\" ";
		}
		
		// ++++ Anzeige ausblenden, wenn Anzeigezeitraum unbegrenzt ist, sonst Anzeige des Zeitraumes mit aktivem Hintergrund
		if (($uhrzeit_stunde_bis == 24 and $uhrzeit_minute_bis == 60) or ($uhrzeit_stunde_bis == "" and $uhrzeit_minute_bis == "")) {
			$backgroundstyle_bis = "";
		} else {
			$backgroundstyle_bis = "style=\"background-color: " . $filter_aktiv_color . "\" ";
		}
		
		// ++++ Uhrzeiten f�r die Buttons abh�ngig vom aktuellen Uhrzeitfilter berechnen
		$zeitfenster = abs ( stdmin_to_min ( $uhrzeit_stunde_bis . ":" . $uhrzeit_minute_bis ) - stdmin_to_min ( $uhrzeit_stunde_von . ":" . $uhrzeit_minute_von ) );
		
		$uhrzeit_frueher_von = min_to_stdmin ( max ( 0, stdmin_to_min ( $uhrzeit_stunde_von . ":" . $uhrzeit_minute_von ) - $zeitfenster ), "-" );
		$uhrzeit_frueher_bis = min_to_stdmin ( max ( 0, stdmin_to_min ( $uhrzeit_stunde_bis . ":" . $uhrzeit_minute_bis ) - $zeitfenster ), "-" );
		
		$uhrzeit_spaeter_von = min_to_stdmin ( min ( 1439, stdmin_to_min ( $uhrzeit_stunde_von . ":" . $uhrzeit_minute_von ) + $zeitfenster ), "-" );
		$uhrzeit_spaeter_bis = min_to_stdmin ( min ( 1439, stdmin_to_min ( $uhrzeit_stunde_bis . ":" . $uhrzeit_minute_bis ) + $zeitfenster ), "-" );
		
		$uhrzeit_vormittags_von = "00-00";
		$uhrzeit_vormittags_bis = "12-00";
		
		$uhrzeit_nachmittags_von = "12-00";
		$uhrzeit_nachmittags_bis = "23-59";
		
		// Wenn kein Filter gesetzt ist, dann haben auch die vor uns zur�ck-Buttons keine Funktion
		if ($uhrzeit_stunde_von == 24 and $uhrzeit_minute_von == 60) {
			$uhrzeit_frueher_von = "24-60";
			$uhrzeit_frueher_bis = "24-60";
		}
		if ($uhrzeit_stunde_bis == 24 and $uhrzeit_minute_bis == 60) {
			$uhrzeit_spaeter_von = "24-60";
			$uhrzeit_spaeter_bis = "24-60";
		}
		
		echo "<nobr class=\"text\">";
		echo "<table border=0 cellspacing=0 cellpadding=0><tr>";
		
		echo "<form name=\"uhrzeitfilter\" action=\"$PHP_SELF\" method=\"post\">";
		
		echo "<td valign=\"top\"><nobr>";
		
		echo "<input type=\"hidden\" name=\"" . session_name () . "\" value=\"" . session_id () . "\">";
		
		echo "<input type=\"hidden\" name=\"target\" value=\"" . $target . "\">";
		echo "<input type=\"hidden\" name=\"typ\" value=\"" . $typ . "\">";
		echo "<input type=\"hidden\" name=\"id\" value=\"" . $id . "\">";
		echo "<input type=\"hidden\" name=\"subtarget\" value=\"" . $subtarget . "\">";
		echo "<input type=\"hidden\" name=\"subtyp\" value=\"" . $subtyp . "\">";
		echo "<input type=\"hidden\" name=\"id\" value=\"" . $id . "\">";
		
		echo "<input type=\"hidden\" name=\"listenname\" value=\"" . $listenname . "\">";
		echo "<input type=\"hidden\" name=\"filtername\" value=\"uhrzeitbereich\">";
		echo "<input type=\"hidden\" name=\"filterwert_neu\" value=\"xyz\">";
		echo "<input type=\"hidden\" name=\"standardfilterladen\" value=\"0\">";
		echo "<input type=\"hidden\" name=\"standardfilterspeichern\" value=\"0\">";
		
		echo "<input type=\"hidden\" name=\"" . session_name () . "\" value=\"" . session_id () . "\">";
		
		echo "<input type=\"text\" class=\"input_time\" $backgroundstyle_von name=\"uhrzeit_von_neu\" value=\"" . $uhrzeit_von_anzeige . "\" title=\"Uhrzeitfilter von\" onChange=\"this.form.uhrzeit_von_neu.value=check_zeit(this.form.uhrzeit_von_neu.value)\" accesskey=\"u\">";
		
		echo "</nobr></td><td style='width:5px;'></td><td valign=\"top\"><nobr>";
		echo "<input type=\"text\" class=\"input_time\" $backgroundstyle_bis name=\"uhrzeit_bis_neu\" value=\"" . $uhrzeit_bis_anzeige . "\" title=\"Uhrzeitfilter bis\" onChange=\"this.form.uhrzeit_bis_neu.value=check_zeit(this.form.uhrzeit_bis_neu.value)\">";
		
		echo "</td><td style='width:5px;'></td><td valign=\"top\">";
		echo "<input  id=\"absendenbutton\" type=\"image\" src=\"config/pics/button_filteranzeigen.png\" title=\"Uhrzeitfilter anwenden\">&nbsp;";
		echo "</td>";
		
		echo "</form>";
		
		echo "<td valign=\"top\">";
		$link = "main.php?" . $ziel . "&filtername=uhrzeitbereich&listenname=$listenname&filterwert_neu=xyz";
		$link .= "&uhrzeit_von_neu=" . $uhrzeit_frueher_von;
		$link .= "&uhrzeit_bis_neu=" . $uhrzeit_frueher_bis;
		echo erzeuge_button ( "&lt;", $link, "", "Anzeigezeitraum frher" );
		
		echo "</td><td valign=\"top\">";
		$link = "main.php?" . $ziel . "&filtername=uhrzeitbereich&listenname=$listenname&filterwert_neu=xyz";
		$link .= "&uhrzeit_von_neu=" . $uhrzeit_spaeter_von;
		$link .= "&uhrzeit_bis_neu=" . $uhrzeit_spaeter_bis;
		echo erzeuge_button ( "&gt;", $link, "", "Anzeigezeitraum spter" );
		
		echo "</td><td valign=\"top\">";
		$link = "main.php?" . $ziel . "&filtername=uhrzeitbereich&listenname=$listenname&filterwert_neu=xyz";
		$link .= "&uhrzeit_von_neu=" . $uhrzeit_vormittags_von;
		$link .= "&uhrzeit_bis_neu=" . $uhrzeit_vormittags_bis;
		echo erzeuge_button ( "V", $link, "", "Vormittag anzeigen" );
		
		echo "</td><td valign=\"top\">";
		$link = "main.php?" . $ziel . "&filtername=uhrzeitbereich&listenname=$listenname&filterwert_neu=xyz";
		$link .= "&uhrzeit_von_neu=" . $uhrzeit_nachmittags_von;
		$link .= "&uhrzeit_bis_neu=" . $uhrzeit_nachmittags_bis;
		echo erzeuge_button ( "N", $link, "", "Nachmittag anzeigen" );
		
		echo "</td><td valign=\"top\">";
		$link = "main.php?" . $ziel . "&filtername=uhrzeitbereich&listenname=$listenname&filterwert_neu=xyz";
		$link .= "&uhrzeit_von_neu=";
		$link .= "&uhrzeit_bis_neu=";
		echo erzeuge_button ( "...", $link, "", "Anzeigezeitraum unbegrenzt" );
		
		echo "</td><td style='width:5px;'></td></tr></table>";
		
		return ($uhrzeit_stunde_von . "-" . $uhrzeit_minute_von . "-" . $uhrzeit_stunde_bis . "-" . $uhrzeit_minute_bis);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++ ZielString
if (! function_exists ( zielstring )) {
	function zielstring($target, $typ, $id = "", $subtarget = "", $subtyp = "", $subid = "") {
		$ziel = "target=" . $target . "&typ=" . $typ;
		if ($id != "") {
			$ziel .= "&id=" . $id;
		}
		;
		if ($subtarget != "") {
			$ziel .= "&subtarget=" . $subtarget;
		}
		;
		if ($subtyp != "") {
			$ziel .= "&subtyp=" . $subtyp;
		}
		;
		if ($subid != "") {
			$ziel .= "&subid=" . $subid;
		}
		;
		
		return ($ziel);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++ einzelne Datumsfelder aus Datumsstring extrahieren
if (! function_exists ( extract_datum_aus_datumsfilter )) {
	function extract_datum_aus_datumsfilter($datumstring) {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		// ++++ einzelne Datumsfelder aus Datumsstring extrahieren
		$datum_explode = explode ( "-", $datumstring );
		
		$datum_tag_von = $datum_explode [0];
		$datum_monat_von = $datum_explode [1];
		$datum_jahr_von = $datum_explode [2];
		$datum_tag_bis = $datum_explode [3];
		$datum_monat_bis = $datum_explode [4];
		$datum_jahr_bis = $datum_explode [5];
		
		// ++++ Zeitraum korrigieren, wenn er aus dem Maximalbereich rasuf�llt
		if ($datum_jahr_von < 1970 or $datum_jahr_von > 2030) {
			$datum_tag_von = "01";
			$datum_monat_von = "01";
			$datum_jahr_von = "1970";
		}
		
		if ($datum_jahr_bis < 1970 or $datum_jahr_bis > 2030) {
			$datum_tag_bis = "01";
			$datum_monat_bis = "01";
			$datum_jahr_bis = "2030";
		}
		
		// ++++ Anzeige ausblenden, wenn Anzeigezeitraum unbegrenzt ist
		if ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) {
			$datum_tag_von_anzeige = "";
			$datum_monat_von_anzeige = "";
			$datum_jahr_von_anzeige = "";
			
			// ++++ sonst Anzeige des Zeitraumes mit aktivem Hintergrund
		} else {
			$datum_tag_von_anzeige = $datum_tag_von;
			$datum_monat_von_anzeige = $datum_monat_von;
			$datum_jahr_von_anzeige = $datum_jahr_von;
		}
		
		// ++++ Anzeige ausblenden, wenn Anzeigezeitraum unbegrenzt ist
		if ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) {
			$datum_tag_bis_anzeige = "";
			$datum_monat_bis_anzeige = "";
			$datum_jahr_bis_anzeige = "";
			
			// ++++ sonst Anzeige des Zeitraumes mit aktivem Hintergrund
		} else {
			$datum_tag_bis_anzeige = $datum_tag_bis;
			$datum_monat_bis_anzeige = $datum_monat_bis;
			$datum_jahr_bis_anzeige = $datum_jahr_bis;
		}
		
		// ++++ sortiere von <> bis richtig
		if (date ( "U", mktime ( 0, 0, 0, $datum_monat_bis, $datum_tag_bis, $datum_jahr_bis ) ) >= date ( "U", mktime ( 0, 0, 0, $datum_monat_von, $datum_tag_von, $datum_jahr_von ) )) {
			
			return (array (
					$datum_tag_von,
					$datum_monat_von,
					$datum_jahr_von,
					$datum_tag_bis,
					$datum_monat_bis,
					$datum_jahr_bis,
					$datum_tag_von_anzeige,
					$datum_monat_von_anzeige,
					$datum_jahr_von_anzeige,
					$datum_tag_bis_anzeige,
					$datum_monat_bis_anzeige,
					$datum_jahr_bis_anzeige 
			));
		} else {
			
			return (array (
					$datum_tag_bis,
					$datum_monat_bis,
					$datum_jahr_bis,
					$datum_tag_von,
					$datum_monat_von,
					$datum_jahr_von,
					$datum_tag_bis_anzeige,
					$datum_monat_bis_anzeige,
					$datum_jahr_bis_anzeige,
					$datum_tag_von_anzeige,
					$datum_monat_von_anzeige,
					$datum_jahr_von_anzeige 
			));
		}
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++ einzelne Uhrzeitfelder aus Uhrzeitsstring extrahieren
if (! function_exists ( extract_uhrzeit_aus_uhrzeitfilter )) {
	function extract_uhrzeit_aus_uhrzeitfilter($uhrzeitstring) {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		// ++++ einzelne Datumsfelder aus Datumsstring extrahieren
		$uhrzeit_explode = explode ( "-", $uhrzeitstring );
		
		$uhrzeit_stunde_von = $uhrzeit_explode [0];
		$uhrzeit_minute_von = $uhrzeit_explode [1];
		$uhrzeit_stunde_bis = $uhrzeit_explode [2];
		$uhrzeit_minute_bis = $uhrzeit_explode [3];
		
		// ++++ Zeitraum korrigieren, wenn er aus dem Maximalbereich rasuf�llt
		if ($uhrzeit_stunde_von < 0 or $uhrzeit_stunde_von > 23 or $uhrzeit_minute_von < 0 or $uhrzeit_minute_von > 59) {
			$uhrzeit_stunde_von = "24";
			$uhrzeit_minute_von = "60";
		}
		if ($uhrzeit_stunde_bis < 0 or $uhrzeit_stunde_bis > 23 or $uhrzeit_minute_bis < 0 or $uhrzeit_minute_bis > 59) {
			$uhrzeit_stunde_bis = "24";
			$uhrzeit_minute_bis = "60";
		}
		
		// ++++ Anzeige ausblenden, wenn Anzeigezeitraum unbegrenzt ist
		if ($uhrzeit_stunde_von == 24 and $uhrzeit_minute_von == 60) {
			$uhrzeit_von_anzeige = "";
			
			// ++++ sonst Anzeige des Zeitraumes mit aktivem Hintergrund
		} else {
			
			if (( int ) $uhrzeit_stunde_von < 10) {
				$uhrzeit_von_anzeige = "0";
			}
			;
			$uhrzeit_von_anzeige .= ( int ) $uhrzeit_stunde_von . ":";
			if (( int ) $uhrzeit_minute_von < 10) {
				$uhrzeit_von_anzeige .= "0";
			}
			;
			$uhrzeit_von_anzeige .= ( int ) $uhrzeit_minute_von;
		}
		
		// ++++ Anzeige ausblenden, wenn Anzeigezeitraum unbegrenzt ist
		if ($uhrzeit_stunde_bis == 24 and $uhrzeit_minute_bis == 60) {
			$uhrzeit_bis_anzeige = "";
			
			// ++++ sonst Anzeige des Zeitraumes mit aktivem Hintergrund
		} else {
			
			if (( int ) $uhrzeit_stunde_bis < 10) {
				$uhrzeit_bis_anzeige = "0";
			}
			;
			$uhrzeit_bis_anzeige .= ( int ) $uhrzeit_stunde_bis . ":";
			if (( int ) $uhrzeit_minute_bis < 10) {
				$uhrzeit_bis_anzeige .= "0";
			}
			;
			$uhrzeit_bis_anzeige .= ( int ) $uhrzeit_minute_bis;
		}
		
		// ++++ sortiere von <> bis richtig
		if (stdmin_to_min ( $uhrzeit_stunde_bis . ":" . $uhrzeit_minute_bis ) >= stdmin_to_min ( $uhrzeit_stunde_von . ":" . $uhrzeit_minute_von )) {
			
			return (array (
					$uhrzeit_stunde_von,
					$uhrzeit_minute_von,
					$uhrzeit_stunde_bis,
					$uhrzeit_minute_bis,
					$uhrzeit_von_anzeige,
					$uhrzeit_bis_anzeige 
			));
		} else {
			
			return (array (
					$uhrzeit_stunde_bis,
					$uhrzeit_minute_bis,
					$uhrzeit_stunde_von,
					$uhrzeit_minute_von,
					$uhrzeit_bis_anzeige,
					$uhrzeit_von_anzeige 
			));
		}
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++ Multiselect Filterwerte auswerten und Query zurueckgeben

if (! function_exists ( filter_multiselect_return_query )) {
	function filter_multiselect_return_query($filtervalue, $feld, $likestring_before = false, $likestring_after = false, $zweites_feld = false, $ignore = false) {
		if ($filtervalue == "") {
			// Filter leer
			return "";
		}
		
		if (! is_array ( $filtervalue )) {
			// Filter kein Array
			if (is_array ( $ignore )) {
				if (in_array ( $filtervalue, $ignore )) {
					return "";
				}
			}
			
			if (! $likestring_before && ! $likestring_after) {
				if ($zweites_feld) {
					return " and (" . $feld . " = '" . $filtervalue . "' or " . $zweites_feld . " = '" . $filtervalue . "') ";
				} else {
					return " and " . $feld . " = '" . $filtervalue . "' ";
				}
			} elseif ($likestring_before && $likestring_after) {
				if ($zweites_feld) {
					return " and (" . $feld . " LIKE '" . $likestring_before . $filtervalue . $likestring_after . "' or " . $zweites_feld . " LIKE '" . $likestring_before . $filtervalue . $likestring_after . "') ";
				} else {
					return " and " . $feld . " LIKE '" . $likestring_before . $filtervalue . $likestring_after . "' ";
				}
			}
		} else { // Multiselect Filter
			$counter = 0;
			foreach ( $filtervalue as $v ) {
				if (is_array ( $ignore )) {
					if (in_array ( $v, $ignore )) {
						continue;
					}
				}
				
				if (! $likestring_before && ! $likestring_after) {
					if ($counter == 0) {
						$q = " and ( " . $feld . " = '" . $v . "' ";
					} else {
						$q .= " or " . $feld . " = '" . $v . "' ";
					}
					if ($zweites_feld) {
						$q .= " or " . $zweites_feld . " = '" . $v . "' ";
					}
				} elseif ($likestring_before && $likestring_after) {
					if ($counter == 0) {
						$q = " and ( " . $feld . " LIKE '" . $likestring_before . $v . $likestring_after . "' ";
					} else {
						$q .= " or " . $feld . " LIKE '" . $likestring_before . $v . $likestring_after . "' ";
					}
					if ($zweites_feld) {
						$q .= " or " . $zweites_feld . " LIKE '" . $likestring_before . $v . $likestring_after . "' ";
					}
				}
				$counter ++;
			}
			
			if (strpos ( $q, "(" ) !== false)
				$q .= " ) ";
			return $q;
		}
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

if (! function_exists ( returnFilterWert )) {
	function returnFilterWert($array) {
		if (is_array ( $array )) {
			return $array [0];
		} else {
			return $array;
		}
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

if (! function_exists ( returnProjektlisteMitTeilprojekten )) {
	function returnProjektlisteMitTeilprojekten($additional_sql = "") {
		global $sql_query, $tblprojektteilprojekte, $tblprojekte;
		$projektquery = $sql_query ["projektliste"] . " AND fiStatus < 3 order by dtProjektNr";
		$projektliste = array ();
		
		$liste = get_table_array ( $projektquery );

			
		
		if (count ( $liste ) > 0) {
			foreach ( $liste as $listenzeile ) {
				$projektliste [$listenzeile ["Projekt_id"]] = $listenzeile ["dtProjektDDText"];
				
 				$teilprojektquery = $sql_query ["projektteilprojekteliste"] . " and $tblprojektteilprojekte.fiTeilprojektStatus < 3 and $tblprojektteilprojekte.fiProjekt = '" . $listenzeile ["Projekt_id"] . "' ";
 				$teilprojektliste = get_table_array ( $teilprojektquery );
				
 				if (count ( $teilprojektliste ) > 0) {
 					foreach ( $teilprojektliste as $teilprojektzeile ) {
 						$projektliste [$listenzeile ["Projekt_id"] . "//" . $teilprojektzeile ["Teilprojekte_id"]] = "--- " . $teilprojektzeile ["dtTeilprojektName"] . " (" . $listenzeile ["dtProjektNr"] . ")";
 					}
 				}
			}
		}
		
		return $projektliste;
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

/*
 * Benoetigt bei AJAX Filtern mit statischem Array, welches jedoch zu gross fuer einen AJAX Request ist.
 */

if (! function_exists ( returnAjaxArray )) {
	function returnAjaxArray($name, $more = "") {
		switch ($name) {
			case "projektliste_mit_teilprojekten" :
				return returnProjektlisteMitTeilprojekten ( $more );
				break;
		}
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

/*
 * Ruft die Einstellung 'ft_min_word_len' aus den MySQL-Settings ab
 */
if (! function_exists ( "get_ft_min_word_len" )) {
	function get_ft_min_word_len() {
		$row = mysql_fetch_array ( mysql_query ( "SHOW VARIABLES LIKE 'ft_min_word_len'" ) );
		return $row ['Value'];
	}
}

?>