<?php

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "strip_only" )) {
	function strip_only($str, $tags) {
		if (! is_array ( $tags )) {
			$tags = (strpos ( $str, '>' ) !== false ? explode ( '>', str_replace ( '<', '', $tags ) ) : array (
					$tags 
			));
			if (end ( $tags ) == '')
				array_pop ( $tags );
		}
		foreach ( $tags as $tag )
			$str = preg_replace ( '#</?' . $tag . '[^>]*>#is', '', $str );
		return $str;
	}
}

if (! function_exists ( "strip_tags_attributes" )) {
	function strip_tags_attributes($string, $allowtags = NULL, $allowattributes = NULL) {
		if (! is_null ( $allowattributes )) {
			if (! is_array ( $allowattributes ))
				$allowattributes = explode ( ",", $allowattributes );
			if (is_array ( $allowattributes ))
				$allowattributes = implode ( ")(?<!", $allowattributes );
			if (strlen ( $allowattributes ) > 0)
				$allowattributes = "(?<!" . $allowattributes . ")";
			$string = preg_replace_callback ( "/<[^>]*>/i", create_function ( '$matches', 'return preg_replace("/ [^ =]*' . $allowattributes . '=(\"[^\"]*\"|\'[^\']*\')/i", "", $matches[0]);' ), $string );
		}
		$string = strip_tags ( $string, $allowtags );
		return $string;
	}
}

if (! function_exists ( "strip_script" )) {
	function strip_script($start, $end, $buffer) {
		$runcounter = 0;
		while ( ! strpos ( $buffer, $start ) === false && $runcounter < 10 ) {
			$pos1 = strpos ( $buffer, $start );
			$linkerteil = substr ( $buffer, 0, $pos1 );
			$rechterteil = substr ( $buffer, (strpos ( $buffer, $pos1 + strlen ( $start ) )) );
			$pos3 = strpos ( $rechterteil, $end ) + strlen ( $end );
			$buffer = $linkerteil . substr ( $rechterteil, $pos3 );
			
			$runcounter ++;
		}
		return $buffer;
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "decode_ajax_string" )) {
	function decode_ajax_string($ajax_string) {
		return str_replace ( array (
				"U",
				"G",
				"CR",
				"TAB",
				"DK" 
		), array (
				"&",
				"=",
				"\n",
				"\t",
				"#" 
		), $ajax_string );
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "history_buffer_save" )) {
	function history_buffer_save($buffer) {
		if ($GLOBALS ['new_history_preview'] && $GLOBALS ['typ'] != "list") {
			$elementname = $GLOBALS ['target'] . "-" . $GLOBALS ['typ'];
			
			if (is_numeric ( $GLOBALS ['id'] )) {
				$elementname .= "-" . $GLOBALS ['id'];
			}
			
			$_SESSION ["linkhistorypreview"] [$elementname] = history_preview_strip_html ( $buffer );
		}
		
		return $buffer;
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

if (! function_exists ( "history_preview_strip_html" )) {
	function history_preview_strip_html($buffer) {
		$tags = "<table><td><tr><input><script><select><option><img><span><nobr><hr><b><div><textarea>";
		$attr = "valign,value,class,border,cellspacing,cellpadding,colspan,style,height,width,type,src";
		
		$buffer = strip_script ( "<script>", "</script>", $buffer );
		$buffer = strip_tags_attributes ( $buffer, $tags, $attr );
		return $buffer;
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (! function_exists ( "historypreview" )) {
	function historypreview($boxid, $link) {
		
		// ++++ hole Variablen aus bergabestring
		$link = decode_ajax_string ( $link );
		$link = str_replace ( "phpsessid", "PHPSESSID", $link );
		
		$vars = explode ( "&", $link );
		foreach ( ( array ) $vars as $key => $value ) {
			$var = explode ( "=", $value );
			$$var [0] = $var [1];
		}
		
		// ++++ erzeuge berschrift
		$ueberschrift = $target . " - " . str_replace ( array (
				"show",
				"list" 
		), array (
				"Detailansicht",
				"Listenansicht" 
		), $typ );
		
		$elementname = $target . "-" . $typ;
		if (is_numeric ( $id ))
			$elementname .= "-" . $id;
		
		echo "<!--historyid" . $boxid . "-->";
		
		echo "<table border=0 class=\"header\" cellspacing=0 width=100%>";
		echo "<tr><td style=\"background-color: #00397d;\" width=10></td>";
		echo "<td style=\"background-color: #00397d;\"><font color=\"" . $fontcolor_menu . "\" size=2><center><b>" . $ueberschrift . "</b></center></font></td>";
		echo "<td style=\"background-color: #00397d; text-align: right; padding-top: 8px;\">";
		echo klickbutton ( "anzeigen", "onClick=\"top.location.href = 'main.php?" . $link . "';\"", "", "zu dieser Seite gehen" );
		echo "&nbsp;";
		echo klickbutton ( "schliessen", "onClick=\"historybox_close('" . $boxid . "');\"", "", "History-Voransicht schlieen" );
		echo "</td></tr></table>";
		
		echo $_SESSION ["linkhistorypreview"] [$elementname];
	}
}

?>
