<?php

// Pfad zu include Dateien bestimmen
file_exists ( "config/" ) ? $include_prefix = "" : $include_prefix = "../";

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// neue Projektnummer erzeugen
if (! function_exists ( "projektnummer_neu" )) {
	function projektnummer_neu() {
		global $tblprojekte;
		
		$query = "select max(cast(dtProjektNr as unsigned)) as dtMaxProjektNr from $tblprojekte where dtProjektNr > 0";
		$field_projektnr = get_table_row ( $query );
		$projektnr = $field_projektnr ["dtMaxProjektNr"] + 1;
		
		return ($projektnr);
	}
}

if (! function_exists ( "projektnummer_aendern" )) {
	function projektnummer_aendern($id) {
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// neue Contentnummer erzeugen
if (! function_exists ( "contentnummer_neu" )) {
	function contentnummer_neu() {
		global $tblcontent;
		
		$query = "select max(cast(dtContentNr as unsigned)) as dtContentNr from $tblcontent";
		$field_contentnr = get_table_row ( $query );
		$contentnr = $field_contentnr ["dtContentNr"] + 1;
		
		return $contentnr;
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// suche das passende Icon zu einer Datei
if (! function_exists ( "icon" )) {
	function icon($filename, $width = 35) {
		global $iconordner;
		
		if (is_dir ( $filename )) {
			
			$icon = "<img src=\"" . $iconordner . "/icon_folder.jpg" . "\" width=$width border=0>";
		} else {
			
			$endung = strtolower ( substr ( $filename, strrpos ( $filename, "." ) + 1 ) );
			
			if (is_file ( $dateipfad . "/" . $iconordner . "/icon_" . $endung . ".jpg" )) {
				$icon = "<img src=\"" . $iconordner . "/icon_" . $endung . ".jpg" . "\" width=$width border=0>";
			} else {
				$icon = "<img src=\"" . $iconordner . "/icon.jpg" . "\" width=$width border=0>";
			}
		}
		
		return $icon;
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// suche einen Stundensatz zu einem Projekt
if (! function_exists ( "stundensatz_zu_projekt" )) {
	function stundensatz_zu_projekt($projektid, $stundensatzid) {
		global $tblprojekte, $tblstundensaetzestandard, $tblkontakte, $sql_query;
		
		$kundequery = $sql_query ["projektliste"] . " and $tblprojekte.id = " . $projektid;
		$liste = get_table_row ( $kundequery );
		$kundeid = $liste ["fiKunde"];
		
		$projektstundensatzquery = $sql_query ["stundensatzprojekteliste"];
		$projektstundensatzquery .= " and $tblstundensaetzestandard.id = " . $stundensatzid;
		$projektstundensatzquery .= " and $tblprojekte.id = " . $projektid;
		
		$kundenstundensatzquery = $sql_query ["stundensatzkundenliste"];
		$kundenstundensatzquery .= " and $tblstundensaetzestandard.id = " . $stundensatzid;
		$kundenstundensatzquery .= " and $tblkontakte.id = " . $kundeid;
		
		$standardstundensatzquery = $sql_query ["stundensatzstandardliste"] . " and $tblstundensaetzestandard.id = " . $stundensatzid;
		
		// nimm zunchst mal den Standard-Stundensatz
		$standardliste = get_table_row ( $standardstundensatzquery );
		$stundensatz = $standardliste ["dtStdSatz"];
		
		// wenn es einen Kunden-eigenen-Stundensatz gibt, dann nimm den
		if (get_table_count ( $kundenstundensatzquery ) != 0) {
			$kundenliste = get_table_row ( $kundenstundensatzquery );
			$stundensatz = $kundenliste ["dtStdSatzKunde"];
		} else {
			$kundenliste ["dtStdSatzKunde"] = $standardliste ["dtStdSatz"];
		}
		
		// wenn es einen Projekt-eigenen-Stundensatz gibt, dann nimm den
		if (get_table_count ( $projektstundensatzquery ) != 0) {
			$projektliste = get_table_row ( $projektstundensatzquery );
			$stundensatz = $projektliste ["dtStdSatzProjekt"];
		}
		
		return array (
				"stundensatz_real" => $stundensatz,
				"stundensatz_standard" => $standardliste ["dtStdSatz"],
				"stundensatz_kunde" => $kundenliste ["dtStdSatzKunde"] 
		);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// suche Anzahl eines Lager-Artikels
if (! function_exists ( "anzahl_lagerartikel" )) {
	function anzahl_lagerartikel($artikelid, $lieferantid = "", $rechnungid = "", $lagerortid = "", $projektid = "", $belegid = "") {
		global $tblartikelstueck;
		
		$query = "select * from $tblartikelstueck where fiArtikel = " . $artikelid;
		
		if ($lieferantid != "") {
			$query .= " and fiLieferant = " . $lieferantid;
		}
		;
		if ($rechnungid != "") {
			$query .= " and fiRechnung = " . $rechnungid;
		}
		;
		if ($lagerortid != "") {
			$query .= " and fiLagerOrt = " . $lagerortid;
		}
		;
		if ($projektid != "") {
			$query .= " and fiProjekt = " . $projektid;
		}
		;
		if ($belegid != "") {
			$query .= " and fiBeleg = " . $belegid;
		}
		;
		
		return get_table_count ( $query );
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// suche Anzahl eines Lager-Artikels
if (! function_exists ( "anzahl_artikelauflager" )) {
	function anzahl_artikelauflager($artikelid) {
		global $tblartikelstueck;
		
		$query = "select * from $tblartikelstueck where fiArtikel = " . $artikelid . " and fiProjekt = 0 and fiBeleg = 0 and fiBelegVerbrauch = 0 and fiArtikelStueckVerbrauch = 0";
		
		return get_table_count ( $query );
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Projektkalkulation
if (! function_exists ( "projektkalkulation" )) {
	function projektkalkulation($projektid) {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		include ($GLOBALS ['include_prefix'] . "config/config-sqlserver.php");
		
		include ("$functionsordner_custom/function_custom_pre.php");
		include ("$functionsordner/function_sql.php");
		include ("$functionsordner/function_sql_query.php");
		include ("$functionsordner_custom/function_custom_post.php");
		
		$query = $sql_query ["taetigkeitenliste"] . " and $tbltaetigkeiten.dtProjektkalkulationRelevant = 1";
		$query .= " order by $tbltaetigkeiten.dtTaetigkeitCode";
		$taetigkeiten_liste = get_table_array ( $query );
		
		$query = $sql_query ["projektliste"] . " and $tblprojekte.id = " . $projektid;
		$field = get_table_row ( $query );
		$kalkulation_array = unserialize ( $field ["dtKalkulation"] );
		
		if (is_array ( $taetigkeiten_liste )) {
			foreach ( $taetigkeiten_liste as $taetigkeiten_id => $taetigkeiten_field ) {
				
				$bisherige_kosten = 0;
				$bisherige_kosten_vk = 0;
				$kalkulation_wert = 0;
				
				// Wenn es ein Mat-Code ist, dann summiere alle Artikel zu diesem Projekt und Mat-Code
				if ($taetigkeiten_field ["dtIstMaterial"] != 0) {
					
					$query = $sql_query ["artikelstueckliste"] . " and $tblartikelstueck.fiProjekt = " . $projektid . " and $tblartikelstueck.fiProjektTaetigkeit = " . $taetigkeiten_field ["Taetigkeiten_id"];
					$projektartikel_liste = get_table_array ( $query );
					
					if (is_array ( $projektartikel_liste )) {
						foreach ( $projektartikel_liste as $key => $projektartikel_field ) {
							$bisherige_kosten = $bisherige_kosten + $projektartikel_field ["dtPreisEK"];
							$bisherige_kosten_vk = $bisherige_kosten_vk + $projektartikel_field ["dtPreisVK1"];
						}
					}
				}
				
				// Wenn es ein Ttigkeiten-Code ist, dann summiere alle Arbeitszeiten zu diesem Projekt und Code
				if ($taetigkeiten_field ["dtIstMaterial"] == 0) {
					
					$query = $sql_query ["projektzeitenliste"] . " and $tblprojektzeiten.fiProjekt = " . $projektid . " and $tblprojektzeiten.fiTaetigkeit = " . $taetigkeiten_field ["Taetigkeiten_id"];
					$projektzeit_liste = get_table_array ( $query );
					
					if (is_array ( $projektzeit_liste )) {
						foreach ( $projektzeit_liste as $key => $projektzeit_field ) {
							$bisherige_kosten = $bisherige_kosten + ($projektzeit_field ["dtProjektzeitDezimal"] * $projektzeit_field ["dtStdSatz"]);
						}
					}
				}
				
				// berechne kalkulierten Wert und addiere Summen
				if (is_array ( $kalkulation_array )) {
					$kalkulation_wert = $kalkulation_array [$taetigkeiten_field ["dtTaetigkeitCode"]];
				}
				$gesamtkalkulation = $gesamtkalkulation + $kalkulation_wert;
				$gesamtbisherige_kosten = $gesamtbisherige_kosten + $bisherige_kosten;
				if ($taetigkeiten_field ["dtIstMaterial"] == 0) {
					$gesamtkalkulation_personal = $gesamtkalkulation_personal + $kalkulation_wert;
					$gesamtbisherige_kosten_personal = $gesamtbisherige_kosten_personal + $bisherige_kosten;
				} else {
					$gesamtkalkulation_material = $gesamtkalkulation_material + $kalkulation_wert;
					$gesamtbisherige_kosten_material = $gesamtbisherige_kosten_material + $bisherige_kosten;
					$gesamtbisherige_kosten_material_vk = $gesamtbisherige_kosten_material_vk + $bisherige_kosten_vk;
				}
			}
		}
		
		return array (
				"GesamtKalkulation" => $gesamtkalkulation,
				"GesamtBisherigeKosten" => $gesamtbisherige_kosten,
				"GesamtKalkulationMaterial" => $gesamtkalkulation_material,
				"GesamtKalkulationPersonal" => $gesamtkalkulation_personal,
				"GesamtBisherigeKostenMaterial" => $gesamtbisherige_kosten_material,
				"GesamtBisherigeKostenPersonal" => $gesamtbisherige_kosten_personal,
				"GesamtBisherigeKostenMaterialVK" => $gesamtbisherige_kosten_material_vk 
		);
	}
}

?>
