<?php
if (file_exists ( "$functionsordner/function_sql_structure.php" )) {
	include ("$functionsordner/function_sql_structure.php");
} else {
	include ("../$functionsordner/function_sql_structure.php");
}

if (! function_exists ( "create_fieldnames_from_structure" )) {
	function create_fieldnames_from_structure($structure) {
		foreach ( ( array ) $structure as $tabelle => $felder ) {
			$arr [$tabelle] = "";
			$zaehler = 0;
			
			foreach ( ( array ) $felder as $feldname => $feld_info ) {
				if (substr ( $feldname, 0, 1 ) == "_") {
					// Feldname enthaelt Tabelleninformationen
					$zaehler ++;
					continue;
				}
				
				$zaehler ++;
				
				if (isset ( $feld_info [2] ) && $feld_info [2] != "") {
					$arr [$tabelle] .= "$tabelle." . $feldname . " as " . $feld_info [2];
				} else {
					$arr [$tabelle] .= $tabelle . "." . $feldname;
				}
				if ($zaehler < count ( $felder ))
					$arr [$tabelle] .= ", ";
			}
		}
		return $arr;
	}
}

$fieldnames = create_fieldnames_from_structure ( $sqlstructure );
// echo '<pre>'.str_replace(array("\n" , " "), array('<br>', '&nbsp;'), print_r($fieldnames, true)).'</pre><br><br>';

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

$sql_query = array (
		"kontaktliste" => "select $fieldnames[$tblkontakte],$fieldnames[$tblanreden],$fieldnames[$tblbenutzergruppe],$fieldnames[$tbllaender],

		cast(tblKontakte.dtKontaktNr AS DECIMAL) as dtKontaktNrSortable,

		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtName_Anzeige,

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText,
		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname,\" (\", $tblkontakte.dtKontaktNr,\")\") as dtKontaktDDText2,
		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname,\" (\", $tblkontakte.dtKontaktNr,\") (\", $tblkontakte.dtOrt,\")\") as dtKontaktDDText3,
		
		concat($tblkontakte.dtFirmenname, $tblkontakte.dtNachname, $tblkontakte.dtVorname) as dtKontaktSortierung

		from $tblkontakte,$tblanreden,$tblbenutzergruppe,$tbllaender

		where $tbllaender.id = $tblkontakte.fiLand
		and $tblbenutzergruppe.id = $tblkontakte.fiBenutzergruppe
		and $tblanreden.id = $tblkontakte.fiAnrede ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"mitarbeiterliste" => "select $fieldnames[$tblkontakte],$fieldnames[$tblanreden],$fieldnames[$tblbenutzergruppe],$fieldnames[$tbllaender],$fieldnames[$tblpersonaldaten],

		cast(tblKontakte.dtKontaktNr AS DECIMAL) as dtKontaktNrSortable,

		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtName_Anzeige,

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText,
		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname,\" (\", $tblkontakte.dtKontaktNr,\")\") as dtKontaktDDText2,

		concat($tblkontakte.dtFirmenname, $tblkontakte.dtNachname, $tblkontakte.dtVorname) as dtKontaktSortierung

		from $tblkontakte,$tblanreden,$tblbenutzergruppe,$tbllaender,$tblpersonaldaten

		where $tblkontakte.dtIstMitarbeiter = 1
		and $tbllaender.id = $tblkontakte.fiLand
		and $tblkontakte.id = $tblpersonaldaten.fiKontaktNr
		and $tblbenutzergruppe.id = $tblkontakte.fiBenutzergruppe
		and $tblanreden.id = $tblkontakte.fiAnrede ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"mitarbeiterliste-geburtstag" => "select $fieldnames[$tblkontakte],$fieldnames[$tblanreden],$fieldnames[$tblbenutzergruppe],$fieldnames[$tbllaender],$fieldnames[$tblpersonaldaten],

		cast(tblKontakte.dtKontaktNr AS DECIMAL) as dtKontaktNrSortable,

		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtName_Anzeige,

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText,
		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname,\" (\", $tblkontakte.dtKontaktNr,\")\") as dtKontaktDDText2,

		concat($tblkontakte.dtFirmenname, $tblkontakte.dtNachname, $tblkontakte.dtVorname) as dtKontaktSortierung,

		DATEDIFF($tblpersonaldaten.dtGeburtsdatum + INTERVAL
		(YEAR(CURRENT_DATE) - YEAR($tblpersonaldaten.dtGeburtsdatum) +
		IF(DATE_FORMAT(CURRENT_DATE, \"%m%d\") >
		DATE_FORMAT($tblpersonaldaten.dtGeburtsdatum, \"%m%d\"), 1, 0))
		YEAR, CURRENT_DATE) AS dtDaysToBirthday

		from $tblkontakte,$tblanreden,$tblbenutzergruppe,$tbllaender,$tblpersonaldaten

		where $tblkontakte.dtIstMitarbeiter = 1
		and $tblkontakte.dtAktiv = 1
		and $tbllaender.id = $tblkontakte.fiLand
		and $tblkontakte.id = $tblpersonaldaten.fiKontaktNr
		and $tblbenutzergruppe.id = $tblkontakte.fiBenutzergruppe
		and $tblanreden.id = $tblkontakte.fiAnrede
		HAVING dtDaysToBirthday <= 6 OR dtDaysToBirthday >= 360 ORDER BY dtDaysToBirthday",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"kontaktaspliste" => "select $fieldnames[$tblkontaktasp],$tblkontakte.id,
		$tblkontakte.dtIstKunde, $tblkontakte.dtIstLieferant, $tblkontakte.dtIstMitarbeiter,

		concat($tblkontaktasp.dtNachname,\", \", $tblkontaktasp.dtVorname) as dtKontaktASPDDText,

		concat($tblkontaktasp.dtNachname, $tblkontaktasp.dtVorname) as dtKontaktASPSortierung

		from $tblkontaktasp, $tblkontakte

		where $tblkontakte.id = $tblkontaktasp.fiKontaktID ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"kontaktbelegadressenliste" => "select $fieldnames[$tblkontaktebelegadressen]

		from $tblkontaktebelegadressen

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"laenderliste" => "select $fieldnames[$tbllaender]
		
		from $tbllaender
		
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"zahlungszielliste" => "select $fieldnames[$tblzahlungsziele]

		from $tblzahlungsziele

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"personaldatenliste" => "select $fieldnames[$tblpersonaldaten],$tblkontakte.id,$tblkontakte.dtAktiv

		from $tblpersonaldaten, $tblkontakte

		where $tblkontakte.id = $tblpersonaldaten.fiKontaktNr ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"sessiondatenliste" => "select $fieldnames[$tblsession]

		from $tblsession

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"userliste" => "select $fieldnames[$tblsession], $fieldnames[$tblkontakte],
		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText

		from $tblsession

		left join $tblkontakte on $tblkontakte.id = $tblsession.fiUserNr

		where $tblkontakte.id IS NOT NULL ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"bemerkungenliste" => "select $fieldnames[$tblbemerkungen],
		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText

		from $tblbemerkungen

		left join $tblkontakte on $tblkontakte.id = $tblbemerkungen.fiBemerkungAutor

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelbestandcacheliste" => "select $fieldnames[$tblartikelbestandcache] from $tblartikelbestandcache
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"lieferartenliste" => "select $fieldnames[$tbllieferarten] from $tbllieferarten
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"anredenliste" => "select $fieldnames[$tblanreden] from $tblanreden
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"benutzergruppenliste" => "select $fieldnames[$tblbenutzergruppe] from $tblbenutzergruppe
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"landliste" => "select $fieldnames[$tbllaender] from $tbllaender
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"rabattgruppenliste" => "select $fieldnames[$tblrabattgruppen]

		from $tblrabattgruppen

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"belegrabatteliste" => "select $fieldnames[$tblbelegrabatte]

		from $tblbelegrabatte

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelattributgruppenliste" => "select $fieldnames[$tblartikelattributegruppen] from $tblartikelattributegruppen
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelattributliste" => "select $fieldnames[$tblartikelattribute],$fieldnames[$tblartikelattributegruppen] from $tblartikelattribute

		left join $tblartikelattributegruppen on $tblartikelattribute.fiArtikelAttributeGruppen = $tblartikelattributegruppen.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelwarengruppenalternativliste" => "select $fieldnames[$tblartikelwarengruppenalternativ], $fieldnames[$tblartikel], $fieldnames[$tblwarengruppen],$fieldnames[$tblartikeleinheiten],

		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe) as dtArtikelDDText3

		from $tblartikelwarengruppenalternativ

		left join $tblartikel on $tblartikelwarengruppenalternativ.fiArtikel = $tblartikel.id
		left join $tblwarengruppen on $tblartikelwarengruppenalternativ.fiWarengruppe = $tblwarengruppen.id
		left join $tblartikeleinheiten on $tblartikel.fiEinheit = $tblartikeleinheiten.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikellisteexport" => "select $fieldnames[$tblartikel],$fieldnames[$tblwarengruppen],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblartikellieferanten],$fieldnames[$tblartikelhersteller],

		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe) as dtArtikelDDText3

		from $tblartikel

		left join $tblartikeleinheiten on $tblartikel.fiEinheit = $tblartikeleinheiten.id
		left join $tblwarengruppen on $tblartikel.fiWarengruppe = $tblwarengruppen.id
		left join $tblartikelhersteller on $tblartikel.id = $tblartikelhersteller.fiArtikel
		left join $tblartikellieferanten on $tblartikel.id = $tblartikellieferanten.fiArtikel
		
		where 1=1",
		
		"lagerartikellisteanzeige" => "select $fieldnames[$tblartikel],$fieldnames[$tblwarengruppen],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblartikelhersteller],
		
		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe) as dtArtikelDDText3
		
		from $tblartikel
		
		left join $tblartikeleinheiten on $tblartikel.fiEinheit = $tblartikeleinheiten.id
		left join $tblwarengruppen on $tblartikel.fiWarengruppe = $tblwarengruppen.id
		left join $tblartikelhersteller on $tblartikel.id = $tblartikelhersteller.fiArtikel
		left join $tblartikellieferanten on $tblartikel.id = $tblartikellieferanten.fiArtikel
		
		where 1=1",
		
		"artikelvariantenlisteexport" => "select $fieldnames[$tblartikel],$fieldnames[$tblwarengruppen],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblartikellieferanten],$fieldnames[$tblartikelhersteller],$fieldnames[$tblartikelvarianten],
		
		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe) as dtArtikelDDText3
		
		from $tblartikel
		
		left join $tblartikeleinheiten on $tblartikel.fiEinheit = $tblartikeleinheiten.id
		left join $tblwarengruppen on $tblartikel.fiWarengruppe = $tblwarengruppen.id
		left join $tblartikelhersteller on $tblartikel.id = $tblartikelhersteller.fiArtikel
		left join $tblartikellieferanten on $tblartikel.id = $tblartikellieferanten.fiArtikel
		left join $tblartikelvarianten on $tblartikel.id = $tblartikelvarianten.fiArtikel
		where 1=1",
		
		"artikelvariantenlisteexportverkauft" => "select $fieldnames[$tblartikel],$fieldnames[$tblbelege],$fieldnames[$tblbelegmaterialposten],$fieldnames[$tblartikelvarianten],
		
		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText
		
		from $tblartikel

		left join $tblartikelvarianten on $tblartikel.id = $tblartikelvarianten.fiArtikel
		left join $tblbelegmaterialposten on $tblartikel.id = $tblbelegmaterialposten.fiArtikel
		left join $tblbelege on $tblbelege.id = $tblbelegmaterialposten.fiBeleg
		
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikellistelieferantenexport" => "select $fieldnames[$tblartikel],$fieldnames[$tblartikellieferanten],$fieldnames[$tblwarengruppen],$fieldnames[$tblartikeleinheiten],
		
		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe) as dtArtikelDDText3
		
		from $tblartikel
		
		left join $tblartikeleinheiten on $tblartikel.fiEinheit = $tblartikeleinheiten.id
		left join $tblwarengruppen on $tblartikel.fiWarengruppe = $tblwarengruppen.id
		left join $tblartikellieferanten on $tblartikel.id = $tblartikellieferanten.fiArtikel
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"projektliste" => "select $fieldnames[$tblprojekte], $fieldnames[$tblkontakte], $fieldnames[$tblanreden], $fieldnames[$tblprojektstatus], $fieldnames[$tblprojektuebersicht],$fieldnames[$tblprojekttyp],

		cast(tblProjekte.dtProjektNr AS DECIMAL) as dtProjektNrSortable,

		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtKunde_Anzeige,

		concat($tblprojekte.dtProjektNr,\" | \", $tblprojekte.dtProjektname,\" | \",
		$tblkontakte.dtFirmenname,\" \", $tblkontakte.dtVorname,\" \", $tblkontakte.dtNachname) as dtProjektDDText,

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtVorname,\" \", $tblkontakte.dtNachname,\" | \", $tblprojekte.dtProjektname,\" | \", $tblprojekte.dtProjektNr) as dtProjektDD2Text
		

		from $tblprojekte, $tblkontakte, $tblanreden, $tblprojektstatus, $tblprojektuebersicht, $tblprojekttyp

		where $tblkontakte.id = $tblprojekte.fiKunde
		and $tblanreden.id = $tblkontakte.fiAnrede
		and $tblprojektstatus.id = $tblprojekte.fiStatus
		and $tblprojekttyp.id = $tblprojekte.fiProjektTyp
		and $tblprojektuebersicht.id = $tblprojekte.fiProjektUebersicht ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"projektstatusliste" => "select $fieldnames[$tblprojektstatus] from $tblprojektstatus
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"projekttypliste" => "select $fieldnames[$tblprojekttyp] from $tblprojekttyp
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"projektuebersichtliste" => "select $fieldnames[$tblprojektuebersicht] from $tblprojektuebersicht
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		"projektteilprojekteliste" => "select $fieldnames[$tblprojektteilprojekte], $fieldnames[$tblkontakte], $fieldnames[$tblprojekte], $fieldnames[$tblprojektstatus],

		concat($tblprojektteilprojekte.dtTeilprojektName,\" (\", $tblprojekte.dtProjektNr,\" | \", $tblprojekte.dtProjektname,\")\") as dtTeilprojektDDText,
		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText,
		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname,\" (\", $tblkontakte.dtKontaktNr,\")\") as dtKontaktDDText2

		from $tblprojektteilprojekte
		left join $tblkontakte on $tblprojektteilprojekte.fiTeilprojektVerantwortlicher = $tblkontakte.id
		left join $tblprojekte on $tblprojektteilprojekte.fiProjekt = $tblprojekte.id
		left join $tblprojektstatus on $tblprojektteilprojekte.fiTeilprojektStatus = $tblprojektstatus.id
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"belegliste" => "select $fieldnames[$tblbelege], $fieldnames[$tblkontakte], $fieldnames[$tblbelegstatus], $fieldnames[$tblanreden], $fieldnames[$tbllaender],

		cast(tblBelege.dtBelegNr AS DECIMAL) as dtBelegNrSortable,
		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtKunde_Anzeige,

		concat($tblbelege.dtBelegNr, \" | \", $tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname, \" | \", $tblbelege.dtBezeichnung) as dtBelegDDText,
		concat($tblbelege.dtAngebotNr, \" | \", $tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname, \" | \", $tblbelege.dtBezeichnung) as dtBelegDDText2

		from ($tblbelege, $tblkontakte, $tblanreden)

		left join $tbllaender on $tblkontakte.fiLand = $tbllaender.id
		left join $tblbelegstatus on $tblbelege.fiStatus = $tblbelegstatus.id

		where $tblbelege.fiKunde = $tblkontakte.id
		and $tblanreden.id = $tblkontakte.fiAnrede ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"beleglisteoptimized" => "SELECT $fieldnames[$tblkontakte],$fieldnames[$tblartikel],$fieldnames[$tblbelegstatus], $fieldnames[$tblbelege], $fieldnames[$tblbelegposten], $fieldnames[$tblbelegmaterialposten],$fieldnames[$tblanreden], $fieldnames[$tbllaender],

				
		cast(tblBelege.dtBelegNr AS DECIMAL) as dtBelegNrSortable,
		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtKunde_Anzeige
		
		from ($tblbelege,$tblkontakte,$tblanreden,$tblbelegstatus)
		
		left join ($tblbelegmaterialposten 
		INNER JOIN $tblartikel ON $tblbelegmaterialposten.fiArtikel = $tblartikel.id) 
		on $tblbelege.id = $tblbelegmaterialposten.fiBeleg
		left join $tblbelegposten on $tblbelege.id = $tblbelegposten.fiBeleg
		left join $tbllaender on $tblkontakte.fiLand = $tbllaender.id
		
		where $tblbelege.fiKunde = $tblkontakte.id 
		and   $tblbelege.fiStatus = $tblbelegstatus.id
		and   $tblanreden.id = $tblkontakte.fiAnrede",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"beleglisteoptimized2" => "SELECT $fieldnames[$tblkontakte],$fieldnames[$tblbelegstatus], $fieldnames[$tblbelege], $fieldnames[$tblanreden], $fieldnames[$tbllaender],
		
		cast(tblBelege.dtBelegNr AS DECIMAL) as dtBelegNrSortable,
		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtKunde_Anzeige
		
		from ($tblbelege,$tblkontakte,$tblanreden,$tblbelegstatus)
		
		left join $tbllaender on $tblkontakte.fiLand = $tbllaender.id
		
		where $tblbelege.fiKunde = $tblkontakte.id
		and   $tblbelege.fiStatus = $tblbelegstatus.id
		and   $tblanreden.id = $tblkontakte.fiAnrede",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"beleglistesuche" => "select DISTINCT $fieldnames[$tblbelege], $fieldnames[$tblkontakte], $fieldnames[$tblbelegstatus], $fieldnames[$tblanreden], $fieldnames[$tbllaender],
		
		cast(tblBelege.dtBelegNr AS DECIMAL) as dtBelegNrSortable,
		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtKunde_Anzeige,
		
		concat($tblbelege.dtBelegNr, \" | \", $tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname, \" | \", $tblbelege.dtBezeichnung) as dtBelegDDText,
		concat($tblbelege.dtAngebotNr, \" | \", $tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname, \" | \", $tblbelege.dtBezeichnung) as dtBelegDDText2
		
		from ($tblbelege, $tblkontakte, $tblanreden)
		
		left join $tbllaender on $tblkontakte.fiLand = $tbllaender.id
		left join $tblbelegstatus on $tblbelege.fiStatus = $tblbelegstatus.id
		
		where ($tblbelege.fiKunde = $tblkontakte.id)
		and $tblanreden.id = $tblkontakte.fiAnrede",
		
		"beleglistesuchemitposten" => "select DISTINCT $fieldnames[$tblbelege],$fieldnames[$tblbelegmaterialposten],$fieldnames[$tblbelegposten]
		
		from ($tblbelege,$tblbelegmaterialposten,$tblbelegposten)
		
		
		where $tblbelegmaterialposten.fiBeleg = $tblbelege.id and
		$tblbelege.id = $tblbelegposten.fiBeleg",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		/*
		 * "belegpostenliste" => "select $fieldnames[$tblbelegposten], $fieldnames[$tblbelege], $fieldnames[$tblartikeleinheiten], $fieldnames[$tblbuchungskonten] from $tblbelegposten,$tblbelege, $tblartikeleinheiten, $tblbuchungskonten where $tblbelegposten.fiBeleg = $tblbelege.id and $tblbelegposten.fiEinheit = $tblartikeleinheiten.id and $tblbelegposten.fiBuchungsKonto = $tblbuchungskonten.id ",
		 */
		"belegpostenliste" => "select $fieldnames[$tblbelegposten], $fieldnames[$tblbelege], $fieldnames[$tblartikeleinheiten], $fieldnames[$tblbuchungskonten]

		from $tblbelegposten

		left join $tblbelege on $tblbelegposten.fiBeleg = $tblbelege.id
		left join $tblartikeleinheiten on $tblbelegposten.fiEinheit = $tblartikeleinheiten.id
		left join $tblbuchungskonten on $tblbelegposten.fiBuchungsKonto = $tblbuchungskonten.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		/*
		 * "belegmaterialpostenliste" => "select $fieldnames[$tblbelegmaterialposten], $fieldnames[$tblartikel], $fieldnames[$tblbelege], $fieldnames[$tblartikeleinheiten], $fieldnames[$tblbuchungskonten], concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr) as dtArtikelDDText3 from $tblbelegmaterialposten, $tblartikel, $tblbelege, $tblartikeleinheiten, $tblbuchungskonten where $tblbelegmaterialposten.fiBeleg = $tblbelege.id and $tblbelegmaterialposten.fiArtikel = $tblartikel.id and $tblbelegmaterialposten.fiEinheit = $tblartikeleinheiten.id and $tblbelegmaterialposten.fiBuchungsKonto = $tblbuchungskonten.id ",
		 */
		
		"belegmaterialpostenliste" => "select $fieldnames[$tblbelegmaterialposten], $fieldnames[$tblartikel], $fieldnames[$tblbelege], $fieldnames[$tblartikeleinheiten], $fieldnames[$tblbuchungskonten],

		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr) as dtArtikelDDText3

		from $tblbelegmaterialposten

		left join $tblbelege on $tblbelegmaterialposten.fiBeleg = $tblbelege.id
		left join $tblartikel on $tblbelegmaterialposten.fiArtikel = $tblartikel.id
		left join $tblartikeleinheiten on $tblbelegmaterialposten.fiEinheit = $tblartikeleinheiten.id
		left join $tblbuchungskonten on $tblbelegmaterialposten.fiBuchungsKonto = $tblbuchungskonten.id

		where 1=1 ",
		
		"belegmaterialposteninbelegeliste" => "select $fieldnames[$tblbelegmaterialposten], $fieldnames[$tblartikel],$fieldnames[$tblbelege],
		
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr) as dtArtikelDDText3
		
		from $tblbelegmaterialposten
		

		left join $tblartikel on $tblbelegmaterialposten.fiArtikel = $tblartikel.id
		left join $tblbelege on $tblbelegmaterialposten.fiBeleg = $tblbelege.id
		
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"belegmaterialverbrauch" => "select $fieldnames[$tblbelegmaterialverbrauch],

		from $tblbelegmaterialverbrauch

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"belegzeitpostenliste" => "select $fieldnames[$tblbelegzeitposten], $fieldnames[$tblkontakte], $fieldnames[$tblbuchungskonten],

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText,
		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname,\" (\", $tblkontakte.dtKontaktNr,\")\") as dtKontaktDDText2

		from $tblbelegzeitposten

		left join $tblkontakte on $tblbelegzeitposten.fiMitarbeiter = $tblkontakte.id
		left join $tblbuchungskonten on $tblbelegzeitposten.fiBuchungsKonto = $tblbuchungskonten.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"belegzeitpostenzusatzeitliste" => "select $fieldnames[$tblbelegzeitpostenzusatzzeiten], $fieldnames[$tblartikeleinheiten]

		from $tblbelegzeitpostenzusatzzeiten

		left join $tblartikeleinheiten on $tblbelegzeitpostenzusatzzeiten.fiZusatzzeitEinheit = $tblartikeleinheiten.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"belegdrucklogliste" => "select $fieldnames[$tblbelegdrucklog], $fieldnames[$tblkontakte]

		from $tblbelegdrucklog
		left join $tblkontakte on $tblbelegdrucklog.fiBenutzer = $tblkontakte.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"bestellungdrucklogliste" => "select $fieldnames[$tblbestellungdrucklog], $fieldnames[$tblkontakte]

		from $tblbestellungdrucklog
		left join $tblkontakte on $tblbestellungdrucklog.fiBenutzer = $tblkontakte.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"updateliste" => "select $fieldnames[$tblupdate]

		from $tblupdate

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"belegdruckinfoliste" => "select $fieldnames[$tblbelegdruckinfo], $fieldnames[$tblbelege]

		from ($tblbelegdruckinfo, $tblbelege)
		where $tblbelege.id = $tblbelegdruckinfo.fiBeleg ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"kundenmahnungdruckinfoliste" => "select $fieldnames[$tblkundenmahnungdruckinfo]
		
		from $tblkundenmahnungdruckinfo
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"kundenmahnungdrucklogliste" => "select $fieldnames[$tblkundenmahnungdrucklog], $fieldnames[$tblkontakte]
		
		from $tblkundenmahnungdrucklog
		left join $tblkontakte on $tblkundenmahnungdrucklog.fiBenutzer = $tblkontakte.id
		
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"belegstatusliste" => "select $fieldnames[$tblbelegstatus] from $tblbelegstatus
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"buchungskontenliste" => "select $fieldnames[$tblbuchungskonten],

		concat($tblbuchungskonten.dtKontoID,\" | \", $tblbuchungskonten.dtKontoBezeichnung) as dtBuchungsKontoDDText

		from $tblbuchungskonten
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"mailverteilerliste" => "select $fieldnames[$tblmailverteiler], $fieldnames[$tblmailverteilergruppen]

		from $tblmailverteiler, $tblmailverteilergruppen
		where $tblmailverteiler.fiVerteilergruppe = $tblmailverteilergruppen.id",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"mailverteilergruppenliste" => "select $fieldnames[$tblmailverteilergruppen]

		from $tblmailverteilergruppen
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"bankkontenliste" => "select $fieldnames[$tblbankkonten]

		from $tblbankkonten
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelvariantengruppenliste" => "select $fieldnames[$tblartikelvariantengruppen]

		from $tblartikelvariantengruppen
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelvariantenliste" => "select $fieldnames[$tblartikelvarianten], $fieldnames[$tblartikelvariantengruppen]
		from $tblartikelvarianten

		left join $tblartikelvariantengruppen on $tblartikelvariantengruppen.id = $tblartikelvarianten.fiArtikelVariantenGruppe

		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikeleinheitenliste" => "select $fieldnames[$tblartikeleinheiten]

		from $tblartikeleinheiten
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"warengruppenliste" => "select $fieldnames[$tblwarengruppen]

		from $tblwarengruppen
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"stundensatzstandardliste" => "select $fieldnames[$tblstundensaetzestandard]

		from $tblstundensaetzestandard
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"stundensatzprojekteliste" => "select $fieldnames[$tblstundensaetzeprojekte],$fieldnames[$tblstundensaetzestandard],$fieldnames[$tblprojekte]

		from $tblstundensaetzeprojekte, $tblstundensaetzestandard, $tblprojekte
		where 1=1
		and $tblstundensaetzeprojekte.fiStdSatz = $tblstundensaetzestandard.id
		and $tblstundensaetzeprojekte.fiProjekt = $tblprojekte.id",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"stundensatzkundenliste" => "select $fieldnames[$tblstundensaetzekunden],$fieldnames[$tblstundensaetzestandard],$fieldnames[$tblkontakte]

		from $tblstundensaetzekunden, $tblstundensaetzestandard, $tblkontakte
		where 1=1
		and $tblstundensaetzekunden.fiStdSatz = $tblstundensaetzestandard.id
		and $tblstundensaetzekunden.fiKunde = $tblkontakte.id",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"lagerorteliste" => "select $fieldnames[$tbllagerorte],

		concat($tbllagerorte.dtLagerName,\" | \", $tbllagerorte.dtLagerPosition) as dtLagerOrtDDText

		from $tbllagerorte
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelliste" => "select $fieldnames[$tblartikel],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblwarengruppen],$fieldnames[$tblartikellieferanten],

		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe) as dtArtikelDDText3

		from ($tblartikel,$tblwarengruppen)
		left join $tblartikellieferanten on $tblartikellieferanten.fiArtikel = $tblartikel.id
		left join $tblartikeleinheiten on $tblartikel.fiEinheit = $tblartikeleinheiten.id
		
		where $tblwarengruppen.id = $tblartikel.fiWarengruppe ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelliste-verfuegbar" => "select $fieldnames[$tblartikel],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblwarengruppen], $fieldnames[$tblartikelstueck],

		count($tblartikelstueck.fiArtikel) as Artikel_Anzahl,

		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel,\" (\", count($tblartikelstueck.fiArtikel),\" \", $tblartikeleinheiten.dtEinheit ,\") \") as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel,\" (\", count($tblartikelstueck.fiArtikel),\" \", $tblartikeleinheiten.dtEinheit ,\") \") as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe,\" (\", count($tblartikelstueck.fiArtikel),\" \", $tblartikeleinheiten.dtEinheit ,\") \") as dtArtikelDDText3

		from ($tblartikel,$tblartikeleinheiten,$tblwarengruppen)
		left join $tblartikelstueck on $tblartikelstueck.fiArtikel = $tblartikel.id

		where $tblartikel.fiEinheit = $tblartikeleinheiten.id
		and $tblartikel.fiWarengruppe = $tblwarengruppen.id
		and $tblartikelstueck.fiBeleg = 0
		and $tblartikelstueck.fiBelegVerbrauch = 0
		and $tblartikelstueck.fiArtikelStueckVerbrauch = 0
		and $tblartikelstueck.fiProjekt = 0

		group by $tblartikel.id",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelliste-verfuegbar-simple" => "select $fieldnames[$tblartikelstueck]
		from $tblartikelstueck
		where $tblartikelstueck.fiBeleg = 0
		and $tblartikelstueck.fiBelegVerbrauch = 0
		and $tblartikelstueck.fiArtikelStueckVerbrauch = 0",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelliste-verfuegbar2" => "select $fieldnames[$tblartikel],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblwarengruppen], $fieldnames[$tblartikelstueck],

		count($tblartikelstueck.fiArtikel) as Artikel_Anzahl,

		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel,\" (\", count($tblartikelstueck.fiArtikel),\" \", $tblartikeleinheiten.dtEinheit ,\") \") as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel,\" (\", count($tblartikelstueck.fiArtikel),\" \", $tblartikeleinheiten.dtEinheit ,\") \") as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe,\" (\", count($tblartikelstueck.fiArtikel),\" \", $tblartikeleinheiten.dtEinheit ,\") \") as dtArtikelDDText3

		from ($tblartikel,$tblartikeleinheiten,$tblwarengruppen)
		left join $tblartikelstueck on $tblartikelstueck.fiArtikel = $tblartikel.id

		where $tblartikel.fiEinheit = $tblartikeleinheiten.id
		and $tblartikel.fiWarengruppe = $tblwarengruppen.id
		and $tblartikelstueck.fiBeleg = 0
		and $tblartikelstueck.fiBelegVerbrauch = 0
		and $tblartikelstueck.fiArtikelStueckVerbrauch = 0
		and $tblartikelstueck.fiProjekt = 0
		",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelliste-materialpostenauswahl" => "select $fieldnames[$tblartikel],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblwarengruppen], $fieldnames[$tblartikelstueck],
		count($tblartikelstueck.fiArtikel) as Artikel_Anzahl,

		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel,\" (\", count($tblartikelstueck.fiArtikel),\" \", $tblartikeleinheiten.dtEinheit ,\") \") as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe,\" (\", count($tblartikelstueck.fiArtikel),\" \", $tblartikeleinheiten.dtEinheit ,\") \") as dtArtikelDDText3

		from $tblartikelstueck
		left join $tblartikel on $tblartikel.id = $tblartikelstueck.fiArtikel
		left join $tblartikeleinheiten on $tblartikeleinheiten.id = $tblartikel.fiEinheit
		left join $tblwarengruppen on $tblwarengruppen.id = $tblartikel.fiWarengruppe

		where $tblartikelstueck.fiBeleg = 0
		and $tblartikelstueck.fiBelegVerbrauch = 0
		and $tblartikelstueck.fiArtikelStueckVerbrauch = 0
		and $tblartikel.dtArtikelAktiv = 1

		group by $tblartikel.id",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelliste-materialpostenauswahl-alle" => "select $fieldnames[$tblartikel],$fieldnames[$tblwarengruppen],

		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe) as dtArtikelDDText3

		from $tblartikel
		left join $tblwarengruppen on $tblwarengruppen.id = $tblartikel.fiWarengruppe

		where 1=1 and $tblartikel.dtArtikelAktiv = 1

		group by $tblartikel.id",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelliste-projekt-verfuegbar" => "select $fieldnames[$tblartikel],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblwarengruppen], $fieldnames[$tblartikelstueck],

		count($tblartikelstueck.fiArtikel) as Artikel_Anzahl,

		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel,\" (\", count($tblartikelstueck.fiArtikel),\" \", $tblartikeleinheiten.dtEinheit ,\") \") as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe,\" (\", count($tblartikelstueck.fiArtikel),\" \", $tblartikeleinheiten.dtEinheit ,\") \") as dtArtikelDDText3

		from $tblartikelstueck
		left join $tblartikel on $tblartikel.id = $tblartikelstueck.fiArtikel
		left join $tblartikeleinheiten on $tblartikeleinheiten.id = $tblartikel.fiEinheit
		left join $tblwarengruppen on $tblwarengruppen.id = $tblartikel.fiWarengruppe

		where $tblartikelstueck.fiProjekt = 0
		and $tblartikelstueck.fiArtikelStueckVerbrauch = 0

		group by $tblartikel.id",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelliste-verbrauch-zugeordnet" => "select $fieldnames[$tblartikel],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblwarengruppen], $fieldnames[$tblartikelstueck],

		count($tblartikelstueck.fiArtikel) as Artikel_Anzahl,

		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel,\" (\", count($tblartikelstueck.fiArtikel),\" \", $tblartikeleinheiten.dtEinheit ,\") \") as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe,\" (\", count($tblartikelstueck.fiArtikel),\" \", $tblartikeleinheiten.dtEinheit ,\") \") as dtArtikelDDText3

		from ($tblartikel,$tblartikeleinheiten,$tblwarengruppen)
		left join $tblartikelstueck on $tblartikelstueck.fiArtikel = $tblartikel.id

		where $tblartikel.fiEinheit = $tblartikeleinheiten.id
		and $tblartikel.fiWarengruppe = $tblwarengruppen.id
		and $tblartikelstueck.fiBeleg = 0
		and $tblartikelstueck.fiBelegVerbrauch != 0

		group by $tblartikel.id, $tblartikelstueck.fiBelegVerbrauch",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelstueckliste" => "select $fieldnames[$tblartikelstueck],$fieldnames[$tblartikel],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblwarengruppen],
		$fieldnames[$tblkontakte],$fieldnames[$tbllagerorte],$fieldnames[$tblprojekte],$fieldnames[$tbltaetigkeiten],$fieldnames[$tblbelege],$fieldnames[$tblrechnungen],$fieldnames[$tblanreden],

		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtLieferant_Anzeige,

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText,

		concat($tblprojekte.dtProjektNr,\"<br>\", $tblprojekte.dtProjektname) as dtProjekt_Anzeige

		from $tblartikelstueck
		left join $tblartikel on $tblartikelstueck.fiArtikel = $tblartikel.id
		left join $tblkontakte on $tblartikelstueck.fiLieferant = $tblkontakte.id
		left join $tblrechnungen on $tblartikelstueck.fiRechnung = $tblrechnungen.id
		left join $tbllagerorte on $tblartikelstueck.fiLagerOrt = $tbllagerorte.id
		left join $tblprojekte on $tblartikelstueck.fiProjekt = $tblprojekte.id
		left join $tbltaetigkeiten on $tblartikelstueck.fiProjektTaetigkeit = $tbltaetigkeiten.id
		left join $tblbelege on $tblartikelstueck.fiBeleg = $tblbelege.id
		left join $tblartikeleinheiten on $tblartikel.fiEinheit = $tblartikeleinheiten.id
		left join $tblwarengruppen on $tblartikel.fiWarengruppe = $tblwarengruppen.id
		left join $tblanreden on $tblanreden.id = $tblkontakte.fiAnrede
		left join $tblpreisgruppen on $tblartikelstueck.fiPreisgruppe = $tblpreisgruppen.id
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelstueckliste2" => "select $fieldnames[$tblartikelstueck],$fieldnames[$tblartikel],
		$fieldnames[$tblkontakte],$fieldnames[$tblprojekte],$fieldnames[$tblrechnungen],$fieldnames[$tblanreden],

		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtLieferant_Anzeige,

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText,

		concat($tblprojekte.dtProjektNr,\"<br>\", $tblprojekte.dtProjektname) as dtProjekt_Anzeige

		from $tblartikelstueck
		left join $tblartikel on $tblartikelstueck.fiArtikel = $tblartikel.id
		left join $tblkontakte on $tblartikelstueck.fiLieferant = $tblkontakte.id
		left join $tblrechnungen on $tblartikelstueck.fiRechnung = $tblrechnungen.id
		left join $tblprojekte on $tblartikelstueck.fiProjekt = $tblprojekte.id
		left join $tblanreden on $tblanreden.id = $tblkontakte.fiAnrede
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelstuecknegativliste" => "select $fieldnames[$tblartikelstuecknegativ],$fieldnames[$tblartikel],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblwarengruppen],
		$fieldnames[$tblkontakte],$fieldnames[$tbllagerorte],$fieldnames[$tblprojekte],$fieldnames[$tbltaetigkeiten],$fieldnames[$tblbelege],$fieldnames[$tblrechnungen],$fieldnames[$tblanreden],

		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtLieferant_Anzeige,

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText,

		concat($tblprojekte.dtProjektNr,\"<br>\", $tblprojekte.dtProjektname) as dtProjekt_Anzeige

		from $tblartikelstuecknegativ
		left join $tblartikel on $tblartikelstuecknegativ.fiArtikel = $tblartikel.id
		left join $tblprojekte on $tblartikelstuecknegativ.fiProjekt = $tblprojekte.id
		left join $tbltaetigkeiten on $tblartikelstuecknegativ.fiProjektTaetigkeit = $tbltaetigkeiten.id
		left join $tblbelege on $tblartikelstuecknegativ.fiBeleg = $tblbelege.id
		left join $tblartikeleinheiten on $tblartikel.fiEinheit = $tblartikeleinheiten.id
		left join $tblwarengruppen on $tblartikel.fiWarengruppe = $tblwarengruppen.id
		left join $tblanreden on $tblanreden.id = $tblkontakte.fiAnrede
		left join $tblpreisgruppen on $tblartikelstuecknegativ.fiPreisgruppe = $tblpreisgruppen.id
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelstuecklistegrouped" => "select $fieldnames[$tblartikelstueck],$fieldnames[$tblartikel],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblwarengruppen],
		$fieldnames[$tblkontakte],$fieldnames[$tbllagerorte],$fieldnames[$tblprojekte],$fieldnames[$tbltaetigkeiten],$fieldnames[$tblbelege],$fieldnames[$tblrechnungen],$fieldnames[$tblanreden],
		COUNT(fiArtikel) as dtMenge, SUM(dtStueckMenge) AS dtMassenMenge,
		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtLieferant_Anzeige,

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText,

		concat($tblprojekte.dtProjektNr,\"<br>\", $tblprojekte.dtProjektname) as dtProjekt_Anzeige

		from $tblartikelstueck
		left join $tblartikel on $tblartikelstueck.fiArtikel = $tblartikel.id
		left join $tblkontakte on $tblartikelstueck.fiLieferant = $tblkontakte.id
		left join $tblrechnungen on $tblartikelstueck.fiRechnung = $tblrechnungen.id
		left join $tbllagerorte on $tblartikelstueck.fiLagerOrt = $tbllagerorte.id
		left join $tblprojekte on $tblartikelstueck.fiProjekt = $tblprojekte.id
		left join $tbltaetigkeiten on $tblartikelstueck.fiProjektTaetigkeit = $tbltaetigkeiten.id
		left join $tblbelege on $tblartikelstueck.fiBeleg = $tblbelege.id
		left join $tblartikeleinheiten on $tblartikel.fiEinheit = $tblartikeleinheiten.id
		left join $tblwarengruppen on $tblartikel.fiWarengruppe = $tblwarengruppen.id
		left join $tblanreden on $tblanreden.id = $tblkontakte.fiAnrede
		left join $tblpreisgruppen on $tblartikelstueck.fiPreisgruppe = $tblpreisgruppen.id
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelstuecklistegrouped-negativ" => "select $fieldnames[$tblartikelstuecknegativ],$fieldnames[$tblartikel],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblwarengruppen],
		$fieldnames[$tblprojekte],$fieldnames[$tbltaetigkeiten],$fieldnames[$tblbelege],$fieldnames[$tblbelegstatus],
		COUNT(fiArtikel) as dtMenge, SUM(dtStueckMenge) AS dtMassenMenge,

		concat($tblprojekte.dtProjektNr,\"<br>\", $tblprojekte.dtProjektname) as dtProjekt_Anzeige

		from $tblartikelstuecknegativ
		left join $tblartikel on $tblartikelstuecknegativ.fiArtikel = $tblartikel.id
		left join $tblprojekte on $tblartikelstuecknegativ.fiProjekt = $tblprojekte.id
		left join $tbltaetigkeiten on $tblartikelstuecknegativ.fiProjektTaetigkeit = $tbltaetigkeiten.id
		left join $tblbelege on $tblartikelstuecknegativ.fiBeleg = $tblbelege.id
		left join $tblbelegstatus on $tblbelege.fiStatus = $tblbelegstatus.id
		left join $tblartikeleinheiten on $tblartikel.fiEinheit = $tblartikeleinheiten.id
		left join $tblwarengruppen on $tblartikel.fiWarengruppe = $tblwarengruppen.id
		left join $tblpreisgruppen on $tblartikelstuecknegativ.fiPreisgruppe = $tblpreisgruppen.id
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelstueckliste_kurz" => "select $fieldnames[$tblartikelstueck],$fieldnames[$tblartikel],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblwarengruppen]

		from $tblartikelstueck
		left join $tblartikel on $tblartikelstueck.fiArtikel = $tblartikel.id
		left join $tblartikeleinheiten on $tblartikel.fiEinheit = $tblartikeleinheiten.id
		left join $tblwarengruppen on $tblartikel.fiWarengruppe = $tblwarengruppen.id

		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelstuecknegativliste_kurz" => "select $fieldnames[$tblartikelstuecknegativ],$fieldnames[$tblartikel],$fieldnames[$tblartikeleinheiten],$fieldnames[$tblwarengruppen]

		from $tblartikelstuecknegativ
		left join $tblartikel on $tblartikelstuecknegativ.fiArtikel = $tblartikel.id
		left join $tblartikeleinheiten on $tblartikel.fiEinheit = $tblartikeleinheiten.id
		left join $tblwarengruppen on $tblartikel.fiWarengruppe = $tblwarengruppen.id

		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikellieferantenliste" => "select $fieldnames[$tblartikellieferanten],$fieldnames[$tblartikel],$fieldnames[$tblkontakte],$fieldnames[$tblwarengruppen],

		concat($tblartikellieferanten.dtArtikelNrFremd,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe) as dtArtikelDDText3,
		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText

		from $tblartikellieferanten

		left join $tblartikel on $tblartikellieferanten.fiArtikel = $tblartikel.id
		left join $tblkontakte on $tblartikellieferanten.fiLieferant = $tblkontakte.id
		left join $tblwarengruppen on $tblartikel.fiWarengruppe = $tblwarengruppen.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelherstellerliste" => "select $fieldnames[$tblartikelhersteller],$fieldnames[$tblartikel],$fieldnames[$tblkontakte],$fieldnames[$tblwarengruppen],

		concat($tblartikelhersteller.dtHerstellerArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText,
		concat($tblwarengruppen.dtWarengruppe,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText2,
		concat($tblartikel.dtArtikel,\" | \", $tblartikel.dtEigeneArtikelNr,\" | \", $tblwarengruppen.dtWarengruppe) as dtArtikelDDText3

		from $tblartikelhersteller
		left join $tblartikel on $tblartikelhersteller.fiArtikel = $tblartikel.id
		left join $tblkontakte on $tblartikelhersteller.fiHerstellername = $tblkontakte.id
		left join $tblwarengruppen on $tblartikel.fiWarengruppe = $tblwarengruppen.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelstuecklistenliste" => "select $fieldnames[$tblartikelstuecklisten],$fieldnames[$tblartikel],$fieldnames[$tblwarengruppen],$fieldnames[$tblartikeleinheiten],

		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText

		from $tblartikelstuecklisten
		left join $tblartikel on $tblartikelstuecklisten.fiArtikelStueckliste = $tblartikel.id
		left join $tblwarengruppen on $tblartikel.fiWarengruppe = $tblwarengruppen.id
		left join $tblartikeleinheiten on $tblartikel.fiEinheit = $tblartikeleinheiten.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"rechnungliste" => "select $fieldnames[$tblrechnungen], $fieldnames[$tblkontakte], $fieldnames[$tblrechnungstatus], $fieldnames[$tblanreden],

		cast($tblrechnungen.dtRechnungNrIntern AS DECIMAL) as dtRechnungNrInternSortable,
		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtLieferant_Anzeige,

		concat($tblrechnungen.dtRechnungNrIntern, \" | \", $tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtRechnungDDText

		from $tblrechnungen, $tblkontakte, $tblrechnungstatus, $tblanreden

		where $tblrechnungen.fiLieferant = $tblkontakte.id
		and $tblanreden.id = $tblkontakte.fiAnrede
		and $tblrechnungen.fiStatus = $tblrechnungstatus.id ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"rechnunglisteoptimized" => "SELECT $fieldnames[$tblrechnungen], $fieldnames[$tblkontakte], $fieldnames[$tblrechnungstatus], $fieldnames[$tblanreden],$fieldnames[$tblrechnungposten],
		
		cast($tblrechnungen.dtRechnungNrIntern AS DECIMAL) as dtRechnungNrInternSortable,
		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtLieferant_Anzeige
		
		from ($tblrechnungen,$tblkontakte,$tblanreden,$tblrechnungstatus)

		left join $tblrechnungposten on $tblrechnungen.id = $tblrechnungposten.fiRechnung
		
		where $tblrechnungen.fiLieferant = $tblkontakte.id
		and $tblanreden.id = $tblkontakte.fiAnrede
		and $tblrechnungen.fiStatus = $tblrechnungstatus.id ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"rechnungstatusliste" => "select $fieldnames[$tblrechnungstatus] from $tblrechnungstatus
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"rechnungzahlartliste" => "select $fieldnames[$tblrechnungzahlart] from $tblrechnungzahlart
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"rechnungpostenliste" => "select $fieldnames[$tblrechnungposten], $fieldnames[$tblrechnungen], $fieldnames[$tblartikeleinheiten], $fieldnames[$tblbuchungskonten]

		from $tblrechnungposten

		left join $tblrechnungen on $tblrechnungposten.fiRechnung = $tblrechnungen.id
		left join $tblartikeleinheiten on $tblrechnungposten.fiEinheit = $tblartikeleinheiten.id
		left join $tblbuchungskonten on $tblrechnungposten.fiBuchungsKonto = $tblbuchungskonten.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"umsatzliste" => "select $fieldnames[$tblbankumsatz], $fieldnames[$tblbankkonten], $fieldnames[$tblrechnungen], $fieldnames[$tblbelege], $fieldnames[$tblbuchungskonten]

		from $tblbankumsatz

		left join $tblbankkonten on $tblbankumsatz.fiBankKonto = $tblbankkonten.id
		left join $tblrechnungen on $tblbankumsatz.fiRechnung = $tblrechnungen.id
		left join $tblbelege on $tblbankumsatz.fiBeleg = $tblbelege.id
		left join $tblbuchungskonten on $tblbankumsatz.fiBuchungsKonto = $tblbuchungskonten.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"umsatzimportliste" => "select $fieldnames[$tblbankumsatzimport], $fieldnames[$tblbankkonten]

		from $tblbankumsatzimport

		left join $tblbankkonten on $tblbankumsatzimport.fiBankKonto = $tblbankkonten.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"preisgruppenliste" => "select $fieldnames[$tblpreisgruppen],

		concat($tblpreisgruppen.id,\" | \", $tblpreisgruppen.dtBezeichnung) as dtPreisgruppeDDText

		from $tblpreisgruppen

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"preisgruppenkundenliste" => "select $fieldnames[$tblpreisgruppenkunden], $fieldnames[$tblpreisgruppen]

		from $tblpreisgruppenkunden, $tblpreisgruppen

		where $tblpreisgruppenkunden.fiPreisgruppe = $tblpreisgruppen.id ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"preisgruppenprojektliste" => "select $fieldnames[$tblpreisgruppenprojekte], $fieldnames[$tblpreisgruppen]

		from $tblpreisgruppenprojekte, $tblpreisgruppen

		where $tblpreisgruppenprojekte.fiPreisgruppe = $tblpreisgruppen.id ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"abschlagstextliste" => "select $fieldnames[$tblabschlagtexte]

		from $tblabschlagtexte

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"belegabschlagliste" => "select $fieldnames[$tblbelegabschlag], $fieldnames[$tblabschlagtexte]

		from $tblbelegabschlag

		left join $tblabschlagtexte on $tblbelegabschlag.fiAbschlagText = $tblabschlagtexte.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"provisionenliste" => "select $fieldnames[$tblbelegmaterialposten], $fieldnames[$tblartikel],$fieldnames[$tblbelege],$fieldnames[$tblkontakte],
		$tblbelege.dtBezeichnung as dtBelegBezeichnung,
		concat($tblartikel.dtEigeneArtikelNr,\" | \", $tblartikel.dtArtikel) as dtArtikelDDText

		from $tblbelegmaterialposten

		left join $tblartikel on $tblbelegmaterialposten.fiArtikel = $tblartikel.id
		left join $tblbelege on $tblbelege.id = $tblbelegmaterialposten.fiBeleg
		left join $tblkontakte on $tblkontakte.id = $tblbelege.fiKunde

		where $tblartikel.dtArtikelIstProvisionsfaehig = 1
		and $tblbelege.fiBelegProvisionsempfaenger != 0

		",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"mahnschritteliste" => "select $fieldnames[$tblmahnschritte]

		from $tblmahnschritte

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"belegmahnschritteliste" => "select $fieldnames[$tblbelegmahnschritte], $fieldnames[$tblanreden], $fieldnames[$tblkontakte],

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname,\" (\", $tblkontakte.dtKontaktNr,\")\") as dtKontaktDDText2

		from $tblbelegmahnschritte

		left join $tblkontakte on $tblbelegmahnschritte.fiMahnschrittMitarbeiter = $tblkontakte.id
		left join $tblanreden on $tblanreden.id = $tblkontakte.fiAnrede

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"dokumentlayoutliste" => "select $fieldnames[$tbldokumentlayout], $fieldnames[$tblbelegtexte]

		from $tbldokumentlayout

		left join $tblbelegtexte on $tblbelegtexte.fiDokumentLayout = $tbldokumentlayout.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"mwstsatzkundenliste" => "select $fieldnames[$tblmwstsatzkunden]

		from $tblmwstsatzkunden

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"taetigkeitenliste" => "select $fieldnames[$tbltaetigkeiten],

		concat($tbltaetigkeiten.dtTaetigkeitCode,\" | \", $tbltaetigkeiten.dtTaetigkeit,\" | \", $tbltaetigkeiten.dtTaetigkeitBeschreibung) as dtTaetigkeitDDText

		from $tbltaetigkeiten

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"contentliste" => "select $fieldnames[$tblcontent],$fieldnames[$tblcontenttyp],

		cast(tblContent.dtContentNr AS DECIMAL) as dtContentNrSortable,
		concat($tblcontent.dtContentNr,\" | \", $tblcontent.dtUeberschrift) as dtContentDDText

		from $tblcontent
		left join $tblcontenttyp on $tblcontent.fiContentTyp = $tblcontenttyp.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"contenttypliste" => "select $fieldnames[$tblcontenttyp]

		from $tblcontenttyp

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"contenttextliste" => "select $fieldnames[$tblcontenttext],$fieldnames[$tblcontent]

		from $tblcontenttext
		left join $tblcontent on $tblcontenttext.fiContent = $tblcontent.id

		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"bestellungliste" => "select $fieldnames[$tblbestellungen], $fieldnames[$tblkontakte], $fieldnames[$tblbestellungstatus], $fieldnames[$tblanreden], $fieldnames[$tbllaender],

		cast(tblBestellungen.dtBestellungNr AS DECIMAL) as dtBestellungNrSortable,
		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtLieferant_Anzeige,

		concat($tblbestellungen.dtBestellungNr, \" | \", $tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtBestellungDDText

		from ($tblbestellungen, $tblkontakte, $tblbestellungstatus, $tblanreden)

		left join $tbllaender on $tblkontakte.fiLand = $tbllaender.id

		where $tblbestellungen.fiLieferant = $tblkontakte.id
		and $tblanreden.id = $tblkontakte.fiAnrede
		and $tblbestellungen.fiStatus = $tblbestellungstatus.id ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"bestellunglisteoptimized" => "SELECT $fieldnames[$tblkontakte],$fieldnames[$tblartikel],$fieldnames[$tblkontakte],$fieldnames[$tblbestellungstatus], $fieldnames[$tblbestellungen], $fieldnames[$tblbestellungposten], $fieldnames[$tblbestellungmaterialposten],$fieldnames[$tblanreden], $fieldnames[$tbllaender],

				
 		cast(tblBestellungen.dtBestellungNr AS DECIMAL) as dtBestellungNrSortable,
 		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,
 		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtLieferant_Anzeige
		
		from ($tblbestellungen,$tblkontakte, $tblbestellungstatus,$tblanreden)
		
		left join ($tblbestellungmaterialposten 
		INNER JOIN $tblartikel ON $tblbestellungmaterialposten.fiArtikel = $tblartikel.id) 
		on $tblbestellungen.id = $tblbestellungmaterialposten.fiBestellung
		left join $tblbestellungposten on $tblbestellungen.id = $tblbestellungposten.fiBestellung
		left join $tbllaender on $tblkontakte.fiLand = $tbllaender.id
		
		where $tblbestellungen.fiLieferant = $tblkontakte.id 
		and   $tblbestellungen.fiStatus = $tblbestellungstatus.id
		and   $tblanreden.id = $tblkontakte.fiAnrede",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"bestellungstatusliste" => "select $fieldnames[$tblbestellungstatus] from $tblbestellungstatus
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"bestellungpostenliste" => "select $fieldnames[$tblbestellungposten], $fieldnames[$tblbestellungen], $fieldnames[$tblartikeleinheiten], $fieldnames[$tblbuchungskonten]

		from $tblbestellungposten,$tblbestellungen, $tblartikeleinheiten, $tblbuchungskonten

		where $tblbestellungposten.fiBestellung = $tblbestellungen.id
		and $tblbestellungposten.fiEinheit = $tblartikeleinheiten.id
		and $tblbestellungposten.fiBuchungsKonto = $tblbuchungskonten.id ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"bestellungmaterialpostenliste" => "select $fieldnames[$tblbestellungmaterialposten], $fieldnames[$tblartikel], $fieldnames[$tblbestellungen], $fieldnames[$tblartikeleinheiten], $fieldnames[$tblbuchungskonten]

		from $tblbestellungmaterialposten, $tblartikel, $tblbestellungen, $tblartikeleinheiten, $tblbuchungskonten

		where $tblbestellungmaterialposten.fiBestellung = $tblbestellungen.id
		and $tblbestellungmaterialposten.fiArtikel = $tblartikel.id
		and $tblbestellungmaterialposten.fiEinheit = $tblartikeleinheiten.id
		and $tblbestellungmaterialposten.fiBuchungsKonto = $tblbuchungskonten.id ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"bestellungdruckinfoliste" => "select $fieldnames[$tblbestellungdruckinfo], $fieldnames[$tblbestellungen], $fieldnames[$tblanreden], $fieldnames[$tbllaender]

		from ($tblbestellungdruckinfo, $tblbestellungen, $tblanreden)

		left join $tbllaender on $tblbestellungdruckinfo.fiAlternativLand = $tbllaender.id

		where $tblbestellungen.id = $tblbestellungdruckinfo.fiBestellung
		and $tblanreden.id = $tblbestellungdruckinfo.fiAlternativAnrede     ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"textvorlagenliste" => "select $fieldnames[$tbltextvorlagen]

		from $tbltextvorlagen

		where 1=1    ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"stempelzeitenliste" => "select $fieldnames[$tblstempelzeiten], $fieldnames[$tblkontakte],$fieldnames[$tblstempelzeitenstatus],

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText,

		concat($tblkontakte.dtFirmenname, $tblkontakte.dtNachname, $tblkontakte.dtVorname) as dtKontaktSortierung

		from $tblstempelzeiten

		left join $tblkontakte on $tblstempelzeiten.fiMitarbeiter = $tblkontakte.id
		left join $tblstempelzeitenstatus on $tblstempelzeiten.fiStatus = $tblstempelzeitenstatus.id

		where 1=1    ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"stempelzeitenstatusliste" => "select $fieldnames[$tblstempelzeitenstatus]

		from $tblstempelzeitenstatus
		where 1=1    ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"abteilungenliste" => "select $fieldnames[$tblabteilungen],

		concat($tblabteilungen.dtAbteilungNr,\" | \", $tblabteilungen.dtAbteilungName) as dtAbteilungDDText

		from $tblabteilungen
		where 1=1    ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"ueberstundensaetzeliste" => "select $fieldnames[$tblueberstundensaetze]

		from $tblueberstundensaetze
		where 1=1    ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"ueberstundenliste" => "select $fieldnames[$tblueberstunden]

		from $tblueberstunden
		where 1=1    ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		// $fieldnames[$tblprojektteilprojekte] muss VOR $fieldnames[$tblprojektzeiten] stehen, damit fiProjekt im Ausgabearray den richtigen Wert bekommt!
		"projektzeitenliste" => "select $fieldnames[$tblprojektteilprojekte], $fieldnames[$tblprojektzeiten], $fieldnames[$tblkontakte], $fieldnames[$tbltaetigkeiten], $fieldnames[$tblprojekte],

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText,
		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname,\" (\", $tblkontakte.dtKontaktNr,\")\") as dtKontaktDDText2,

		concat($tblkontakte.dtFirmenname, $tblkontakte.dtNachname, $tblkontakte.dtVorname) as dtKontaktSortierung,

		concat($tblprojekte.dtProjektNr,\" | \", $tblprojekte.dtProjektname,\" | \",
		$tblkontakte.dtFirmenname,\" \", $tblkontakte.dtVorname,\" \", $tblkontakte.dtNachname) as dtProjektDDText,

		concat($tblprojekte.dtProjektNr,\" | \", $tblprojekte.dtProjektname) as dtProjektDDText2,

		concat($tbltaetigkeiten.dtTaetigkeitCode,\" | \", $tbltaetigkeiten.dtTaetigkeit,\" | \", $tbltaetigkeiten.dtTaetigkeitBeschreibung) as dtTaetigkeitDDText,

		concat($tbltaetigkeiten.dtTaetigkeitCode,\" | \", $tbltaetigkeiten.dtTaetigkeit) as dtTaetigkeitDDText2

		from $tblprojektzeiten

		left join $tblkontakte on $tblprojektzeiten.fiMitarbeiter = $tblkontakte.id
		left join $tbltaetigkeiten on $tblprojektzeiten.fiTaetigkeit = $tbltaetigkeiten.id
		left join $tblprojekte on $tblprojektzeiten.fiProjekt = $tblprojekte.id
		left join $tblprojektteilprojekte on $tblprojektzeiten.fiTeilprojekt = $tblprojektteilprojekte.id

		where 1=1    ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"bilanztaetigkeitenliste" => "select $fieldnames[$tblprojektzeiten], $fieldnames[$tblkontakte], $fieldnames[$tbltaetigkeiten], $fieldnames[$tblprojekte],
		sum(dtProjektzeitDezimal) as Zeiten, sum(dtStdSatz * dtProjektzeitDezimal) as Kosten,

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText,
		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname,\" (\", $tblkontakte.dtKontaktNr,\")\") as dtKontaktDDText2,

		concat($tblkontakte.dtFirmenname, $tblkontakte.dtNachname, $tblkontakte.dtVorname) as dtKontaktSortierung,

		concat($tblprojekte.dtProjektNr,\" | \", $tblprojekte.dtProjektname,\" | \",
		$tblkontakte.dtFirmenname,\" \", $tblkontakte.dtVorname,\" \", $tblkontakte.dtNachname) as dtProjektDDText,

		concat($tblprojekte.dtProjektNr,\" | \", $tblprojekte.dtProjektname) as dtProjektDDText2,

		concat($tbltaetigkeiten.dtTaetigkeitCode,\" | \", $tbltaetigkeiten.dtTaetigkeit,\" | \", $tbltaetigkeiten.dtTaetigkeitBeschreibung) as dtTaetigkeitDDText,

		concat($tbltaetigkeiten.dtTaetigkeitCode,\" | \", $tbltaetigkeiten.dtTaetigkeit) as dtTaetigkeitDDText2

		from $tblprojektzeiten

		left join $tblkontakte on $tblprojektzeiten.fiMitarbeiter = $tblkontakte.id
		left join $tbltaetigkeiten on $tblprojektzeiten.fiTaetigkeit = $tbltaetigkeiten.id
		left join $tblprojekte on $tblprojektzeiten.fiProjekt = $tblprojekte.id

		where 1=1    ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"feiertageliste" => "select $fieldnames[$tblfeiertage]

		from $tblfeiertage
		where 1=1    ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"fahrstreckenliste" => "select $fieldnames[$tblfahrstrecken], $fieldnames[$tblkontakte],

		concat($tblkontakte.dtFirmenname, $tblkontakte.dtNachname, $tblkontakte.dtVorname) as dtKontaktSortierung

		from $tblfahrstrecken

		left join $tblkontakte on $tblfahrstrecken.fiVonKontakt = $tblkontakte.id

		where 1=1    ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"zeiterfassungmeldungen" => "select $fieldnames[$tblzeiterfassungmeldungen]

		from $tblzeiterfassungmeldungen

		where 1=1    ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"zusatzzeitvorlagenliste" => "select $fieldnames[$tblzusatzzeitvorlagen], $fieldnames[$tblartikeleinheiten]

		from $tblzusatzzeitvorlagen

		left join $tblartikeleinheiten on $tblzusatzzeitvorlagen.fiZusatzzeitEinheit = $tblartikeleinheiten.id

		where 1=1    ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"lohnliste" => "select $fieldnames[$tblkontaktelohn] from $tblkontaktelohn where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"angebotliste" => "select $fieldnames[$tblbelege], $fieldnames[$tblkontakte], $fieldnames[$tblbelegstatus], $fieldnames[$tblanreden], $fieldnames[$tbllaender], $fieldnames[$tblcontent],

		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \",
		$tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtKunde_Anzeige,

		concat($tblbelege.dtBelegNr, \" | \", $tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtBelegDDText,
		concat($tblbelege.dtAngebotNr, \" | \", $tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname,\", \", $tblcontent.dtUeberschrift) as dtAngebotDDText

		from ($tblbelege, $tblkontakte, $tblanreden)

		left join $tbllaender on $tblkontakte.fiLand = $tbllaender.id
		left join $tblbelegstatus on $tblbelege.fiStatus = $tblbelegstatus.id
		left join $tblcontent on $tblbelege.dtZusatz3Wert = $tblcontent.id

		where $tblbelege.fiKunde = $tblkontakte.id
		and $tblanreden.id = $tblkontakte.fiAnrede ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"qualitaetssicherungliste" => "select $fieldnames[$tblprojektqualitaetssicherung], $fieldnames[$tblprojekte], $fieldnames[$tblkontakte],

		concat($tblkontakte.dtFirmenname,\" \", $tblkontakte.dtNachname,\", \", $tblkontakte.dtVorname) as dtKontaktDDText

		from ($tblprojektqualitaetssicherung)

		left join $tblkontakte on $tblkontakte.id = $tblprojektqualitaetssicherung.fiQSKunde
		left join $tblprojekte on $tblprojekte.id = $tblprojektqualitaetssicherung.fiQSProjekt
		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"qualitaetssicherungschritteliste" => "select $fieldnames[$tblprojektqualitaetssicherungschritte]
		from ($tblprojektqualitaetssicherungschritte)

		where 1=1",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"eventlogliste" => "select $fieldnames[$tbleventlog], $fieldnames[$tblkontakte],
		concat($tblkontakte.dtVorname, \" \", $tblkontakte.dtNachname) as dtBenutzer_Anzeige

		from $tbleventlog
		left join $tblkontakte on $tblkontakte.id = $tbleventlog.fiUser
		where 1=1
		",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"wiedervorlagenliste" => "select $fieldnames[$tblwiedervorlagen], $fieldnames[$tblkontakte], $fieldnames[$tblbenutzergruppe],
		concat($tblkontakte.dtVorname, \" \", $tblkontakte.dtNachname) as dtBenutzer_Anzeige

		from $tblwiedervorlagen
		left join $tblkontakte on $tblkontakte.id = $tblwiedervorlagen.fiBenutzer
		left join $tblbenutzergruppe on $tblbenutzergruppe.id = $tblwiedervorlagen.fiGruppe
		where 1=1
		",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelstueck-negativ" => "select $fieldnames[$tblartikelstuecknegativ]

		from $tblartikelstuecknegativ
		where 1=1
		",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"artikelstueckmitbeleg-negativ" => "select $fieldnames[$tblartikelstuecknegativ], $fieldnames[$tblbelege], $fieldnames[$tblbelegstatus]
		
		from $tblartikelstuecknegativ
		left join $tblbelege on $tblbelege.id = $tblartikelstuecknegativ.fiBeleg
		left join $tblbelegstatus on $tblbelegstatus.id = $tblbelege.fiStatus
		where 1=1
		",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"dashboardliste" => "select $fieldnames[$tbldashboard]

		from $tbldashboard
		where 1=1
		",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"taskplanerliste" => "select $fieldnames[$tbltaskplaner]

		from $tbltaskplaner
		where 1=1
		",
		
		"artikelstandexportliste" => "select $fieldnames[$tblartikelstandexport]
		
		from $tblartikelstandexport
		where 1=1
		",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"agorumobjectliste" => "select $fieldnames[$tblagorumobjectid] from $tblagorumobjectid
		where 1=1 ",
		
		// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		"aufgabenliste" => "select $fieldnames[$tblaufgaben], $fieldnames[$tblkontakte],$fieldnames[$tblanreden],$fieldnames[$tblprojekte],

		concat($tblkontakte.dtFirmenname,\"<br>\", $tblkontakte.dtNamenszusatz,\"<br>\",$tblanreden.dtAnrede,\" \", $tblkontakte.dtVorname,\" \",$tblkontakte.dtNachname) as dtKunde_Anzeige

		from $tblaufgaben

		left join $tblprojekte on $tblaufgaben.fiAufgabeProjekt = $tblprojekte.id
		left join $tblkontakte on $tblaufgaben.fiAufgabeKunde = $tblkontakte.id
		left join $tblanreden on $tblkontakte.fiAnrede = $tblanreden.id

		where 1=1
		" 
);

?>