<?php
$old_include_path = set_include_path ( "/usr/share/php" );
require_once ("mapi/mapi.util.php");
require_once ("mapi/mapicode.php");
require_once ("mapi/mapidefs.php");
require_once ("mapi/mapitags.php");
set_include_path ( $old_include_path );
unset ( $old_include_path );

/*
 * Achtung: In den Methoden add(), get() und loeschen() muss darauf geachtet werden das der Prefix "conceptERP-KontaktID-" vor einer Kontaktid bereits automatisch fest vorgegeben ist!
 */

if (! class_exists ( "KontaktZarafa" )) {
	class KontaktZarafa {
		public $Benutzername;
		public $Passwort;
		public $Server = "http://localhost:236/zarafa";
		public $Ordner;
		protected $Session;
		protected $DefaultStore;
		protected $Inbox;
		protected $Contacts;
		protected $folder_entryid;
		
		/* Diese Felder werden mit der get() Methode abgerufen. */
		protected $properties = array (
				PR_ENTRYID,
				PR_CUSTOMER_ID,
				PR_DISPLAY_NAME,
				PR_GIVEN_NAME,
				PR_SURNAME,
				PR_OFFICE_TELEPHONE_NUMBER,
				PR_CELLULAR_TELEPHONE_NUMBER,
				PR_BUSINESS_FAX_NUMBER,
				PR_COMPANY_NAME,
				PR_DISPLAY_NAME_PREFIX,
				PR_GENERATION,
				PR_PROFESSION,
				"PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x801b",
				"PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8084",
				PR_LAST_MODIFICATION_TIME 
		);
		
		/*
		 * Konstruktor
		 */
		public function __construct() {
		}
		
		/*
		 * Am Zarafaserver anmelden
		 */
		public function login() {
			@$this->Session = mapi_logon_zarafa ( $this->Benutzername, $this->Passwort, $this->Server );
			
			if (! $this->Session) {
				throw new ZarafaLogonFailedException ();
			}
			
			$this->openStores ();
		}
		
		/*
		 * User-Store und Inbox ffnen
		 */
		protected function openStores() {
			$this->openFolder ();
			$this->Inbox = mapi_msgstore_getreceivefolder ( $this->DefaultStore );
		}
		
		/*
		 * $Ordner ffnen
		 */
		protected function openFolder() {
			$expl_ordner = explode ( "/", $this->Ordner );
			
			$zarafa_storeData = $this->getFoldersArray ( $this->Session );
			$this->DefaultStore = mapi_openmsgstore ( $this->Session, $zarafa_storeData [0] ["attributes"] ["id_orig"] );
			
			$this->folder_entryid = $this->buildFolderArray ( $zarafa_storeData );
			
			if (! isset ( $this->folder_entryid [$expl_ordner [0]] [$expl_ordner [1]] )) {
				$ex = new ZarafaStoreOrFolderNotExists ();
				$ex->Folderarray = $this->folder_entryid;
				throw $ex;
			}
			
			$this->Contacts = mapi_msgstore_openentry ( $this->DefaultStore, $this->folder_entryid [$expl_ordner [0]] [$expl_ordner [1]] );
		}
		
		/*
		 * Ordnerstruktur abrufen
		 */
		public function getOrdnerstruktur() {
			$ausg = array ();
			$zarafa_storeData = $this->getFoldersArray ( $this->Session );
			
			foreach ( $this->buildFolderArray ( $zarafa_storeData ) as $name => $inhalt ) {
				if (is_array ( $inhalt )) {
					foreach ( $inhalt as $namesub => $inhaltsub ) {
						$ausg [$name . "/" . $namesub] = $name . "/" . $namesub;
					}
				}
			}
			
			return $ausg;
		}
		
		/*
		 * Neuen Kontakt anlegen/bearbeiten und abspeichern
		 */
		public function add($k) {
			if (empty ( $k->Vorname ) && empty ( $k->Name ) && empty ( $k->Firma ) && empty ( $k->Namenszusatz ))
				return;
				
				/*
			 * Eigenschaften festlegen
			 */
			
			$properties = $this->setProperties ( $k );
			
			/*
			 * Suche nach gleichen Kontakt
			 */
			$restriction = array (
					RES_PROPERTY,
					array (
							RELOP => RELOP_EQ,
							ULPROPTAG => PR_CUSTOMER_ID,
							VALUE => "conceptERP-KontaktID-" . $k->Id 
					) 
			);
			$table = mapi_folder_getcontentstable ( $this->Contacts );
			$rows = mapi_table_queryallrows ( $table, array (
					PR_ENTRYID,
					PR_CUSTOMER_ID 
			), $restriction );
			
			if (count ( ( array ) $rows ) > 0) {
				// Wenn ein gleicher Kontakt gefunden wurde, aktualisiere diesen.
				foreach ( $rows as $row ) {
					$row = array_values ( $row );
					$kontakt = mapi_msgstore_openentry ( $this->DefaultStore, $row [0] );
					mapi_setprops ( $kontakt, $properties );
					mapi_savechanges ( $kontakt );
				}
			} else { // sonst lege einen an
				$kontakt = mapi_folder_createmessage ( $this->Contacts );
				mapi_setprops ( $kontakt, $properties );
				mapi_savechanges ( $kontakt );
			}
		}
		
		/*
		 * Kontakte-Array hinzufgen/bearbeiten
		 */
		public function addArray($k) {
			if (! is_array ( $k )) {
				return;
			}
			
			foreach ( $k as $kontakt ) {
				$this->add ( $kontakt );
			}
		}
		
		/*
		 * PR_CUSTOMER_ID von einem Kontakt ndern
		 */
		public function aendereID($idalt, $idneu) {
			$restriction = array (
					RES_PROPERTY,
					array (
							RELOP => RELOP_EQ,
							ULPROPTAG => PR_CUSTOMER_ID,
							VALUE => $idalt 
					) 
			);
			$table = mapi_folder_getcontentstable ( $this->Contacts );
			$rows = mapi_table_queryallrows ( $table, array (
					PR_ENTRYID,
					PR_CUSTOMER_ID 
			), $restriction );
			
			if (count ( ( array ) $rows ) > 0) {
				foreach ( $rows as $row ) {
					$row2 = array_values ( $row );
					$unknowncontact = mapi_msgstore_openentry ( $this->DefaultStore, $row2 [0] );
					
					$row [PR_CUSTOMER_ID] = "conceptERP-KontaktID-" . $idneu;
					
					mapi_setprops ( $unknowncontact, $row );
					mapi_savechanges ( $unknowncontact );
				}
			}
		}
		
		/*
		 * Setzt die Properties fr einen Kontakt
		 */
		protected function setProperties($k) {
			$expl_ordner = explode ( "/", $this->Ordner );
			
			$properties = array ();
			$properties [PR_MESSAGE_CLASS] = "IPM.Contact";
			$properties [PR_PARENT_ENTRYID] = $this->folder_entryid [$expl_ordner [0]] [$expl_ordner [1]];
			$properties [PR_CUSTOMER_ID] = "conceptERP-KontaktID-" . $k->Id;
			$properties [PR_DISPLAY_NAME] = $this->encode_mapi_feld_erp_zarafa ( $k->Vorname . " " . $k->Name );
			$properties [PR_GIVEN_NAME] = $this->encode_mapi_feld_erp_zarafa ( $k->Vorname );
			$properties [PR_SURNAME] = $this->encode_mapi_feld_erp_zarafa ( $k->Name );
			$properties [PR_OFFICE_TELEPHONE_NUMBER] = $this->encode_mapi_feld_erp_zarafa ( $k->TelNr );
			$properties [PR_CELLULAR_TELEPHONE_NUMBER] = $this->encode_mapi_feld_erp_zarafa ( $k->MobilNr );
			$properties [PR_BUSINESS_FAX_NUMBER] = $this->encode_mapi_feld_erp_zarafa ( $k->FaxNr );
			$properties [PR_COMPANY_NAME] = $this->encode_mapi_feld_erp_zarafa ( $k->Firma );
			$properties [PR_DISPLAY_NAME_PREFIX] = $this->encode_mapi_feld_erp_zarafa ( $k->Anrede );
			$properties [PR_GENERATION] = $this->encode_mapi_feld_erp_zarafa ( $k->Namenszusatz );
			$properties ["PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x801b"] = $this->encode_mapi_feld_erp_zarafa ( $k->Strasse . "\r\n" . $k->PLZ . " " . $k->Ort . "\r\n" . $k->Land );
			// $properties["PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x801c"] = $kontakt["dtPostfach"] . "\r\n" . $kontakt["dtPostfachPLZ"] . " " . $kontakt["dtPostfachOrt"] . "\r\n" . $kontakt["dtLandesname"];
			$properties [PR_PROFESSION] = $this->encode_mapi_feld_erp_zarafa ( $k->Position );
			
			$properties ["PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8083"] = $this->encode_mapi_feld_erp_zarafa ( $k->EMail );
			$properties ["PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8084"] = $this->encode_mapi_feld_erp_zarafa ( $k->EMail );
			
			if ($k->Firma == "" and ($k->Name != "" or $k->Vorname != "")) {
				$properties ["PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8005"] = $this->encode_mapi_feld_erp_zarafa ( $k->Name . ", " . $k->Vorname );
				$properties [PR_SUBJECT] = $this->encode_mapi_feld_erp_zarafa ( $k->Name . ", " . $k->Vorname );
				$properties [PR_NORMALIZED_SUBJECT] = $this->encode_mapi_feld_erp_zarafa ( $k->Name . ", " . $k->Vorname );
			} elseif ($k->Firma != "" and ($k->Name == "" and $k->Vorname == "")) {
				$properties ["PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8005"] = $this->encode_mapi_feld_erp_zarafa ( $k->Firma );
				$properties [PR_SUBJECT] = $this->encode_mapi_feld_erp_zarafa ( $k->Firma );
				$properties [PR_NORMALIZED_SUBJECT] = $this->encode_mapi_feld_erp_zarafa ( $k->Firma );
			} elseif ($k->Firma != "" and ($k->Name != "" or $k->Vorname != "")) {
				$properties ["PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8005"] = $this->encode_mapi_feld_erp_zarafa ( $k->Firma . " (" . $k->Name . ", " . $k->Vorname . ")" );
				$properties [PR_SUBJECT] = $this->encode_mapi_feld_erp_zarafa ( $k->Firma . " " . $k->Name . ", " . $k->Vorname );
				$properties [PR_NORMALIZED_SUBJECT] = $this->encode_mapi_feld_erp_zarafa ( $k->Firma . " " . $k->Name . ", " . $k->Vorname );
			}
			
			$properties ["PT_LONG:{00062004-0000-0000-C000-000000000046}:0x8006"] = 6;
			$properties ["PT_LONG:{00062004-0000-0000-C000-000000000046}:0x8022"] = 0;
			$properties ["PT_MV_LONG:{00062004-0000-0000-C000-000000000046}:0x8028"] = array (
					0 
			);
			$properties ["PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8082"] = "SMTP";
			$properties ["PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x801a"] = "";
			$properties ["PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8085"] = "";
			
			if ($k->EMail) {
				$properties ["PT_LONG:{00062004-0000-0000-C000-000000000046}:0x8029"] = 1;
			} else {
				$properties ["PT_LONG:{00062004-0000-0000-C000-000000000046}:0x8029"] = 0;
			}
			
			$properties = $this->getPropIdsFromStrings ( $properties );
			
			return $properties;
		}
		
		/*
		 * Ruft alle Kontakte oder einen bestimmten ab
		 */
		public function get($erpid = false) {
			$unknown = 0;
			
			/*
			 * Wenn ein bestimmter Kontakt ausgegeben werden soll.
			 */
			if ($erpid) {
				$restriction = array (
						RES_PROPERTY,
						array (
								RELOP => RELOP_EQ,
								ULPROPTAG => PR_CUSTOMER_ID,
								VALUE => "conceptERP-KontaktID-" . $erpid 
						) 
				);
			}
			
			/*
			 * Abzurufende Felder muss geflipt werden, da die Methode getPropIdsFromStrings() ein anderes Format erwartet.
			 */
			$tagarray = array_flip ( $this->getPropIdsFromStrings ( array_flip ( $this->properties ) ) );
			
			/*
			 * Inhaltstabelle aller Kontakte
			 */
			$table = mapi_folder_getcontentstable ( $this->Contacts );
			
			/*
			 * Wenn ein bestimmter Kontakt ausgegeben werden soll.
			 */
			if ($erpid) {
				$rows = mapi_table_queryallrows ( $table, $tagarray, $restriction );
			} else {
				$rows = mapi_table_queryallrows ( $table, $tagarray );
			}
			
			/*
			 * Alle Kontakte durchlaufen
			 */
			$ausgabe = array ();
			
			if (count ( ( array ) $rows ) > 0) {
				foreach ( $rows as $row ) {
					/*
					 * Vergebe bei unbekannten Kontakten eine fiktive ID
					 */
					if (empty ( $row [PR_CUSTOMER_ID] ) || substr ( $row [PR_CUSTOMER_ID], 0, strlen ( "conceptERP-Unknown-" ) ) == "conceptERP-Unknown-") {
						$row2 = array_values ( $row );
						$unknowncontact = mapi_msgstore_openentry ( $this->DefaultStore, $row2 [0] );
						
						$row [PR_CUSTOMER_ID] = "conceptERP-Unknown-" . $unknown ++;
						
						mapi_setprops ( $unknowncontact, $row );
						mapi_savechanges ( $unknowncontact );
					}
					
					$str_id = explode ( "-", $row [PR_CUSTOMER_ID] );
					$id = $str_id [3];
					$typ = $str_id [2];
					unset ( $str_id );
					
					if ($typ == "ASP") {
						$kontakt = new Ansprechpartner ();
					} else {
						$kontakt = new Kontakt ();
					}
					
					$kontakt->Id = $row [PR_CUSTOMER_ID];
					
					$kontakt->Anrede = $this->encode_mapi_feld_zarafa_erp ( $row [PR_DISPLAY_NAME_PREFIX] );
					$kontakt->Vorname = $this->encode_mapi_feld_zarafa_erp ( $row [PR_GIVEN_NAME] );
					$kontakt->Name = $this->encode_mapi_feld_zarafa_erp ( $row [PR_SURNAME] );
					$kontakt->Firma = $this->encode_mapi_feld_zarafa_erp ( $row [PR_COMPANY_NAME] );
					$kontakt->Position = $this->encode_mapi_feld_zarafa_erp ( $row [PR_PROFESSION] );
					$kontakt->Namenszusatz = $this->encode_mapi_feld_zarafa_erp ( $row [PR_GENERATION] );
					
					$kontakt->setAdresse ( $this->encode_mapi_feld_zarafa_erp ( $row [- 2134179810] ) );
					
					$kontakt->TelNr = $this->encode_mapi_feld_zarafa_erp ( $row [PR_OFFICE_TELEPHONE_NUMBER] );
					$kontakt->MobilNr = $this->encode_mapi_feld_zarafa_erp ( $row [PR_CELLULAR_TELEPHONE_NUMBER] );
					$kontakt->FaxNr = $this->encode_mapi_feld_zarafa_erp ( $row [PR_BUSINESS_FAX_NUMBER] );
					$kontakt->EMail = $row [- 2127298530];
					$kontakt->Unknown = true;
					
					$kontakt->Aenderungszeit = $row [PR_LAST_MODIFICATION_TIME];
					
					$ausgabe [] = $kontakt;
				}
			}
			
			return $ausgabe;
		}
		
		/*
		 * ??
		 */
		protected function getPropIdsFromStrings($props_orig) {
			$props = array ();
			$guids = array ();
			
			$ids = array (
					"name" => array (),
					"id" => array (),
					"guid" => array (),
					"type" => array (),
					"val" => array () 
			); // this array stores all the information needed to retrieve a named property
			$num = 0;
			
			foreach ( $props_orig as $name => $val ) {
				if (is_string ( $name )) {
					$split = explode ( ":", $name );
					
					if (substr ( $split [2], 0, 2 ) == "0x") {
						$id = hexdec ( substr ( $split [2], 2 ) );
					} else {
						$id = $split [2];
					}
					
					// have we used this guid before?
					if (! array_key_exists ( $split [1], $guids )) {
						$guids [$split [1]] = makeguid ( $split [1] );
					}
					$guid = $guids [$split [1]];
					
					// temp store info about named prop, so we have to call mapi_getidsfromnames just one time
					$ids ["name"] [$num] = $name;
					$ids ["val"] [$num] = $val;
					$ids ["id"] [$num] = $id;
					$ids ["guid"] [$num] = $guid;
					$ids ["type"] [$num] = $split [0];
					$num ++;
				} else {
					// not a named property
					$props [$name] = $val;
				}
			}
			
			// get the ids
			$named = mapi_getidsfromnames ( $this->DefaultStore, $ids ["id"], $ids ["guid"] );
			foreach ( $named as $num => $prop ) {
				$props [mapi_prop_tag ( constant ( $ids ["type"] [$num] ), mapi_prop_id ( $prop ) )] = $ids ["val"] [$num];
			}
			
			return $props;
		}
		
		/*
		 * Kodiere ein Feld je nach Konfigurationseinstellungen
		 */
		protected function encode_mapi_feld_erp_zarafa($string) {
			global $zarafa_kontaksync_encoding_erp_zarafa;
			return $this->encode_mapi_feld ( $string, $zarafa_kontaksync_encoding_erp_zarafa );
		}
		protected function encode_mapi_feld_zarafa_erp($string) {
			global $zarafa_kontaksync_encoding_zarafa_erp;
			return $this->encode_mapi_feld ( $string, $zarafa_kontaksync_encoding_zarafa_erp );
		}
		protected function encode_mapi_feld($string, $encode_typ) {
			if ($encode_typ == "utf8_encode") {
				return utf8_encode ( $string );
			} else if ($encode_typ == "utf8_decode") {
				return utf8_decode ( $string );
			} else {
				return $string;
			}
		}
		
		/*
		 * Kodiere UTF-8 in Windows 1252
		 */
		protected function utf8_to_windows1252($string) {
			global $bUtfInIso;
			
			if ($bUtfInIso == 1) {
				return utf8_decode ( $string );
			}
			
			if (function_exists ( "iconv" )) {
				return iconv ( "UTF-8", "Windows-1252", $string );
			} else {
				return utf8_decode ( $string ); // no euro support here
			}
		}
		
		/*
		 * Kodiere Windows 1252 in UTF-8
		 */
		protected function windows1252_to_utf8($string) {
			global $bUtfInIso;
			
			if ($bUtfInIso == 1) {
				return utf8_decode ( $string );
			}
			
			if (function_exists ( "iconv" )) {
				return iconv ( "Windows-1252", "UTF-8", $string );
			} else {
				return utf8_encode ( $string ); // no euro support here
			}
		}
		protected function setFolder($folderProps) {
			$props = array ();
			$props ["entryid"] = bin2hex ( $folderProps [PR_ENTRYID] );
			$props ["entryid_orig"] = $folderProps [PR_ENTRYID];
			$props ["parent_entryid"] = bin2hex ( $folderProps [PR_PARENT_ENTRYID] );
			$props ["store_entryid"] = bin2hex ( $folderProps [PR_STORE_ENTRYID] );
			$props ["display_name"] = $this->windows1252_to_utf8 ( $folderProps [PR_DISPLAY_NAME] );
			
			if (isset ( $folderProps [PR_CONTAINER_CLASS] )) {
				$props ["container_class"] = $folderProps [PR_CONTAINER_CLASS];
			} else {
				$props ["container_class"] = "IPF.Note";
			}
			
			return $props;
		}
		protected function getSubFolders($folder, $properties) {
			$hierarchyTable = mapi_folder_gethierarchytable ( $folder, CONVENIENT_DEPTH );
			
			if (is_bool ( $hierarchyTable ))
				return; // Abbrechen wenn keine Unterordner enthalten sind
			
			mapi_table_sort ( $hierarchyTable, array (
					PR_DISPLAY_NAME => TABLE_SORT_ASCEND 
			) );
			$subfolders = mapi_table_queryallrows ( $hierarchyTable, array_merge ( array (
					PR_ENTRYID,
					PR_SUBFOLDERS 
			), $properties ) );
			
			if (is_array ( $subfolders )) {
				foreach ( $subfolders as $subfolder ) {
					$storeData [] = $this->setFolder ( $subfolder );
				}
			}
			
			return $storeData;
		}
		protected function buildFolderArray($storeDataAllShares) {
			foreach ( ( array ) $storeDataAllShares as $key => $store ) {
				
				foreach ( ( array ) $store as $store_key => $folder_list ) {
					
					if ($store_key == "attributes") {
						$akt_store = $folder_list ["display_name"];
					}
					
					if ($store_key == "folder") {
						
						foreach ( ( array ) $folder_list [1] as $folder_key => $folder ) {
							
							$folder_array [$akt_store] [$folder ["display_name"]] = $folder ["entryid_orig"];
						}
					}
				}
			}
			
			return $folder_array;
		}
		protected function getFoldersArray() {
			// Loop through all stores
			$storestables = mapi_getmsgstorestable ( $this->Session );
			$result = mapi_last_hresult ();
			$entryid = false;
			
			if ($result == NOERROR) {
				$rows = mapi_table_queryallrows ( $storestables, array (
						PR_ENTRYID 
				) );
				$result = mapi_last_hresult ();
				
				if ($result == NOERROR) {
					foreach ( $rows as $row ) {
						
						// Check the cache before opening
						if (isset ( $storelist [$row [PR_ENTRYID]] ))
							return $storelist [$row [PR_ENTRYID]];
						
						$store = mapi_openmsgstore ( $this->Session, $row [PR_ENTRYID] );
						$hresult = mapi_last_hresult ();
						
						// Cache the store for later use
						if ($hresult == NOERROR)
							$storelist [$row [PR_ENTRYID]] = $store;
					}
				}
			}
			
			foreach ( $storelist as $store ) {
				$msgstore_props = mapi_getprops ( $store, array (
						PR_ENTRYID,
						PR_DISPLAY_NAME,
						PR_IPM_SUBTREE_ENTRYID,
						PR_IPM_OUTBOX_ENTRYID,
						PR_IPM_SENTMAIL_ENTRYID,
						PR_IPM_WASTEBASKET_ENTRYID,
						PR_MDB_PROVIDER,
						PR_IPM_PUBLIC_FOLDERS_ENTRYID,
						PR_IPM_FAVORITES_ENTRYID 
				) );
				
				switch ($msgstore_props [PR_MDB_PROVIDER]) {
					case ZARAFA_SERVICE_GUID :
						$storeType = "default";
						break;
					case ZARAFA_STORE_PUBLIC_GUID :
						$storeType = "public";
						break;
					case ZARAFA_STORE_DELEGATE_GUID :
						$storeType = "other";
						break;
				}
				
				$inboxProps = array ();
				$storeData = array ();
				$storeData ["attributes"] = array (
						"id" => bin2hex ( $msgstore_props [PR_ENTRYID] ),
						"id_orig" => $msgstore_props [PR_ENTRYID],
						"display_name" => $this->windows1252_to_utf8 ( $msgstore_props [PR_DISPLAY_NAME] ),
						"subtree" => bin2hex ( $msgstore_props [PR_IPM_SUBTREE_ENTRYID] ),
						"type" => $storeType,
						"foldertype" => "all" 
				);
				
				$storeData ["folder"] = array ();
				$folder = mapi_msgstore_openentry ( $store, $msgstore_props [PR_IPM_SUBTREE_ENTRYID] );
				
				if ($folder) {
					// Add root folder
					array_push ( $storeData ['folder'], $this->setFolder ( mapi_getprops ( $folder, array (
							PR_ENTRYID,
							PR_DISPLAY_NAME,
							PR_IPM_SUBTREE_ENTRYID,
							PR_IPM_OUTBOX_ENTRYID,
							PR_IPM_SENTMAIL_ENTRYID,
							PR_IPM_WASTEBASKET_ENTRYID,
							PR_MDB_PROVIDER,
							PR_IPM_PUBLIC_FOLDERS_ENTRYID,
							PR_IPM_FAVORITES_ENTRYID 
					) ) ) );
					
					// Recursively add all subfolders
					array_push ( $storeData ['folder'], $this->getSubFolders ( $folder, array (
							PR_ENTRYID,
							PR_DISPLAY_NAME,
							PR_IPM_SUBTREE_ENTRYID,
							PR_IPM_OUTBOX_ENTRYID,
							PR_IPM_SENTMAIL_ENTRYID,
							PR_IPM_WASTEBASKET_ENTRYID,
							PR_MDB_PROVIDER,
							PR_IPM_PUBLIC_FOLDERS_ENTRYID,
							PR_IPM_FAVORITES_ENTRYID 
					) ) );
				}
				
				$storeDataAllShares [] = $storeData;
			}
			
			return $storeDataAllShares;
		}
		
		/*
		 * Kontakt lschen
		 */
		public function loeschen($erpid) {
			$restriction = array (
					RES_PROPERTY,
					array (
							RELOP => RELOP_EQ,
							ULPROPTAG => PR_CUSTOMER_ID,
							VALUE => "conceptERP-KontaktID-" . $erpid 
					) 
			);
			
			$table = mapi_folder_getcontentstable ( $this->Contacts );
			$rows = mapi_table_queryallrows ( $table, array (
					PR_ENTRYID,
					PR_CUSTOMER_ID 
			), $restriction );
			
			if (count ( ( array ) $rows ) > 0) {
				foreach ( $rows as $row ) {
					$row = array_values ( $row );
					mapi_folder_deletemessages ( $this->Contacts, array (
							$row [0] 
					) );
				}
			}
		}
		
		/*
		 * Viele Kontakte loeschen
		 */
		public function loeschenArray($erpids) {
			if (! is_array ( $erpids ))
				return;
			
			foreach ( $erpids as $id ) {
				$this->loeschen ( $id );
			}
		}
		
		/*
		 * Destruktor
		 */
		public function __destruct() {
		}
	}
}

/*
 * Wird ausgelst wenn ein Fehler beim Login auftritt
 */
if (! class_exists ( "ZarafaLogonFailedException" )) {
	class ZarafaLogonFailedException extends Exception {
	}
}

/*
 * Wird ausgelst wenn der Store oder Ordner nicht existiert.
 */
if (! class_exists ( "ZarafaStoreOrFolderNotExists" )) {
	class ZarafaStoreOrFolderNotExists extends Exception {
	}
}

?>
