<?php

// Pfad zu include Dateien bestimmen
file_exists ( "config/" ) ? $include_prefix = "" : $include_prefix = "../";

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Gebe Anzahl Arbeitstage zurck (ohne Sa,So und Feiertage)
if (! function_exists ( "get_arbeitstage" )) {
	function get_arbeitstage($startdate, $enddate) {
		$arbeitstage = 0;
		
		$startdate_array = split_date ( $startdate );
		$enddate_array = split_date ( $enddate );
		
		$tage_startdatum = mktime ( 0, 0, 0, $startdate_array ["monat"], $startdate_array ["tag"], $startdate_array ["jahr"] );
		$tage_enddatum = mktime ( 0, 0, 0, $enddate_array ["monat"], $enddate_array ["tag"], $enddate_array ["jahr"] );
		
		if ($tage_startdatum > $tage_enddatum) {
			$arbeitstage = "--";
		}
		
		while ( $tage_startdatum < $tage_enddatum ) {
			$tage_startdatum = mktime ( 0, 0, 0, $startdate_array ["monat"], $startdate_array ["tag"] + 1, $startdate_array ["jahr"] );
			$startdate = date ( "Y-m-d", $tage_startdatum );
			$startdate_array = split_date ( $startdate );
			
			$weekday_count = date ( "w", $tage_startdatum );
			$feiertag = check_feiertag ( $startdate_array ["tag"], $startdate_array ["monat"], $startdate_array ["jahr"] );
			if ($weekday_count != "0" and $weekday_count != "6" and $feiertag == "") {
				$arbeitstage ++;
			}
		}
		
		return ($arbeitstage);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Gebe Wochentag als 2stelligen String zu einem Datum zurck
if (! function_exists ( "weekday_from_date" )) {
	function weekday_from_date($date) {
		$datum = split_date ( $date );
		
		$weekday_count = date ( "w", mktime ( 0, 0, 0, $datum ["monat"], $datum ["tag"], $datum ["jahr"] ) );
		if ($weekday_count == "0") :
			$weekday = "So";
		 elseif ($weekday_count == "1") :
			$weekday = "Mo";
		 elseif ($weekday_count == "2") :
			$weekday = "Di";
		 elseif ($weekday_count == "3") :
			$weekday = "Mi";
		 elseif ($weekday_count == "4") :
			$weekday = "Do";
		 elseif ($weekday_count == "5") :
			$weekday = "Fr";
		 elseif ($weekday_count == "6") :
			$weekday = "Sa";
		endif;
		
		return ($weekday);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Gebe Wochentag als Ziffer von 1 (Mo.) bis 7 (So.) von einem Datum zurck
if (! function_exists ( "weekdaynumber_from_date" )) {
	function weekdaynumber_from_date($date) {
		$datum = split_date ( $date );
		$weekday_count = date ( "w", mktime ( 0, 0, 0, ( int ) $datum ["monat"], ( int ) $datum ["tag"], ( int ) $datum ["jahr"] ) );
		if ($weekday_count == 0) :
			$weekday_count = 7;
		
		
		
		endif;
		
		return ($weekday_count);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// gebe Nummer der Woche des Jahres aus einem Datum zurck
if (! function_exists ( "week_from_date" )) {
	function week_from_date($date) {
		$datum = split_date ( $date );
		$wochenoffset = date ( "w", mktime ( 0, 0, 0, $datum ["monat"], 1, $datum ["jahr"] ) );
		$erstertagimjahr = date ( "w", mktime ( 0, 0, 0, 1, 1, $datum ["jahr"] ) );
		$erstermonatstagimjahr = date ( "z", mktime ( 0, 0, 0, $datum ["monat"], 2, $datum ["jahr"] ) );
		
		if ($wochenoffset == 0) :
			$wochenoffset = 7;
		
		
		
		endif;
		
		if ($erstertagimjahr <= 2 or $erstertagimjahr >= 5) :
			$erstewocheimmonat = floor ( ($erstermonatstagimjahr - $wochenoffset + 1) / 7 ) + 1;
		 else :
			$erstewocheimmonat = floor ( ($erstermonatstagimjahr - $wochenoffset + 1) / 7 ) + 2;
		endif;
		
		$wocheimmonat = floor ( ($datum ["tag"] - 2 + $wochenoffset) / 7 );
		$week = $erstewocheimmonat + $wocheimmonat;
		
		return ($week);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// gebe Datum des Montags der Woche des bergebenen Datums zurck
if (! function_exists ( "monday_of_week" )) {
	function monday_of_week($date) {
		$daynumber = weekdaynumber_from_date ( $date );
		$datum = split_date ( $date );
		$monday_of_week = date ( "Y-m-d", mktime ( 0, 0, 0, $datum ["monat"], $datum ["tag"] - $daynumber + 1, $datum ["jahr"] ) );
		return ($monday_of_week);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// gebe Datum des Montags der Woche der bergebenen Kalenderwoche zurck (Format: KW.JJ)
if (! function_exists ( "monday_of_kw" )) {
	function monday_of_kw($kw) {
		$kw_array = explode ( ".", $kw );
		if (substr ( $kw_array [1], - 2 ) > 50) {
			$jahr = "19" . substr ( $kw_array [1], - 2 );
		}
		;
		if (substr ( $kw_array [1], - 2 ) <= 50) {
			$jahr = "20" . substr ( $kw_array [1], - 2 );
		}
		;
		
		$tag_nr = ($kw_array [0] - 1) * 7;
		$monday_of_kw = monday_of_week ( date ( "Y-m-d", mktime ( 0, 0, 0, 1, $tag_nr, $jahr ) ) );
		
		while ( week_from_date ( $monday_of_kw ) != $kw_array [0] ) {
			$datum_split = split_date ( $monday_of_kw );
			$monday_of_kw = date ( "Y-m-d", mktime ( 0, 0, 0, 1, $tag_nr ++, $jahr ) );
		}
		
		return ($monday_of_kw);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// gebe eine Uhrzeit aus einer dezimalen Zeit zurck
if (! function_exists ( "time_from_deztime" )) {
	function time_from_deztime($dezzeit) {
		$stunde = floor ( $dezzeit );
		if ($stunde < 10)
			$stunde = "0" . $stunde;
		
		$minute = round ( ($dezzeit - $stunde) * 60, 0 );
		
		if ($minute < 10)
			$minute = "0" . $minute;
		
		return ($stunde . ":" . $minute);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// gebe dezimale Zeit zu einer Uhrzeit zurck (in 15min Schritten)
if (! function_exists ( "deztime_from_time" )) {
	function deztime_from_time($zeit) {
		// include ($GLOBALS['include_prefix']."config/config.php"); extract(exportiereKonfiguration());
		global $projektzeitdezimal_intervall;
		$zeit = split_time ( $zeit );
		
		if ($projektzeitdezimal_intervall == 60) {
			
			if ($zeit ["minute"] >= 30) {
				$deztime ["stunde"] = $zeit ["stunde"] + 1;
				$deztime ["minute"] = "00";
			} elseif ($zeit ["minute"] < 30) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "00";
			}
		} elseif ($projektzeitdezimal_intervall == 30) {
			
			if ($zeit ["minute"] >= 45) {
				$deztime ["stunde"] = $zeit ["stunde"] + 1;
				$deztime ["minute"] = "00";
			} elseif ($zeit ["minute"] >= 15) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "50";
			} elseif ($zeit ["minute"] < 15) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "00";
			}
		} elseif ($projektzeitdezimal_intervall == 15) {
			
			if ($zeit ["minute"] >= 53) {
				$deztime ["stunde"] = $zeit ["stunde"] + 1;
				$deztime ["minute"] = "00";
			} elseif ($zeit ["minute"] >= 38) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "75";
			} elseif ($zeit ["minute"] >= 23) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "50";
			} elseif ($zeit ["minute"] >= 8) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "25";
			} elseif ($zeit ["minute"] < 8) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "00";
			}
		} elseif ($projektzeitdezimal_intervall == 10) {
			
			if ($zeit ["minute"] >= 55) {
				$deztime ["stunde"] = $zeit ["stunde"] + 1;
				$deztime ["minute"] = "00";
			} elseif ($zeit ["minute"] >= 45) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "83";
			} elseif ($zeit ["minute"] >= 35) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "67";
			} elseif ($zeit ["minute"] >= 25) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "50";
			} elseif ($zeit ["minute"] >= 15) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "33";
			} elseif ($zeit ["minute"] >= 5) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "17";
			} elseif ($zeit ["minute"] < 5) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "00";
			}
		} elseif ($projektzeitdezimal_intervall == 5) {
			
			if ($zeit ["minute"] >= 58) {
				$deztime ["stunde"] = $zeit ["stunde"] + 1;
				$deztime ["minute"] = "00";
			} elseif ($zeit ["minute"] >= 53) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "92";
			} elseif ($zeit ["minute"] >= 48) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "83";
			} elseif ($zeit ["minute"] >= 43) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "75";
			} elseif ($zeit ["minute"] >= 38) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "67";
			} elseif ($zeit ["minute"] >= 33) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "58";
			} elseif ($zeit ["minute"] >= 28) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "50";
			} elseif ($zeit ["minute"] >= 23) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "42";
			} elseif ($zeit ["minute"] >= 18) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "33";
			} elseif ($zeit ["minute"] >= 13) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "25";
			} elseif ($zeit ["minute"] >= 8) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "17";
			} elseif ($zeit ["minute"] >= 3) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "08";
			} elseif ($zeit ["minute"] < 3) {
				$deztime ["stunde"] = $zeit ["stunde"];
				$deztime ["minute"] = "00";
			}
		} elseif ($projektzeitdezimal_intervall == 1) {
			
			$deztime ["stunde"] = $zeit ["stunde"];
			$deztime ["minute"] = floor ( $zeit ["minute"] / 60 * 100 );
			
			if ($deztime ["minute"] < 10)
				$deztime ["minute"] = "0" . $deztime ["minute"];
		}
		
		return ($deztime ["stunde"] . "." . $deztime ["minute"] );
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Ersetze englische Textanangaben in Datumstexten gegen deutsche
if (! function_exists ( "datetext_to_datetext_de" )) {
	function datetext_to_datetext_de($datum, $ersetzungstyp) {
		if ($ersetzungstyp == "WT3") {
			$datum = str_replace ( array (
					"Mon",
					"Tue",
					"Wed",
					"Thu",
					"Fri",
					"Sat",
					"Sun" 
			), array (
					"Mo",
					"Di",
					"Mi",
					"Do",
					"Fr",
					"Sa",
					"So" 
			), $datum );
		} elseif ($ersetzungstyp == "WT") {
			$datum = str_replace ( array (
					"Monday",
					"Tuesday",
					"Wednesday",
					"Thursday",
					"Friday",
					"Saturday",
					"Sunday" 
			), array (
					"Montag",
					"Dienstag",
					"Mittwoch",
					"Donnerstag",
					"Freitag",
					"Samstag",
					"Sonntag" 
			), $datum );
		} elseif ($ersetzungstyp == "MT3") {
			$datum = str_replace ( array (
					"Jan",
					"Feb",
					"Mar",
					"Apr",
					"May",
					"Jun",
					"Jul",
					"Aug",
					"Sep",
					"Oct",
					"Nov",
					"Dec" 
			), array (
					"Jan",
					"Feb",
					"Mr",
					"Apr",
					"Mai",
					"Jun",
					"Jul",
					"Aug",
					"Sep",
					"Okt",
					"Nov",
					"Dez" 
			), $datum );
		} elseif ($ersetzungstyp == "MT") {
			$datum = str_replace ( array (
					"January",
					"February",
					"March",
					"April",
					"May",
					"June",
					"July",
					"August",
					"September",
					"October",
					"November",
					"December" 
			), array (
					"Januar",
					"Februar",
					"Mrz",
					"April",
					"Mai",
					"Juni",
					"Juli",
					"August",
					"September",
					"Oktober",
					"November",
					"Dezember" 
			), $datum );
		}
		
		return ($datum);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Suche Sollzeit eines Mitarbeiters eines Tages
if (! function_exists ( "get_sollzeit" )) {
	function get_sollzeit($mitarbeiternr, $taetigkeit, $datum) {
		
		// include ($GLOBALS['include_prefix']."config/config.php"); extract(exportiereKonfiguration());
		// include ($GLOBALS['include_prefix']."$functionsordner_custom/function_custom_pre.php");
		// include ($GLOBALS['include_prefix']."$functionsordner/function_sql_query.php");
		// include ($GLOBALS['include_prefix']."$functionsordner_custom/function_custom_post.php");
		global $tbltaetigkeiten, $tblpersonaldaten, $tblprojektzeiten;
		global $standard_taetigkeit_arbeit, $standard_taetigkeit_arztbesuch, $standard_taetigkeit_krankheit, $standard_taetigkeit_feiertag;
		global $standard_taetigkeit_dienstreise, $standard_taetigkeit_urlaub, $standard_taetigkeit_sonderurlaub, $standard_taetigkeit_urlaubhalbertag;
		global $standard_taetigkeit_ueberstundenabbau, $standard_taetigkeit_kurzarbeit, $bErweiterteTaetigkeitsfunktionen;
		
		$aDatumSplit = split_date ( $datum );
		
		// ++++ bei Leereintrgen berechne die Sollzeit so als wenn es ein normaler Arbeitstag wre
		if ($taetigkeit == 0)
			$taetigkeit = $standard_taetigkeit_arbeit;
			
			// ++++ hole Details zur Sollzeit
		$query = "select * from $tbltaetigkeiten where id = $taetigkeit";
		$taetigkeit_field = get_table_row ( $query );
		
		// ++++ hole Sollzeiten des Mitarbeiters
		$query = "select * from $tblpersonaldaten where fiKontaktNr = $mitarbeiternr";
		$mitarbeiter_sollzeit_field = get_table_row ( $query );
		
		// ++++ ermittle den Wochentag
		$wochentag = weekday_from_date ( $datum );
		
		// +++ Sollzeit-Relevanz (ja/nein)
		if ($taetigkeit_field ["dtSollzeitrelevant"] == 0) {
			$sollzeit = "0,00";
		}		

		// ++++ Krankheit
		elseif ($taetigkeit == $standard_taetigkeit_arztbesuch) {
			$sollzeit = "0,00";
			$bemerkung = "Arztbesuch";
		} elseif ($taetigkeit == $standard_taetigkeit_krankheit) {
			$sollzeit = "0,00";
			$bemerkung = "Krankheit";
		}		

		// ++++ Feiertag nach Ttigkeit
		elseif ($taetigkeit == $standard_taetigkeit_feiertag) {
			$sollzeit = "0,00";
			$bemerkung = "Feiertag";
		}		

		// ++++ Dienstreise (wie Vergtezeit)
		elseif ($taetigkeit == $standard_taetigkeit_dienstreise) {
			$sollzeit = "0,00";
			$bemerkung = "Dienstreise, Messebesuch, etc.";
		}		

		// ++++ Urlaub
		elseif ($taetigkeit == $standard_taetigkeit_urlaub) {
			$sollzeit = "0,00";
			$bemerkung = "Urlaub";
		} elseif ($taetigkeit == $standard_taetigkeit_sonderurlaub) {
			$sollzeit = "0,00";
			$bemerkung = "Sonderurlaub";
		}		

		// ++++ halber Urlaubstag = halbe Sollzeit
		elseif ($taetigkeit == $standard_taetigkeit_urlaubhalbertag) {
			
			$sollzeithalbierung = false;
			// Sonderregelung fr 24.12. und 31.12.
			if (($aDatumSplit ["tag"] == "24" and $aDatumSplit ["monat"] == "12") or ($aDatumSplit ["tag"] == "31" and $aDatumSplit ["monat"] == "12")) {
				$sollzeit = "0,00";
			}  // sonst halbierung der Standardsollzeit
else {
				// ++++ Wochentage wie in Personaldaten hinterlegt
				if ($wochentag == "Mo")
					$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenMontag"], 2 );
				elseif ($wochentag == "Di")
					$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenDienstag"], 2 );
				elseif ($wochentag == "Mi")
					$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenMittwoch"], 2 );
				elseif ($wochentag == "Do")
					$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenDonnerstag"], 2 );
				elseif ($wochentag == "Fr")
					$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenFreitag"], 2 );
				elseif ($wochentag == "Sa")
					$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenSamstag"], 2 );
				elseif ($wochentag == "So")
					$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenSonntag"], 2 );
				$sollzeithalbierung = true;
			}
			$bemerkung = "Urlaub halber Tag";
		}		

		// ++++ Wochentage wie in Personaldaten hinterlegt
		elseif ($wochentag == "Mo")
			$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenMontag"], 2 );
		elseif ($wochentag == "Di")
			$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenDienstag"], 2 );
		elseif ($wochentag == "Mi")
			$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenMittwoch"], 2 );
		elseif ($wochentag == "Do")
			$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenDonnerstag"], 2 );
		elseif ($wochentag == "Fr")
			$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenFreitag"], 2 );
		elseif ($wochentag == "Sa")
			$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenSamstag"], 2 );
		elseif ($wochentag == "So")
			$sollzeit = double_from_sql ( $mitarbeiter_sollzeit_field ["dtStundenSonntag"], 2 );
			
			// ++++ Feiertag nach Datum
		if (check_feiertag ( $aDatumSplit ["tag"], $aDatumSplit ["monat"], $aDatumSplit ["jahr"] ) != "") {
			$sollzeit = "0,00";
			$bemerkung = "Feiertag! " . check_feiertag ( $aDatumSplit ["tag"], $aDatumSplit ["monat"], $aDatumSplit ["jahr"] );
		}
		
		// ++++ berstundenabbau setzt nur Bemerkung
		if ($taetigkeit == $standard_taetigkeit_ueberstundenabbau) {
			$bemerkung = "berstundenabbau";
		}
		if ($taetigkeit == $standard_taetigkeit_kurzarbeit) {
			$bemerkung = "Kurzarbeit";
		}
		
		// Sollzeit-Erhhungen berechnen
		if ($bErweiterteTaetigkeitsfunktionen == 1) {
			$sollzeiterhoehung = 0;
			
			$query = "select * from $tblprojektzeiten, $tbltaetigkeiten ";
			$query = $query . "where fiMitarbeiter = $mitarbeiternr ";
			$query = $query . "and dtDatum = '$datum' ";
			$query = $query . "and $tblprojektzeiten.fiTaetigkeit = $tbltaetigkeiten.id ";
			
			$pzliste = get_table_array ( $query );
			foreach ( ( array ) $pzliste as $listenzeile_id => $listenzeile ) {
				if ($listenzeile ["dtSollzeiterhoehung"] == 1) {
					$sollzeiterhoehung += deztime_from_time ( $listenzeile ["dtVergueteZeit"] );
					// echo $datum.": ".$mitarbeiternr." / ".$sollzeiterhoehung."<hr>";
				}
			}
			
			$sollzeit = double_from_sql ( (double_to_sql ( $sollzeit ) + $sollzeiterhoehung), 2 );
		}
		
		// ggf. Sollzeit halbieren
		if ($sollzeithalbierung) {
			$sollzeit = str_replace ( ".", ",", $sollzeit );
			$sollzeit = $sollzeit / 2;
		}
		
		return array (
				$sollzeit,
				$bemerkung 
		);
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// setze gleiche Sollzeit bei allen Eintrgen dieses Tages
if (! function_exists ( "normalisiereSollzeit" )) {
	function normalisiereSollzeit($mitarbeiternr, $datum, $sollzeit) {
		global $tblprojektzeiten;
		
		$query = "update $tblprojektzeiten ";
		$query .= "set $tblprojektzeiten.dtSollzeit = '" . $sollzeit . "' ";
		$query .= "where $tblprojektzeiten.fiMitarbeiter = $mitarbeiternr ";
		$query .= "and $tblprojektzeiten.dtDatum = '$datum' ";
		
		mysql_query ( $query );
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// lsche ggf. Leereintrge an diesem Tag
if (! function_exists ( "leereintragloeschen" )) {
	function leereintragloeschen($mitarbeiternr, $datum) {
		global $tblprojektzeiten;
		
		$query = "delete from $tblprojektzeiten ";
		$query .= "where $tblprojektzeiten.fiMitarbeiter = $mitarbeiternr ";
		$query .= "and $tblprojektzeiten.dtDatum = '$datum' ";
		$query .= "and $tblprojektzeiten.dtBeginnZeit = '00:00:00' ";
		$query .= "and $tblprojektzeiten.dtEndeZeit = '00:00:00' ";
		$query .= "and $tblprojektzeiten.dtAnwesendZeit = '00:00:00' ";
		$query .= "and $tblprojektzeiten.dtPauseZeit = '00:00:00' ";
		$query .= "and $tblprojektzeiten.dtArbeitsZeit = '00:00:00' ";
		$query .= "and $tblprojektzeiten.dtZusatzZeit = '00:00:00' ";
		$query .= "and $tblprojektzeiten.dtVergueteZeit = '00:00:00' ";
		$query .= "and $tblprojektzeiten.fiTaetigkeit = 0 ";
		$query .= "and $tblprojektzeiten.fiProjekt = 0 ";
		$query .= "and $tblprojektzeiten.dtStundennachweisGeprueft = 0 ";
		$query .= "and $tblprojektzeiten.dtAbgerechnet = 0 ";
		
		mysql_query ( $query );
	}
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// suche einen Stundensatz zu einer Projektzeit
if (! function_exists ( "stundensatz_zu_projektzeit" )) {
	function stundensatz_zu_projektzeit($mitarbeiterid, $projektid = 0) {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		extract ( exportiereKonfiguration () );
		include ($GLOBALS ['include_prefix'] . "$functionsordner_custom/function_custom_pre.php");
		include ($GLOBALS ['include_prefix'] . "$functionsordner/function_sql_query.php");
		include ($GLOBALS ['include_prefix'] . "$functionsordner_custom/function_custom_post.php");
		
		$mitarbeiterquery = $sql_query ["personaldatenliste"] . " and fiKontaktNr = " . $mitarbeiterid;
		$liste = get_table_row ( $mitarbeiterquery );
		$stundensatzid = $liste ["fiStdSatz"];
		
		if ($projektid != 0) {
			$kundequery = $sql_query ["projektliste"] . " and $tblprojekte.id = " . $projektid;
			$liste = get_table_row ( $kundequery );
			$kundeid = $liste ["fiKunde"];
			
			$projektstundensatzquery = $sql_query ["stundensatzprojekteliste"];
			$projektstundensatzquery .= " and $tblstundensaetzestandard.id = " . $stundensatzid;
			$projektstundensatzquery .= " and $tblprojekte.id = " . $projektid;
			
			$kundenstundensatzquery = $sql_query ["stundensatzkundenliste"];
			$kundenstundensatzquery .= " and $tblstundensaetzestandard.id = " . $stundensatzid;
			$kundenstundensatzquery .= " and $tblkontakte.id = " . $kundeid;
		}
		
		$standardstundensatzquery = $sql_query ["stundensatzstandardliste"] . " and $tblstundensaetzestandard.id = " . $stundensatzid;
		
		// nimm zunchst mal den Standard-Stundensatz
		$standardliste = get_table_row ( $standardstundensatzquery );
		$stundensatz = $standardliste ["dtStdSatz"];
		
		// wenn es einen Kunden-eigenen-Stundensatz gibt, dann nimm den
		if ($kundeid != 0) {
			if (get_table_count ( $kundenstundensatzquery ) != 0) {
				$kundenliste = get_table_row ( $kundenstundensatzquery );
				$stundensatz = $kundenliste ["dtStdSatzKunde"];
			} else {
				$kundenliste ["dtStdSatzKunde"] = $standardliste ["dtStdSatz"];
			}
		}
		
		// wenn es einen Projekt-eigenen-Stundensatz gibt, dann nimm den
		if ($projektid != 0) {
			if (get_table_count ( $projektstundensatzquery ) != 0) {
				$projektliste = get_table_row ( $projektstundensatzquery );
				$stundensatz = $projektliste ["dtStdSatzProjekt"];
			}
		}
		
		return ($stundensatz);
	}
}

// ***************************************************************************************************
// ************************************* get_arbeitszeit ***********************************************
// Arbeitszeit eines Mitarbeiters in einem Zeitraum berechnen

if (! function_exists ( "get_arbeitszeit" )) {
	function get_arbeitszeit($mitarbeiternr, $datum_von, $datum_bis, $usecache = false) {
		
		// include ($GLOBALS['include_prefix']."config/config.php"); extract(exportiereKonfiguration());
		// include ($GLOBALS['include_prefix']."$functionsordner_custom/function_custom_pre.php");
		// include ($GLOBALS['include_prefix']."$functionsordner/function_sql_query.php");
		// include ($GLOBALS['include_prefix']."$functionsordner_custom/function_custom_post.php");
		global $tblprojektzeiten;
		
		// +++++++++++ SQL Abfrage der Liste
		if ($usecache) {
			global $tblarbeitszeitencache;
			
			$query = "select SEC_TO_TIME( SUM( TIME_TO_SEC(dtSummeZeitArbeit))) as dtAZSumme from $tblarbeitszeitencache ";
			$query = $query . "where fiMitarbeiter = $mitarbeiternr ";
			$query = $query . "and to_days(dtDatum) >= to_days('$datum_von') ";
			$query = $query . "and to_days(dtDatum) <= to_days('$datum_bis') ";
		} else {
			$query = "select SEC_TO_TIME( SUM( TIME_TO_SEC(dtArbeitsZeit))) as dtAZSumme from $tblprojektzeiten ";
			$query = $query . "where fiMitarbeiter = $mitarbeiternr ";
			$query = $query . "and to_days(dtDatum) >= to_days('$datum_von') ";
			$query = $query . "and to_days(dtDatum) <= to_days('$datum_bis') ";
		}
		
		$azsum_row = get_table_row ( $query );
		return ($azsum_row ["dtAZSumme"]);
	}
}

// ***************************************************************************************************
// ************************************* get_arbeitszeit ***********************************************
// Arbeitszeit eines Mitarbeiters in einem Zeitraum berechnen

if (! function_exists ( "get_sollzeit_zeitraum" )) {
	function get_sollzeit_zeitraum($mitarbeiternr, $datum_von, $datum_bis, $usecache = false) {
		
		// include ($GLOBALS['include_prefix']."config/config.php"); extract(exportiereKonfiguration());
		// include ($GLOBALS['include_prefix']."$functionsordner_custom/function_custom_pre.php");
		// include ($GLOBALS['include_prefix']."$functionsordner/function_sql_query.php");
		// include ($GLOBALS['include_prefix']."$functionsordner_custom/function_custom_post.php");
		global $tblprojektzeiten;
		
		// +++++++++++ SQL Abfrage der Liste
		if ($usecache) {
			global $tblarbeitszeitencache;
			
			$query = "select distinct dtSollzeit from $tblarbeitszeitencache ";
			$query = $query . "where fiMitarbeiter = $mitarbeiternr";
			$query = $query . "and to_days(dtDatum) >= to_days('$datum_von') ";
			$query = $query . "and to_days(dtDatum) <= to_days('$datum_bis') ";
			$query = $query . "group by dtDatum ";
		} else {
			$query = "select distinct dtDatum, dtSollzeit from $tblprojektzeiten ";
			$query = $query . "where fiMitarbeiter = $mitarbeiternr ";
			$query = $query . "and to_days(dtDatum) >= to_days('$datum_von') ";
			$query = $query . "and to_days(dtDatum) <= to_days('$datum_bis') ";
			$query = $query . "group by dtDatum ";
		}
		
		$dSollzeit = 0;
		foreach ( ( array ) get_table_array ( $query ) as $cpSollzeit ) {
			$dSollzeit += $cpSollzeit ["dtSollzeit"];
		}
		return ($dSollzeit);
	}
}

// ***************************************************************************************************
// ************************************* get_tagesarbeitszeiten ***********************************************
// Array aller Zeiten eines Tages summiert berechnen

if (! function_exists ( "get_tagesarbeitszeiten" )) {
	function get_tagesarbeitszeiten($mitarbeiternr, $datum) {
		global $tblprojektzeiten;
		
		$query = "select * from " . $tblprojektzeiten;
		$query .= " where fiMitarbeiter = '" . $mitarbeiternr . "' ";
		$query .= " and dtDatum = '" . $datum . "' ";
		$query .= " order by dtBeginnZeit ";
		
		$liste = get_table_array ( $query );
		
		if (count ( $liste ) != 0) {
			
			foreach ( ( array ) $liste as $listenzeile_id => $listenzeile ) {
				
				if (array_key_exists ( "dtDatum", ( array ) $liste_return )) {
					
					if (stdmin_to_min ( $listenzeile ["dtBeginnZeit"] ) != 0 and stdmin_to_min ( $listenzeile ["dtEndeZeit"] ) != 0) {
						
						if (stdmin_to_min ( $liste_return ["dtBeginnZeit"] ) != 0) {
							$liste_return ["dtBeginnZeit"] = min_to_stdmin ( min ( stdmin_to_min ( $liste_return ["dtBeginnZeit"] ), stdmin_to_min ( $listenzeile ["dtBeginnZeit"] ) ) );
						} else {
							$liste_return ["dtBeginnZeit"] = $listenzeile ["dtBeginnZeit"];
						}
						$liste_return ["dtEndeZeit"] = min_to_stdmin ( max ( stdmin_to_min ( $liste_return ["dtEndeZeit"] ), stdmin_to_min ( $listenzeile ["dtEndeZeit"] ) ) );
						$liste_return ["dtAnwesendZeit"] = min_to_stdmin ( stdmin_to_min ( $liste_return ["dtEndeZeit"] ) - stdmin_to_min ( $liste_return ["dtBeginnZeit"] ) );
						$liste_return ["dtArbeitsZeit"] = min_to_stdmin ( stdmin_to_min ( $liste_return ["dtArbeitsZeit"] ) + stdmin_to_min ( $listenzeile ["dtArbeitsZeit"] ) );
						$liste_return ["dtZusatzZeit"] = min_to_stdmin ( stdmin_to_min ( $liste_return ["dtZusatzZeit"] ) + stdmin_to_min ( $listenzeile ["dtZusatzZeit"] ) );
						$liste_return ["dtVergueteZeit"] = min_to_stdmin ( stdmin_to_min ( $liste_return ["dtArbeitsZeit"] ) + stdmin_to_min ( $liste_return ["dtZusatzZeit"] ) );
						$liste_return ["dtPauseZeit"] = min_to_stdmin ( stdmin_to_min ( $liste_return ["dtAnwesendZeit"] ) - stdmin_to_min ( $liste_return ["dtArbeitsZeit"] ) );
					}
				} else {
					
					$liste_return ["dtDatum"] = $listenzeile ["dtDatum"];
					$liste_return ["dtBeginnZeit"] = $listenzeile ["dtBeginnZeit"];
					$liste_return ["dtEndeZeit"] = $listenzeile ["dtEndeZeit"];
					$liste_return ["dtAnwesendZeit"] = $listenzeile ["dtAnwesendZeit"];
					$liste_return ["dtArbeitsZeit"] = $listenzeile ["dtArbeitsZeit"];
					$liste_return ["dtZusatzZeit"] = $listenzeile ["dtZusatzZeit"];
					$liste_return ["dtVergueteZeit"] = $listenzeile ["dtVergueteZeit"];
					$liste_return ["dtPauseZeit"] = $listenzeile ["dtPauseZeit"];
				}
			}
		}
		
		return $liste_return;
	}
}
// ***************************************************************************************************
// ************************************* set_gleitzeit ***********************************************
// Gleitzeit eines Mitarbeiters in einem Zeitraum berechnen und setzen

if (! function_exists ( "set_gleitzeit" )) {
	function set_gleitzeit($mitarbeiternr,$fGleitzeitstand, $datum_von, $datum_bis) {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		extract ( exportiereKonfiguration () );
		include ($GLOBALS ['include_prefix'] . "$functionsordner_custom/function_custom_pre.php");
		include ($GLOBALS ['include_prefix'] . "$functionsordner/function_sql_query.php");
		include ($GLOBALS ['include_prefix'] . "$functionsordner_custom/function_custom_post.php");
		 
		
		$aTag = split_date($datum_bis);
		
	if($field_pz)
		unset($field_pz);
		
		$field_pz ["dtVergueteZeit"] = time_to_sql_nocheck ( $fGleitzeitstand );
		$field_pz ["fiTaetigkeit"] = $standard_taetigkeit_gleitzeitstandaenderung_absolut;
		if ($field_new ["gz_abs_min"] == 1) {
			$field_pz ["dtBemerkungProjektzeit"] = "automatische Anpassung des Gleitzeitkontostandes auf " . stdmin_to_min($fGleitzeitstand) . " Minute";
		} else {
			$field_pz ["dtBemerkungProjektzeit"] = "automatische Anpassung des Gleitzeitkontostandes auf " . stdmin_to_min($fGleitzeitstand) . " Minuten";
		}
	
		// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Projektzeiteneintrag
	
		$field_pz ["fiMitarbeiter"] = $mitarbeiternr;
		$field_pz ["dtDatum"] = concat_date ( $aTag ["tag"], $aTag ["monat"], $aTag ["jahr"] );
	
		$field_pz ["dtBeginnZeit"] = "00:00:00";
		$field_pz ["dtEndeZeit"] = "00:00:00";
		$field_pz ["dtAnwesendZeit"] = "00:00:00";
		$field_pz ["dtPauseZeit"] = "00:00:00";
		$field_pz ["dtArbeitsZeit"] = "00:00:00";
		$field_pz ["dtZusatzZeit"] = "00:00:00";
		$field_pz ["dtSollzeit"] = 0;
		$field_pz ["dtProjektzeitAutoManuell"] = 0;
		$field_pz ["fiStempelungBeginn"] = 0;
		$field_pz ["fiStempelungEnde"] = 0;
		$field_pz ["fiProjekt"] = 0;
		$field_pz ["dtProjektzeitDezimal"] = 0;
		$field_pz ["dtBemerkungArbeitszeit"] = "";
		$field_pz ["dtErlaeuterungStundennachweis"] = "";
		$field_pz ["dtBemerkungKontrolle"] = "";
		$field_pz ["dtStundennachweisGeprueft"] = 0;
		$field_pz ["dtAbgerechnet"] = 0;
		$field_pz ["dtAutoEintragProjektzeit"] = 0;
		$field_pz ["dtOrt"] = "";
		$field_pz ["dtEinsatzort"] = "";
		$field_pz ["dtKommentarUebernehmen"] = 0;
		$field_pz ["dtFahrzeit"] = 0;
		$field_pz ["dtArtDerFahrt"] = "";
		$field_pz ["dtEntfernungKilometer"] = 0;
		$field_pz ["dtStdSatz"] = 0;
		$field_pz ["dtStdSatzAutoManuell"] = 0;
		$field_pz ["dtProjektzeitDezimalBericht"] = 0;
		$field_pz ["dtDatensatzDrucken"] = 0;
		$field_pz ["dtVonZeitBerichtManuell"] = "";
		$field_pz ["dtBisZeitBerichtManuell"] = "";
		$field_pz ["dtUeberstundenAutoManuell"] = 0;
	
		$id = insert_into_table ( $tblprojektzeiten, $field_pz );
	
		// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		// ++++ Gleitzeitkontostand in Personaldaten bernehmen
		unset ( $field_pd );
	
		$query = $sql_query ["personaldatenliste"] . " and fiKontaktNr = " . $mitarbeiternr;
		$liste = get_table_array ( $query );

		$aktmonatdatum = date ( "Y-m-d", mktime ( 0, 0, 0, $aktmonat, 1, $aktjahr ) );
		$aktdatum = date ( "Y-m-d", mktime ( 0, 0, 0, $aktmonat, $akttag, $aktjahr ) );
	
		$field_pd ["dtGleitzeitkontoMinuten"] = get_gleitzeit ( $mitarbeiternr, "1970-01-01", $aktdatum, "daemon" );
		$field_pd ["dtUeberstundenMinuten"] = get_gleitzeit ( $mitarbeiternr, $aktmonatdatum, $aktdatum, "daemon" );
	
		// $field_pd["dtResturlaub"] = get_urlaubsstand($field_new["mitarbeiterid"], "1970-01-01", $aktdatum, "daemon");
		// $field_pd["dtUrlaubImMonat"] = get_urlaubsstand($field_new["mitarbeiterid"], $aktmonatdatum, $aktdatum, "daemon");

		// ++++ trage die neuen Werte in tblPersonaldaten ein
		update_into_table ( $tblpersonaldaten, $liste[0]["Personaldaten_id"], $field_pd );

	}
}


// ***************************************************************************************************
// ************************************* get_gleitzeit ***********************************************
// Gleitzeit eines Mitarbeiters in einem Zeitraum berechnen

if (! function_exists ( "get_gleitzeit" )) {
	function get_gleitzeit($mitarbeiternr, $datum_von, $datum_bis, $ziel = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		extract ( exportiereKonfiguration () );
		include ($GLOBALS ['include_prefix'] . "$functionsordner_custom/function_custom_pre.php");
		include ($GLOBALS ['include_prefix'] . "$functionsordner/function_sql_query.php");
		include ($GLOBALS ['include_prefix'] . "$functionsordner_custom/function_custom_post.php");
		
		$laufdatum = $datum_von;
		$gleitzeitmin = 0;
		$rundung = 15;
		
		// +++++++++++ SQL Abfrage der Liste
		$query = "select * from $tblprojektzeiten ";
		$query = $query . "where fiMitarbeiter = $mitarbeiternr ";
		$query = $query . "and to_days(dtDatum) >= to_days('$datum_von') ";
		$query = $query . "and to_days(dtDatum) <= to_days('$datum_bis') ";
		$query = $query . "order by dtDatum, dtBeginnZeit desc";
		
		$anzahl = get_table_count ( $query );
		
		$liste = get_table_array ( $query );
		
		if (count ( $liste ) != 0) {
			foreach ( $liste as $listenzeile_id => $listenzeile ) {
				
				if ($laufdatum != $listenzeile ["dtDatum"]) {
					
					if ($absoluteaenderung == "ja") {
						$gleitzeitmin = $neuegleitzeit;
						$absoluteaenderung = "nein";
					} else {
						$gleitzeitmin = $gleitzeitmin + ($verguetezeit - $sollzeitmin);
					}
					
					$laufdatum = $listenzeile ["dtDatum"];
					$sollzeit = 0;
					$sollzeitmin = 0;
					$sollzeit_urlaubstag = "";
					$verguetezeit = 0;
				}
				
				// ++++ bestimmung der Sollzeit fr diesen Tag
				if ($listenzeile ["fiTaetigkeit"] == $standard_taetigkeit_urlaub or $listenzeile ["fiTaetigkeit"] == $standard_taetigkeit_urlaubhalbertag or $listenzeile ["fiTaetigkeit"] == $standard_taetigkeit_feiertag) {
					// $sollzeit = double_from_sql ($listenzeile["dtSollzeit"],$rundung);
					// $sollzeitmin = str_replace(",",".",$sollzeit) * 60;
					$sollzeit = $listenzeile ["dtSollzeit"];
					$sollzeitmin = stdmin_to_min ( deztime_to_stdmin ( $sollzeit ) );
					$sollzeit_urlaubstag = "ja";
				}
				
				// if ($sollzeit < (double_from_sql ($listenzeile["dtSollzeit"],$rundung)) and $sollzeit_urlaubstag != "ja") {
				if ($sollzeit < $listenzeile ["dtSollzeit"] and $sollzeit_urlaubstag != "ja") {
					// $sollzeit = double_from_sql ($listenzeile["dtSollzeit"],$rundung);
					// $sollzeitmin = str_replace(",",".",$sollzeit) * 60;
					$sollzeit = $listenzeile ["dtSollzeit"];
					$sollzeitmin = stdmin_to_min ( deztime_to_stdmin ( $sollzeit ) );
				}
				
				// ++++ Berechnung incl. nderungen
				if ($ziel != "bericht") {
					
					// ++++ absolutes setzen des Gleitzeitstandes
					if ($listenzeile ["fiTaetigkeit"] == $standard_taetigkeit_gleitzeitstandaenderung_absolut) {
						
						// ++++ eine Gleitzeitnderung am Ende des Zeitraumes ggf. nicht dazuzhlen!
						if (! ($ziel == "bericht_zeitraum_ende" and $listenzeile ["dtDatum"] == $datum_bis)) {
							$absoluteaenderung = "ja";
							$neuegleitzeit = stdmin_to_min ( $listenzeile ["dtVergueteZeit"] );
						}
					}
					
					// ++++ setzen des Gleitzeitstandes (ausser bei Dienstreisen)
					if ($listenzeile ["fiTaetigkeit"] != $standard_taetigkeit_dienstreise) {
						$verguetezeit = $verguetezeit + stdmin_to_min ( $listenzeile ["dtVergueteZeit"] );
					} else {
						$sollzeitmin = 0;
					}
					
					// Berechnungen ohne nderungen (fr Bericht)
				} else {
					
					if ($listenzeile ["fiTaetigkeit"] != $standard_taetigkeit_gleitzeitstandaenderung_relativ and $listenzeile ["fiTaetigkeit"] != $standard_taetigkeit_urlaubsstandaenderung_relativ and $listenzeile ["fiTaetigkeit"] != $standard_taetigkeit_gleitzeitstandaenderung_absolut and $listenzeile ["fiTaetigkeit"] != $standard_taetigkeit_urlaubsstandaenderung_absolut) {
						if ($listenzeile ["fiTaetigkeit"] != $standard_taetigkeit_dienstreise) {
							$verguetezeit = $verguetezeit + stdmin_to_min ( $listenzeile ["dtVergueteZeit"] );
						} else {
							$sollzeitmin = 0;
						}
					}
				}
			}
		}
		
		// ++++ die letzte Zeit muss noch zur Gleitzeit hinzugezhlt werden
		if ($anzahl != 0) {
			if ($absoluteaenderung == "ja") {
				
				$gleitzeitmin = $neuegleitzeit;
				$absoluteaenderung = "nein";
			} else {
				$gleitzeitmin = $gleitzeitmin + ($verguetezeit - $sollzeitmin);
			}
		}
		
		return ($gleitzeitmin);
	}
}

// ***************************************************************************************************
// ************************************* get_urlaubsstand ***********************************************
// Urlaubsstand eines Mitarbeiters in einem Zeitraum berechnen

if (! function_exists ( "get_urlaubsstand" )) {
	function get_urlaubsstand($mitarbeiternr, $datum_von, $datum_bis, $ziel = "") {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		extract ( exportiereKonfiguration () );
		include ($GLOBALS ['include_prefix'] . "$functionsordner_custom/function_custom_pre.php");
		include ($GLOBALS ['include_prefix'] . "$functionsordner/function_sql_query.php");
		include ($GLOBALS ['include_prefix'] . "$functionsordner_custom/function_custom_post.php");
		
		$urlaubsstand = 0;
		
		// +++++++++++ SQL Abfrage der Liste
		$query = "select * from $tblprojektzeiten ";
		$query = $query . "where fiMitarbeiter = $mitarbeiternr ";
		$query = $query . "and to_days(dtDatum) >= to_days('$datum_von') ";
		$query = $query . "and to_days(dtDatum) <= to_days('$datum_bis') ";
		$query = $query . "order by dtDatum, dtBeginnZeit desc";
		
		$anzahl = get_table_count ( $query );
		$liste = get_table_array ( $query );
		
		if (count ( $liste ) != 0) {
			foreach ( $liste as $listenzeile_id => $listenzeile ) {
				
				// ++++ normaler Urlaubstag
				if ($listenzeile ["fiTaetigkeit"] == $standard_taetigkeit_urlaub) :
					$urlaubsstand = $urlaubsstand - 1;
								

				// ++++ halber Urlaubstag
				elseif ($listenzeile ["fiTaetigkeit"] == $standard_taetigkeit_urlaubhalbertag) :
					$urlaubsstand = $urlaubsstand - 0.5;
								

				// ++++ nderung des Urlaubsstandes (differenz)
				elseif ($listenzeile ["fiTaetigkeit"] == $standard_taetigkeit_urlaubsstandaenderung_relativ and $ziel != "bericht") :
					$urlausstandbemerkung = explode ( " ", $listenzeile ["dtBemerkungProjektzeit"] );
					$urlaubsstand = $urlaubsstand + double_to_sql ( $urlausstandbemerkung [5] );
								

				// ++++ nderung des Urlaubsstandes (absolut)
				elseif ($listenzeile ["fiTaetigkeit"] == $standard_taetigkeit_urlaubsstandaenderung_absolut and $ziel != "bericht") :
					
					$urlausstandbemerkung = explode ( " ", $listenzeile ["dtBemerkungProjektzeit"] );
					
					if ($urlausstandbemerkung [10]) {
						if ($urlausstandbemerkung [10] != $urlaubsstand) {
							$urlaubsstand = double_to_sql ( $urlausstandbemerkung [8] + $urlaubsstand );
						}
					} else
						$urlaubsstand = double_to_sql ( $urlausstandbemerkung [5] );
				

				endif;
			}
		}
		
		return ($urlaubsstand);
	}
}

// ***************************************************************************************************
// ************************************* standardpause ***********************************************
//
// berechnet die Standard-Pause zwischen Startzeit und Endzeit, wenn keine dedizierten Pausen vorgegeben wurden

if (! function_exists ( "standardpause" )) {
	function standardpause($mitarbeiternr, $beginnzeit, $endezeit) {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		extract ( exportiereKonfiguration () );
		include ($GLOBALS ['include_prefix'] . "$functionsordner_custom/function_custom_pre.php");
		include ($GLOBALS ['include_prefix'] . "$functionsordner/function_sql_query.php");
		include ($GLOBALS ['include_prefix'] . "$functionsordner_custom/function_custom_post.php");
		
		$fruehstueck_von_min = stdmin_to_min ( $fruehstueck_von );
		$fruehstueck_bis_min = stdmin_to_min ( $fruehstueck_bis );
		$mittagspause_von_min = stdmin_to_min ( $mittagspause_von );
		$mittagspause_bis_min = stdmin_to_min ( $mittagspause_bis );
		
		$fruehstueck_schwelle_min = stdmin_to_min ( $fruehstueck_schwelle );
		$mittagspause_schwelle_min = stdmin_to_min ( $mittagspause_schwelle );
		
		// ++++ mindestens lnger als Kurzarbeitszeit anwesend
		if (($endezeit - $beginnzeit) >= $kurzarbeit) :
			
			// ++++ anwesend whrend der Frhstckszeit
			if ($beginnzeit <= $fruehstueck_von_min and $endezeit >= $fruehstueck_schwelle_min) {
				$pause = $pause + $fruehstueck_standard;
			} elseif ($beginnzeit <= $fruehstueck_schwelle_min and $endezeit >= $fruehstueck_bis_min) {
				$pause = $pause + $fruehstueck_standard;
			}
			
			// ++++ anwesend whrend der Mittagszeit
			if ($beginnzeit <= $mittagspause_von_min and $endezeit >= $mittagspause_schwelle_min) {
				$pause = $pause + $mittagspause_standard;
			} elseif ($beginnzeit <= $mittagspause_schwelle_min and $endezeit >= $mittagspause_bis_min) {
				$pause = $pause + $mittagspause_standard;
			}
		
		
		
			
			endif;
		
		// ++++ Wenn der Mitarbeiter auf Teilzeitbasis arbeitet, dann grundstzlich keine Pause anrechnen
		$query = $sql_query ["personaldatenliste"] . " and fiKontaktNr = " . $mitarbeiternr;
		$mitarbeiter_row = get_table_row ( $query );
		
		if ($mitarbeiter_row ["dtTeilzeit"] != 0) :
			$pause = 0;
		
		
		
			endif;
		
		return ($pause);
	}
}

// ***************************************************************************************************
// ************************************* pausenberechnung ********************************************
//
// berechnet die Pausen zwischen zwei Stempelzeiten und setzt ggf Standardpausen

if (! function_exists ( "pausenberechnung" )) {
	function pausenberechnung($mitarbeiternr, $datum, $beginn, $ende) {
		include ($GLOBALS ['include_prefix'] . "config/config.php");
		extract ( exportiereKonfiguration () );
		include ($GLOBALS ['include_prefix'] . "$functionsordner_custom/function_custom_pre.php");
		include ($GLOBALS ['include_prefix'] . "$functionsordner/function_sql_query.php");
		include ($GLOBALS ['include_prefix'] . "$functionsordner_custom/function_custom_post.php");
		
		$fruehstueck_von_min = stdmin_to_min ( $fruehstueck_von );
		$fruehstueck_bis_min = stdmin_to_min ( $fruehstueck_bis );
		$mittagspause_von_min = stdmin_to_min ( $mittagspause_von );
		$mittagspause_bis_min = stdmin_to_min ( $mittagspause_bis );
		
		$fruehstueck_schwelle_min = stdmin_to_min ( $fruehstueck_schwelle );
		$mittagspause_schwelle_min = stdmin_to_min ( $mittagspause_schwelle );
		
		$beginn_zeit = min_to_stdmin ( $beginn ) . ":00";
		$ende_zeit = min_to_stdmin ( $ende ) . ":00";
		
		// ++++ Wenn der Mitarbeiter auf Teilzeitbasis arbeitet, dann grundstzlich keine automatischen Pausen anrechnen
		$query = $sql_query ["personaldatenliste"] . " and fiKontaktNr = " . $mitarbeiternr;
		$mitarbeiter_row = get_table_row ( $query );
		if ($mitarbeiter_row ["dtTeilzeit"] != 0) {
			$standardpausen_anrechnen = 0;
		} else {
			$standardpausen_anrechnen = 1;
		}
		
		// ++++ suche alle Stempelzeiten des Kartenlesers im Zeitbereich dieses Mitarbeiters
		$query = $sql_query ["stempelzeitenliste"] . " and fiMitarbeiter = " . $mitarbeiternr . " and dtDatum = '$datum' ";
		$query .= "and (dtGeraet = 'RFID-Leser_1' or dtGeraet = 'RFID-Leser_2') and dtUhrzeit >= '$beginn_zeit' and dtUhrzeit <= '$ende_zeit' order by dtUhrzeit";

		$anzahl = get_table_count ( $query );
		
		// ++++ bestimme die Anzahl der Pausen aus der Anzahl der Stempelungen
		$anzahl_pausen = ( int ) (($anzahl - 1) / 2);
		
		// ++++ die erste Stempelung ist der Beginn, dann immer zwei Stempelungen pro Pause
		if ($anzahl_pausen > 0) :
			
			$liste = get_table_array ( $query );
			$listecounter = 0;
			
			// $beginn_row = mysql_fetch_row($result);
			$beginn_row = $liste [$listecounter ++];
			$beginnzeit = stdmin_to_min ( $beginn_row ["dtUhrzeit"] );
			
			for($n = 1; $n <= $anzahl_pausen; $n ++) {
				
				// $pause_beginn_row = mysql_fetch_row($result);
				// $pause_ende_row = mysql_fetch_row($result);
				$pause_beginn_row = $liste [$listecounter ++];
				$pause_ende_row = $liste [$listecounter ++];
				
				$pausebeginn = stdmin_to_min ( $pause_beginn_row ["dtUhrzeit"] );
				$pauseende = stdmin_to_min ( $pause_ende_row ["dtUhrzeit"] );
				
				// ++++ Grundstzlich ist die tatschliche Pause anzurechnen
				$diese_pause = $pauseende - $pausebeginn;
				
				// ++++ es sei denn:
				// ++++ die Pause liegt (ggf. teilweise) innerhalb der Frhstckszeit
				// ++++ und es wurde noch keine Frhstckspause gemacht
				if ($fruehstueckspause == 0) :
					
					if ($pausebeginn >= $fruehstueck_von_min and $pauseende <= $fruehstueck_bis_min) :
						$fruehstueckspause = 1;
					
					
					
				endif;
					
					if ($pausebeginn <= $fruehstueck_von_min and ($pauseende - $fruehstueck_von_min) >= $fruehstueck_standard) :
						$fruehstueckspause = 1;
					
					
					
				endif;
					
					if ($pauseende >= $fruehstueck_bis_min and ($fruehstueck_bis_min - $pausebeginn) >= $fruehstueck_standard) :
						$fruehstueckspause = 1;
					
					
					
				endif;
					
					if ($fruehstueckspause == 1 and ($pauseende - $pausebeginn) < $fruehstueck_standard) :
						$diese_pause = $fruehstueck_standard;
					
					
					
				endif;
				
				
				  
				
				endif;
				
				// ++++ die Pause liegt (ggf. teilweise) innerhalb der Mittagszeit
				// ++++ und es wurde noch keine Mittagsspause gemacht
				if ($mittagspause == 0) :
					
					if ($pausebeginn >= $mittagspause_von_min and $pauseende <= $mittagspause_bis_min) :
						$mittagspause = 1;
					
					
					
					endif;
					
					if ($pausebeginn <= $mittagspause_von_min and ($pauseende - $mittagspause_von_min) >= $mittagspause_standard) :
						$mittagspause = 1;
					
					
					
					endif;
					
					if ($pauseende >= $mittagspause_bis_min and ($mittagspause_bis_min - $pausebeginn) >= $mittagspause_standard) :
						$mittagspause = 1;
					
					
					
					endif;
					
					if ($mittagspause == 1 and ($pauseende - $pausebeginn) < $mittagspause_standard) :
						$diese_pause = $mittagspause_standard;
					
					
					
					endif;
				
				
				
					
					endif;
				
				$pause = $pause + $diese_pause;
				$diese_pause = 0;
			}
		
		
		
		
		endif;
		
		// ++++ Wenn eine Endezeit gesetzt ist, dann berechne auch ggf. Standardpausen hinzu
		// ++++ Endezeit ist gegeben, wenn es eine gerade Anzahl an Stempelungen gibt
		if (($anzahl % 2) == 0 and $standardpausen_anrechnen == 1) :
			
			// ++++ mindestens lnger als Kurzarbeitszeit anwesend
			if ($ende != 0 and ($ende - $beginn) >= $kurzarbeit) :
				
				// ++++ anwesend whrend der Frhstckszeit
				if ($fruehstueckspause == 0 and $beginn <= $fruehstueck_von_min and $ende >= $fruehstueck_schwelle_min) {
					$pause = $pause + $fruehstueck_standard;
				} elseif ($fruehstueckspause == 0 and $beginn <= $fruehstueck_schwelle_min and $ende >= $fruehstueck_bis_min) {
					$pause = $pause + $fruehstueck_standard;
				}
				
				// ++++ anwesend whrend der Mittagszeit
				if ($mittagspause == 0 and $beginn <= $mittagspause_von_min and $ende >= $mittagspause_schwelle_min) {
					$pause = $pause + $mittagspause_standard;
				} elseif ($mittagspause == 0 and $beginn <= $mittagspause_schwelle_min and $ende >= $mittagspause_bis_min) {
					$pause = $pause + $mittagspause_standard;
				}
			
			
			
				
				endif;
		
		
		
				
				endif;
		
		return ($pause);
	}
}

// ***************************************************************************************************
// ************************************* berstundenberechnung ********************************************
// berechnet automatisch die berstunden eines Projektzeiteneintrages

if (! function_exists ( "ueberstundenberechnung_auto" )) {
	function ueberstundenberechnung_auto($projektzeitenid, $aPZRow = "", $bAZRelevant = true, $bPZRelevant = true) {
		global $sql_query, $tblprojektzeiten, $tblueberstunden;
		
		// include ($GLOBALS['include_prefix']."config/config.php");
		// extract(exportiereKonfiguration());
		// include ($GLOBALS['include_prefix']."$functionsordner_custom/function_custom_pre.php");
		// include ($GLOBALS['include_prefix']."$functionsordner/function_sql_query.php");
		// include ($GLOBALS['include_prefix']."$functionsordner_custom/function_custom_post.php");
		
		// ++++ hole Projektzeiteneintrag
		if ($aPZRow == "") {
			$query = $sql_query ["projektzeitenliste"] . " and $tblprojektzeiten.id = " . $projektzeitenid;
			$aPZRow = get_table_row ( $query );
		}
		
		// ++++ zunchst alle berstunden lschen
		delete_all_from_table ( $tblueberstunden, "fiProjektzeit", $projektzeitenid );
		
		// ++++ dann berstunden neu erzeugen
		$query = $sql_query ["ueberstundensaetzeliste"];
		
		// prfe auf passenden Tag
		$datum = split_date ( $aPZRow ["dtDatum"] );
		
		// Ist der Tag ein Feiertag, darf nur der Feiertagszuschlag berechnet werden
		if(check_feiertag ( $datum ["tag"], $datum ["monat"], $datum ["jahr"] )) 
		{
			$query .= " AND dtKuerzel LIKE 'Ft'";
		}
		
		$liste = get_table_array ( $query );
		
		if (count ( $liste ) != 0) {
			foreach ( $liste as $listenzeile_id => $ueberstundensatz_field ) {
				
				$satz_greift = 0;
				

				$wochentagnummer = weekdaynumber_from_date ( $aPZRow ["dtDatum"] );
				$wochentag_array = array (
						1 => "dtMontag",
						2 => "dtDienstag",
						3 => "dtMittwoch",
						4 => "dtDonnerstag",
						5 => "dtFreitag",
						6 => "dtSamstag",
						7 => "dtSonntag" 
				);
				if ($ueberstundensatz_field [$wochentag_array [$wochentagnummer]] == 1 or (check_feiertag ( $datum ["tag"], $datum ["monat"], $datum ["jahr"] ) != "" and $ueberstundensatz_field ["dtFeiertag"] == 1)) {
					$satz_greift ++;
				}
				
				// prfe auf passenden Zeitbereich
				if ($bAZRelevant) {
					$p_von = stdmin_to_min ( $aPZRow ["dtBeginnZeit"] );
					$p_bis = stdmin_to_min ( $aPZRow ["dtEndeZeit"] );
					$ustd_von = stdmin_to_min ( $ueberstundensatz_field ["dtZeitVon"] );
					$ustd_bis = stdmin_to_min ( $ueberstundensatz_field ["dtZeitBis"] );
					
					if (($p_von > $p_bis and $p_von <= $ustd_von) or ($p_von < $p_bis and $p_von <= $ustd_von and $p_bis >= $ustd_von) or ($p_von < $p_bis and $p_von <= $ustd_bis and $p_bis >= $ustd_bis) or ($p_von <= $p_bis and $p_von >= $ustd_von and $p_bis <= $ustd_bis)) {
						$satz_greift ++;
					}
				} else {
					$satz_greift ++;
				}
				
				// prfe auf passende Projektzeit
				if ($bPZRelevant) {
					if ($ueberstundensatz_field ["dtProjektzeitDez"] == "" or $aPZRow ["dtProjektzeitDezimalBericht"] > $ueberstundensatz_field ["dtProjektzeitDez"]) {
						$satz_greift ++;
					}
				} else {
					$satz_greift ++;
				}
				
				// berechne Anzahl der berstunden, wenn ein berstundensatz greift
				if ($satz_greift == 3) {
					
					if ($p_von > $p_bis) {
						$p_bis = 1439;
					}
					;
					
					$ueberstundenrelevante_arbeitszeit = min ( $p_bis, $ustd_bis ) - max ( $p_von, $ustd_von );
					$ueberstundenrelevante_projektzeit = ($aPZRow ["dtProjektzeitDezimalBericht"] * 60) - ($ueberstundensatz_field ["dtProjektzeitDez"] * 60);
					
					$ustd = 0;
					if ($bAZRelevant and ! $bPZRelevant) {
						$ustd = $ueberstundenrelevante_arbeitszeit;
					} else if (! $bAZRelevant and $bPZRelevant) {
						$ustd = $ueberstundenrelevante_projektzeit;
					} else {
						$ustd = min ( $ueberstundenrelevante_arbeitszeit, $ueberstundenrelevante_projektzeit );
					}
					
					unset ( $field_new );
					
					if ($ustd != 0) {
						$field_new ["dtBezeichnung"] = $ueberstundensatz_field ["dtBezeichnung"];
						$field_new ["dtKuerzel"] = $ueberstundensatz_field ["dtKuerzel"];
						$field_new ["fiProjektzeit"] = $projektzeitenid;
						$field_new ["dtUeberstundenZeit"] = deztime_from_time ( min_to_stdmin ( $ustd ) );
						$field_new ["dtUeberstundenSatz"] = $ueberstundensatz_field ["dtSatz"];
						
						$us_id = insert_into_table ( $tblueberstunden, $field_new );
						$us_return [$us_id] = $field_new;
					}
				}
			}
		}
		if (is_array ( $us_return ))
			return $us_return;
	}
}

// ***************************************************************************************************
// ************************************* berstundenberechnung ********************************************
// berechnet automatisch die berstunden eines Projektzeiteneintrages

if (! function_exists ( "nachtarbeit_berechnen" )) {
	function nachtarbeit_berechnen($nachtarbeitRow, $nachtarbeitRowF, $listenzeile) {
		Global $tblprojektzeiten;
		
		if ($nachtarbeitRow ["dtBeginnZeit"] != "00:00:00" && $nachtarbeitRow ["dtEndeZeit"] == "00:00:00") {	
			if ($nachtarbeitRowF ["dtBeginnZeit"] != "00:00:00" && $nachtarbeitRowF ["dtEndeZeit"] == "00:00:00") {
				// $sub_row ["Projektzeiten_id"]
				
				unset ( $array );
				// ++++ Startzeit vorhanden...
				$stempelzeit = stdmin_to_min ( $listenzeile ["dtUhrzeit"] );
				$beginn = stdmin_to_min ( $nachtarbeitRow ["dtBeginnZeit"] );
				$ende = stdmin_to_min ( "23:59:00" );
				$pause = stdmin_to_min ( $nachtarbeitRow ["dtPauseZeit"] );
				$zusatz = stdmin_to_min ( $nachtarbeitRow ["dtZusatzZeit"] );
				
				// ++++ Stempelzeit ist Endezeit
				$pause = pausenberechnung ( $listenzeile ["fiMitarbeiter"], $listenzeile ["dtDatum"], $beginn, $ende );
				
				$array ["dtBeginnZeit"] = min_to_stdmin ( $beginn );
				$array ["dtEndeZeit"] = min_to_stdmin ( $ende );
				$array ["dtAnwesendZeit"] = min_to_stdmin ( $ende - $beginn );
				$array ["dtPauseZeit"] = min_to_stdmin ( $pause );
				$array ["dtArbeitsZeit"] = min_to_stdmin ( $ende - $beginn - $pause );
				$array ["dtZusatzZeit"] = min_to_stdmin ( $zusatz );
				$array ["dtVergueteZeit"] = min_to_stdmin ( $ende - $beginn - $pause + $zusatz );
				$array ["fiStempelungBeginn"] = "1";
				$array ["fiStempelungEnde"] = "0";
				
				if ($nachtarbeitRow ["dtProjektzeitAutoManuell"] != 0) {
					$array ["dtProjektzeitDezimal"] = deztime_from_time ( $array ["dtArbeitsZeit"] );
					$array ["dtProjektzeitDezimalBericht"] = $array ["dtProjektzeitDezimal"];
				}
				
				update_into_table ( $tblprojektzeiten, $nachtarbeitRow ["Projektzeiten_id"], $array );
				$erfasst = 1;
				echo " <br>aktualisiere Projektzeit Nachtarbeit ID " . $nachtarbeitRow ["Projektzeiten_id"] . ": Arbeitsende RFID-Leser_1";
				
				unset ( $array );
				$stempelzeit = stdmin_to_min ( $listenzeile ["dtUhrzeit"] );
				$beginn = stdmin_to_min ( "00:00:00" );
				$ende = stdmin_to_min ( $nachtarbeitRowF ["dtBeginnZeit"] );
				$pause = stdmin_to_min ( $nachtarbeitRowF ["dtPauseZeit"] );
				$zusatz = stdmin_to_min ( $nachtarbeitRowF ["dtZusatzZeit"] );
				
				// ++++ Stempelzeit ist Endezeit
				$pause = pausenberechnung ( $listenzeile ["fiMitarbeiter"], $listenzeile ["dtDatum"], $beginn, $ende );
				
				$array ["dtBeginnZeit"] = min_to_stdmin ( $beginn );
				$array ["dtEndeZeit"] = min_to_stdmin ( $ende );
				$array ["dtAnwesendZeit"] = min_to_stdmin ( $ende - $beginn );
				$array ["dtPauseZeit"] = min_to_stdmin ( $pause );
				$array ["dtArbeitsZeit"] = min_to_stdmin ( $ende - $beginn - $pause );
				$array ["dtZusatzZeit"] = min_to_stdmin ( $zusatz );
				$array ["dtVergueteZeit"] = min_to_stdmin ( $ende - $beginn - $pause + $zusatz );
				$array ["fiStempelungEnde"] = "1";
				$array ["fiStempelungBeginn"] = "0";
				
				if ($nachtarbeitRowF ["dtProjektzeitAutoManuell"] != 0) {
					$array ["dtProjektzeitDezimal"] = deztime_from_time ( $array ["dtArbeitsZeit"] );
					$array ["dtProjektzeitDezimalBericht"] = $array ["dtProjektzeitDezimal"];
				}
				
				update_into_table ( $tblprojektzeiten, $nachtarbeitRowF ["Projektzeiten_id"], $array );
				$erfasst = 1;
				echo " <br>aktualisiere Projektzeit Nachtarbeit ID " . $nachtarbeitRowF ["Projektzeiten_id"] . ": Arbeitsende RFID-Leser_1";
			}
		}
	}
}

?>
