var db;
var jQT = new $.jQTouch({
	icon: 'functions/ext/iphone/img/icon_iphone.png',
	addGlossToIcon: false,
	startupScreen: 'functions/ext/iphone/img/iphone_startscreen.png',
	preloadImages: [
	                'config/pics/logo.png',
	                'functions/ext/iphone/themes/apple/img/backButton.png',
	                'functions/ext/iphone/themes/apple/img/toolbar.png',
	                'functions/ext/iphone/themes/apple/img/toolButton.png',
	                'functions/ext/iphone/themes/apple/img/blueButton.png',
	                'functions/ext/iphone/themes/apple/img/whiteButton.png',
	                'functions/ext/iphone/themes/apple/img/loading.gif',
	                'functions/ext/iphone/themes/apple/img/listArrowSel.png'
	                ]
});

$(function() {
	opendb('zeiterfassung','1.0','conceptERP Zeiterfassung',65536);
	readZugangsdaten();

	$('.eintragListeProjekte').click(function(evt, data) {                
		auswaehlenInListe(this, 'projekte');
	});

	$('.eintragListeKunden').click(function(evt, data) {                
		auswaehlenInListe(this, 'kunden');
	});

	$('.eintragListeTaetigkeiten').click(function(evt, data) {                
		auswaehlenInListe(this, 'taetigkeiten');
	});

	$('#formular').submit(function(evt, data) {                
		kopiereWerteInForm();

		if(!validiereFormular()) {
			return false;
		}
	});
	
	$('#buttonAdd').click(function(evt,data) {
		setFormularTitel('Neu');
		
		document.getElementById('eintragId').value = '';
		document.getElementById('formularButtonLoeschen').style.display = 'none';
	});

	$('#einstellungen').submit(function(evt, data) {
		setZugangsdaten(document.getElementById('benutzername').value, document.getElementById('passwort').value);
		jQT.goBack();
		alert("Bitte die App schliessen und erneut starten!");
		return false;
	});
});

function createTables(db) {
	db.transaction(
			function (transaction) {
				transaction.executeSql('CREATE TABLE IF NOT EXISTS zeiterfassung (benutzername TEXT NOT NULL, passwort TEXT NOT NULL);', [], nullDataHandler, errorHandler);
			}
	);
}

function readZugangsdaten() {
	db.transaction(
			function (transaction) {
				transaction.executeSql("SELECT * FROM zeiterfassung;", [], dataHandler, errorHandler);
			}
	)
}

function nullDataHandler(transaction, results) {
}

function errorHandler(transaction,error) {
	alert('Fehler: '+error.message);
}

function setZugangsdaten(benutzername, passwort) {
	db.transaction(function(transaction){
		transaction.executeSql('DELETE FROM zeiterfassung;', [], nullDataHandler, errorHandler);
	});

	db.transaction(function(transaction){
		var query = 'INSERT INTO zeiterfassung (benutzername, passwort) VALUES ( "' + benutzername + '", "' + passwort + '");';
		transaction.executeSql(query, [], nullDataHandler, errorHandler);
	});

	readZugangsdaten();
}

function opendb(shortname, version, displayName, expectedSize) {
	try {
		if (!window.openDatabase) {
			alert('Kein HTML5 Database Storage mglich!');
		} else {
			db = openDatabase(shortname, version, displayName, expectedSize);
			createTables(db);
		}
	} 
	catch (e) {
		alert("Unbekannter Fehler " + e + ".");
		return false;
	}
}

function dataHandler(transaction,results) {
	for (var i=0; i<results.rows.length; i++) {
		var row = results.rows.item(i);

		if(row['benutzername'].length > 0) {
			document.getElementById('benutzername').value = row['benutzername'];
		}

		if(row['passwort'].length > 0) {
			document.getElementById('passwort').value = row['passwort'];
		}
		
		writeZugangsdatenIntoCookie(row['benutzername'], row['passwort']);
		
		break;
	}
}

function trim (zeichenkette) {
	// Erst fhrende, dann Abschlieende Whitespaces entfernen
	// und das Ergebnis dieser Operationen zurckliefern
	return zeichenkette.replace (/^\s+/, '').replace (/\s+$/, '');
}

function sucheInListe(suchText, rootObj)
{
	objekte = rootObj.getElementsByTagName("li");

	for(i = 0; i < objekte.length; i++) {		
		text = objekte[i].innerText.toLowerCase();
		if(text.indexOf(suchText.toLowerCase()) >= 0 || suchText.length == 0)
		{
			objekte[i].style.display = 'block';
		}
		else
		{
			objekte[i].style.display = 'none';
		}
	}
}

var projekt = "";
var taetigkeit = "";
var kunde = "";

function auswaehlenInListe(obj, typ)
{
	id = obj.getAttribute('eintragId');

	switch(typ) {
	case "projekte":
		projekt = id;
		setTextProjekte(obj.innerText);
		break;

	case "taetigkeiten":
		taetigkeit = id;
		setTextTaetigkeiten(obj.innerText);
		break;

	case "kunden":
		kunde = id;
		setTextKunden(obj.innerText);
		break;
	}

	jQT.goBack();
}

function setTextKunden(text)
{
	document.getElementById('anzeigeKunden').innerText = text;
}

function setTextProjekte(text)
{
	document.getElementById('anzeigeProjekte').innerText = text;
}

function setTextTaetigkeiten(text)
{
	document.getElementById('anzeigeTaetigkeiten').innerText = text;
}

function setFormularTitel(text)
{
	document.getElementById('formularTitel').innerText = text;
}



function kopiereWerteInForm()
{
	document.getElementById('formProjekt').value = projekt;
	document.getElementById('formTaetigkeit').value = taetigkeit;
	document.getElementById('formKunde').value = kunde;
}

function validiereFormular()
{
	if(trim(document.getElementById('benutzername').value) == '' || trim(document.getElementById('passwort').value) == '')
	{
		alert("Keine Zugangsdaten eingetragen!");
		return false;
	}

	if(taetigkeit == 0 || taetigkeit == "")
	{
		alert("Bitte whlen Sie eine Ttigkeit aus!");
		return false;
	}

	return true;
}

function editieren(projektAnzeige, kundeAnzeige, taetigkeitAnzeige, datum, beginn, ende, erlaeuterung, projektId, kundeId, taetigkeitId, id)
{
	projekt = projektId;
	taetigkeit = taetigkeitId;
	kunde = kundeId;

	setTextKunden(kundeAnzeige);
	setTextProjekte(projektAnzeige);
	setTextTaetigkeiten(taetigkeitAnzeige);

	document.getElementById('formDatum').value = datum;
	document.getElementById('formBeginnzeit').value = beginn;
	document.getElementById('formEndezeit').value = ende;
	document.getElementById('formBeschreibung').value = erlaeuterung;
	document.getElementById('eintragId').value = id;
	document.getElementById('formularButtonLoeschen').style.display = 'block';
	document.getElementById('formularButtonLoeschen').href = 'zeiterfassung_iphone.php?delete=' + id;
	
	setFormularTitel('Bearbeiten');
	jQT.goTo('#formular', 'slide');
}

function writeZugangsdatenIntoCookie(benutzername, passwort)
{
	setCookie("login", benutzername + ':::' + passwort, 1);
}

function setCookie( name, value, expires, path, domain, secure ) {
	var today = new Date();
	today.setTime( today.getTime() );
	if ( expires ) {
		expires = expires * 1000 * 60 * 60 * 24;
	}
	var expires_date = new Date( today.getTime() + (expires) );
	document.cookie = name+'='+escape( value ) +
		( ( expires ) ? ';expires='+expires_date.toGMTString() : '' ) + //expires.toGMTString()
		( ( path ) ? ';path=' + path : '' ) +
		( ( domain ) ? ';domain=' + domain : '' ) +
		( ( secure ) ? ';secure' : '' );
}