<?php
require_once ("functions/init.php");
require_once ("rechteverwaltung.php");
require_once ("functions/ext/Payment_Sepa/sepaexport.php");

$filter = $_SESSION ["dtausexport_filter"];
unset ( $_SESSION ["dtausexport_filter"] );
$sortierung = $_SESSION ["dtausexport_sortierung"];
unset ( $_SESSION ["dtausexport_sortierung"] );

$listenname = "belege";
$bk = $_POST ["bk"];
$iban = $_POST ["iban"];
$bic = $_POST ["bic"];
$glaeubigerid = $_POST ["glaeubigerid"];
$sDebitDate = $_POST ["txtDebitDate"];

if ($bk != "") {
	// Bankkonto bestimmen
	$query = $sql_query ["bankkontenliste"] . " AND id = " . $bk;
	$bankkonto_row = get_table_row ( $query );
}

$sDownloadTyp = "sepa";

// **********************************************************************************************************
$query = $sql_query ["belegliste"];
$anzahl_gesamt = get_table_count ( $query );

// Belegstatusfilter
if (is_array ( $filter [$listenname] ["belegstatus"] )) {
	$query .= filter_multiselect_return_query ( $filter [$listenname] ["belegstatus"], "$tblbelege.fiStatus" );
} else {
	$query .= " and $tblbelege.fiStatus < 900 ";
}
$iQueryLaenge = strlen ( $query );

if ($benutzerrechte [$target] ["zugriffsart"] == 1) {
	$query .= " and " . $sql_rechte_referer [$target] [$benutzerrechte [$target] ["zugriffsart"]] . " = " . $_SESSION ["benutzerkontaktid"] . " ";
}

// Kundefilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["kunde"], "$tblbelege.fiKunde" );

// Endkunde
$query .= filter_multiselect_return_query ( $filter [$listenname] ["endkunde"], "$tblbelege.fiEndkunde" );

// Projektfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["projekt"], "$tblbelege.fiProjekt" );

// Autorfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["autor"], "$tblbelege.fiBelegAutor" );

// Beleg Verantwortlicher
$query .= filter_multiselect_return_query ( $filter [$listenname] ["belegverantwortlicher"], "$tblbelege.fiBelegVerantwortlicher" );

// Zahlartfilter
$query .= filter_multiselect_return_query ( $filter [$listenname] ["zahlart"], "$tblbelege.fiZahlart" );

// Datumsbereich
if ($filter [$listenname] ["datumsbereich"] != "") {
	
	$datum_explode = explode ( "-", $filter [$listenname] ["datumsbereich"] );
	$datum_tag_von = $datum_explode [0];
	$datum_monat_von = $datum_explode [1];
	$datum_jahr_von = $datum_explode [2];
	$datum_tag_bis = $datum_explode [3];
	$datum_monat_bis = $datum_explode [4];
	$datum_jahr_bis = $datum_explode [5];
	
	if (! ($datum_tag_von == 1 and $datum_monat_von == 1 and $datum_jahr_von == 1970) and ! ($datum_tag_von == "" and $datum_monat_von == "" and $datum_jahr_von == "")) {
		$query .= " and (dtAnzeigeDatum <> '2030-01-01' and to_days(dtAnzeigeDatum) >= to_days('" . concat_date ( $datum_tag_von, $datum_monat_von, $datum_jahr_von ) . "'))";
	}
	
	if (! ($datum_tag_bis == 1 and $datum_monat_bis == 1 and $datum_jahr_bis == 2030) and ! ($datum_tag_bis == "" and $datum_monat_bis == "" and $datum_jahr_bis == "")) {
		$query .= " and (dtAnzeigeDatum <> '2030-01-01' and to_days(dtAnzeigeDatum) <= to_days('" . concat_date ( $datum_tag_bis, $datum_monat_bis, $datum_jahr_bis ) . "'))";
	}
}

if ($listePosten) {
	$query2 .= $query . $queryPosten;
	$query .= create_fulltext_index_search ( array (
			$tblbelege,
			$tblkontakte 
	), $filter [$listenname] ["textfilter"] );
} else {
	// Volltextsuche
	$query .= create_fulltext_index_search ( array (
			$tblbelege,
			$tblkontakte 
	), $filter [$listenname] ["textfilter"] );
}
// wenn es eine Sortierung gibt, dann fge sie dem SQL-String hinzu
if ($sortierung [$listenname] ["feldname"] != "") {
	$sortierung_sql = " order by " . $sortierung [$listenname] ["feldname"] . " " . $sortierung [$listenname] ["richtung"];
	if ($sortierung [$listenname] ["feldname2"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname2"] . " " . $sortierung [$listenname] ["richtung2"];
	}
	if ($sortierung [$listenname] ["feldname3"] != "") {
		$sortierung_sql .= ", " . $sortierung [$listenname] ["feldname3"] . " " . $sortierung [$listenname] ["richtung3"];
	}
} else {
	$sortierung_sql = "";
}

// wenn es eine Limitierung der Liste gibt, dann fge sie dem SQL-String hinzu
if (! (array_key_exists ( "anzahl", ( array ) $sortierung [$listenname] ))) {
	$sortierung [$listenname] ["anzahl"] = 50;
	$sortierung [$listenname] ["position"] = 1;
}
;
if ($sortierung [$listenname] ["anzahl"] != "") {
	$limit_sql = " limit " . ($sortierung [$listenname] ["position"] - 1) . "," . $sortierung [$listenname] ["anzahl"];
} else {
	$limit_sql = "";
	$sortierung [$listenname] ["anzahl"] = "";
}

$anzahl_ausgabe = get_table_count ( $query );
$query .= $sortierung_sql . $limit_sql;
$liste = get_table_array ( $query );

// Payment_DTA
$dta_file = new DTA ( DTA_CREDIT );

$creator = new SepaXmlCreator ();
$creator->setAccountValues ( $bankkonto_row ['dtInhaberName'], $iban, $bic );
$creator->setGlaeubigerId ( $glaeubigerid );

$aDebitDate = split_date_us ( $sDebitDate );
$dCollectionDate = concat_date ( $aDebitDate ["tag"], $aDebitDate ["monat"], $aDebitDate ["jahr"] );
if ($dCollectionDate < $aktdatum)
	$dCollectionDate = $aktdatum;

$datetime1 = date_create ( $dCollectionDate );
$datetime2 = date_create ( $aktdatum );
$interval = date_diff ( $datetime1, $datetime2 );

$creator->setAusfuehrungOffset ( $interval->format ( '%a' ) );

if (count ( $liste ) != 0) {
	foreach ( $liste as $listenzeile_id => $listenzeile ) {
		
		if ($_POST ["exportieren_" . $listenzeile ["Beleg_id"]] == "1" || ! isset ( $listeHaken )) {
			
			// +++++++++++ hole Bilanzdaten
			$bilanz_query = "select * from tblBilanzBelege where fiBeleg = " . $listenzeile ["Beleg_id"];
			$bilanz_row = get_table_row ( $bilanz_query );
			
			$aBelegeUpdate ["dtDatumDTA"] = $aktdatum;
			update_into_table ( $tblbelege, $listenzeile ["Beleg_id"], $aBelegeUpdate );
			
			// Leerzeichen filtern
			$listenzeile ['dtBankBIC'] = str_replace ( " ", "", $listenzeile ['dtBankBIC'] );
			$listenzeile ['dtBankIBAN'] = str_replace ( " ", "", $listenzeile ['dtBankIBAN'] );
			$listenzeile ['dtGlaeubigerID'] = str_replace ( " ", "", $listenzeile ['dtGlaeubigerID'] );
			
			if (strlen ( $listenzeile ['dtFirmenname'] ) > 0 && strlen ( $listenzeile ['dtBankIBAN'] ) > 0 && strlen ( $listenzeile ['dtBankBIC'] ) > 0 && strlen ( $listenzeile ['dtGlaeubigerID'] ) > 0) {
			}
			
			$fSummeBrutto = $bilanz_row ["dtSummeVerkaufBrutto"];
			
			unset ( $verwendungszweck_suche_array );
			$verwendungszweck_suche_array = array (
					0 => "%%%belegnummer%%%",
					1 => "%%%rechnungsdatum%%%",
					2 => "%%%betrag%%%" 
			);
			
			unset ( $verwendungszweck_ersetz_array );
			$verwendungszweck_ersetz_array = array (
					0 => $listenzeile ["dtBelegNr"],
					1 => date_from_sql ( $listenzeile ["dtRechnungDatum"] ),
					2 => number_format ( $fSummeBrutto, 2, ".", "" ) . "EUR" 
			);
			
			$zweck_zeile1 = str_replace ( $verwendungszweck_suche_array, $verwendungszweck_ersetz_array, $verwendungszweck_sepa_belege_zeile1 );
			$zweck_zeile2 = str_replace ( $verwendungszweck_suche_array, $verwendungszweck_ersetz_array, $verwendungszweck_sepa_belege_zeile2 );
			
			if ($listenzeile ["dtLieferantEigeneKdNr"] != "") {
				$zweck_zeile2 .= " KdNr.: " . $listenzeile ["dtLieferantEigeneKdNr"];
			}
			
			if ($listenzeile ["dtBankdatenAenderung"] == 1) {
				$bMandatChange = true;
				$aKontakteID [$listenzeile ["Kontakte_id"]] = $listenzeile ["Kontakte_id"];
			} else
				$bMandatChange = false;
				
				// Erzeugung einer neuen Buchungssatz
			$buchung = new SepaBuchung ();
			// gewnschter Einzugsbetrag
			$buchung->setBetrag ( number_format ( $fSummeBrutto, 2, ".", "" ) );
			// gewnschte End2End Referenz (OPTIONAL)
			$buchung->setEnd2End ( 'DEB-ID0-' . date ( 'YmdHis', $creationTime ) . rand ( 0, 1000 ) );
			// BIC des Zahlungspflichtigen Institutes
			$buchung->setBic ( $listenzeile ["dtBankBIC"] );
			// Name des Zahlungspflichtigen
			$buchung->setName ( replace_special_character ( $dta_file->makeValidString ( check_input_string ( $listenzeile ['dtKunde_Anzeige'] ) ) ) );
			// IBAN des Zahlungspflichtigen
			$buchung->setIban ( $listenzeile ["dtBankIBAN"] );
			// gewnschter Verwendungszweck (OPTIONAL)
			$buchung->setVerwendungszweck ( replace_special_character ( $dta_file->makeValidString ( ($zweck_zeile1 . " " . $zweck_zeile2) ) ) );
			// Referenz auf das vom Kunden erteilte Lastschriftmandat
			// ID = MANDAT0001
			// Erteilung durch Kunden am 20. Mai 2013
			// False = seit letzter Lastschrift wurde am Mandat nichts gendert
			$buchung->setMandat ( $listenzeile ["dtMandatsreferenz"], $listenzeile ["dtSepaMandatDatum"], $bMandatChange );
			// Buchung zur Liste hinzufgen
			$creator->addBuchung ( $buchung );
		}
	}
}

if ($aKontakteID) {
	foreach ( $aKontakteID as $cpKontakteID ) {
		$aKontakteUpdate ["dtBankdatenAenderung"] = 0;
		
		update_into_table ( $tblkontakte, $cpKontakteID, $aKontakteUpdate );
	}
}

$sDateiSEPA = $tmpoutputordner . "/" . SID . "_SEPA0.xml";
$sNameSEPA = "Lastschrift_" . $aktdatum . ".xml";
$iSessionID = SID;

header ( 'Content-type: text/xml' );
header ( 'Content-Disposition: attachment; filename=' . $sNameSEPA . '' );
print $creator->generateBasislastschriftXml ();

?>