<?php
if (check_link_permission ( "lagerartikel", "neu", $benutzerrechte )) {
	$field_new ["dtNeueArtikelAnlegen"] = ( int ) $field_new ["dtNeueArtikelAnlegen"];
} else {
	$field_new ["dtNeueArtikelAnlegen"] = 0;
}

/*
 * Kopfzeile mit mglichen Feldern abgleichen
 */
$aSpaltenCSV = $aCSV [0];
$iSpaltenCount = count ( $aSpaltenCSV );
unset ( $aCSV [0] );

for($i = 0; $i <= $iSpaltenCount; $i ++) {
	$sTest = preg_replace ( array (
			"%_[0-9][0-9][0-9]_%",
			"%_[0-9][0-9]_%",
			"%_[0-9]_%" 
	), "_1_", $aSpaltenCSV [$i] );
	if (! array_search ( $sTest, $aFelder ) || empty ( $aSpaltenCSV [$i] )) {
		unset ( $aSpaltenCSV [$i] );
	}
}

if (count ( $aSpaltenCSV ) < 1) {
	$f = new Fehler ();
	$f->setCustom ( "Ungltige Importdatei", "Die Importdatei enthlt keine gltigen Kopfdaten!" );
	$f->setNext ( $target, $typ );
	throw ($f);
}

$aSpaltenCSV = array_flip ( $aSpaltenCSV );

foreach ( $aCSV as $aLine ) {
	$iArtikelId = 0;
	$bNeuArtikel = false;
	unset ( $aArtikel );
	
	if (! empty ( $aLine [$aSpaltenCSV ["ArtikelNr"]] )) {
		$aArtikel = get_table_row ( $sql_query ["artikelliste"] . " and $tblartikel.dtEigeneArtikelNr = '" . $aLine [$aSpaltenCSV ["ArtikelNr"]] . "'" );
		$iArtikelId = $aArtikel ["Artikel_id"];
	} else {
		continue;
	}
	
	// erzeuge ggf. neuen Artikel wenn keiner mit dieser Art-Nr. vorhanden ist
	if ($iArtikelId == 0 and $field_new ["dtNeueArtikelAnlegen"] == 1) {
		$bNeuArtikel = true;
		
		$aArtikel = array ();
		$aArtikel ["dtEigeneArtikelNr"] = $aLine [$aSpaltenCSV ["ArtikelNr"]];
		$aArtikel ["dtRabattfaehig"] = $neueartikel_rabattfaehig;
		$aArtikel ["dtMwstSatzVK"] = $stdmwstsatz;
		$aArtikel ["dtArtikelAktiv"] = 1;
	}
	
	/*
	 * Warengruppe
	 */
	if (isset ( $aLine [$aSpaltenCSV ["Warengruppe"]] )) {
		// Warengruppe suchen
		$aWarengruppe = get_table_row ( $sql_query ["warengruppenliste"] . " and $tblwarengruppen.dtWarengruppe LIKE '" . $aLine [$aSpaltenCSV ["Warengruppe"]] . "'" );
		
		if ($aWarengruppe) {
			$aArtikel ["fiWarengruppe"] = $aWarengruppe ["Warengruppe_id"];
		} else {
			$aWarengruppeNeu = array ();
			$aWarengruppeNeu ["dtWarengruppe"] = $aLine [$aSpaltenCSV ["Warengruppe"]];
			$aWarengruppeNeu ["dtWarengruppenBeschreibung"] = "Automatisch bei Artikelimport angelegt.";
			$aArtikel ["fiWarengruppe"] = insert_into_table ( $tblwarengruppen, $aWarengruppeNeu );
		}
	} elseif (empty ( $aArtikel ["fiWarengruppe"] )) {
		$aArtikel ["fiWarengruppe"] = $standard_material_warengruppe;
	}
	
	/*
	 * Einheit
	 */
	if (isset ( $aLine [$aSpaltenCSV ["Verpackungseinheit"]] )) {
		// Einheit suchen
		$aEinheit = get_table_row ( $sql_query ["artikeleinheitenliste"] . " and $tblartikeleinheiten.dtEinheit LIKE '" . $aLine [$aSpaltenCSV ["Verpackungseinheit"]] . "'" );
		
		if ($aEinheit)
			$aArtikel ["fiEinheit"] = $aEinheit ["ArtikelEinheiten_id"];
		else
			$aArtikel ["fiEinheit"] = 1;
	} elseif (empty ( $aArtikel ["fiEinheit"] )) {
		$aArtikel ["fiEinheit"] = 1;
	}
	
	if (isset ( $aArtikel ["dtEigeneArtikelNr"] )) {
		$aArtikel ["dtEigeneArtikelNr"] = artikelnummer_neu ();
	}
	
	$aArtikel ["dtLetzteAenderung"] = date ( "Y-m-d H:i:s" );
	
	/*
	 * Felder des Artikels
	 */
	if (isset ( $aLine [$aSpaltenCSV ["ArtikelNr"]] ))
		$aArtikel ["dtEigeneArtikelNr"] = $aLine [$aSpaltenCSV ["ArtikelNr"]];
	if (isset ( $aLine [$aSpaltenCSV ["Artikel"]] ))
		$aArtikel ["dtArtikel"] = $aLine [$aSpaltenCSV ["Artikel"]];
	if (isset ( $aLine [$aSpaltenCSV ["Fabrikat"]] ))
		$aArtikel ["dtFabrikat"] = $aLine [$aSpaltenCSV ["Fabrikat"]];
	if (isset ( $aLine [$aSpaltenCSV ["EAN"]] ))
		$aArtikel ["dtArtikelEAN"] = $aLine [$aSpaltenCSV ["EAN"]];
	if (isset ( $aLine [$aSpaltenCSV ["Warentarifnummer"]] ))
		$aArtikel ["dtArtikelWarentarifnummer"] = $aLine [$aSpaltenCSV ["Warentarifnummer"]];
	if (isset ( $aLine [$aSpaltenCSV ["Verantwortlicher"]] ))
		$aArtikel ["dtPLZ"] = $aLine [$aSpaltenCSV ["Verantwortlicher"]];
	if (isset ( $aLine [$aSpaltenCSV ["Buchungskonto"]] ))
		$aArtikel ["fiArtikelBuchungsKonto"] = $aLine [$aSpaltenCSV ["Buchungskonto"]];
	if (isset ( $aLine [$aSpaltenCSV ["IstLieferartikel"]] ))
		$aArtikel ["dtArtikelIstLieferartikel"] = ( int ) $aLine [$aSpaltenCSV ["IstLieferartikel"]];
	if (isset ( $aLine [$aSpaltenCSV ["IstProduktionsartikel"]] ))
		$aArtikel ["dtArtikelIstProduktionsartikel"] = ( int ) $aLine [$aSpaltenCSV ["IstProduktionsartikel"]];
	if (isset ( $aLine [$aSpaltenCSV ["VerpackungseinheitStueckzahl"]] ))
		$aArtikel ["dtArtikelEinheitStueckzahl"] = double_to_sql ( $aLine [$aSpaltenCSV ["VerpackungseinheitStueckzahl"]] );
	if (isset ( $aLine [$aSpaltenCSV ["Meldebestand"]] ))
		$aArtikel ["dtArtikelMeldebestand"] = double_to_sql ( $aLine [$aSpaltenCSV ["Meldebestand"]] );
	if (isset ( $aLine [$aSpaltenCSV ["Mindestbestand"]] ))
		$aArtikel ["dtArtikelMindestbestand"] = double_to_sql ( $aLine [$aSpaltenCSV ["Mindestbestand"]] );
	if (isset ( $aLine [$aSpaltenCSV ["IstAktiv"]] ))
		$aArtikel ["dtArtikelAktiv"] = ( int ) $aLine [$aSpaltenCSV ["IstAktiv"]];
	if (isset ( $aLine [$aSpaltenCSV ["IstRabattfaehig"]] ))
		$aArtikel ["dtRabattfaehig"] = ( int ) $aLine [$aSpaltenCSV ["IstRabattfaehig"]];
	if (isset ( $aLine [$aSpaltenCSV ["IstMaximalrabatt"]] ))
		$aArtikel ["dtArtikelMaximalrabatt"] = ( int ) $aLine [$aSpaltenCSV ["IstMaximalrabatt"]];
	if (isset ( $aLine [$aSpaltenCSV ["Rabatt"]] ))
		$aArtikel ["dtArtikelRabatt"] = double_to_sql ( $aLine [$aSpaltenCSV ["Rabatt"]] );
	if (isset ( $aLine [$aSpaltenCSV ["EKAufschlag"]] ))
		$aArtikel ["dtArtikelEKAufschlag"] = double_to_sql ( $aLine [$aSpaltenCSV ["EKAufschlag"]] );
	if (isset ( $aLine [$aSpaltenCSV ["VK1"]] ))
		$aArtikel ["dtPreisVK1"] = double_to_sql ( $aLine [$aSpaltenCSV ["VK1"]] );
	if (isset ( $aLine [$aSpaltenCSV ["VK2"]] ))
		$aArtikel ["dtPreisVK2"] = double_to_sql ( $aLine [$aSpaltenCSV ["VK2"]] );
	if (isset ( $aLine [$aSpaltenCSV ["VK3"]] ))
		$aArtikel ["dtPreisVK3"] = double_to_sql ( $aLine [$aSpaltenCSV ["VK3"]] );
	if (isset ( $aLine [$aSpaltenCSV ["VK4"]] ))
		$aArtikel ["dtPreisVK4"] = double_to_sql ( $aLine [$aSpaltenCSV ["VK4"]] );
	if (isset ( $aLine [$aSpaltenCSV ["VK5"]] ))
		$aArtikel ["dtPreisVK5"] = double_to_sql ( $aLine [$aSpaltenCSV ["VK5"]] );
	if (isset ( $aLine [$aSpaltenCSV ["MwSt"]] ))
		$aArtikel ["dtMwstSatzVK"] = double_to_sql ( $aLine [$aSpaltenCSV ["MwSt"]] );
	if (isset ( $aLine [$aSpaltenCSV ["Beschreibung_1"]] ))
		$aArtikel ["dtBeschreibung"] = $aLine [$aSpaltenCSV ["Beschreibung_1"]];
	if (isset ( $aLine [$aSpaltenCSV ["Beschreibung_2"]] ))
		$aArtikel ["dtBeschreibung2"] = $aLine [$aSpaltenCSV ["Beschreibung_2"]];
	if (isset ( $aLine [$aSpaltenCSV ["Beschreibung_3"]] ))
		$aArtikel ["dtBeschreibung3"] = $aLine [$aSpaltenCSV ["Beschreibung_3"]];
	if (isset ( $aLine [$aSpaltenCSV ["Beschreibung_4"]] ))
		$aArtikel ["dtBeschreibung4"] = $aLine [$aSpaltenCSV ["Beschreibung_4"]];
	if (isset ( $aLine [$aSpaltenCSV ["Beschreibung_5"]] ))
		$aArtikel ["dtBeschreibung5"] = $aLine [$aSpaltenCSV ["Beschreibung_5"]];
	if (isset ( $aLine [$aSpaltenCSV ["BeschreibungZuVKGruppen"]] ))
		$aArtikel ["dtArtikelBeschreibungZuVKGruppen"] = $aLine [$aSpaltenCSV ["BeschreibungZuVKGruppen"]];
	if (isset ( $aLine [$aSpaltenCSV ["IstProvisionsfaehig"]] ))
		$aArtikel ["dtArtikelIstProvisionsfaehig"] = ( int ) $aLine [$aSpaltenCSV ["IstProvisionsfaehig"]];
	if (isset ( $aLine [$aSpaltenCSV ["Provision"]] ))
		$aArtikel ["dtArtikelProvisionProzent"] = double_to_sql ( $aLine [$aSpaltenCSV ["Provision"]] );
	if (isset ( $aLine [$aSpaltenCSV ["IstMaximalprovision"]] ))
		$aArtikel ["dtArtikelIstMaximalprovision"] = ( int ) $aLine [$aSpaltenCSV ["IstMaximalprovision"]];
		
		/*
	 * In Datenbank eintragen
	 */
	if ($bNeuArtikel) {
		$iArtikelId = insert_into_table ( $tblartikel, $aArtikel );
		$iCountNeu ++;
		
		if (function_exists ( "artikelAngelegt" )) {
			artikelAngelegt ( $iArtikelId );
		}
	} else {
		update_into_table ( $tblartikel, $iArtikelId, $aArtikel );
		$iCountUpdate ++;
		
		if (function_exists ( "artikelAktualisiert" )) {
			artikelAktualisiert ( $iArtikelId );
		}
	}
	
	/*
	 * Lieferanten importieren
	 */
	$iCountSub = 1;
	while ( isset ( $aLine [$aSpaltenCSV ["Lieferant_" . $iCountSub . "_Nr"]] ) ) {
		
		// suche Lieferanten-ID
		$aLieferant = get_table_row ( $sql_query ["kontaktliste"] . " and $tblkontakte.dtIstLieferant = 1 and $tblkontakte.dtKontaktNr = '" . $aLine [$aSpaltenCSV ["Lieferant_" . $iCountSub . "_Nr"]] . "'" );
		$iLieferantId = $aLieferant ["Kontakte_id"];
		
		unset ( $aArtikelLieferant );
		$aArtikelLieferant ["fiArtikel"] = $iArtikelId;
		$aArtikelLieferant ["fiLieferant"] = $iLieferantId;
		if (isset ( $aLine [$aSpaltenCSV ["Lieferant_" . $iCountSub . "_ArtNr"]] ))
			$aArtikelLieferant ["dtArtikelNrFremd"] = $aLine [$aSpaltenCSV ["Lieferant_" . $iCountSub . "_ArtNr"]];
		if (isset ( $aLine [$aSpaltenCSV ["Lieferant_" . $iCountSub . "_Anzahl"]] ))
			$aArtikelLieferant ["dtAnzahl"] = $aLine [$aSpaltenCSV ["Lieferant_" . $iCountSub . "_Anzahl"]];
		if (isset ( $aLine [$aSpaltenCSV ["Lieferant_" . $iCountSub . "_Stueckpreis"]] ))
			$aArtikelLieferant ["dtStueckPreisEK"] = double_to_sql ( $aLine [$aSpaltenCSV ["Lieferant_" . $iCountSub . "_Stueckpreis"]] );
		if (isset ( $aLine [$aSpaltenCSV ["Lieferant_" . $iCountSub . "_MwSt"]] ))
			$aArtikelLieferant ["dtMwstSatzEK"] = $aLine [$aSpaltenCSV ["Lieferant_" . $iCountSub . "_MwSt"]];
		
		if ($iLieferantId) {
			// prfe, ob dieser Lieferant schon dem Artikel zugeordnet ist (neu oder update)
			$query = $sql_query ["artikellieferantenliste"];
			$query .= " and $tblartikellieferanten.fiArtikel = '" . $iArtikelId . "'";
			$query .= " and $tblartikellieferanten.fiLieferant = '" . $iLieferantId . "'";
			
			$aCheck = get_table_row ( $query );
			$iArtikelLieferantId = $aCheck ["ArtikelLieferant_id"];
			
			if ($iArtikelLieferantId == "") {
				$iArtikelLieferantId = insert_into_table ( $tblartikellieferanten, $aArtikelLieferant );
			} else {
				update_into_table ( $tblartikellieferanten, $iArtikelLieferantId, $aArtikelLieferant );
			}
		}
		
		$iCountSub ++;
	}
	unset ( $aLieferant );
	unset ( $aArtikelLieferant );
	
	/*
	 * Hersteller importieren
	 */
	$iCountSub = 1;
	while ( isset ( $aLine [$aSpaltenCSV ["Hersteller_" . $iCountSub . "_Nr"]] ) ) {
		
		// suche Hersteller-ID
		$aHersteller = get_table_row ( $sql_query ["kontaktliste"] . " and $tblkontakte.dtKontaktNr = '" . $aLine [$aSpaltenCSV ["Hersteller_" . $iCountSub . "_Nr"]] . "'" );
		$iHerstellerId = $aHersteller ["Kontakte_id"];
		
		unset ( $aArtikelHersteller );
		$aArtikelHersteller ["fiArtikel"] = $iArtikelId;
		$aArtikelHersteller ["fiHerstellername"] = $iHerstellerId;
		if (isset ( $aLine [$aSpaltenCSV ["Hersteller_" . $iCountSub . "_ArtNr"]] ))
			$aArtikelHersteller ["dtHerstellerArtikelNr"] = $aLine [$aSpaltenCSV ["Hersteller_" . $iCountSub . "_ArtNr"]];
		if (isset ( $aLine [$aSpaltenCSV ["Hersteller_" . $iCountSub . "_ArtName"]] ))
			$aArtikelHersteller ["dtHerstellerArtikelName"] = $aLine [$aSpaltenCSV ["Hersteller_" . $iCountSub . "_ArtName"]];
		if (isset ( $aLine [$aSpaltenCSV ["Hersteller_" . $iCountSub . "_ArtFabrikat"]] ))
			$aArtikelHersteller ["dtHerstellerArtikelFabrikat"] = $aLine [$aSpaltenCSV ["Hersteller_" . $iCountSub . "_ArtFabrikat"]];
		if (isset ( $aLine [$aSpaltenCSV ["Hersteller_" . $iCountSub . "_ArtEAN"]] ))
			$aArtikelHersteller ["dtHerstellerArtikelEAN"] = $aLine [$aSpaltenCSV ["Hersteller_" . $iCountSub . "_ArtEAN"]];
		
		if ($iHerstellerId) {
			// prfe, ob dieser Hersteller schon dem Artikel zugeordnet ist (neu oder update)
			$query = $sql_query ["artikelherstellerliste"];
			$query .= " and $tblartikellieferanten.fiArtikel = '" . $iArtikelId . "'";
			$query .= " and $tblartikellieferanten.fiHerstellername = '" . $iHerstellerId . "'";
			
			$aCheck = get_table_row ( $query );
			$iArtikelHerstellerId = $aCheck ["ArtikelHersteller_id"];
			
			if ($iArtikelHerstellerId == "") {
				$iArtikelHerstellerId = insert_into_table ( $tblartikelhersteller, $aArtikelHersteller );
			} else {
				update_into_table ( $tblartikelhersteller, $iArtikelHerstellerId, $aArtikelHersteller );
			}
		}
		
		$iCountSub ++;
	}
	unset ( $aHersteller );
	unset ( $aArtikelHersteller );
	
	/*
	 * Varianten importieren
	 */
	$iCountSub = 1;
	while ( isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Gruppe"]] ) and isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_ArtNr"]] ) ) {
		
		// suche VariantenGruppe-ID
		$aVariantengruppe = get_table_row ( $sql_query ["artikelvariantengruppenliste"] . " and $tblartikelvariantengruppen.dtGruppenName = '" . $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Gruppe"]] . "'" );
		$iVariantengruppeId = $aVariantengruppe ["Gruppen_id"];
		
		unset ( $aArtikelVariante );
		$aArtikelVariante ["fiArtikel"] = $iArtikelId;
		$aArtikelVariante ["fiArtikelVariantenGruppe"] = $iVariantengruppeId;
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_ArtNr"]] ))
			$aArtikelVariante ["dtArtikelVariantenNr"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_ArtNr"]];
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Name"]] ))
			$aArtikelVariante ["dtArtikelVariantenName"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Name"]];
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Beschreibung"]] ))
			$aArtikelVariante ["dtArtikelVariantenBeschreibung1"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Beschreibung"]];
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Beschreibung_1"]] ))
			$aArtikelVariante ["dtArtikelVariantenBeschreibung1"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Beschreibung_1"]];
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Beschreibung_2"]] ))
			$aArtikelVariante ["dtArtikelVariantenBeschreibung2"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Beschreibung_2"]];
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Beschreibung_3"]] ))
			$aArtikelVariante ["dtArtikelVariantenBeschreibung3"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Beschreibung_3"]];
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Beschreibung_4"]] ))
			$aArtikelVariante ["dtArtikelVariantenBeschreibung4"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Beschreibung_4"]];
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Beschreibung_5"]] ))
			$aArtikelVariante ["dtArtikelVariantenBeschreibung5"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Beschreibung_5"]];
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aufpreis_VK1"]] ))
			$aArtikelVariante ["dtArtikelVariantenPreisdiffVK1"] = double_to_sql ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aufpreis_VK1"]] );
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aufpreis_VK2"]] ))
			$aArtikelVariante ["dtArtikelVariantenPreisdiffVK2"] = double_to_sql ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aufpreis_VK2"]] );
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aufpreis_VK3"]] ))
			$aArtikelVariante ["dtArtikelVariantenPreisdiffVK3"] = double_to_sql ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aufpreis_VK3"]] );
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aufpreis_VK4"]] ))
			$aArtikelVariante ["dtArtikelVariantenPreisdiffVK4"] = double_to_sql ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aufpreis_VK4"]] );
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aufpreis_VK5"]] ))
			$aArtikelVariante ["dtArtikelVariantenPreisdiffVK5"] = double_to_sql ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aufpreis_VK5"]] );
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aufpreis_Prozentual"]] )) {
			$aArtikelVariante ["dtArtikelVariantenPreisEinheit"] = ! $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aufpreis_Prozentual"]];
		} else {
			$aArtikelVariante ["dtArtikelVariantenPreisEinheit"] = 1;
		}
		
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aktiv"]] )) {
			$aArtikelVariante ["dtArtikelVarianteAktiv"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Aktiv"]];
		} else {
			$aArtikelVariante ["dtArtikelVarianteAktiv"] = 1;
		}
		
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Meldebestand"]] ))
			$aArtikelVariante ["dtArtikelVariantenMeldebestand"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Meldebestand"]];
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Mindestbestand"]] ))
			$aArtikelVariante ["dtArtikelVariantenMindestbestand"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Mindestbestand"]];
		if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_AnzahlVE"]] ))
			$aArtikelVariante ["dtArtikelVariantenAnzahlVEVerkauf"] = double_to_sql ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_AnzahlVE"]] );
		
		if ($iVariantengruppeId) {
			
			// prfe, ob diese Variante schon dem Artikel zugeordnet ist (neu oder update)
			$query = $sql_query ["artikelvariantenliste"];
			$query .= " and $tblartikelvarianten.fiArtikel = '" . $iArtikelId . "'";
			$query .= " and $tblartikelvarianten.fiArtikelVariantenGruppe = '" . $iVariantengruppeId . "'";
			$query .= " and $tblartikelvarianten.dtArtikelVariantenNr = '" . $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_ArtNr"]] . "'";
			
			$aCheck = get_table_row ( $query );
			$iArtikelVarianteId = $aCheck ["Variante_id"];
			
			if ($iArtikelVarianteId == "") {
				/*
				 * baue neues Array fr Lieferanteninfo und Herstellerinfo
				 */
				unset ( $aHerstellerInfo );
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerID"]] ))
					$aHerstellerInfo ["Hersteller_ID"] = ( int ) $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerID"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtNr"]] ))
					$aHerstellerInfo ["Hersteller_Nr"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtNr"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtName"]] ))
					$aHerstellerInfo ["Hersteller_Name"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtName"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtFabrikat"]] ))
					$aHerstellerInfo ["Hersteller_Fabrikat"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtFabrikat"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtEAN"]] ))
					$aHerstellerInfo ["Hersteller_EAN"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtEAN"]];
				$sHerstellerInfo = serialize ( $aHerstellerInfo );
				$aArtikelVariante ["dtArtikelVarianteHerstellerInfo"] = $sHerstellerInfo;
				
				unset ( $aLieferantenInfo );
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_ID"]] ))
					$aLieferantenInfo ["Lieferant_ID"] = ( int ) $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_ID"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_Bemerkung"]] ))
					$aLieferantenInfo ["Lieferant_Bemerkung"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_Bemerkung"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_ArtNr"]] ))
					$aLieferantenInfo ["Lieferant_Nr"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_ArtNr"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_AnzahlVE"]] ))
					$aLieferantenInfo ["Lieferant_Anzahl"] = double_to_sql ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_AnzahlVE"]] );
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_Stueckpreis"]] ))
					$aLieferantenInfo ["Lieferant_EK"] = double_to_sql ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_Stueckpreis"]] );
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_MwSt"]] ))
					$aLieferantenInfo ["Lieferant_MwSt"] = double_to_sql ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_MwSt"]] );
				$sLieferantenInfo = serialize ( $aLieferantenInfo );
				$aArtikelVariante ["dtArtikelVarianteLieferantenInfo"] = $sLieferantenInfo;
				
				$iArtikelVarianteId = insert_into_table ( $tblartikelvarianten, $aArtikelVariante );
			} else {
				/*
				 * aktualisiere Arrays fr Lieferanteninfo und Herstellerinfo
				 */
				$aHerstellerInfo = unserialize ( $aArtikelVariante ["dtArtikelVarianteHerstellerInfo"] );
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerID"]] ))
					$aHerstellerInfo ["Hersteller_ID"] = ( int ) $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerID"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtNr"]] ))
					$aHerstellerInfo ["Hersteller_Nr"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtNr"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtName"]] ))
					$aHerstellerInfo ["Hersteller_Name"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtName"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtFabrikat"]] ))
					$aHerstellerInfo ["Hersteller_Fabrikat"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtFabrikat"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtEAN"]] ))
					$aHerstellerInfo ["Hersteller_EAN"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_HerstellerArtEAN"]];
				$sHerstellerInfo = serialize ( $aHerstellerInfo );
				$aArtikelVariante ["dtArtikelVarianteHerstellerInfo"] = $sHerstellerInfo;
				
				$aLieferantenInfo = unserialize ( $aArtikelVariante ["dtArtikelVarianteLieferantenInfo"] );
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_ID"]] ))
					$aLieferantenInfo ["Lieferant_ID"] = ( int ) $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_ID"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_Bemerkung"]] ))
					$aLieferantenInfo ["Lieferant_Bemerkung"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_Bemerkung"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_ArtNr"]] ))
					$aLieferantenInfo ["Lieferant_Nr"] = $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_ArtNr"]];
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_AnzahlVE"]] ))
					$aLieferantenInfo ["Lieferant_Anzahl"] = double_to_sql ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_AnzahlVE"]] );
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_Stueckpreis"]] ))
					$aLieferantenInfo ["Lieferant_EK"] = double_to_sql ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_Stueckpreis"]] );
				if (isset ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_MwSt"]] ))
					$aLieferantenInfo ["Lieferant_MwSt"] = double_to_sql ( $aLine [$aSpaltenCSV ["Variante_" . $iCountSub . "_Lieferant_MwSt"]] );
				$sLieferantenInfo = serialize ( $aLieferantenInfo );
				$aArtikelVariante ["dtArtikelVarianteLieferantenInfo"] = $sLieferantenInfo;
				
				update_into_table ( $tblartikelvarianten, $iArtikelVarianteId, $aArtikelVariante );
			}
		}
		
		$iCountSub ++;
	}
	
	unset ( $aVariantengruppe );
	unset ( $aArtikelVariante );
	
	/*
	 * Attribute importieren
	 */
	$iCountSub = 1;
	while ( isset ( $aLine [$aSpaltenCSV ["Attribut_" . $iCountSub . "_Name"]] ) ) {
		
		// suche Attribut-GruppeID
		$aAttribGruppe = get_table_row ( $sql_query ["artikelattributgruppenliste"] . " and $tblartikelattributegruppen.dtAttributGruppeName = '" . $aLine [$aSpaltenCSV ["Attribut_" . $iCountSub . "_Name"]] . "'" );
		$iAttribGruppeId = $aAttribGruppe ["AttributGruppen_id"];
		
		// prfe ob der Artikel dieses Attribut hat
		$aAttribGruppeWarengruppen = unserialize ( $aAttribGruppe ["fiAttributGruppeWarengruppen"] );
		
		// wenn nicht, lege zunchst die Attributsgruppe passend an
		if ($iAttribGruppeId != "" and ! in_array ( $aArtikel ["fiWarengruppe"], $aAttribGruppeWarengruppen )) {
			
			unset ( $aArtikelAttribGruppe );
			
			// Wenn es die Attributsgruppe gibt, fge nur die Warengruppe hinzu
			if ($iAttribGruppeId == "") {
				$aAttribGruppeWarengruppen [] = $aArtikel ["fiWarengruppe"];
				$aArtikelAttribGruppe ["fiAttributGruppeWarengruppen"] = serialize ( $aAttribGruppeWarengruppen );
				
				update_into_table ( $tblartikelattributegruppen, $iAttribGruppeId, $aArtikelAttribGruppe );
			} 			

			// wenn nicht, lege Attributsgruppe an
			else {
				$aAttribGruppeWarengruppen [] = $aArtikel ["fiWarengruppe"];
				$aArtikelAttribGruppe ["dtAttributGruppeName"] = $aLine [$aSpaltenCSV ["Attribut_" . $iCountSub . "_Name"]];
				$aArtikelAttribGruppe ["dtAttributGruppeBeschreibung"] = $aLine [$aSpaltenCSV ["Attribut_" . $iCountSub . "_Beschreibung"]];
				$aArtikelAttribGruppe ["fiAttributGruppeWarengruppen"] = serialize ( $aAttribGruppeWarengruppen );
				
				$iAttribGruppeId = insert_into_table ( $tblartikelattributegruppen, $aArtikelAttribGruppe );
			}
		}
		
		unset ( $aArtikelAttrib );
		$aArtikelAttrib ["fiArtikel"] = $iArtikelId;
		$aArtikelAttrib ["fiArtikelAttributeGruppen"] = $iAttribGruppeId;
		if (isset ( $aLine [$aSpaltenCSV ["Attribut_" . $iCountSub . "_Wert"]] ))
			$aArtikelAttrib ["dtAttributWert"] = $aLine [$aSpaltenCSV ["Attribut_" . $iCountSub . "_Wert"]];
		
		if ($iAttribGruppeId) {
			// prfe, ob dieser Hersteller schon dem Artikel zugeordnet ist (neu oder update)
			$query = $sql_query ["artikelattributliste"];
			$query .= " and $tblartikelattribute.fiArtikel = '" . $iArtikelId . "'";
			$query .= " and $tblartikelattribute.fiArtikelAttributeGruppen = '" . $iAttribGruppeId . "'";
			
			$aCheck = get_table_row ( $query );
			$iArtikelAttribId = $aCheck ["Attribut_id"];
			
			if ($iArtikelAttribId == "") {
				$iArtikelAttribId = insert_into_table ( $tblartikelattribute, $aArtikelAttrib );
			} else {
				update_into_table ( $tblartikelattribute, $iArtikelAttribId, $aArtikelAttrib );
			}
		}
		
		$iCountSub ++;
	}
	unset ( $aAttribGruppe );
	unset ( $aArtikelAttribGruppe );
	unset ( $aArtikelAttrib );
	
	/*
	 * Stckliste importieren
	 */
	$iCountSub = 1;
	while ( isset ( $aLine [$aSpaltenCSV ["Stueckliste_" . $iCountSub . "_Artikelnummer"]] ) ) {
		
		// suche Stcklisten-Artikel-ID
		$aSLArtikel = get_table_row ( $sql_query ["artikelliste"] . " and $tblartikel.dtEigeneArtikelNr = '" . $aLine [$aSpaltenCSV ["Stueckliste_" . $iCountSub . "_Artikelnummer"]] . "'" );
		$iSLArtikelId = $aSLArtikel ["Artikel_id"];
		
		unset ( $aArtikelSL );
		$aArtikelSL ["fiArtikel"] = $iArtikelId;
		$aArtikelSL ["fiArtikelStueckliste"] = $iSLArtikelId;
		if (isset ( $aLine [$aSpaltenCSV ["Stueckliste_" . $iCountSub . "_Anzahl"]] ))
			$aArtikelSL ["dtHerstellerArtikelNr"] = $aLine [$aSpaltenCSV ["Stueckliste_" . $iCountSub . "_Anzahl"]];
		
		if ($iSLArtikelId) {
			// prfe, ob dieser Artikel schon der Stckliste zu dem Artikel zugeordnet ist (neu oder update)
			$query = $sql_query ["artikelstuecklistenliste"];
			$query .= " and $tblartikelstuecklisten.fiArtikel = '" . $iArtikelId . "'";
			$query .= " and $tblartikelstuecklisten.fiArtikelStueckliste = '" . $iSLArtikelId . "'";
			
			$aCheck = get_table_row ( $query );
			$iArtikelSLId = $aCheck ["ArtikelStueckliste_id"];
			
			if ($iArtikelSLId == "") {
				$iArtikelSLId = insert_into_table ( $tblartikelstuecklisten, $aArtikelSL );
			} else {
				update_into_table ( $tblartikelstuecklisten, $iArtikelSLId, $aArtikelSL );
			}
		}
		
		$iCountSub ++;
	}
	unset ( $aSLArtikel );
	unset ( $aArtikelSL );
	
	/*
	 * alternative Warengruppen importieren
	 */
	$iCountSub = 1;
	while ( isset ( $aLine [$aSpaltenCSV ["AltWarengruppe_" . $iCountSub . "_Name"]] ) ) {
		
		// suche AlternativeWarengruppen-ID
		$aAltWarengruppe = get_table_row ( $sql_query ["warengruppenliste"] . " and $tblwarengruppen.dtWarengruppe LIKE '" . $aLine [$aSpaltenCSV ["AltWarengruppe_" . $iCountSub . "_Name"]] . "'" );
		$iAltWarengruppeId = $aAltWarengruppe ["Warengruppe_id"];
		
		unset ( $aAltWg );
		$aAltWg ["fiArtikel"] = $iArtikelId;
		$aAltWg ["fiWarengruppe"] = $iAltWarengruppeId;
		
		if ($iAltWarengruppeId) {
			// prfe, ob diese Warengruppe schon dem Artikel zugeordnet ist (neu oder update)
			$query = $sql_query ["artikelwarengruppenalternativliste"];
			$query .= " and $tblartikelwarengruppenalternativ.fiArtikel = '" . $iArtikelId . "'";
			
			$aCheck = get_table_row ( $query );
			$iAltWGId = $aCheck ["ArtikelZuordnung_id"];
			
			if ($iAltWGId == "") {
				$iAltWGId = insert_into_table ( $tblartikelwarengruppenalternativ, $aAltWg );
			} else {
				update_into_table ( $tblartikelwarengruppenalternativ, $iAltWGId, $aAltWg );
			}
		}
		
		$iCountSub ++;
	}
	unset ( $aAltWarengruppe );
	unset ( $aAltWg );
	
	/*
	 * Bemerkungen importieren (nur bei Neuanlage eines Artikels)
	 */
	$iCountSub = 1;
	if ($bNeuArtikel) {
		while ( isset ( $aLine [$aSpaltenCSV ["Bemerkung_" . $iCountSub]] ) ) {
			if (! empty ( $aLine [$aSpaltenCSV ["Bemerkung_" . $iCountSub]] )) {
				
				$dtDatum = $aktdatum;
				$dtBerechtigung = ";1;";
				$dtBelegrelevant = 0;
				
				if (! empty ( $aLine [$aSpaltenCSV ["BemerkungDatum_" . $iCountSub]] )) {
					$aDatum = explode ( ".", $aLine [$aSpaltenCSV ["BemerkungDatum_" . $iCountSub]] );
					$dtDatum = concat_date ( $aDatum [0], $aDatum [1], $aDatum [2] );
				}
				if (! empty ( $aLine [$aSpaltenCSV ["BemerkungBerechtigung_" . $iCountSub]] ))
					$dtBerechtigung = $aLine [$aSpaltenCSV ["BemerkungBerechtigung_" . $iCountSub]];
					// if(!empty($aLine[$aSpaltenCSV["BemerkungBelegrelevant_".$iCountSub]])) $dtBelegrelevant = (int)$aLine[$aSpaltenCSV["BemerkungBelegrelevant_".$iCountSub]];
				
				unset ( $aBemerkung );
				$aBemerkung ["dtZugehoerigkeit"] = "tblArtikel";
				$aBemerkung ["fiZugehoerigkeitNr"] = $iArtikelId;
				$aBemerkung ["fiBemerkungAutor"] = 0;
				$aBemerkung ["dtDatum"] = $dtDatum;
				$aBemerkung ["dtBemerkung"] = $aLine [$aSpaltenCSV ["Bemerkung_" . $iCountSub]];
				$aBemerkung ["dtBerechtigung"] = $dtBerechtigung;
				$aBemerkung ["dtBelegrelevant"] = "";
				
				insert_into_table ( $tblbemerkungen, $aBemerkung );
			}
			$iCountSub ++;
		}
	}
	unset ( $aBemerkung );
}

?>