<?php
/*
 *
 * conceptERP
 *
 * Copyright (C) 2005 mm-concept GbR , Maik Unruh & Michael Schulte to Brinke
 * http://www.mm-concept.de
 *
 * Synchronisation von Kontakten ins ERP
 */
$query = $sql_query ["mitarbeiterliste"] . " and $tblpersonaldaten.dtKontaktsyncSyncModus = 2";
$mitarbeiterliste = get_table_array ( $query );

if (count ( $mitarbeiterliste ) > 0) {
	foreach ( $mitarbeiterliste as $mitarbeiter ) {
		$aKontaktListe = array ();
		
		if ($zarafa_mapi_aktiv) {
			$z = new KontaktZarafa ();
			$z->Benutzername = $mitarbeiter ["dtKontaktsyncBenutzername"];
			$z->Passwort = $mitarbeiter ["dtKontaktsyncPasswort"];
			$z->Server = $zarafa_sync_server;
			$z->Ordner = $mitarbeiter ["dtKontaktsyncOrdner"];
			
			try {
				$z->login ();
			} 

			catch ( ZarafaLogonFailedException $e ) {
				echo "Login nicht mglich: Zarafa User " . $mitarbeiter ["dtKontaktsyncBenutzername"] . "<br>";
				continue;
			}
			$aKontaktListe = $z->get ();
		}
		
		if ($bOXKontaktsyncAktiv) {
			try {
				$z = new KontaktOX6 ( $mitarbeiter ["dtKontaktsyncBenutzername"], $mitarbeiter ["dtKontaktsyncPasswort"], $sOXServerUrl );
				$z->setKontaktordner ( $mitarbeiter ["dtKontaktsyncOrdner"] );
				$aKontaktListe = $z->get ();
			} 

			catch ( Exception $e ) {
				echo "Kontaktsynchronisation nicht mglich: " . $e->getMessage ();
			}
		}
		
		foreach ( $aKontaktListe as $kontakt ) {
			
			if (strpos ( $kontakt->Id, "conceptERP-Unknown-" ) !== false && $mitarbeiter ["dtKontaktsyncImportiereNeue"] == 1) {
				/*
				 * Neuer Kontakt
				 * bertrage Kontakt ins ERP wenn die Flag dafr gesetzt ist
				 */
				
				/*
				 * Standardwahnsinn....
				 */
				
				$field_new ["dtKontaktNr"] = kontaktnummer_neu ();
				$field_new ["dtIstKunde"] = 0;
				$field_new ["dtIstLieferant"] = 0;
				$field_new ["dtIstMitarbeiter"] = 0;
				$field_new ["dtAktiv"] = 1;
				$field_new ["dtLetzteAenderung"] = date ( "Y-m-d H:i:s", $kontakt->Aenderungszeit );
				$field_new ["fiLand"] = 1;
				$field_new ["fiBenutzergruppe"] = 5;
				if ($field_new ["dtBuchhaltungKontoKunde"] == "") {
					$field_new ["dtBuchhaltungKontoKunde"] = $standardbuchhaltungskonto_kunden + $field_new ["dtKontaktNr"];
				}
				;
				if ($field_new ["dtBuchhaltungKontoLieferant"] == "") {
					$field_new ["dtBuchhaltungKontoLieferant"] = $standardbuchhaltungskonto_lieferanten + $field_new ["dtKontaktNr"];
				}
				;
				if ($field_new ["dtBuchhaltungKontoMitarbeiter"] == "") {
					$field_new ["dtBuchhaltungKontoMitarbeiter"] = $standardbuchhaltungskonto_mitarbeiter + $field_new ["dtKontaktNr"];
				}
				;
				
				/*
				 * Felder des Kontakts
				 */
				
				$field_new ["dtFirmenname"] = $kontakt->Firma;
				$field_new ["dtNamenszusatz"] = $kontakt->Namenszusatz;
				$field_new ["dtVorname"] = $kontakt->Vorname;
				$field_new ["dtNachname"] = $kontakt->Name;
				$field_new ["dtStrasse"] = $kontakt->Strasse;
				$field_new ["dtPLZ"] = $kontakt->PLZ;
				$field_new ["dtOrt"] = $kontakt->Ort;
				$field_new ["dtTelefon"] = $kontakt->TelNr;
				$field_new ["dtFax"] = $kontakt->FaxNr;
				$field_new ["dtMobil"] = $kontakt->MobilNr;
				$field_new ["dtEmail"] = $kontakt->EMail;
				$field_new ["fiAnrede"] = 1;
				
				/*
				 * Standardwahnsinn....
				 */
				
				// erzeuge Feld Nummern Suche fr Volltextsuche in Telefonnummern
				$nummer_telefon = normalisiere_telefonnummer ( $field_new ["dtTelefon"] );
				$nummer_mobil = normalisiere_telefonnummer ( $field_new ["dtMobil"] );
				$nummer_fax = normalisiere_telefonnummer ( $field_new ["dtFax"] );
				
				$field_new ["dtNummernSuche"] = str_replace ( " ", "", $nummer_telefon ) . " " . $nummer_telefon;
				$field_new ["dtNummernSuche"] .= " " . str_replace ( " ", "", $nummer_mobil ) . " " . $nummer_mobil;
				$field_new ["dtNummernSuche"] .= " " . str_replace ( " ", "", $nummer_fax ) . " " . $nummer_fax;
				
				$nummernsuche_array = array_unique ( explode ( " ", $field_new ["dtNummernSuche"] ) );
				$field_new ["dtNummernSuche"] = "";
				foreach ( $nummernsuche_array as $key => $value ) {
					if ($value != "") {
						$field_new ["dtNummernSuche"] .= $value . " ";
					}
				}
				
				$field_new ["dtKontaktGebucht"] = 0;
				$field_new ["dtSyncInfo"] = ";" . $mitarbeiter ["fiBenutzergruppe"] . ";";
				
				/*
				 * In Datenbank eintragen und diesem Kontakt eine ERP-ID zuweisen
				 */
				$neuid = insert_into_table ( $tblkontakte, $field_new );
				$z->aendereID ( $kontakt->Id, "Kontakt-" . $neuid );
				echo $kontakt->Id . " nach " . $neuid;
				
				echo "Kontakt $neuid hinzugefgt von User " . $mitarbeiter ["dtKontaktsyncBenutzername"] . "  <br>";
			} else {
				/*
				 * Alter Kontakt
				 */
				$str_id = explode ( "-", $kontakt->Id );
				$id = $str_id [3];
				$typ = $str_id [2];
				unset ( $str_id );
				
				if ($typ == "Kontakt") {
					$kontakt_db = new Kontakt ();
					$kontakt_db->get ( $id );
					
					if ($kontakt_db->Aenderungszeit < $kontakt->Aenderungszeit - 10) {
						// Wenn remote Kontakt aktueller ist als der im ERP (10 Sekunden subtrahieren wegen Verarbeitungsdauer)
						$kontakt->save ( $id );
						echo "Aendere Kontakt $id von User " . $mitarbeiter ["dtKontaktsyncBenutzername"] . "  <br>";
					}
				} elseif ($typ == "ASP") {
					$kontakt_db = new Ansprechpartner ();
					$kontakt_db->get ( $id );
					
					if ($kontakt_db->Aenderungszeit < $kontakt->Aenderungszeit - 10) {
						// Wenn remote Kontakt aktueller ist als der im ERP (10 Sekunden subtrahieren wegen Verarbeitungsdauer)
						$kontakt->save ( $id );
						echo "Aendere ASP $id von User " . $mitarbeiter ["dtKontaktsyncBenutzername"] . "  <br>";
					}
				}
			}
		}
	}
}

?>