<?php
/*
 *
 * conceptERP
 *
 * Copyright (C) 2005 mm-concept GbR , Maik Unruh & Michael Schulte to Brinke
 * http://www.mm-concept.de
 *
 *
 */
require_once ("functions/init.php");

/*
 * Einstellungen
 */
neuesKonfigurationsfeld ( $sTask . "_contentOrdner", "In diesem Content-Ordner sind die Artikelbilder gespeichert.", CONFIG_TYP_TEXT, "", $sTask );
neuesKonfigurationsfeld ( $sTask . "_zielUrl", "URL der conceptERP Schnittstelle in der OXID Installation.", CONFIG_TYP_TEXT, "", $sTask );
neuesKonfigurationsfeld ( $sTask . "_authToken", "Authentifizierungstoken der OXID Schnittstelle.", CONFIG_TYP_TEXT, "", $sTask );
neuesKonfigurationsfeld ( $sTask . "_komplettExport", "Erzwingt einen Komplettexport beim nchsten Durchlauf.", CONFIG_TYP_BOOL, false, $sTask );
neuesKonfigurationsfeld ( $sTask . "_komplettExportImmer", "Exportiere _immer_ die kompletten Artikeldaten.", CONFIG_TYP_BOOL, false, $sTask );

neuesKonfigurationsfeld ( $sTask . "_ftpHost", "Hostname des FTP-Servers.", CONFIG_TYP_TEXT, "", $sTask );
neuesKonfigurationsfeld ( $sTask . "_ftpUser", "Benutzername des FTP-Servers.", CONFIG_TYP_TEXT, "", $sTask );
neuesKonfigurationsfeld ( $sTask . "_ftpPass", "Passwort des FTP-Servers.", CONFIG_TYP_TEXT, "", $sTask );
neuesKonfigurationsfeld ( $sTask . "_ftpPfad", "Pfad des FTP-Servers.", CONFIG_TYP_TEXT, "/import.zip", $sTask );

neuesKonfigurationsfeld ( $sTask . "_zielDatenblaetter", "An diesen Ort werden Datenbltter abgelegt.", CONFIG_TYP_TEXT, "", $sTask );
neuesKonfigurationsfeld ( $sTask . "_zielDatenblaetterURL", "ber diese URL werden die Datenbltter verlinkt.", CONFIG_TYP_TEXT, "", $sTask );

$aConfig = exportiereKonfiguration ();

$sContentOrdner = $aConfig [$sTask . "_contentOrdner"];
$sZielUrl = $aConfig [$sTask . "_zielUrl"];
$sAuth = $aConfig [$sTask . "_authToken"];

$sFTPHost = $aConfig [$sTask . "_ftpHost"];
$sFTPUser = $aConfig [$sTask . "_ftpUser"];
$sFTPPass = $aConfig [$sTask . "_ftpPass"];
$sFTPPfad = $aConfig [$sTask . "_ftpPfad"];

$sDatenblattPfad = $aConfig [$sTask . "_zielDatenblaetter"];
$sDatenblattURL = $aConfig [$sTask . "_zielDatenblaetterURL"];

if (empty ( $sContentOrdner ) || empty ( $sZielUrl ) || empty ( $sAuth ) || empty ( $sFTPHost ) || empty ( $sFTPUser ) || empty ( $sFTPPass ) || empty ( $sFTPPfad )) {
	echo "Bitte die Schnittstelle konfigurieren!\n";
	$iReturncode = 3;
	
	return;
}

/*
 * Komplettexport durchfhren?
 */
if ($aConfig [$sTask . "_komplettExportImmer"]) {
	schreibeInKonfiguration ( $sTask . "_komplettExport", true );
}

if ($aConfig [$sTask . "_komplettExport"]) {
	$bKomplettexport = true;
	if (! $aConfig [$sTask . "_komplettExportImmer"]) {
		schreibeInKonfiguration ( $sTask . "_komplettExport", false );
	}
} else {
	$bKomplettexport = false;
}

/*
 * Warengruppen auswhlen
 */
echo "\n=== Ausgabe conceptERP: === \n";

$aWarengruppeIdExport = array ();
$aWarengruppeNameExport = array ();
$aTask = get_table_row ( $sql_query ["taskplanerliste"] . " and $tbltaskplaner.dtTaskName = '" . $sTask . "'" ); // Informationen ber den Task

/*
 * Sammle IDs der Warengruppen die fr diesen Task in Frage kommen
 */
$aListeWarengruppen = get_table_array ( $sql_query ["warengruppenliste"] );

if (count ( $aListeWarengruppen ) > 0) {
	foreach ( $aListeWarengruppen as $aWarengruppe ) {
		if (! empty ( $aWarengruppe ["dtWarengruppeExportziele"] )) {
			$aExport = unserialize ( $aWarengruppe ["dtWarengruppeExportziele"] );
			
			if (array_search ( $aTask ["Taskplaner_id"], $aExport ) !== false) {
				$aWarengruppeIdExport [] = $aWarengruppe ["Warengruppe_id"];
				$aWarengruppeNameExport [] = $aWarengruppe ["dtWarengruppe"];
			}
		}
	}
}

if (count ( $aWarengruppeIdExport ) > 0) {
	echo "Exportiere folgende Warengruppen: " . join ( ", ", $aWarengruppeNameExport ) . "\n";
} else {
	echo "Keine Warengruppen zum Export verfuegbar.";
	$iReturncode = 2;
	
	return;
}

/*
 * Komplettexport durchfhren?
 */
if (! $bKomplettexport) {
	$sQueryOnlyLastUpdates = "and $tblartikel.dtLetzteAenderung > '" . $aTask ["dtLetzteAusfuehrung"] . "'";
} else {
	$sQueryOnlyLastUpdates = "";
}

/*
 * Verarbeite Artikel in ausgewhlten Warengruppen
 */

$aArtikelInWarengruppen = array ();
$sQuery = $sql_query ["artikellisteexport"] . " " . $sQueryOnlyLastUpdates . " and ( $tblartikel.fiWarengruppe = " . join ( " OR $tblartikel.fiWarengruppe = ", $aWarengruppeIdExport ) . " )";
$rResult = mysql_query ( $sQuery ); // Um saubere CSVs zu haben, frage Datenbank ueber diesen Weg ab. (Keine numerische Zuordnung)
while ( $aRow = mysql_fetch_array ( $rResult, MYSQL_ASSOC ) ) {
	$aArtikelInWarengruppen [] = $aRow;
}

/*
 * Verarbeite ber alternative Warengruppe zugeordnete Artikel
 */

$sQuery = $sql_query ["artikelwarengruppenalternativliste"] . " " . $sQueryOnlyLastUpdates . " and ( $tblartikelwarengruppenalternativ.fiWarengruppe = " . join ( " OR $tblartikelwarengruppenalternativ.fiWarengruppe = ", $aWarengruppeIdExport ) . " )";
$rResult = mysql_query ( $sQuery ); // Um saubere CSVs zu haben, frage Datenbank ueber diesen Weg ab. (Keine numerische Zuordnung)
while ( $aRow = mysql_fetch_array ( $rResult, MYSQL_ASSOC ) ) {
	$aArtikelInWarengruppen [] = $aRow;
}

/*
 * Artikel verarbeiten
 */
$aDateiliste = array ();
$aArtikelIds = array ();

if (count ( $aArtikelInWarengruppen ) > 0) {
	foreach ( $aArtikelInWarengruppen as &$aArtikel ) {
		$aArtikelIds [] = $aArtikel ["Artikel_id"];
		unset ( $aArtikel ["fiWarengruppe"], $aArtikel ["fiArtikel"], $aArtikel ["ArtikelZuordnung_id"] );
		
		$aArtikel ["dtArtikel"] = utf8_encode ( $aArtikel ["dtArtikel"] );
		$aArtikel ["dtFabrikat"] = utf8_encode ( $aArtikel ["dtFabrikat"] );
		$aArtikel ["Artikel_Beschreibung"] = utf8_encode ( nl2br ( $aArtikel ["Artikel_Beschreibung"] ) );
		$aArtikel ["dtBeschreibung2"] = utf8_encode ( nl2br ( $aArtikel ["dtBeschreibung2"] ) );
		$aArtikel ["dtBeschreibung3"] = utf8_encode ( nl2br ( $aArtikel ["dtBeschreibung3"] ) );
		$aArtikel ["dtBeschreibung4"] = utf8_encode ( nl2br ( $aArtikel ["dtBeschreibung4"] ) );
		$aArtikel ["dtBeschreibung5"] = utf8_encode ( nl2br ( $aArtikel ["dtBeschreibung5"] ) );
		$aArtikel ["Gewicht"] = double_to_sql ( getArtikelAttribut ( "Gewicht (kg)", getArtikelAttribute ( $aArtikel ["Artikel_id"] ) ) );
		$aArtikel ["Mengeneinheit"] = double_to_sql ( getArtikelAttribut ( "Mengeneinheit", getArtikelAttribute ( $aArtikel ["Artikel_id"] ) ) );
		$aArtikel ["Grundpreis"] = double_to_sql ( getArtikelAttribut ( "Grundpreis", getArtikelAttribute ( $aArtikel ["Artikel_id"] ) ) );
		
		/*
		 * Content suchen
		 */
		$sQuery = $sql_query ["contentliste"] . " and fiArtikel like '%;" . $aArtikel ["Artikel_id"] . ";%' and $tblcontent.fiContentTyp < 900";
		$aContentListe = get_table_array ( $sQuery );
		
		if (count ( $aContentListe ) > 0) {
			foreach ( $aContentListe as $aContent ) {
				/*
				 * Speichere Dateipfade fr Artikel in Liste
				 */
				if (is_dir ( returnContentOrdner ( $aContent ["Content_id"] ) . "/" . $sContentOrdner )) {
					$aDateiliste [$aArtikel ["Artikel_id"]] = glob ( returnContentOrdner ( $aContent ["Content_id"] ) . "/" . $sContentOrdner . "/*.{jpg,png,jpeg}", GLOB_BRACE );
				}
			}
		}
		
		/*
		 * Datenbltter ablegen
		 */
		if (count ( $aDatenblaetter = glob ( returnContentOrdner ( $aContent ["Content_id"] ) . "/" . $sContentOrdner . "/*.{pdf}", GLOB_BRACE ) ) > 0) {
			if (is_writable ( $sDatenblattPfad )) {
				if (! is_dir ( $sDatenblattPfad . "/" . $aArtikel ["dtEigeneArtikelNr"] )) {
					mkdir ( $sDatenblattPfad . "/" . $aArtikel ["dtEigeneArtikelNr"] );
				}
				
				$aArtikel ["Artikel_Beschreibung"] .= "\n\n<b>Datenbl&auml;tter:</b>\n";
				
				foreach ( $aDatenblaetter as $sDateiQuelle ) {
					if (file_exists ( ($sPfadZiel = $sDatenblattPfad . "/" . $aArtikel ["dtEigeneArtikelNr"] . "/" . basename ( $sDateiQuelle )) )) {
						unlink ( $sPfadZiel );
					}
					
					echo "Kopiere Datenblatt von '" . $sDateiQuelle . "' nach '" . $sPfadZiel . "'\n";
					
					copy ( $sDateiQuelle, $sPfadZiel );
					
					$aArtikel ["Artikel_Beschreibung"] .= "\n<a href='" . $sDatenblattURL . "/" . $aArtikel ["dtEigeneArtikelNr"] . "/" . basename ( $sDateiQuelle ) . "'>" . basename ( $sDateiQuelle ) . " ( " . format_bytes ( filesize ( $sPfadZiel ) ) . " )</a>";
				}
			}
		}
		
		echo "Exportiere Artikel " . $aArtikel ["dtArtikelDDText"] . " (" . $aArtikel ["Artikel_id"] . ") - Anzahl Dateien: " . count ( $aDateiliste [$aArtikel ["Artikel_id"]] ) . "\n";
	}
} else {
	echo "Keine Artikel zum Exportieren verfuegbar.\n";
	$iReturncode = 2;
	
	return;
}

/*
 * Warengruppenzuordnungen separat exportieren
 */

$aWarengruppenExport = array ();
$aWarengruppenExport [] = array (
		"ID",
		"Name",
		"Beschreibung",
		"Uebergeordnet",
		"Sortierung",
		"Aktiv" 
);

if (count ( $aWarengruppeIdExport ) > 0) {
	foreach ( $aWarengruppeIdExport as $iWarengruppeId ) {
		$aWarengruppe = get_table_row ( $sql_query ["warengruppenliste"] . " and $tblwarengruppen.id = " . $iWarengruppeId );
		$aWarengruppenExport [] = array (
				$aWarengruppe ["Warengruppe_id"],
				utf8_encode ( $aWarengruppe ["dtWarengruppe"] ),
				utf8_encode ( $aWarengruppe ["dtWarengruppenBeschreibung"] ),
				$aWarengruppe ["fiWarengruppeUebergeordnet"],
				$aWarengruppe ["dtWarengruppenSortierung"],
				1 
		);
	}
}

if (count ( $aArtikelInWarengruppen ) > 0) {
	foreach ( $aArtikelInWarengruppen as $aRow ) {
		$aArtikelWarengruppenZuordnung [] = array (
				"ZuordnungId" => $aRow ["Artikel_id"] . "0000" . $aRow ["Warengruppe_id"],
				"Artikel" => $aRow ["Artikel_id"],
				"Warengruppe" => $aRow ["Warengruppe_id"] 
		);
	}
}

/*
 * Lieferanten separat exportieren
 */
$aLieferantenListe = get_table_array ( $sql_query ["artikellieferantenliste"] . " GROUP BY $tblartikellieferanten.fiArtikel" );
$aLieferantenListeNeu = array ();
if (count ( $aLieferantenListe ) > 0) {
	foreach ( $aLieferantenListe as $aLieferant ) {
		if (array_search ( $aLieferant ["fiArtikel"], $aArtikelIds ) === false) {
			continue;
		}
		
		$aLieferantenListeNeu [] = array (
				"Artikel_ID" => $aLieferant ["fiArtikel"],
				"Lieferant_ID" => $aLieferant ["fiLieferant"],
				"Lieferant_Anzeige" => utf8_encode ( $aLieferant ["dtFirmenname"] ),
				"Lieferant_Aktiv" => $aLieferant ["dtAktiv"],
				"dtArtikelNrFremd" => $aLieferant ["dtArtikelNrFremd"] 
		);
	}
}

/*
 * Artikelverfgbarkeiten separat exportieren
 */

$aArtikelVerfuegbarListeNeu = array ();

foreach ( $aArtikelIds as $iArtikelId ) {
	$aArtikelVerfuegbarListeNeu [] = array (
			"Artikel_ID" => $iArtikelId,
			"Artikel_Menge" => getArtikelAnzahlVerfuegbar ( $iArtikelId ) 
	);
}

/*
 * Varianten exportieren
 */
$aVariantenListe = get_table_array ( $sql_query ["artikelvariantenliste"] );
$aVariantenListeExport = array ();

if (count ( $aVariantenListe ) > 0) {
	foreach ( $aVariantenListe as $aVariante ) {
		if (array_search ( $aVariante ["fiArtikel"], $aArtikelIds ) === false) {
			continue;
		}
		
		$aVariante ["Gewicht"] = getArtikelAttribut ( "Gewicht (kg)", getArtikelAttribute ( $aVariante ["fiArtikel"], array (
				"variante_" . $aVariante ["fiArtikelVariantenGruppe"] => $aVariante ["Variante_id"] 
		) ) );
		
		$aVariantenListeExport [] = $aVariante;
		
		// Verfgbarkeit
		$aArtikelVerfuegbarListeNeu [] = array (
				"Artikel_ID" => $aVariante ["fiArtikel"] . "-" . $aVariante ["Variante_id"],
				"Artikel_Menge" => getArtikelAnzahlVerfuegbar ( $aVariante ["fiArtikel"], 0, array (
						"variante_" . $aVariante ["fiArtikelVariantenGruppe"] => $aVariante ["Variante_id"] 
				) ) 
		);
		
		/*
		 * Content suchen
		 */
		$sArtikelNummerVariante = $aVariante ["fiArtikel"] . "-" . $aVariante ["Variante_id"];
		$sVarianteOrdner = $aVariante ["dtGruppenArtikelNrPrefix"] . $aVariante ["dtArtikelVariantenNr"];
		
		$sQuery = $sql_query ["contentliste"] . " and fiArtikel like '%;" . $aVariante ["fiArtikel"] . ";%' and $tblcontent.fiContentTyp < 900";
		$aContentListe = get_table_array ( $sQuery );
		
		if (count ( $aContentListe ) > 0) {
			foreach ( $aContentListe as $aContent ) {
				/*
				 * Speichere Dateipfade fr Artikel in Liste
				 */
				if (is_dir ( returnContentOrdner ( $aContent ["Content_id"] ) . "/" . $sVarianteOrdner . "/" . $sContentOrdner )) {
					$aDateiliste [$sArtikelNummerVariante] = glob ( returnContentOrdner ( $aContent ["Content_id"] ) . "/" . $sVarianteOrdner . "/" . $sContentOrdner . "/*.{jpg,png,jpeg}", GLOB_BRACE );
				}
			}
		}
	}
}

/*
 * ZIP erzeugen
 */
$sPfadZIPFile = tempnam ( sys_get_temp_dir (), "conceptERP-" );

$oZip = new ZipArchive ();
$rZip = $oZip->open ( $sPfadZIPFile, ZIPARCHIVE::CREATE | ZIPARCHIVE::OVERWRITE );
$oZip->addFromString ( "article.txt", json_encode ( $aArtikelInWarengruppen ) ); // Artikel
$oZip->addFromString ( "warengruppenzuordnung.txt", json_encode ( $aArtikelWarengruppenZuordnung ) ); // Warengruppenzuordnungen
$oZip->addFromString ( "vendor.txt", json_encode ( $aLieferantenListeNeu ) ); // Lieferanten
$oZip->addFromString ( "verfuegbar.txt", json_encode ( $aArtikelVerfuegbarListeNeu ) ); // Verfuegbare Artikel
$oZip->addFromString ( "warengruppen.txt", json_encode ( $aWarengruppenExport ) ); // Warengruppen
$oZip->addFromString ( "varianten.txt", serialize ( $aVariantenListeExport ) ); // Varianten
$oZip->addEmptyDir ( "files" );

/*
 * Artikelcontents in ZIP Datei schreiben
 */
foreach ( $aDateiliste as $iArtikelId => $aDateien ) {
	if (count ( $aDateien ) > 0) {
		$oZip->addEmptyDir ( "files/" . $iArtikelId );
		
		foreach ( $aDateien as $sDateiPfad ) {
			$oZip->addFile ( $sDateiPfad, "files/" . $iArtikelId . "/" . basename ( $sDateiPfad ) );
		}
	}
}

$oZip->close ();

echo "ZIP Datei erzeugt: " . $sPfadZIPFile . " (" . strlen ( file_get_contents ( $sPfadZIPFile ) ) . " Bytes)\n";

/*
 * ZIP hochladen
 */
if (! empty ( $sFTPHost )) {
	$sCurlUpload = "ftp://" . $sFTPUser . ":" . $sFTPPass . "@" . $sFTPHost . $sFTPPfad;
	$rZIPFile = fopen ( $sPfadZIPFile, "r" );
	
	$rCurl = curl_init ();
	curl_setopt ( $rCurl, CURLOPT_URL, $sCurlUpload );
	curl_setopt ( $rCurl, CURLOPT_UPLOAD, 1 );
	curl_setopt ( $rCurl, CURLOPT_INFILE, $rZIPFile );
	curl_setopt ( $rCurl, CURLOPT_INFILESIZE, filesize ( $sPfadZIPFile ) );
	
	if (! curl_exec ( $rCurl )) {
		echo "Die ZIP Datei kann nicht hochgeladen werden!\n";
		var_dump ( curl_getinfo ( $rCurl ) );
		$iReturncode = 3;
		return;
	} else {
		echo "ZIP Datei erfolgreich per FTP hochgeladen!\n";
		unset ( $rCurl );
	}
}

$rCurl = curl_init ();
curl_setopt ( $rCurl, CURLOPT_HEADER, 0 );
curl_setopt ( $rCurl, CURLOPT_VERBOSE, 0 );
curl_setopt ( $rCurl, CURLOPT_URL, $sZielUrl );
curl_setopt ( $rCurl, CURLOPT_POST, true );

$aPost = array (
		"auth" => $sAuth,
		"crc" => crc32 ( file_get_contents ( $sPfadZIPFile ) ) 
);

curl_setopt ( $rCurl, CURLOPT_POSTFIELDS, $aPost );

echo "\n=== Ausgabe OXID: ===\n";
curl_exec ( $rCurl );

/*
 * Aufrumen
 */
unlink ( $sPfadZIPFile );

?>