<?php
/*
 *
 * conceptERP
 *
 * Copyright (C) 2005 mm-concept GbR , Maik Unruh & Michael Schulte to Brinke
 * http://www.mm-concept.de
 *
 *
 */

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// Empfange Zeilen der Log-Datei des ISDN-Logs mit Anrufen von Mitarbeitern
// und erzeuge daraus Stempelzeiten
//
// Die erlaubten Telefonnummern stehen in den Personaldaten. Mehrere erlaubte
// Nummern pro Mitarbeiter sind durch Leerzeichen getrennt. Es werden immer
// nur die letzen 10 Stellen einer Nummer zum Vergleich verwendet

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
require ('functions/init.php');

// ************************** Berechtigung des anfragenden Rechners prfen
if (! (in_array ( getenv ( "REMOTE_ADDR" ), $zeiterfasser_ip_array ))) {
	echo getenv ( "REMOTE_ADDR" ) . ": keine Berechtigung!";
	exit ();
}

// ************************** /var/log/messages wurde als $_POST bergeben
if (isset ( $_POST ["varlogmessages"] )) {
	$varlogmessages = explode ( "\n", $_POST ["varlogmessages"] );
} else {
	exit ();
}

// ************************** Ausgabe zeilenweise von unten nach oben abarbeiten
$varlogmessages = array_reverse ( $varlogmessages );
$monat_array = array (
		"Jan" => 1,
		"Feb" => 2,
		"Mar" => 3,
		"Apr" => 4,
		"May" => 5,
		"Jun" => 6,
		"Jul" => 7,
		"Aug" => 8,
		"Sep" => 9,
		"Oct" => 10,
		"Nov" => 11,
		"Dec" => 12 
);

foreach ( ( array ) $varlogmessages as $key => $zeile ) {
	
	// Mar 11 05:55:46 server kernel: [155730.142450] capidrv-1: incoming call 01711234567,1,1,52
	$zeile_array = explode ( " ", str_replace ( array (
			"  ",
			"[ " 
	), array (
			" ",
			"[" 
	), $zeile ) );
	
	// Rufnummern-Block steht an Pos.8 oder pos.9, je nach Kernel-Version des IDSN-Log
	$rufnummern_array = explode ( ",", $zeile_array [8] );
	if (count ( ( array ) $rufnummern_array ) < 4) {
		$rufnummern_array = explode ( ",", $zeile_array [9] );
	}
	
	echo $rufnummern_array [0] . " | ";
	
	// bearbeite nur die Rufnummrn der Anruferkennung
	if (($rufnummern_array [3] == $isdn_msn_fahrtbeginn or $rufnummern_array [3] == $isdn_msn_arbeitsbeginn or $rufnummern_array [3] == $isdn_msn_arbeitsende) and $rufnummern_array [0] != "") {
		
		// suche Mitarbeiter zur Telefonnummer
		if (strlen ( $rufnummern_array [0] ) > 10)
			$rufnummern_array [0] = substr ( $rufnummern_array [0], - 10 );
		$query = str_replace ( "where", "having", $sql_query ["personaldatenliste"] ) . " and dtAnruferkennung like '%" . $rufnummern_array [0] . "%'";
		
		$mitarbeiter_field = get_table_row ( $query );
		
		// erzeuge Datum und Uhrzeit aus Text-Zeile
		$datum_zeile = $aktjahr . "-" . $monat_array [$zeile_array [0]] . "-" . $zeile_array [1];
		$uhrzeit_array = explode ( ":", $zeile_array [2] );
		$uhrzeit_zeile = $uhrzeit_array [0] . ":" . $uhrzeit_array [1] . ":00";
		
		echo $mitarbeiter_field ["fiKontaktNr"] . " | " . $datum_zeile . " | " . $uhrzeit_zeile;
		
		// filtere doppelte Eintrge einer Rufnummer innerhalb von 10sek. heraus (sonst knnte doppelt gestempelt werden, wenn darin ein Minutenwechsel liegt)
		$sekunden = ($uhrzeit_array [0] * 60 * 60) + ($uhrzeit_array [1] * 60) + $uhrzeit_array [2];
		if ($datum_zeile != $datum_alt) {
			$sekunden_alt = "";
		}
		;
		
		// echo " | " . $sekunden . " | " . $sekunden_alt . " = " . ($sekunden_alt - $sekunden);
		
		if ($rufnummer_alt == "" or ($rufnummern_array [0] != $rufnummer_alt and $rufnummer_alt != "") or ($rufnummern_array [0] == $rufnummer_alt and (($sekunden_alt - $sekunden > 20 and $sekunden_alt != "") or $sekunden_alt == ""))) {
			
			// wenn es einen aktiven Mitarbeiter gibt, dann prfe, ob diese Zeit schon erfasst wurde
			if ($mitarbeiter_field ["fiKontaktNr"] != 0 and $mitarbeiter_field ["fiKontaktNr"] != "" and $mitarbeiter_field ["dtAktiv"] == 1) {
				
				$query = "select * from $tblstempelzeiten where fiMitarbeiter = " . $mitarbeiter_field ["fiKontaktNr"] . " and dtDatum = '" . $datum_zeile . "' and dtUhrzeit = '" . $uhrzeit_zeile . "'";
				
				// wenn nicht, dann erfasse sie
				if (get_table_count ( $query ) == 0) {
					
					echo " -> erfasst: ";
					
					unset ( $stempelzeit_array );
					$stempelzeit_array ["fiMitarbeiter"] = $mitarbeiter_field ["fiKontaktNr"];
					$stempelzeit_array ["dtDatum"] = $datum_zeile;
					$stempelzeit_array ["dtUhrzeit"] = $uhrzeit_zeile;
					$stempelzeit_array ["dtGeraet"] = "Anruferfassung";
					if ($rufnummern_array [3] == $isdn_msn_fahrtbeginn) {
						$stempelzeit_array ["dtStempelCode"] = "Fahrtbeginn";
					}
					;
					if ($rufnummern_array [3] == $isdn_msn_arbeitsbeginn) {
						$stempelzeit_array ["dtStempelCode"] = "Arbeitsbeginn";
					}
					;
					if ($rufnummern_array [3] == $isdn_msn_arbeitsende) {
						$stempelzeit_array ["dtStempelCode"] = "Ende";
					}
					;
					$stempelzeit_array ["fiStatus"] = 0;
					
					echo $stempelzeit_array ["dtStempelCode"];
					
					insert_into_table ( $tblstempelzeiten, $stempelzeit_array );
				}
			}
		}
		
		$datum_alt = $datum_zeile;
		$sekunden_alt = $sekunden;
		$rufnummer_alt = $rufnummern_array [0];
	}
	
	echo "<br>";
}

/*
 * Datenbankverbindung schliessen
 */

?>